(function (global, factory) {
typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
typeof define === 'function' && define.amd ? define(factory) :
(global = global || self, global.Tangram = factory());
}(this, (function () { 'use strict';

// define() gets called for each chunk generated by the first Rollup pass.
// The order the chunks are called in is controlled by the imports in bundle.js:
//
// shared.js: shared dependencies between main and worker threads
// scene_worker.js: worker thread code
// index.js: main thread code

// Once all chunks have been provided, the worker thread code is assembled,
// incorporating the shared chunk code, then turned into a blob URL which
// can be used to instantiate the worker.

var shared, worker, Tangram = {};

function define(_, chunk) {
	if (!shared) {
	    shared = chunk;
	} else if (!worker) {
	    worker = chunk;
	} else {
	    var worker_bundle = 'var shared_chunk = {}; (' + shared + ')(shared_chunk); (' + worker + ')(shared_chunk);'
	    var shared_chunk = {};
	    shared(shared_chunk);
	    Tangram = chunk(shared_chunk);
	    Tangram.workerURL = window.URL.createObjectURL(new Blob([worker_bundle], { type: 'text/javascript' }));
	}
}


define(["exports"],function(e){"use strict";function t(e,t){return e(t={exports:{}},t.exports),t.exports}var r=t(function(e){var t=e.exports={version:"2.6.3"};"number"==typeof __e&&(__e=t);}),n=(r.version,t(function(e){var t=e.exports="undefined"!=typeof window&&window.Math==Math?window:"undefined"!=typeof self&&self.Math==Math?self:Function("return this")();"number"==typeof __g&&(__g=t);})),i=t(function(e){var t=n["__core-js_shared__"]||(n["__core-js_shared__"]={});(e.exports=function(e,r){return t[e]||(t[e]=void 0!==r?r:{})})("versions",[]).push({version:r.version,mode:"global",copyright:"© 2019 Denis Pushkarev (zloirock.ru)"});}),o=0,s=Math.random(),a=function(e){return "Symbol(".concat(void 0===e?"":e,")_",(++o+s).toString(36))},l=t(function(e){var t=i("wks"),r=n.Symbol,o="function"==typeof r;(e.exports=function(e){return t[e]||(t[e]=o&&r[e]||(o?r:a)("Symbol."+e))}).store=t;}),u=function(e){return "object"==typeof e?null!==e:"function"==typeof e},c=function(e){if(!u(e))throw TypeError(e+" is not an object!");return e},f=function(e){try{return !!e()}catch(e){return !0}},h=!f(function(){return 7!=Object.defineProperty({},"a",{get:function(){return 7}}).a}),d=n.document,p=u(d)&&u(d.createElement),_=function(e){return p?d.createElement(e):{}},m=!h&&!f(function(){return 7!=Object.defineProperty(_("div"),"a",{get:function(){return 7}}).a}),v=function(e,t){if(!u(e))return e;var r,n;if(t&&"function"==typeof(r=e.toString)&&!u(n=r.call(e)))return n;if("function"==typeof(r=e.valueOf)&&!u(n=r.call(e)))return n;if(!t&&"function"==typeof(r=e.toString)&&!u(n=r.call(e)))return n;throw TypeError("Can't convert object to primitive value")},g=Object.defineProperty,y={f:h?Object.defineProperty:function(e,t,r){if(c(e),t=v(t,!0),c(r),m)try{return g(e,t,r)}catch(e){}if("get"in r||"set"in r)throw TypeError("Accessors not supported!");return "value"in r&&(e[t]=r.value),e}},x=function(e,t){return {enumerable:!(1&e),configurable:!(2&e),writable:!(4&e),value:t}},b=h?function(e,t,r){return y.f(e,t,x(1,r))}:function(e,t,r){return e[t]=r,e},A=l("unscopables"),T=Array.prototype;null==T[A]&&b(T,A,{});var w=function(e){T[A][e]=!0;},E=function(e,t){return {value:t,done:!!e}},R={},M={}.toString,S=function(e){return M.call(e).slice(8,-1)},z=Object("z").propertyIsEnumerable(0)?Object:function(e){return "String"==S(e)?e.split(""):Object(e)},P=function(e){if(null==e)throw TypeError("Can't call method on  "+e);return e},N=function(e){return z(P(e))},k={}.hasOwnProperty,L=function(e,t){return k.call(e,t)},O=t(function(e){var t=a("src"),i=Function.toString,o=(""+i).split("toString");r.inspectSource=function(e){return i.call(e)},(e.exports=function(e,r,i,s){var a="function"==typeof i;a&&(L(i,"name")||b(i,"name",r)),e[r]!==i&&(a&&(L(i,t)||b(i,t,e[r]?""+e[r]:o.join(String(r)))),e===n?e[r]=i:s?e[r]?e[r]=i:b(e,r,i):(delete e[r],b(e,r,i)));})(Function.prototype,"toString",function(){return "function"==typeof this&&this[t]||i.call(this)});}),I=function(e){if("function"!=typeof e)throw TypeError(e+" is not a function!");return e},F=function(e,t,r){if(I(e),void 0===t)return e;switch(r){case 1:return function(r){return e.call(t,r)};case 2:return function(r,n){return e.call(t,r,n)};case 3:return function(r,n,i){return e.call(t,r,n,i)}}return function(){return e.apply(t,arguments)}},U=function(e,t,i){var o,s,a,l,u=e&U.F,c=e&U.G,f=e&U.S,h=e&U.P,d=e&U.B,p=c?n:f?n[t]||(n[t]={}):(n[t]||{}).prototype,_=c?r:r[t]||(r[t]={}),m=_.prototype||(_.prototype={});for(o in c&&(i=t),i)a=((s=!u&&p&&void 0!==p[o])?p:i)[o],l=d&&s?F(a,n):h&&"function"==typeof a?F(Function.call,a):a,p&&O(p,o,a,e&U.U),_[o]!=a&&b(_,o,l),h&&m[o]!=a&&(m[o]=a);};n.core=r,U.F=1,U.G=2,U.S=4,U.P=8,U.B=16,U.W=32,U.U=64,U.R=128;var D=U,G=Math.ceil,C=Math.floor,j=function(e){return isNaN(e=+e)?0:(e>0?C:G)(e)},V=Math.min,B=function(e){return e>0?V(j(e),9007199254740991):0},q=Math.max,H=Math.min,X=function(e,t){return (e=j(e))<0?q(e+t,0):H(e,t)},W=function(e){return function(t,r,n){var i,o=N(t),s=B(o.length),a=X(n,s);if(e&&r!=r){for(;s>a;)if((i=o[a++])!=i)return !0}else for(;s>a;a++)if((e||a in o)&&o[a]===r)return e||a||0;return !e&&-1}},Y=i("keys"),Z=function(e){return Y[e]||(Y[e]=a(e))},J=W(!1),K=Z("IE_PROTO"),$=function(e,t){var r,n=N(e),i=0,o=[];for(r in n)r!=K&&L(n,r)&&o.push(r);for(;t.length>i;)L(n,r=t[i++])&&(~J(o,r)||o.push(r));return o},Q="constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(","),ee=Object.keys||function(e){return $(e,Q)},te=h?Object.defineProperties:function(e,t){c(e);for(var r,n=ee(t),i=n.length,o=0;i>o;)y.f(e,r=n[o++],t[r]);return e},re=n.document,ne=re&&re.documentElement,ie=Z("IE_PROTO"),oe=function(){},se=function(){var e,t=_("iframe"),r=Q.length;for(t.style.display="none",ne.appendChild(t),t.src="javascript:",(e=t.contentWindow.document).open(),e.write("<script>document.F=Object<\/script>"),e.close(),se=e.F;r--;)delete se.prototype[Q[r]];return se()},ae=Object.create||function(e,t){var r;return null!==e?(oe.prototype=c(e),r=new oe,oe.prototype=null,r[ie]=e):r=se(),void 0===t?r:te(r,t)},le=y.f,ue=l("toStringTag"),ce=function(e,t,r){e&&!L(e=r?e:e.prototype,ue)&&le(e,ue,{configurable:!0,value:t});},fe={};b(fe,l("iterator"),function(){return this});var he=function(e,t,r){e.prototype=ae(fe,{next:x(1,r)}),ce(e,t+" Iterator");},de=function(e){return Object(P(e))},pe=Z("IE_PROTO"),_e=Object.prototype,me=Object.getPrototypeOf||function(e){return e=de(e),L(e,pe)?e[pe]:"function"==typeof e.constructor&&e instanceof e.constructor?e.constructor.prototype:e instanceof Object?_e:null},ve=l("iterator"),ge=!([].keys&&"next"in[].keys()),ye=function(){return this},xe=function(e,t,r,n,i,o,s){he(r,t,n);var a,l,u,c=function(e){if(!ge&&e in p)return p[e];switch(e){case"keys":case"values":return function(){return new r(this,e)}}return function(){return new r(this,e)}},f=t+" Iterator",h="values"==i,d=!1,p=e.prototype,_=p[ve]||p["@@iterator"]||i&&p[i],m=_||c(i),v=i?h?c("entries"):m:void 0,g="Array"==t&&p.entries||_;if(g&&(u=me(g.call(new e)))!==Object.prototype&&u.next&&(ce(u,f,!0),"function"!=typeof u[ve]&&b(u,ve,ye)),h&&_&&"values"!==_.name&&(d=!0,m=function(){return _.call(this)}),(ge||d||!p[ve])&&b(p,ve,m),R[t]=m,R[f]=ye,i)if(a={values:h?m:c("values"),keys:o?m:c("keys"),entries:v},s)for(l in a)l in p||O(p,l,a[l]);else D(D.P+D.F*(ge||d),t,a);return a},be=xe(Array,"Array",function(e,t){this._t=N(e),this._i=0,this._k=t;},function(){var e=this._t,t=this._k,r=this._i++;return !e||r>=e.length?(this._t=void 0,E(1)):E(0,"keys"==t?r:"values"==t?e[r]:[r,e[r]])},"values");R.Arguments=R.Array,w("keys"),w("values"),w("entries");for(var Ae=l("iterator"),Te=l("toStringTag"),we=R.Array,Ee={CSSRuleList:!0,CSSStyleDeclaration:!1,CSSValueList:!1,ClientRectList:!1,DOMRectList:!1,DOMStringList:!1,DOMTokenList:!0,DataTransferItemList:!1,FileList:!1,HTMLAllCollection:!1,HTMLCollection:!1,HTMLFormElement:!1,HTMLSelectElement:!1,MediaList:!0,MimeTypeArray:!1,NamedNodeMap:!1,NodeList:!0,PaintRequestList:!1,Plugin:!1,PluginArray:!1,SVGLengthList:!1,SVGNumberList:!1,SVGPathSegList:!1,SVGPointList:!1,SVGStringList:!1,SVGTransformList:!1,SourceBufferList:!1,StyleSheetList:!0,TextTrackCueList:!1,TextTrackList:!1,TouchList:!1},Re=ee(Ee),Me=0;Me<Re.length;Me++){var Se,ze=Re[Me],Pe=Ee[ze],Ne=n[ze],ke=Ne&&Ne.prototype;if(ke&&(ke[Ae]||b(ke,Ae,we),ke[Te]||b(ke,Te,ze),R[ze]=we,Pe))for(Se in be)ke[Se]||O(ke,Se,be[Se],!0);}var Le=l("toStringTag"),Oe="Arguments"==S(function(){return arguments}()),Ie=function(e){var t,r,n;return void 0===e?"Undefined":null===e?"Null":"string"==typeof(r=function(e,t){try{return e[t]}catch(e){}}(t=Object(e),Le))?r:Oe?S(t):"Object"==(n=S(t))&&"function"==typeof t.callee?"Arguments":n},Fe={};Fe[l("toStringTag")]="z",Fe+""!="[object z]"&&O(Object.prototype,"toString",function(){return "[object "+Ie(this)+"]"},!0);var Ue={f:{}.propertyIsEnumerable},De=Ue.f,Ge=function(e){return function(t){for(var r,n=N(t),i=ee(n),o=i.length,s=0,a=[];o>s;)De.call(n,r=i[s++])&&a.push(e?[r,n[r]]:n[r]);return a}},Ce=Ge(!0);D(D.S,"Object",{entries:function(e){return Ce(e)}});var je={f:Object.getOwnPropertySymbols},Ve=Object.assign,Be=!Ve||f(function(){var e={},t={},r=Symbol(),n="abcdefghijklmnopqrst";return e[r]=7,n.split("").forEach(function(e){t[e]=e;}),7!=Ve({},e)[r]||Object.keys(Ve({},t)).join("")!=n})?function(e,t){for(var r=de(e),n=arguments.length,i=1,o=je.f,s=Ue.f;n>i;)for(var a,l=z(arguments[i++]),u=o?ee(l).concat(o(l)):ee(l),c=u.length,f=0;c>f;)s.call(l,a=u[f++])&&(r[a]=l[a]);return r}:Ve;D(D.S+D.F,"Object",{assign:Be});var qe={};try{window instanceof Window&&window.document instanceof HTMLDocument&&(qe.is_worker=!1,qe.is_main=!0);}catch(e){qe.is_worker=!0,qe.is_main=!1,self.window={document:{}},self.document=self.window.document;}var He=function(e){return function(t,r){var n,i,o=String(P(t)),s=j(r),a=o.length;return s<0||s>=a?e?"":void 0:(n=o.charCodeAt(s))<55296||n>56319||s+1===a||(i=o.charCodeAt(s+1))<56320||i>57343?e?o.charAt(s):n:e?o.slice(s,s+2):i-56320+(n-55296<<10)+65536}},Xe=He(!0),We=function(e,t,r){return t+(r?Xe(e,t).length:1)},Ye=RegExp.prototype.exec,Ze=function(e,t){var r=e.exec;if("function"==typeof r){var n=r.call(e,t);if("object"!=typeof n)throw new TypeError("RegExp exec method returned something other than an Object or null");return n}if("RegExp"!==Ie(e))throw new TypeError("RegExp#exec called on incompatible receiver");return Ye.call(e,t)},Je=function(){var e=c(this),t="";return e.global&&(t+="g"),e.ignoreCase&&(t+="i"),e.multiline&&(t+="m"),e.unicode&&(t+="u"),e.sticky&&(t+="y"),t},Ke=RegExp.prototype.exec,$e=String.prototype.replace,Qe=Ke,et=function(){var e=/a/,t=/b*/g;return Ke.call(e,"a"),Ke.call(t,"a"),0!==e.lastIndex||0!==t.lastIndex}(),tt=void 0!==/()??/.exec("")[1];(et||tt)&&(Qe=function(e){var t,r,n,i,o=this;return tt&&(r=new RegExp("^"+o.source+"$(?!\\s)",Je.call(o))),et&&(t=o.lastIndex),n=Ke.call(o,e),et&&n&&(o.lastIndex=o.global?n.index+n[0].length:t),tt&&n&&n.length>1&&$e.call(n[0],r,function(){for(i=1;i<arguments.length-2;i++)void 0===arguments[i]&&(n[i]=void 0);}),n});var rt=Qe;D({target:"RegExp",proto:!0,forced:rt!==/./.exec},{exec:rt});var nt=l("species"),it=!f(function(){var e=/./;return e.exec=function(){var e=[];return e.groups={a:"7"},e},"7"!=="".replace(e,"$<a>")}),ot=function(){var e=/(?:)/,t=e.exec;e.exec=function(){return t.apply(this,arguments)};var r="ab".split(e);return 2===r.length&&"a"===r[0]&&"b"===r[1]}(),st=function(e,t,r){var n=l(e),i=!f(function(){var t={};return t[n]=function(){return 7},7!=""[e](t)}),o=i?!f(function(){var t=!1,r=/a/;return r.exec=function(){return t=!0,null},"split"===e&&(r.constructor={},r.constructor[nt]=function(){return r}),r[n](""),!t}):void 0;if(!i||!o||"replace"===e&&!it||"split"===e&&!ot){var s=/./[n],a=r(P,n,""[e],function(e,t,r,n,o){return t.exec===rt?i&&!o?{done:!0,value:s.call(t,r,n)}:{done:!0,value:e.call(r,t,n)}:{done:!1}}),u=a[0],c=a[1];O(String.prototype,e,u),b(RegExp.prototype,n,2==t?function(e,t){return c.call(e,this,t)}:function(e){return c.call(e,this)});}},at=Math.max,lt=Math.min,ut=Math.floor,ct=/\$([$&`']|\d\d?|<[^>]*>)/g,ft=/\$([$&`']|\d\d?)/g;function ht(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n);}}function dt(e,t,r){return t&&ht(e.prototype,t),r&&ht(e,r),e}function pt(e,t){e.prototype=Object.create(t.prototype),e.prototype.constructor=e,e.__proto__=t;}function _t(e){return (_t=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}function mt(e,t){return (mt=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}function vt(e,t,r){return (vt=function(){if("undefined"==typeof Reflect||!Reflect.construct)return !1;if(Reflect.construct.sham)return !1;if("function"==typeof Proxy)return !0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],function(){})),!0}catch(e){return !1}}()?Reflect.construct:function(e,t,r){var n=[null];n.push.apply(n,t);var i=new(Function.bind.apply(e,n));return r&&mt(i,r.prototype),i}).apply(null,arguments)}function gt(e){var t="function"==typeof Map?new Map:void 0;return (gt=function(e){if(null===e||(r=e,-1===Function.toString.call(r).indexOf("[native code]")))return e;var r;if("function"!=typeof e)throw new TypeError("Super expression must either be null or a function");if(void 0!==t){if(t.has(e))return t.get(e);t.set(e,n);}function n(){return vt(e,arguments,_t(this).constructor)}return n.prototype=Object.create(e.prototype,{constructor:{value:n,enumerable:!1,writable:!0,configurable:!0}}),mt(n,e)})(e)}function yt(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function xt(e,t){var r;if("undefined"==typeof Symbol||null==e[Symbol.iterator]){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return yt(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return "Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?yt(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0;return function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}return (r=e[Symbol.iterator]()).next.bind(r)}st("replace",2,function(e,t,r,n){return [function(n,i){var o=e(this),s=null==n?void 0:n[t];return void 0!==s?s.call(n,o,i):r.call(String(o),n,i)},function(e,t){var o=n(r,e,this,t);if(o.done)return o.value;var s=c(e),a=String(this),l="function"==typeof t;l||(t=String(t));var u=s.global;if(u){var f=s.unicode;s.lastIndex=0;}for(var h=[];;){var d=Ze(s,a);if(null===d)break;if(h.push(d),!u)break;""===String(d[0])&&(s.lastIndex=We(a,B(s.lastIndex),f));}for(var p,_="",m=0,v=0;v<h.length;v++){d=h[v];for(var g=String(d[0]),y=at(lt(j(d.index),a.length),0),x=[],b=1;b<d.length;b++)x.push(void 0===(p=d[b])?p:String(p));var A=d.groups;if(l){var T=[g].concat(x,y,a);void 0!==A&&T.push(A);var w=String(t.apply(void 0,T));}else w=i(g,a,y,x,A,t);y>=m&&(_+=a.slice(m,y)+w,m=y+g.length);}return _+a.slice(m)}];function i(e,t,n,i,o,s){var a=n+e.length,l=i.length,u=ft;return void 0!==o&&(o=de(o),u=ct),r.call(s,u,function(r,s){var u;switch(s.charAt(0)){case"$":return "$";case"&":return e;case"`":return t.slice(0,n);case"'":return t.slice(a);case"<":u=o[s.slice(1,-1)];break;default:var c=+s;if(0===c)return r;if(c>l){var f=ut(c/10);return 0===f?r:f<=l?void 0===i[f-1]?s.charAt(1):i[f-1]+s.charAt(1):r}u=i[c-1];}return void 0===u?"":u})}});var bt=He(!0);xe(String,"String",function(e){this._t=String(e),this._i=0;},function(){var e,t=this._t,r=this._i;return r>=t.length?{value:void 0,done:!0}:(e=bt(t,r),this._i+=e.length,{value:e,done:!1})});var At,Tt,wt,Et=function(e,t,r,n){if(!(e instanceof t)||void 0!==n&&n in e)throw TypeError(r+": incorrect invocation!");return e},Rt=function(e,t,r,n){try{return n?t(c(r)[0],r[1]):t(r)}catch(t){var i=e.return;throw void 0!==i&&c(i.call(e)),t}},Mt=l("iterator"),St=Array.prototype,zt=function(e){return void 0!==e&&(R.Array===e||St[Mt]===e)},Pt=l("iterator"),Nt=r.getIteratorMethod=function(e){if(null!=e)return e[Pt]||e["@@iterator"]||R[Ie(e)]},kt=t(function(e){var t={},r={},n=e.exports=function(e,n,i,o,s){var a,l,u,f,h=s?function(){return e}:Nt(e),d=F(i,o,n?2:1),p=0;if("function"!=typeof h)throw TypeError(e+" is not iterable!");if(zt(h)){for(a=B(e.length);a>p;p++)if((f=n?d(c(l=e[p])[0],l[1]):d(e[p]))===t||f===r)return f}else for(u=h.call(e);!(l=u.next()).done;)if((f=Rt(u,d,l.value,n))===t||f===r)return f};n.BREAK=t,n.RETURN=r;}),Lt=l("species"),Ot=function(e,t){var r,n=c(e).constructor;return void 0===n||null==(r=c(n)[Lt])?t:I(r)},It=n.process,Ft=n.setImmediate,Ut=n.clearImmediate,Dt=n.MessageChannel,Gt=n.Dispatch,Ct=0,jt={},Vt=function(){var e=+this;if(jt.hasOwnProperty(e)){var t=jt[e];delete jt[e],t();}},Bt=function(e){Vt.call(e.data);};Ft&&Ut||(Ft=function(e){for(var t=[],r=1;arguments.length>r;)t.push(arguments[r++]);return jt[++Ct]=function(){!function(e,t,r){var n=void 0===r;switch(t.length){case 0:return n?e():e.call(r);case 1:return n?e(t[0]):e.call(r,t[0]);case 2:return n?e(t[0],t[1]):e.call(r,t[0],t[1]);case 3:return n?e(t[0],t[1],t[2]):e.call(r,t[0],t[1],t[2]);case 4:return n?e(t[0],t[1],t[2],t[3]):e.call(r,t[0],t[1],t[2],t[3])}e.apply(r,t);}("function"==typeof e?e:Function(e),t);},At(Ct),Ct},Ut=function(e){delete jt[e];},"process"==S(It)?At=function(e){It.nextTick(F(Vt,e,1));}:Gt&&Gt.now?At=function(e){Gt.now(F(Vt,e,1));}:Dt?(wt=(Tt=new Dt).port2,Tt.port1.onmessage=Bt,At=F(wt.postMessage,wt,1)):n.addEventListener&&"function"==typeof postMessage&&!n.importScripts?(At=function(e){n.postMessage(e+"","*");},n.addEventListener("message",Bt,!1)):At="onreadystatechange"in _("script")?function(e){ne.appendChild(_("script")).onreadystatechange=function(){ne.removeChild(this),Vt.call(e);};}:function(e){setTimeout(F(Vt,e,1),0);});var qt={set:Ft,clear:Ut},Ht=qt.set,Xt=n.MutationObserver||n.WebKitMutationObserver,Wt=n.process,Yt=n.Promise,Zt="process"==S(Wt);function Jt(e){var t,r;this.promise=new e(function(e,n){if(void 0!==t||void 0!==r)throw TypeError("Bad Promise constructor");t=e,r=n;}),this.resolve=I(t),this.reject=I(r);}var Kt={f:function(e){return new Jt(e)}},$t=function(e){try{return {e:!1,v:e()}}catch(e){return {e:!0,v:e}}},Qt=n.navigator,er=Qt&&Qt.userAgent||"",tr=function(e,t,r){for(var n in t)O(e,n,t[n],r);return e},rr=l("species"),nr=function(e){var t=n[e];h&&t&&!t[rr]&&y.f(t,rr,{configurable:!0,get:function(){return this}});},ir=l("iterator"),or=!1;try{var sr=[7][ir]();sr.return=function(){or=!0;},Array.from(sr,function(){throw 2});}catch(e){}var ar,lr,ur,cr,fr=function(e,t){if(!t&&!or)return !1;var r=!1;try{var n=[7],i=n[ir]();i.next=function(){return {done:r=!0}},n[ir]=function(){return i},e(n);}catch(e){}return r},hr=qt.set,dr=function(){var e,t,r,i=function(){var n,i;for(Zt&&(n=Wt.domain)&&n.exit();e;){i=e.fn,e=e.next;try{i();}catch(n){throw e?r():t=void 0,n}}t=void 0,n&&n.enter();};if(Zt)r=function(){Wt.nextTick(i);};else if(!Xt||n.navigator&&n.navigator.standalone)if(Yt&&Yt.resolve){var o=Yt.resolve(void 0);r=function(){o.then(i);};}else r=function(){Ht.call(n,i);};else {var s=!0,a=document.createTextNode("");new Xt(i).observe(a,{characterData:!0}),r=function(){a.data=s=!s;};}return function(n){var i={fn:n,next:void 0};t&&(t.next=i),e||(e=i,r()),t=i;}}(),pr=n.TypeError,_r=n.process,mr=_r&&_r.versions,vr=mr&&mr.v8||"",gr=n.Promise,yr="process"==Ie(_r),xr=function(){},br=lr=Kt.f,Ar=!!function(){try{var e=gr.resolve(1),t=(e.constructor={})[l("species")]=function(e){e(xr,xr);};return (yr||"function"==typeof PromiseRejectionEvent)&&e.then(xr)instanceof t&&0!==vr.indexOf("6.6")&&-1===er.indexOf("Chrome/66")}catch(e){}}(),Tr=function(e){var t;return !(!u(e)||"function"!=typeof(t=e.then))&&t},wr=function(e,t){if(!e._n){e._n=!0;var r=e._c;dr(function(){for(var n=e._v,i=1==e._s,o=0,s=function(t){var r,o,s,a=i?t.ok:t.fail,l=t.resolve,u=t.reject,c=t.domain;try{a?(i||(2==e._h&&Mr(e),e._h=1),!0===a?r=n:(c&&c.enter(),r=a(n),c&&(c.exit(),s=!0)),r===t.promise?u(pr("Promise-chain cycle")):(o=Tr(r))?o.call(r,l,u):l(r)):u(n);}catch(e){c&&!s&&c.exit(),u(e);}};r.length>o;)s(r[o++]);e._c=[],e._n=!1,t&&!e._h&&Er(e);});}},Er=function(e){hr.call(n,function(){var t,r,i,o=e._v,s=Rr(e);if(s&&(t=$t(function(){yr?_r.emit("unhandledRejection",o,e):(r=n.onunhandledrejection)?r({promise:e,reason:o}):(i=n.console)&&i.error&&i.error("Unhandled promise rejection",o);}),e._h=yr||Rr(e)?2:1),e._a=void 0,s&&t.e)throw t.v});},Rr=function(e){return 1!==e._h&&0===(e._a||e._c).length},Mr=function(e){hr.call(n,function(){var t;yr?_r.emit("rejectionHandled",e):(t=n.onrejectionhandled)&&t({promise:e,reason:e._v});});},Sr=function(e){var t=this;t._d||(t._d=!0,(t=t._w||t)._v=e,t._s=2,t._a||(t._a=t._c.slice()),wr(t,!0));},zr=function(e){var t,r=this;if(!r._d){r._d=!0,r=r._w||r;try{if(r===e)throw pr("Promise can't be resolved itself");(t=Tr(e))?dr(function(){var n={_w:r,_d:!1};try{t.call(e,F(zr,n,1),F(Sr,n,1));}catch(e){Sr.call(n,e);}}):(r._v=e,r._s=1,wr(r,!1));}catch(e){Sr.call({_w:r,_d:!1},e);}}};Ar||(gr=function(e){Et(this,gr,"Promise","_h"),I(e),ar.call(this);try{e(F(zr,this,1),F(Sr,this,1));}catch(e){Sr.call(this,e);}},(ar=function(e){this._c=[],this._a=void 0,this._s=0,this._d=!1,this._v=void 0,this._h=0,this._n=!1;}).prototype=tr(gr.prototype,{then:function(e,t){var r=br(Ot(this,gr));return r.ok="function"!=typeof e||e,r.fail="function"==typeof t&&t,r.domain=yr?_r.domain:void 0,this._c.push(r),this._a&&this._a.push(r),this._s&&wr(this,!1),r.promise},catch:function(e){return this.then(void 0,e)}}),ur=function(){var e=new ar;this.promise=e,this.resolve=F(zr,e,1),this.reject=F(Sr,e,1);},Kt.f=br=function(e){return e===gr||e===cr?new ur(e):lr(e)}),D(D.G+D.W+D.F*!Ar,{Promise:gr}),ce(gr,"Promise"),nr("Promise"),cr=r.Promise,D(D.S+D.F*!Ar,"Promise",{reject:function(e){var t=br(this);return (0,t.reject)(e),t.promise}}),D(D.S+D.F*!Ar,"Promise",{resolve:function(e){return function(e,t){if(c(e),u(t)&&t.constructor===e)return t;var r=Kt.f(e);return (0,r.resolve)(t),r.promise}(this,e)}}),D(D.S+D.F*!(Ar&&fr(function(e){gr.all(e).catch(xr);})),"Promise",{all:function(e){var t=this,r=br(t),n=r.resolve,i=r.reject,o=$t(function(){var r=[],o=0,s=1;kt(e,!1,function(e){var a=o++,l=!1;r.push(void 0),s++,t.resolve(e).then(function(e){l||(l=!0,r[a]=e,--s||n(r));},i);}),--s||n(r);});return o.e&&i(o.v),r.promise},race:function(e){var t=this,r=br(t),n=r.reject,i=$t(function(){kt(e,!1,function(e){t.resolve(e).then(r.resolve,n);});});return i.e&&n(i.v),r.promise}});var Pr=y.f,Nr=Function.prototype,kr=/^\s*function ([^ (]*)/;"name"in Nr||h&&Pr(Nr,"name",{configurable:!0,get:function(){try{return (""+this).match(kr)[1]}catch(e){return ""}}});var Lr=function(e,t){var n=(r.Object||{})[e]||Object[e],i={};i[e]=t(n),D(D.S+D.F*f(function(){n(1);}),"Object",i);};Lr("keys",function(){return function(e){return ee(de(e))}});var Or,Ir="v0.21.1",Fr=l("match"),Ur=function(e){var t;return u(e)&&(void 0!==(t=e[Fr])?!!t:"RegExp"==S(e))},Dr=Math.min,Gr=[].push,Cr=!f(function(){RegExp(4294967295,"y");});st("split",2,function(e,t,r,n){var i;return i="c"=="abbc".split(/(b)*/)[1]||4!="test".split(/(?:)/,-1).length||2!="ab".split(/(?:ab)*/).length||4!=".".split(/(.?)(.?)/).length||".".split(/()()/).length>1||"".split(/.?/).length?function(e,t){var n=String(this);if(void 0===e&&0===t)return [];if(!Ur(e))return r.call(n,e,t);for(var i,o,s,a=[],l=(e.ignoreCase?"i":"")+(e.multiline?"m":"")+(e.unicode?"u":"")+(e.sticky?"y":""),u=0,c=void 0===t?4294967295:t>>>0,f=new RegExp(e.source,l+"g");(i=rt.call(f,n))&&!((o=f.lastIndex)>u&&(a.push(n.slice(u,i.index)),i.length>1&&i.index<n.length&&Gr.apply(a,i.slice(1)),s=i[0].length,u=o,a.length>=c));)f.lastIndex===i.index&&f.lastIndex++;return u===n.length?!s&&f.test("")||a.push(""):a.push(n.slice(u)),a.length>c?a.slice(0,c):a}:"0".split(void 0,0).length?function(e,t){return void 0===e&&0===t?[]:r.call(this,e,t)}:r,[function(r,n){var o=e(this),s=null==r?void 0:r[t];return void 0!==s?s.call(r,o,n):i.call(String(o),r,n)},function(e,t){var o=n(i,e,this,t,i!==r);if(o.done)return o.value;var s=c(e),a=String(this),l=Ot(s,RegExp),u=s.unicode,f=(s.ignoreCase?"i":"")+(s.multiline?"m":"")+(s.unicode?"u":"")+(Cr?"y":"g"),h=new l(Cr?s:"^(?:"+s.source+")",f),d=void 0===t?4294967295:t>>>0;if(0===d)return [];if(0===a.length)return null===Ze(h,a)?[a]:[];for(var p=0,_=0,m=[];_<a.length;){h.lastIndex=Cr?_:0;var v,g=Ze(h,Cr?a:a.slice(_));if(null===g||(v=Dr(B(h.lastIndex+(Cr?0:_)),a.length))===p)_=We(a,_,u);else {if(m.push(a.slice(p,_)),m.length===d)return m;for(var y=1;y<=g.length-1;y++)if(m.push(g[y]),m.length===d)return m;_=p=v;}}return m.push(a.slice(p)),m}]});var jr=Or={},Vr=0,Br={};function qr(e){var t=[];"string"==typeof e&&(t=e.split("."),e=t.pop());for(var r=Or.targets,n=0;n<t.length;n++){if(!r[t[n]])return [];r=r[t[n]];}return [e,r]}function Hr(e){Array.isArray(e)&&e.filter(function(e){return e.parent&&e.property}).forEach(function(e){return delete e.parent[e.property]});}Or.targets={},Or.addTarget=function(e,t){Or.targets[e]=t;},Or.removeTarget=function(e){e&&delete Or.targets[e];},Or.withTransferables=function(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];if(!(this instanceof Or.withTransferables))return vt(Or.withTransferables,t);this.value=t,this.transferables=function e(t,r,n,i){void 0===r&&(r=null);void 0===n&&(n=null);void 0===i&&(i=[]);if(!t)return i;if(Array.isArray(t))t.forEach(function(r,n){return e(r,t,n,i)});else if("object"==typeof t)if(t instanceof ArrayBuffer)i.push({object:t,parent:r,property:n});else if(t.buffer instanceof ArrayBuffer)i.push({object:t.buffer,parent:r,property:n});else for(var o in t)e(t[o],t,o,i);return i}(this.value);},qe.is_main&&(Or.postMessage=function(e,t){for(var r=arguments.length,n=new Array(r>2?r-2:0),i=2;i<r;i++)n[i-2]=arguments[i];if(Array.isArray(e))return Promise.all(e.map(function(e){var r;return (r=Or).postMessage.apply(r,[e,t].concat(n))}));var o={};"object"==typeof t&&(o=t,t=t.method);var s,a=new Promise(function(e,r){Br[Vr]={method:t,message:n,resolve:e,reject:r};}),l=[];return n&&1===n.length&&n[0]instanceof Or.withTransferables&&(l=n[0].transferables,n=n[0].value),s={type:"main_send",message_id:Vr,method:t,message:n},o.stringify&&(s=JSON.stringify(s)),e.postMessage(s,l.map(function(e){return e.object})),Hr(l),l.length>0&&Zr("trace","'"+t+"' transferred "+l.length+" objects to worker thread"),Vr++,a},Or.addWorker=function(e){if(!(e instanceof Worker))throw Error("Worker broker could not add non-Worker object",e);e.addEventListener("message",function(t){var r="string"==typeof t.data?JSON.parse(t.data):t.data,n=r.message_id;if("worker_reply"===r.type)Br[n]&&(r.error?Br[n].reject(r.error):Br[n].resolve(r.message),delete Br[n]);else if("worker_send"===r.type&&null!=n){var i,o,s,a,l;try{var u=qr(r.method);if(a=u[0],!(s=u[1]))throw Error("Worker broker could not dispatch message type "+r.method+" on target "+r.target+" because no object with that name is registered on main thread");if(!(l="function"==typeof s[a]&&s[a]))throw Error("Worker broker could not dispatch message type "+r.method+" on target "+r.target+" because object has no method with that name");i=l.apply(s,r.message);}catch(e){o=e;}var c,f=[];i instanceof Promise?i.then(function(t){t instanceof Or.withTransferables&&(f=t.transferables,t=t.value[0]),c={type:"main_reply",message_id:n,message:t},e.postMessage(c,f.map(function(e){return e.object})),Hr(f),f.length>0&&Zr("trace","'"+a+"' transferred "+f.length+" objects to worker thread");},function(t){e.postMessage({type:"main_reply",message_id:n,error:t instanceof Error?t.message+": "+t.stack:t});}):(i instanceof Or.withTransferables&&(f=i.transferables,i=i.value[0]),c={type:"main_reply",message_id:n,message:i,error:o instanceof Error?o.message+": "+o.stack:o},e.postMessage(c,f.map(function(e){return e.object})),Hr(f),f.length>0&&Zr("trace","'"+a+"' transferred "+f.length+" objects to worker thread"));}});},Or.getMessages=function(){return Br},Or.getMessageId=function(){return Vr}),qe.is_worker&&(Or.postMessage=function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];var i={};"object"==typeof e&&(i=e,e=e.method);var o,s=new Promise(function(t,n){Br[Vr]={method:e,message:r,resolve:t,reject:n};}),a=[];return r&&1===r.length&&r[0]instanceof Or.withTransferables&&(a=r[0].transferables,r=r[0].value),o={type:"worker_send",message_id:Vr,method:e,message:r},i.stringify&&(o=JSON.stringify(o)),self.postMessage(o,a.map(function(e){return e.object})),Hr(a),a.length>0&&Zr("trace","'"+e+"' transferred "+a.length+" objects to main thread"),Vr++,s},self.addEventListener("message",function(e){var t="string"==typeof e.data?JSON.parse(e.data):e.data,r=t.message_id;if("main_reply"===t.type)Br[r]&&(t.error?Br[r].reject(t.error):Br[r].resolve(t.message),delete Br[r]);else if("main_send"===t.type&&null!=r){var n,i,o,s,a;try{var l=qr(t.method);if(s=l[0],!(o=l[1]))throw Error("Worker broker could not dispatch message type "+t.method+" on target "+t.target+" because no object with that name is registered on main thread");if(!(a="function"==typeof o[s]&&o[s]))throw Error("Worker broker could not dispatch message type "+t.method+" because worker has no method with that name");n=a.apply(o,t.message);}catch(e){i=e;}var u,c=[];n instanceof Promise?n.then(function(e){e instanceof Or.withTransferables&&(c=e.transferables,e=e.value[0]),u={type:"worker_reply",message_id:r,message:e},self.postMessage(u,c.map(function(e){return e.object})),Hr(c),c.length>0&&Zr("trace","'"+s+"' transferred "+c.length+" objects to main thread");},function(e){self.postMessage({type:"worker_reply",message_id:r,error:e instanceof Error?e.message+": "+e.stack:e});}):(n instanceof Or.withTransferables&&(c=n.transferables,n=n.value[0]),u={type:"worker_reply",message_id:r,message:n,error:i instanceof Error?i.message+": "+i.stack:i},self.postMessage(u,c.map(function(e){return e.object})),Hr(c),c.length>0&&Zr("trace","'"+s+"' transferred "+c.length+" objects to main thread"));}}));var Xr={silent:-1,error:0,warn:1,info:2,debug:3,trace:4},Wr={},Yr={};function Zr(e){var t="object"==typeof e?e.level:e;if(Xr[t]<=Xr[Zr.level]){for(var r=arguments.length,n=new Array(r>1?r-1:0),i=1;i<r;i++)n[i-1]=arguments[i];if(qe.is_worker)return jr.postMessage.apply(jr,[{method:"_logProxy",stringify:!0},e].concat(n));if("object"==typeof e&&!0===e.once){if(Yr[JSON.stringify(n)])return Promise.resolve(!1);Yr[JSON.stringify(n)]=!0;}var o=function(e){if(qe.is_main)return Wr[e]=Wr[e]||(console[e]?console[e]:console.log).bind(console),Wr[e]}(t);return n.length>1?o.apply(void 0,["Tangram "+Ir+" ["+t+"]: "+n[0]].concat(n.slice(1))):o("Tangram "+Ir+" ["+t+"]: "+n[0]),Promise.resolve(!0)}return Promise.resolve(!1)}Zr.level="info",Zr.workers=null,Zr.setLevel=function(e){Zr.level=e,qe.is_main&&Array.isArray(Zr.workers)&&jr.postMessage(Zr.workers,"_logSetLevelProxy",e);},qe.is_main&&(Zr.setWorkers=function(e){Zr.workers=e;},Zr.reset=function(){Yr={};}),jr.addTarget("_logProxy",Zr),jr.addTarget("_logSetLevelProxy",Zr.setLevel),h&&"g"!=/./g.flags&&y.f(RegExp.prototype,"flags",{configurable:!0,get:Je});var Jr=/./.toString,Kr=function(e){O(RegExp.prototype,"toString",e,!0);};f(function(){return "/a/b"!=Jr.call({source:"a",flags:"b"})})?Kr(function(){var e=c(this);return "/".concat(e.source,"/","flags"in e?e.flags:!h&&e instanceof RegExp?Je.call(e):void 0)}):"toString"!=Jr.name&&Kr(function(){return Jr.call(this)});var $r,Qr={};jr.addTarget("Utils",Qr),Qr.isSafari=function(){return /^((?!chrome|android).)*safari/i.test(navigator.userAgent)},Qr.isMicrosoft=function(){return /(Trident\/7.0|Edge[ \/](\d+[.\d]+))/i.test(navigator.userAgent)},Qr._requests={},Qr._proxy_requests={},Qr.io=function(e,t,r,n,i,o,s){if(void 0===t&&(t=6e4),void 0===r&&(r="text"),void 0===n&&(n="GET"),void 0===i&&(i={}),void 0===o&&(o=null),void 0===s&&(s=!1),qe.is_worker&&Qr.isMicrosoft())return Zr("debug","Proxying request for URL to worker",e),o&&(Qr._proxy_requests[o]=!0),jr.postMessage("Utils.io",e,t,r,n,i,o,!0);var a=new XMLHttpRequest,l=new Promise(function(o,s){if(a.open(n,e,!0),a.timeout=t,a.responseType=r,i&&"object"==typeof i)for(var l in i)a.setRequestHeader(l,i[l]);a.onload=function(){200===a.status?["text","json"].indexOf(a.responseType)>-1?o({body:a.responseText,status:a.status}):o({body:a.response,status:a.status}):204===a.status?o({body:null,status:a.status}):s(Error("Request error with a status of "+a.statusText));},a.onerror=function(e){s(Error("There was a network error"+e.toString()));},a.ontimeout=function(e){s(Error("timeout "+e.toString()));},a.send();});return l=l.then(function(e){return o&&delete Qr._requests[o],s?jr.withTransferables(e):e}),o&&(Qr._requests[o]=a),l},Qr.cancelRequest=function(e){if(qe.is_worker&&Qr._proxy_requests[e])return jr.postMessage("Utils.cancelRequest",e);Qr._requests[e]?(Zr("trace","Cancelling network request key '"+e+"'"),Qr._requests[e].abort(),delete Qr._requests[e]):Zr("trace","Could not find network request key '"+e+"'");},Qr.serializeWithFunctions=function(e){return "function"==typeof e?e.toString():JSON.stringify(e,function(e,t){return "function"==typeof t?t.toString():t})},Qr.use_high_density_display=!0,Qr.updateDevicePixelRatio=function(){var e=Qr.device_pixel_ratio;return Qr.device_pixel_ratio=Qr.use_high_density_display&&window.devicePixelRatio||1,Qr.device_pixel_ratio!==e},qe.is_main&&Qr.updateDevicePixelRatio(),Qr.isPowerOf2=function(e){return 0==(e&e-1)},Qr.interpolate=function(e,t,r){if(!Array.isArray(t)||!Array.isArray(t[0]))return t;if(t.length<1)return t;var n,i,o,s,a;if(e<=t[0][0])s=t[0][1],"function"==typeof r&&(s=r(s));else if(e>=t[t.length-1][0])s=t[t.length-1][1],"function"==typeof r&&(s=r(s));else for(var l=0;l<t.length-1;l++)if(e>=t[l][0]&&e<t[l+1][0]){if(n=t[l][0],i=t[l+1][0],Array.isArray(t[l][1])){s=[];for(var u=0;u<t[l][1].length;u++)"function"==typeof r?(a=r(t[l][1][u]),o=r(t[l+1][1][u])-a,s[u]=o*(e-n)/(i-n)+a):(o=t[l+1][1][u]-t[l][1][u],s[u]=o*(e-n)/(i-n)+t[l][1][u]);}else "function"==typeof r?(a=r(t[l][1]),s=(o=r(t[l+1][1])-a)*(e-n)/(i-n)+a):s=(o=t[l+1][1]-t[l][1])*(e-n)/(i-n)+t[l][1];break}return s},Qr.toCSSColor=function(e){if(null!=e)return 1===e[3]?"rgb("+e.slice(0,3).map(function(e){return Math.round(255*e)}).join(", ")+")":"rgba("+e.map(function(e,t){return t<3&&Math.round(255*e)||e}).join(", ")+")"};var en=$r={draw_label_collision_boxes:!1,draw_label_texture_boxes:!1,suppress_label_fade_in:!1,suppress_label_snap_animation:!1,show_hidden_labels:!1,layer_stats:!1,wireframe:!1};var tn=Object.getOwnPropertyDescriptor,rn={f:h?tn:function(e,t){if(e=N(e),t=v(t,!0),m)try{return tn(e,t)}catch(e){}if(L(e,t))return x(!Ue.f.call(e,t),e[t])}},nn=function(e,t){if(c(e),!u(t)&&null!==t)throw TypeError(t+": can't set as prototype!")},on={set:Object.setPrototypeOf||("__proto__"in{}?function(e,t,r){try{(r=F(Function.call,rn.f(Object.prototype,"__proto__").set,2))(e,[]),t=!(e instanceof Array);}catch(e){t=!0;}return function(e,n){return nn(e,n),t?e.__proto__=n:r(e,n),e}}({},!1):void 0),check:nn}.set,sn=function(e,t,r){var n,i=t.constructor;return i!==r&&"function"==typeof i&&(n=i.prototype)!==r.prototype&&u(n)&&on&&on(e,n),e},an=Q.concat("length","prototype"),ln={f:Object.getOwnPropertyNames||function(e){return $(e,an)}},un=y.f,cn=ln.f,fn=n.RegExp,hn=fn,dn=fn.prototype,pn=/a/g,_n=/a/g,mn=new fn(pn)!==pn;if(h&&(!mn||f(function(){return _n[l("match")]=!1,fn(pn)!=pn||fn(_n)==_n||"/a/i"!=fn(pn,"i")}))){fn=function(e,t){var r=this instanceof fn,n=Ur(e),i=void 0===t;return !r&&n&&e.constructor===fn&&i?e:sn(mn?new hn(n&&!i?e.source:e,t):hn((n=e instanceof fn)?e.source:e,n&&i?Je.call(e):t),r?this:dn,fn)};for(var vn=function(e){e in fn||un(fn,e,{configurable:!0,get:function(){return hn[e]},set:function(t){hn[e]=t;}});},gn=cn(hn),yn=0;gn.length>yn;)vn(gn[yn++]);dn.constructor=fn,fn.prototype=dn,O(n,"RegExp",fn);}nr("RegExp");var xn,bn=Object.is||function(e,t){return e===t?0!==e||1/e==1/t:e!=e&&t!=t};function An(e){if("string"==typeof e&&-1===e.search(/^(data|blob):/)){var t=e.indexOf("?");t>-1&&(e=e.substr(0,t));var r=e.indexOf("#");return r>-1&&(e=e.substr(0,r)),e.substr(0,e.lastIndexOf("/")+1)||""}return ""}function Tn(e){if("string"==typeof e)return !(e.search(/^(http|https|data|blob):/)>-1||"//"===e.substr(0,2))}function wn(e,t){e=e.replace(/[[]/,"\\[").replace(/[\]]/,"\\]");var r=new RegExp("[\\?&]"+e+"=([^&#]*)").exec(t);return null===r?"":decodeURIComponent(r[1].replace(/\+/g," "))}st("search",1,function(e,t,r,n){return [function(r){var n=e(this),i=null==r?void 0:r[t];return void 0!==i?i.call(r,n):new RegExp(r)[t](String(n))},function(e){var t=n(r,e,this);if(t.done)return t.value;var i=c(e),o=String(this),s=i.lastIndex;bn(s,0)||(i.lastIndex=0);var a=Ze(i,o);return bn(i.lastIndex,s)||(i.lastIndex=s),null===a?-1:a.index}]});var En={id:0,queue:[],max_time:20,start_time:null,state:{},add:function(e){e.id=En.id++,e.max_time=e.max_time||En.max_time,e.pause_factor=e.pause_factor||1;var t=new Promise(function(t,r){e.resolve=t,e.reject=r;});return e.promise=t,e.elapsed=0,e.total_elapsed=0,e.stats={calls:0},this.queue.push(e),this.start_time=this.start_time||performance.now(),this.elapsed=performance.now()-this.start_time,(this.elapsed<En.max_time||e.immediate)&&this.process(e),e.promise},remove:function(e){var t=this.queue.indexOf(e);t>-1&&this.queue.splice(t,1);},process:function(e){if(!this.state.user_moving_view||!1!==e.user_moving_view)return e.pause?(e.pause--,!0):(e.stats.calls++,e.start_time=performance.now(),e.run(e))},processAll:function(){this.start_time=this.start_time||performance.now();for(var e=0;e<this.queue.length;e++){var t=this.queue[e];if(!0!==this.process(t)&&(t.pause||(t.pause=t.elapsed>t.max_time?t.pause_factor:0),t.total_elapsed+=t.elapsed),this.elapsed=performance.now()-this.start_time,this.elapsed>=En.max_time){this.start_time=null;break}}},finish:function(e,t){return e.elapsed=performance.now()-e.start_time,e.total_elapsed+=e.elapsed,this.remove(e),e.resolve(t),e.promise},cancel:function(e){var t;e.cancel instanceof Function&&(t=e.cancel(e)),e.resolve(t);},shouldContinue:function(e){return e.elapsed=performance.now()-e.start_time,this.elapsed=performance.now()-this.start_time,e.elapsed<e.max_time&&this.elapsed<En.max_time},removeForTile:function(e){for(var t=this.queue.length-1;t>=0;t--)this.queue[t].tile_id===e&&(this.cancel(this.queue[t]),this.queue.splice(t,1));},setState:function(e){this.state=e;}};function Rn(e){var t=[];return Object.assign(e,{subscribe:function(e){-1===t.indexOf(e)&&t.push(e);},unsubscribe:function(e){var r=t.indexOf(e);r>-1&&t.splice(r,1);},unsubscribeAll:function(){t=[];},trigger:function(e){for(var r=arguments.length,n=new Array(r>1?r-1:0),i=1;i<r;i++)n[i-1]=arguments[i];t.forEach(function(t){if("function"==typeof t[e])try{t[e].apply(t,n);}catch(t){Zr("warn","Caught exception in listener for event '"+e+"':",t);}});},hasSubscribersFor:function(e){var r=!1;return t.forEach(function(t){"function"==typeof t[e]&&(r=!0);}),r}})}function Mn(e,t){var r={};return t.forEach(function(t){return r[t]=e[t]}),r}D(D.P,"String",{repeat:function(e){var t=String(P(this)),r="",n=j(e);if(n<0||n==1/0)throw RangeError("Count can't be negative");for(;n>0;(n>>>=1)&&(t+=t))1&n&&(r+=t);return r}});for(var Sn,zn=a("typed_array"),Pn=a("view"),Nn=!(!n.ArrayBuffer||!n.DataView),kn=Nn,Ln=0,On="Int8Array,Uint8Array,Uint8ClampedArray,Int16Array,Uint16Array,Int32Array,Uint32Array,Float32Array,Float64Array".split(",");Ln<9;)(Sn=n[On[Ln++]])?(b(Sn.prototype,zn,!0),b(Sn.prototype,Pn,!0)):kn=!1;var In={ABV:Nn,CONSTR:kn,TYPED:zn,VIEW:Pn},Fn=function(e){if(void 0===e)return 0;var t=j(e),r=B(t);if(t!==r)throw RangeError("Wrong length!");return r},Un=function(e){for(var t=de(this),r=B(t.length),n=arguments.length,i=X(n>1?arguments[1]:void 0,r),o=n>2?arguments[2]:void 0,s=void 0===o?r:X(o,r);s>i;)t[i++]=e;return t},Dn=t(function(e,t){var r=ln.f,i=y.f,o="prototype",s="Wrong index!",a=n.ArrayBuffer,l=n.DataView,u=n.Math,c=n.RangeError,d=n.Infinity,p=a,_=u.abs,m=u.pow,v=u.floor,g=u.log,x=u.LN2,A=h?"_b":"buffer",T=h?"_l":"byteLength",w=h?"_o":"byteOffset";function E(e,t,r){var n,i,o,s=new Array(r),a=8*r-t-1,l=(1<<a)-1,u=l>>1,c=23===t?m(2,-24)-m(2,-77):0,f=0,h=e<0||0===e&&1/e<0?1:0;for((e=_(e))!=e||e===d?(i=e!=e?1:0,n=l):(n=v(g(e)/x),e*(o=m(2,-n))<1&&(n--,o*=2),(e+=n+u>=1?c/o:c*m(2,1-u))*o>=2&&(n++,o/=2),n+u>=l?(i=0,n=l):n+u>=1?(i=(e*o-1)*m(2,t),n+=u):(i=e*m(2,u-1)*m(2,t),n=0));t>=8;s[f++]=255&i,i/=256,t-=8);for(n=n<<t|i,a+=t;a>0;s[f++]=255&n,n/=256,a-=8);return s[--f]|=128*h,s}function R(e,t,r){var n,i=8*r-t-1,o=(1<<i)-1,s=o>>1,a=i-7,l=r-1,u=e[l--],c=127&u;for(u>>=7;a>0;c=256*c+e[l],l--,a-=8);for(n=c&(1<<-a)-1,c>>=-a,a+=t;a>0;n=256*n+e[l],l--,a-=8);if(0===c)c=1-s;else {if(c===o)return n?NaN:u?-d:d;n+=m(2,t),c-=s;}return (u?-1:1)*n*m(2,c-t)}function M(e){return e[3]<<24|e[2]<<16|e[1]<<8|e[0]}function S(e){return [255&e]}function z(e){return [255&e,e>>8&255]}function P(e){return [255&e,e>>8&255,e>>16&255,e>>24&255]}function N(e){return E(e,52,8)}function k(e){return E(e,23,4)}function L(e,t,r){i(e[o],t,{get:function(){return this[r]}});}function O(e,t,r,n){var i=Fn(+r);if(i+t>e[T])throw c(s);var o=e[A]._b,a=i+e[w],l=o.slice(a,a+t);return n?l:l.reverse()}function I(e,t,r,n,i,o){var a=Fn(+r);if(a+t>e[T])throw c(s);for(var l=e[A]._b,u=a+e[w],f=n(+i),h=0;h<t;h++)l[u+h]=f[o?h:t-h-1];}if(In.ABV){if(!f(function(){a(1);})||!f(function(){new a(-1);})||f(function(){return new a,new a(1.5),new a(NaN),"ArrayBuffer"!=a.name})){for(var F,U=(a=function(e){return Et(this,a),new p(Fn(e))})[o]=p[o],D=r(p),G=0;D.length>G;)(F=D[G++])in a||b(a,F,p[F]);U.constructor=a;}var C=new l(new a(2)),V=l[o].setInt8;C.setInt8(0,2147483648),C.setInt8(1,2147483649),!C.getInt8(0)&&C.getInt8(1)||tr(l[o],{setInt8:function(e,t){V.call(this,e,t<<24>>24);},setUint8:function(e,t){V.call(this,e,t<<24>>24);}},!0);}else a=function(e){Et(this,a,"ArrayBuffer");var t=Fn(e);this._b=Un.call(new Array(t),0),this[T]=t;},l=function(e,t,r){Et(this,l,"DataView"),Et(e,a,"DataView");var n=e[T],i=j(t);if(i<0||i>n)throw c("Wrong offset!");if(i+(r=void 0===r?n-i:B(r))>n)throw c("Wrong length!");this[A]=e,this[w]=i,this[T]=r;},h&&(L(a,"byteLength","_l"),L(l,"buffer","_b"),L(l,"byteLength","_l"),L(l,"byteOffset","_o")),tr(l[o],{getInt8:function(e){return O(this,1,e)[0]<<24>>24},getUint8:function(e){return O(this,1,e)[0]},getInt16:function(e){var t=O(this,2,e,arguments[1]);return (t[1]<<8|t[0])<<16>>16},getUint16:function(e){var t=O(this,2,e,arguments[1]);return t[1]<<8|t[0]},getInt32:function(e){return M(O(this,4,e,arguments[1]))},getUint32:function(e){return M(O(this,4,e,arguments[1]))>>>0},getFloat32:function(e){return R(O(this,4,e,arguments[1]),23,4)},getFloat64:function(e){return R(O(this,8,e,arguments[1]),52,8)},setInt8:function(e,t){I(this,1,e,S,t);},setUint8:function(e,t){I(this,1,e,S,t);},setInt16:function(e,t){I(this,2,e,z,t,arguments[2]);},setUint16:function(e,t){I(this,2,e,z,t,arguments[2]);},setInt32:function(e,t){I(this,4,e,P,t,arguments[2]);},setUint32:function(e,t){I(this,4,e,P,t,arguments[2]);},setFloat32:function(e,t){I(this,4,e,k,t,arguments[2]);},setFloat64:function(e,t){I(this,8,e,N,t,arguments[2]);}});ce(a,"ArrayBuffer"),ce(l,"DataView"),b(l[o],In.VIEW,!0),t.ArrayBuffer=a,t.DataView=l;}),Gn=Array.isArray||function(e){return "Array"==S(e)},Cn=l("species"),jn=function(e,t){return new(function(e){var t;return Gn(e)&&("function"!=typeof(t=e.constructor)||t!==Array&&!Gn(t.prototype)||(t=void 0),u(t)&&null===(t=t[Cn])&&(t=void 0)),void 0===t?Array:t}(e))(t)},Vn=function(e,t){var r=1==e,n=2==e,i=3==e,o=4==e,s=6==e,a=5==e||s,l=t||jn;return function(t,u,c){for(var f,h,d=de(t),p=z(d),_=F(u,c,3),m=B(p.length),v=0,g=r?l(t,m):n?l(t,0):void 0;m>v;v++)if((a||v in p)&&(h=_(f=p[v],v,d),e))if(r)g[v]=h;else if(h)switch(e){case 3:return !0;case 5:return f;case 6:return v;case 2:g.push(f);}else if(o)return !1;return s?-1:i||o?o:g}},Bn=[].copyWithin||function(e,t){var r=de(this),n=B(r.length),i=X(e,n),o=X(t,n),s=arguments.length>2?arguments[2]:void 0,a=Math.min((void 0===s?n:X(s,n))-o,n-i),l=1;for(o<i&&i<o+a&&(l=-1,o+=a-1,i+=a-1);a-- >0;)o in r?r[i]=r[o]:delete r[i],i+=l,o+=l;return r},qn=t(function(e){if(h){var t=n,r=f,i=D,o=In,s=Dn,c=F,d=Et,p=x,_=b,m=tr,g=j,A=B,T=Fn,w=X,E=v,M=L,S=Ie,z=u,P=de,N=zt,k=ae,O=me,I=ln.f,U=Nt,G=a,C=l,V=Vn,q=W,H=Ot,Y=be,Z=R,J=fr,K=nr,$=Un,Q=Bn,ee=y,te=rn,re=ee.f,ne=te.f,ie=t.RangeError,oe=t.TypeError,se=t.Uint8Array,le=Array.prototype,ue=s.ArrayBuffer,ce=s.DataView,fe=V(0),he=V(2),pe=V(3),_e=V(4),ve=V(5),ge=V(6),ye=q(!0),xe=q(!1),Ae=Y.values,Te=Y.keys,we=Y.entries,Ee=le.lastIndexOf,Re=le.reduce,Me=le.reduceRight,Se=le.join,ze=le.sort,Pe=le.slice,Ne=le.toString,ke=le.toLocaleString,Le=C("iterator"),Oe=C("toStringTag"),Fe=G("typed_constructor"),Ue=G("def_constructor"),De=o.CONSTR,Ge=o.TYPED,Ce=o.VIEW,je=V(1,function(e,t){return Xe(H(e,e[Ue]),t)}),Ve=r(function(){return 1===new se(new Uint16Array([1]).buffer)[0]}),Be=!!se&&!!se.prototype.set&&r(function(){new se(1).set({});}),qe=function(e,t){var r=g(e);if(r<0||r%t)throw ie("Wrong offset!");return r},He=function(e){if(z(e)&&Ge in e)return e;throw oe(e+" is not a typed array!")},Xe=function(e,t){if(!(z(e)&&Fe in e))throw oe("It is not a typed array constructor!");return new e(t)},We=function(e,t){return Ye(H(e,e[Ue]),t)},Ye=function(e,t){for(var r=0,n=t.length,i=Xe(e,n);n>r;)i[r]=t[r++];return i},Ze=function(e,t,r){re(e,t,{get:function(){return this._d[r]}});},Je=function(e){var t,r,n,i,o,s,a=P(e),l=arguments.length,u=l>1?arguments[1]:void 0,f=void 0!==u,h=U(a);if(null!=h&&!N(h)){for(s=h.call(a),n=[],t=0;!(o=s.next()).done;t++)n.push(o.value);a=n;}for(f&&l>2&&(u=c(u,arguments[2],2)),t=0,r=A(a.length),i=Xe(this,r);r>t;t++)i[t]=f?u(a[t],t):a[t];return i},Ke=function(){for(var e=0,t=arguments.length,r=Xe(this,t);t>e;)r[e]=arguments[e++];return r},$e=!!se&&r(function(){ke.call(new se(1));}),Qe=function(){return ke.apply($e?Pe.call(He(this)):He(this),arguments)},et={copyWithin:function(e,t){return Q.call(He(this),e,t,arguments.length>2?arguments[2]:void 0)},every:function(e){return _e(He(this),e,arguments.length>1?arguments[1]:void 0)},fill:function(e){return $.apply(He(this),arguments)},filter:function(e){return We(this,he(He(this),e,arguments.length>1?arguments[1]:void 0))},find:function(e){return ve(He(this),e,arguments.length>1?arguments[1]:void 0)},findIndex:function(e){return ge(He(this),e,arguments.length>1?arguments[1]:void 0)},forEach:function(e){fe(He(this),e,arguments.length>1?arguments[1]:void 0);},indexOf:function(e){return xe(He(this),e,arguments.length>1?arguments[1]:void 0)},includes:function(e){return ye(He(this),e,arguments.length>1?arguments[1]:void 0)},join:function(e){return Se.apply(He(this),arguments)},lastIndexOf:function(e){return Ee.apply(He(this),arguments)},map:function(e){return je(He(this),e,arguments.length>1?arguments[1]:void 0)},reduce:function(e){return Re.apply(He(this),arguments)},reduceRight:function(e){return Me.apply(He(this),arguments)},reverse:function(){for(var e,t=He(this).length,r=Math.floor(t/2),n=0;n<r;)e=this[n],this[n++]=this[--t],this[t]=e;return this},some:function(e){return pe(He(this),e,arguments.length>1?arguments[1]:void 0)},sort:function(e){return ze.call(He(this),e)},subarray:function(e,t){var r=He(this),n=r.length,i=w(e,n);return new(H(r,r[Ue]))(r.buffer,r.byteOffset+i*r.BYTES_PER_ELEMENT,A((void 0===t?n:w(t,n))-i))}},tt=function(e,t){return We(this,Pe.call(He(this),e,t))},rt=function(e){He(this);var t=qe(arguments[1],1),r=this.length,n=P(e),i=A(n.length),o=0;if(i+t>r)throw ie("Wrong length!");for(;o<i;)this[t+o]=n[o++];},nt={entries:function(){return we.call(He(this))},keys:function(){return Te.call(He(this))},values:function(){return Ae.call(He(this))}},it=function(e,t){return z(e)&&e[Ge]&&"symbol"!=typeof t&&t in e&&String(+t)==String(t)},ot=function(e,t){return it(e,t=E(t,!0))?p(2,e[t]):ne(e,t)},st=function(e,t,r){return !(it(e,t=E(t,!0))&&z(r)&&M(r,"value"))||M(r,"get")||M(r,"set")||r.configurable||M(r,"writable")&&!r.writable||M(r,"enumerable")&&!r.enumerable?re(e,t,r):(e[t]=r.value,e)};De||(te.f=ot,ee.f=st),i(i.S+i.F*!De,"Object",{getOwnPropertyDescriptor:ot,defineProperty:st}),r(function(){Ne.call({});})&&(Ne=ke=function(){return Se.call(this)});var at=m({},et);m(at,nt),_(at,Le,nt.values),m(at,{slice:tt,set:rt,constructor:function(){},toString:Ne,toLocaleString:Qe}),Ze(at,"buffer","b"),Ze(at,"byteOffset","o"),Ze(at,"byteLength","l"),Ze(at,"length","e"),re(at,Oe,{get:function(){return this[Ge]}}),e.exports=function(e,n,s,a){var l=e+((a=!!a)?"Clamped":"")+"Array",u="get"+e,c="set"+e,f=t[l],h=f||{},p=f&&O(f),m=!f||!o.ABV,v={},g=f&&f.prototype,y=function(e,t){re(e,t,{get:function(){return function(e,t){var r=e._d;return r.v[u](t*n+r.o,Ve)}(this,t)},set:function(e){return function(e,t,r){var i=e._d;a&&(r=(r=Math.round(r))<0?0:r>255?255:255&r),i.v[c](t*n+i.o,r,Ve);}(this,t,e)},enumerable:!0});};m?(f=s(function(e,t,r,i){d(e,f,l,"_d");var o,s,a,u,c=0,h=0;if(z(t)){if(!(t instanceof ue||"ArrayBuffer"==(u=S(t))||"SharedArrayBuffer"==u))return Ge in t?Ye(f,t):Je.call(f,t);o=t,h=qe(r,n);var p=t.byteLength;if(void 0===i){if(p%n)throw ie("Wrong length!");if((s=p-h)<0)throw ie("Wrong length!")}else if((s=A(i)*n)+h>p)throw ie("Wrong length!");a=s/n;}else a=T(t),o=new ue(s=a*n);for(_(e,"_d",{b:o,o:h,l:s,e:a,v:new ce(o)});c<a;)y(e,c++);}),g=f.prototype=k(at),_(g,"constructor",f)):r(function(){f(1);})&&r(function(){new f(-1);})&&J(function(e){new f,new f(null),new f(1.5),new f(e);},!0)||(f=s(function(e,t,r,i){var o;return d(e,f,l),z(t)?t instanceof ue||"ArrayBuffer"==(o=S(t))||"SharedArrayBuffer"==o?void 0!==i?new h(t,qe(r,n),i):void 0!==r?new h(t,qe(r,n)):new h(t):Ge in t?Ye(f,t):Je.call(f,t):new h(T(t))}),fe(p!==Function.prototype?I(h).concat(I(p)):I(h),function(e){e in f||_(f,e,h[e]);}),f.prototype=g,g.constructor=f);var x=g[Le],b=!!x&&("values"==x.name||null==x.name),w=nt.values;_(f,Fe,!0),_(g,Ge,l),_(g,Ce,!0),_(g,Ue,f),(a?new f(1)[Oe]==l:Oe in g)||re(g,Oe,{get:function(){return l}}),v[l]=f,i(i.G+i.W+i.F*(f!=h),v),i(i.S,l,{BYTES_PER_ELEMENT:n}),i(i.S+i.F*r(function(){h.of.call(f,1);}),l,{from:Je,of:Ke}),"BYTES_PER_ELEMENT"in g||_(g,"BYTES_PER_ELEMENT",n),i(i.P,l,et),K(l),i(i.P+i.F*Be,l,{set:rt}),i(i.P+i.F*!b,l,nt),g.toString!=Ne&&(g.toString=Ne),i(i.P+i.F*r(function(){new f(1).slice();}),l,{slice:tt}),i(i.P+i.F*(r(function(){return [1,2].toLocaleString()!=new f([1,2]).toLocaleString()})||!r(function(){g.toLocaleString.call([1,2]);})),l,{toLocaleString:Qe}),Z[l]=b?x:w,b||_(g,Le,w);};}else e.exports=function(){};});qn("Uint8",1,function(e){return function(t,r,n){return e(this,t,r,n)}});var Hn=function(){function e(t,r,n){void 0===n&&(n={}),n=e.sliceOptions(n),this.gl=t,this.texture=t.createTexture(),this.texture&&(this.valid=!0),this.bind(),this.name=r,this.retain_count=0,this.config_type=null,this.loading=null,this.loaded=!1,this.filtering=n.filtering,this.density=n.density||1,this.sprites=n.sprites,this.texcoords={},this.sizes={},this.css_sizes={},this.aspects={},this.setData(1,1,new Uint8Array([0,0,0,0]),{filtering:"nearest"}),this.loaded=!1,e.textures[this.name]&&(this.retain_count=e.textures[this.name].retain_count,e.textures[this.name].retain_count=0,e.textures[this.name].destroy()),e.textures[this.name]=this,e.texture_configs[this.name]=JSON.stringify(Object.assign({name:r},n)),this.load(n),Zr("trace","creating Texture "+this.name);}var t=e.prototype;return t.destroy=function(t){var r=(void 0===t?{}:t).force;this.retain_count>0&&!r?Zr("error","Texture '"+this.name+"': destroying texture with retain count of '"+this.retain_count+"'"):this.valid&&(this.gl.deleteTexture(this.texture),this.texture=null,e.textures[this.name]===this&&(delete e.textures[this.name],delete e.texture_configs[this.name]),this.valid=!1,Zr("trace","destroying Texture "+this.name));},t.retain=function(){this.retain_count++;},t.release=function(){this.retain_count<=0&&Zr("error","Texture '"+this.name+"': releasing texture with retain count of '"+this.retain_count+"'"),this.retain_count--,this.retain_count<=0&&this.destroy();},t.bind=function(t){void 0===t&&(t=0),this.valid&&(e.activeUnit!==t&&(this.gl.activeTexture(this.gl.TEXTURE0+t),e.activeUnit=t,e.boundTexture=null),e.boundTexture!==this.texture&&(this.gl.bindTexture(this.gl.TEXTURE_2D,this.texture),e.boundTexture=this.texture));},t.load=function(e){var t=this;return e?(this.loading=null,"string"==typeof e.url?(this.config_type="url",this.setUrl(e.url,e)):e.element?(this.config_type="element",this.setElement(e.element,e)):e.data&&e.width&&e.height&&(this.config_type="data",this.setData(e.width,e.height,e.data,e)),this.loading=this.loading&&this.loading.then(function(){return t.calculateSprites(),t})||Promise.resolve(this),this.loading):this.loading||Promise.resolve(this)},t.setUrl=function(t,r){var n=this;if(void 0===r&&(r={}),this.valid)return this.url=t,this.loading=new Promise(function(t){var i=new Image;i.onload=function(){try{if("data:"===n.url.slice(0,5)){var o=document.createElement("canvas"),s=o.getContext("2d");o.width=i.width,o.height=i.height,s.drawImage(i,0,0),n.setElement(o,r);}else n.setElement(i,r);}catch(t){n.loaded=!1,Zr("warn","Texture '"+n.name+"': failed to load url: '"+n.url+"'",t,r),e.trigger("warning",{message:"Failed to load texture from "+n.url,error:t,texture:r});}n.loaded=!0,t(n);},i.onerror=function(i){n.loaded=!1,Zr("warn","Texture '"+n.name+"': failed to load url: '"+n.url+"'",i,r),e.trigger("warning",{message:"Failed to load texture from "+n.url,error:i,texture:r}),t(n);},Qr.isSafari()&&"data:"===n.url.slice(0,5)||(i.crossOrigin="anonymous"),i.src=n.url;}),this.loading},t.setData=function(e,t,r,n){return void 0===n&&(n={}),this.width=e,this.height=t,Array.isArray(r)&&(r=new Uint8Array(r)),this.update(r,n),this.setFiltering(n),this.loaded=!0,this.loading=Promise.resolve(this),this.loading},t.setElement=function(t,r){var n=t;if("string"==typeof t&&(t=document.querySelector(t)),t instanceof HTMLCanvasElement||t instanceof HTMLImageElement||t instanceof HTMLVideoElement)this.update(t,r),this.setFiltering(r);else {this.loaded=!1;var i="the 'element' parameter (`element: "+JSON.stringify(n)+"`) must be a CSS ";i+="selector string, or a <canvas>, <image> or <video> object",Zr("warn","Texture '"+this.name+"': "+i,r),e.trigger("warning",{message:"Failed to load texture because "+i,texture:r});}return this.loaded=!0,this.loading=Promise.resolve(this),this.loading},t.update=function(t,r){void 0===r&&(r={}),this.valid&&(this.bind(),t instanceof HTMLCanvasElement||t instanceof HTMLVideoElement||t instanceof HTMLImageElement&&t.complete?(this.width=t.width,this.height=t.height,this.gl.pixelStorei(this.gl.UNPACK_FLIP_Y_WEBGL,!1!==r.UNPACK_FLIP_Y_WEBGL),this.gl.pixelStorei(this.gl.UNPACK_PREMULTIPLY_ALPHA_WEBGL,r.UNPACK_PREMULTIPLY_ALPHA_WEBGL||!1),this.gl.texImage2D(this.gl.TEXTURE_2D,0,this.gl.RGBA,this.gl.RGBA,this.gl.UNSIGNED_BYTE,t)):(this.gl.pixelStorei(this.gl.UNPACK_FLIP_Y_WEBGL,null),this.gl.pixelStorei(this.gl.UNPACK_PREMULTIPLY_ALPHA_WEBGL,null),this.gl.texImage2D(this.gl.TEXTURE_2D,0,this.gl.RGBA,this.width,this.height,0,this.gl.RGBA,this.gl.UNSIGNED_BYTE,t)),e.trigger("update",this));},t.setFiltering=function(t){if(void 0===t&&(t={}),this.valid){t.filtering=t.filtering||"linear";var r=this.gl;this.bind(),Qr.isPowerOf2(this.width)&&Qr.isPowerOf2(this.height)?(this.power_of_2=!0,r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_S,t.TEXTURE_WRAP_S||t.repeat&&r.REPEAT||r.CLAMP_TO_EDGE),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_T,t.TEXTURE_WRAP_T||t.repeat&&r.REPEAT||r.CLAMP_TO_EDGE),"mipmap"===t.filtering?(this.filtering="mipmap",r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,r.LINEAR_MIPMAP_LINEAR),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MAG_FILTER,r.LINEAR),r.generateMipmap(r.TEXTURE_2D)):"linear"===t.filtering?(this.filtering="linear",r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,r.LINEAR),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MAG_FILTER,r.LINEAR)):"nearest"===t.filtering&&(this.filtering="nearest",r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,r.NEAREST),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MAG_FILTER,r.NEAREST))):(this.power_of_2=!1,r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_S,r.CLAMP_TO_EDGE),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_T,r.CLAMP_TO_EDGE),"nearest"===t.filtering?(this.filtering="nearest",r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,r.NEAREST),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MAG_FILTER,r.NEAREST)):(this.filtering="linear",r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MIN_FILTER,r.LINEAR),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_MAG_FILTER,r.LINEAR))),e.trigger("update",this);}},t.calculateSprites=function(){if(this.sprites)for(var t in this.sprites){var r=this.sprites[t];this.texcoords[t]=e.getTexcoordsForSprite([r[0],r[1]],[r[2],r[3]],[this.width,this.height]),this.sizes[t]=[r[2],r[3]],this.css_sizes[t]=[r[2]/this.density,r[3]/this.density],this.aspects[t]=r[2]/r[3];}},t.byteSize=function(){return Math.round(this.width*this.height*4*("mipmap"==this.filtering?1.33:1))},e}();Hn.create=function(e,t,r){return new Hn(e,t,r)},Hn.retain=function(e){Hn.textures[e]&&Hn.textures[e].retain();},Hn.release=function(e){Hn.textures[e]&&Hn.textures[e].release();},Hn.destroy=function(e){Object.keys(Hn.textures).forEach(function(t){var r=Hn.textures[t];r.gl===e&&r.destroy({force:!0});});},Hn.getSpriteInfo=function(e,t){var r=Hn.textures[e];return r&&{size:r.sizes[t],css_size:r.css_sizes[t],aspect:r.aspects[t],texcoords:r.texcoords[t]}},Hn.getTexcoordsForSprite=function(e,t,r){var n=r[1]-e[1]-t[1];return [e[0]/r[0],n/r[1],(t[0]+e[0])/r[0],(t[1]+n)/r[1]]},Hn.createFromObject=function(e,t){var r=[];if(t)for(var n in t){var i=t[n];if(!i.skip_create&&Hn.changed(n,i)){var o=Hn.create(e,n,i);r.push(o.loading);}}return Promise.all(r)},Hn.default="__default",Hn.createDefault=function(e){return Hn.create(e,Hn.default)},Hn.sliceOptions=function(e){return {filtering:e.filtering,sprites:e.sprites,url:e.url,element:e.element,data:e.data,width:e.width,height:e.height,density:e.density,repeat:e.repeat,TEXTURE_WRAP_S:e.TEXTURE_WRAP_S,TEXTURE_WRAP_T:e.TEXTURE_WRAP_T,UNPACK_FLIP_Y_WEBGL:e.UNPACK_FLIP_Y_WEBGL,UNPACK_PREMULTIPLY_ALPHA_WEBGL:e.UNPACK_PREMULTIPLY_ALPHA_WEBGL}},Hn.changed=function(e,t){var r=Hn.textures[e];if(r){if("element"===r.config_type||null!=t.element)return !0;if(t=Hn.sliceOptions(t),Hn.texture_configs[e]===JSON.stringify(Object.assign({name:e},t)))return !1}return !0},Hn.getInfo=function(e){if(e||(e=Object.keys(Hn.textures)),Array.isArray(e))return Promise.all(e.map(function(e){return Hn.getInfo(e)}));var t=Hn.textures[e];return t?(t.loading||Promise.resolve(t)).then(function(){return {name:t.name,width:t.width,height:t.height,density:t.density,css_size:[t.width/t.density,t.height/t.density],aspect:t.width/t.height,sprites:t.sprites,texcoords:t.texcoords,sizes:t.sizes,css_sizes:t.css_sizes,aspects:t.aspects,filtering:t.filtering,power_of_2:t.power_of_2,valid:t.valid}}):Promise.resolve(null)},Hn.syncTexturesToWorker=function(e){return jr.postMessage("Texture.getInfo",e).then(function(e){return e&&e.filter(function(e){return e}).forEach(function(e){return Hn.textures[e.name]=e}),Hn.textures})},Hn.getMaxTextureSize=function(e){return e.getParameter(e.MAX_TEXTURE_SIZE)},Hn.textures={},Hn.texture_configs={},Hn.boundTexture=null,Hn.activeUnit=null,jr.addTarget("Texture",Hn),Rn(Hn),st("match",1,function(e,t,r,n){return [function(r){var n=e(this),i=null==r?void 0:r[t];return void 0!==i?i.call(r,n):new RegExp(r)[t](String(n))},function(e){var t=n(r,e,this);if(t.done)return t.value;var i=c(e),o=String(this);if(!i.global)return Ze(i,o);var s=i.unicode;i.lastIndex=0;for(var a,l=[],u=0;null!==(a=Ze(i,o));){var f=String(a[0]);l[u]=f,""===f&&(i.lastIndex=We(o,B(i.lastIndex),s)),u++;}return 0===u?null:l}]});var Xn={parseUniforms:function(e){var t=[];for(var r in e){var n,i=r,o=e[r];if("number"==typeof o)t.push({type:"float",method:"1f",name:r,value:o,key:i,uniforms:e});else if(Array.isArray(o)){if("number"==typeof o[0])o.length>=2&&o.length<=4?t.push({type:"vec"+o.length,method:o.length+"fv",name:r,value:o,key:i,uniforms:e}):o.length>4&&t.push({type:"float[]",method:"1fv",name:r+"[0]",value:o,key:i,uniforms:e});else if("string"==typeof o[0])for(n=0;n<o.length;n++)t.push({type:"sampler2D",method:"1i",name:r+"["+n+"]",value:o[n],key:n,uniforms:o});else if(Array.isArray(o[0])&&"number"==typeof o[0][0]&&o[0].length>=2&&o[0].length<=4)for(n=0;n<o.length;n++)t.push({type:"vec"+o[0].length,method:o[0].length+"fv",name:r+"["+n+"]",value:o[n],key:n,uniforms:o});}else "boolean"==typeof o?t.push({type:"bool",method:"1i",name:r,value:o,key:i,uniforms:e}):"string"==typeof o&&t.push({type:"sampler2D",method:"1i",name:r,value:o,key:i,uniforms:e});}return t},defineVariable:function(e,t){var r,n;if("number"==typeof t)r="float";else if(Array.isArray(t))"number"==typeof t[0]?t.length>=2&&t.length<=4?r="vec"+t.length:(r="float",n=t.length):"string"==typeof t[0]?(r="sampler2D",n=t.length):Array.isArray(t[0])&&"number"==typeof t[0][0]&&t[0].length>=2&&t[0].length<=4&&(r="vec"+t[0].length,n=t.length);else if("boolean"==typeof t)r="bool";else {if("string"!=typeof t)return;r="sampler2D";}var i="";return i+=r+" "+e,n&&(i+="["+n+"]"),i+=";\n"},defineUniform:function(e,t){var r=Xn.defineVariable(e,t);if(r)return "uniform "+r},expandVec3:function(e,t){var r;if(void 0===t&&(t=1),Array.isArray(e)){if(2!==e.length)return e;r=[].concat(e,[t]).map(parseFloat);}else r=[e,e,e].map(parseFloat);if(r&&r.every(function(e){return "number"==typeof e&&!isNaN(e)}))return r},expandVec4:function(e,t){var r;if(void 0===t&&(t=1),Array.isArray(e)){if(3!==e.length)return e;r=[].concat(e,[t]).map(parseFloat);}else r=[e,e,e,t].map(parseFloat);if(r&&r.every(function(e){return "number"==typeof e&&!isNaN(e)}))return r}},Wn=[];function Yn(e,t){var r=Wn.filter(function(t){return t[0]===e})[0];return (r=r&&r[1])||(Wn.push([e,{}]),r=Wn[Wn.length-1][1]),r[t]||(r[t]=e.getExtension(t)),r[t]}function Zn(e){var t,r,n=0;if(0===e.length)return n;for(t=0,r=e.length;t<r;t++)n=(n<<5)-n+e.charCodeAt(t),n|=0;return n}var Jn=function(e){e=String(e);var t,r=[];for(;t=e.match(/ERROR\:([^\n]+)/);){e=e.slice(t.index+1);var n=t[1].trim(),i=n.split(":"),o=i.slice(2).join(":").trim(),s=parseInt(i[0],10),n=parseInt(i[1],10);r.push({message:o,file:s,line:n});}return r};var Kn=/^\s*#pragma.*$/gm,$n=/\\\s*\n/gm,Qn=function(){function e(t,r,n,i){i=i||{},this.gl=t,this.program=null,this.compiled=!1,this.compiling=!1,this.error=null,this.defines=Object.assign({},i.defines||{}),this.blocks=Object.assign({},i.blocks||{}),this.block_scopes=Object.assign({},i.block_scopes||{}),this.extensions=i.extensions||[],this.dependent_uniforms=i.uniforms,this.uniforms={},this.attribs={},this.vertex_source=r,this.fragment_source=n,this.id=e.id++,this.name=i.name;}var t=e.prototype;return t.destroy=function(){this.gl.useProgram(null),this.gl.deleteProgram(this.program),this.program=null,this.uniforms={},this.attribs={},this.compiled=!1;},t.use=function(){this.compiled&&(e.current!==this&&this.gl.useProgram(this.program),e.current=this);},t.compile=function(){var t=this;if(this.compiling)throw new Error("ShaderProgram.compile(): skipping for "+this.id+" ("+this.name+") because already compiling");this.compiling=!0,this.compiled=!1,this.error=null,this.computed_vertex_source=this.vertex_source,this.computed_fragment_source=this.fragment_source;var r,n=this.checkExtensions(),i=this.buildDefineList(),o=this.buildShaderBlockList();for(var s in o){var a=o[s];if(a&&(!Array.isArray(a)||0!==a.length)){r=new RegExp("^\\s*#pragma\\s+tangram:\\s+"+s+"\\s*$","m");var l=this.computed_vertex_source.match(r),u=this.computed_fragment_source.match(r);if(null!=l||null!=u){var c="";a.forEach(function(e){var t=e.scope+", "+e.key+", "+e.num;c+="\n// tangram-block-start: "+t+"\n",c+=e.source,c+="\n// tangram-block-end: "+t+"\n";}),null!=l&&(this.computed_vertex_source=this.computed_vertex_source.replace(r,c)),null!=u&&(this.computed_fragment_source=this.computed_fragment_source.replace(r,c)),i["TANGRAM_BLOCK_"+s.replace(/[\s-]+/g,"_").toUpperCase()]=!0;}}}this.computed_vertex_source=this.computed_vertex_source.replace(Kn,""),this.computed_fragment_source=this.computed_fragment_source.replace(Kn,""),this.ensureUniforms(this.dependent_uniforms);var f="",h=this.gl.getShaderPrecisionFormat(this.gl.FRAGMENT_SHADER,this.gl.HIGH_FLOAT);f=h&&h.precision>0?"precision highp float;\n":"precision mediump float;\n",i.TANGRAM_VERTEX_SHADER=!0,i.TANGRAM_FRAGMENT_SHADER=!1,this.computed_vertex_source=f+e.buildDefineString(i)+this.computed_vertex_source,i.TANGRAM_VERTEX_SHADER=!1,i.TANGRAM_FRAGMENT_SHADER=!0,this.computed_fragment_source=e.buildExtensionString(n)+f+e.buildDefineString(i)+this.computed_fragment_source,this.computed_vertex_source=this.computed_vertex_source.replace($n,""),this.computed_fragment_source=this.computed_fragment_source.replace($n,"");try{this.program=e.updateProgram(this.gl,this.program,this.computed_vertex_source,this.computed_fragment_source),this.compiled=!0,this.compiling=!1;}catch(e){throw this.program=null,this.compiled=!1,this.compiling=!1,this.error=e,this.error.vertex_shader_source=this.computed_vertex_source,this.error.fragment_shader_source=this.computed_fragment_source,"vertex"!==e.type&&"fragment"!==e.type||(this.shader_errors=e.errors,this.shader_errors.forEach(function(r){r.type=e.type,r.block=t.block(e.type,r.line),r.line=t.block(e.type,r.line);}),this.error.shader_errors=this.shader_errors),e}this.computed_vertex_source=null,this.computed_fragment_source=null,this.use(),this.refreshUniforms(),this.refreshAttributes();},t.buildDefineList=function(){var t,r={};for(t in e.defines)r[t]=e.defines[t];for(t in this.defines)r[t]=this.defines[t];return r},t.buildShaderBlockList=function(){var t,r={};for(t in e.blocks){var n;if(r[t]=[],Array.isArray(e.blocks[t]))(n=r[t]).push.apply(n,e.blocks[t].map(function(e,r){return {key:t,source:e,num:r,scope:"ShaderProgram"}}));else r[t]=[{key:t,source:e.blocks[t],num:0,scope:"ShaderProgram"}];}for(t in this.blocks)if(r[t]=r[t]||[],Array.isArray(this.blocks[t]))for(var i=this.block_scopes&&this.block_scopes[t]||[],o=null,s=0,a=0;a<this.blocks[t].length;a++)i[a]!==o&&(o=i[a],s=0),r[t].push({key:t,source:this.blocks[t][a],num:s,scope:o||this.name}),s++;else r[t].push({key:t,source:this.blocks[t],num:0,scope:this.name});return r},t.ensureUniforms=function(e){if(e){var t=Object.entries(e).map(function(e){var t=e[0],r=e[1];return Xn.defineUniform(t,r)}).filter(function(e){return e});this.computed_vertex_source=t.join("\n")+this.computed_vertex_source,this.computed_fragment_source=t.join("\n")+this.computed_fragment_source;}},t.setUniforms=function(e,t){if(void 0===t&&(t=!0),this.compiled){t&&(this.texture_unit=0);for(var r=Xn.parseUniforms(e),n=0;n<r.length;n++){var i=r[n];"sampler2D"===i.type?this.setTextureUniform(i.name,i.value):this.uniform(i.method,i.name,i.value);}}},t.saveUniforms=function(e){var t=e||this.uniforms;for(var r in t){var n=this.uniforms[r];n&&(n.saved_value=n.value);}this.saved_texture_unit=this.texture_unit||0;},t.restoreUniforms=function(e){var t=e||this.uniforms;for(var r in t){var n=this.uniforms[r];n&&n.saved_value&&(n.value=n.saved_value,this.updateUniform(n));}this.texture_unit=this.saved_texture_unit||0;},t.setTextureUniform=function(e,t){var r=Hn.textures[t];null!=r?(r.bind(this.texture_unit),this.uniform("1i",e,this.texture_unit),this.texture_unit++):Zr("warn","Cannot find texture '"+t+"'");},t.uniform=function(e,t,r){if(this.compiled){this.uniforms[t]=this.uniforms[t]||{};var n=this.uniforms[t];n.name=t,void 0===n.location&&(n.location=this.gl.getUniformLocation(this.program,t)),n.method=e,n.value=r,this.updateUniform(n);}},t.updateUniform=function(e){this.compiled&&e&&null!=e.location&&(this.use(),this.commitUniform(e));},t.commitUniform=function(e){var t=e.location,r=e.value;switch(e.method){case"1i":this.gl.uniform1i(t,r);break;case"1f":this.gl.uniform1f(t,r);break;case"2f":this.gl.uniform2f(t,r[0],r[1]);break;case"3f":this.gl.uniform3f(t,r[0],r[1],r[2]);break;case"4f":this.gl.uniform4f(t,r[0],r[1],r[2],r[3]);break;case"1iv":this.gl.uniform1iv(t,r);break;case"3iv":this.gl.uniform3iv(t,r);break;case"1fv":this.gl.uniform1fv(t,r);break;case"2fv":this.gl.uniform2fv(t,r);break;case"3fv":this.gl.uniform3fv(t,r);break;case"4fv":this.gl.uniform4fv(t,r);break;case"Matrix3fv":this.gl.uniformMatrix3fv(t,!1,r);break;case"Matrix4fv":this.gl.uniformMatrix4fv(t,!1,r);}},t.refreshUniforms=function(){if(this.compiled)for(var e in this.uniforms){var t=this.uniforms[e];t.location=this.gl.getUniformLocation(this.program,e),this.updateUniform(t);}},t.refreshAttributes=function(){this.attribs={};},t.attribute=function(e){if(this.compiled){var t=this.attribs[e]=this.attribs[e]||{};return null!=t.location?t:(t.name=e,t.location=this.gl.getAttribLocation(this.program,e),t)}},t.source=function(e){return "vertex"===e?this.computed_vertex_source:"fragment"===e?this.computed_fragment_source:void 0},t.lines=function(e){var t=this.source(e);return t?t.split("\n"):[]},t.line=function(e,t){var r=this.lines(e);if(r)return r[t]},t.block=function(e,t){for(var r,n=this.lines(e),i=0;i<t&&i<n.length;i++){var o=n[i],s=o.match(/\/\/ tangram-block-start: ([A-Za-z0-9_-]+), ([A-Za-z0-9_-]+), (\d+)/);s&&s.length>1?r={scope:s[1],name:s[2],num:s[3]}:(s=o.match(/\/\/ tangram-block-end: ([A-Za-z0-9_-]+), ([A-Za-z0-9_-]+), (\d+)/))&&s.length>1&&(r=null),r&&(r.line=null==r.line?-1:r.line+1,r.source=o);}return r},t.checkExtensions=function(){var e=this,t=[];return this.extensions.forEach(function(r){var n=Yn(e.gl,r),i="TANGRAM_EXTENSION_"+r;e.defines[i]=null!=n,n?t.push(r):Zr("debug","Could not enable extension '"+r+"'");}),t},e}();Qn.id=0,Qn.current=null,Qn.defines={},Qn.blocks={},Qn.reset=function(){Qn.programs_by_source={},Qn.shaders_by_source={};},Qn.reset(),Qn.buildDefineString=function(e){var t="";for(var r in e)null!=e[r]&&!1!==e[r]&&("boolean"==typeof e[r]&&!0===e[r]?t+="#define "+r+"\n":"number"==typeof e[r]&&Math.floor(e[r])===e[r]?t+="#define "+r+" "+e[r].toFixed(1)+"\n":t+="#define "+r+" "+e[r]+"\n");return t},Qn.buildExtensionString=function(e){var t="";return (e=e||[]).forEach(function(e){t+="#ifdef GL_"+e+"\n#extension GL_"+e+" : enable\n#endif\n";}),t},Qn.addBlock=function(e){var t;Qn.blocks[e]=Qn.blocks[e]||[];for(var r=arguments.length,n=new Array(r>1?r-1:0),i=1;i<r;i++)n[i-1]=arguments[i];(t=Qn.blocks[e]).push.apply(t,n);},Qn.removeBlock=function(e){Qn.blocks[e]=[];},Qn.replaceBlock=function(e){Qn.removeBlock(e);for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];Qn.addBlock.apply(Qn,[e].concat(r));},Qn.updateProgram=function(e,t,r,n){var i=Zn(e._tangram_id+"::"+r+"::"+n);if(Qn.programs_by_source[i])return Zr("trace","Reusing identical source GL program object"),Qn.programs_by_source[i];var o=Qn.createShader(e,r,e.VERTEX_SHADER),s=Qn.createShader(e,n,e.FRAGMENT_SHADER);if(e.useProgram(null),null!=t)for(var a=e.getAttachedShaders(t),l=0;l<a.length;l++)e.detachShader(t,a[l]);else t=e.createProgram();if(null==o||null==s)return t;if(e.attachShader(t,o),e.attachShader(t,s),e.bindAttribLocation(t,0,"a_position"),e.linkProgram(t),!e.getProgramParameter(t,e.LINK_STATUS)){var u=new Error("WebGL program error:\n            VALIDATE_STATUS: "+e.getProgramParameter(t,e.VALIDATE_STATUS)+"\n            ERROR: "+e.getError()+"\n            --- Vertex Shader ---\n            "+r+"\n            --- Fragment Shader ---\n            "+n);throw Object.assign(new Error(u),{type:"program"})}return Qn.programs_by_source[i]=t,t},Qn.createShader=function(e,t,r){var n=Zn(e._tangram_id+"::"+t);if(Qn.shaders_by_source[n])return Zr("trace","Reusing identical source GL shader object"),Qn.shaders_by_source[n];var i=e.createShader(r);if(e.shaderSource(i,t),e.compileShader(i),!e.getShaderParameter(i,e.COMPILE_STATUS)){var o=r===e.VERTEX_SHADER?"vertex":"fragment",s=e.getShaderInfoLog(i),a=Jn(s);throw Object.assign(new Error(s),{type:o,errors:a})}return Qn.shaders_by_source[n]=i,i};var ei={disabled:!1,bound_vao:[],init:function(e){var t;!0!==this.disabled&&(t=Yn(e,"OES_vertex_array_object")),null!=t?Zr("info","Vertex Array Object extension available"):!0!==this.disabled?Zr("warn","Vertex Array Object extension NOT available"):Zr("warn","Vertex Array Object extension force disabled");},getExtension:function(e,t){if(!0!==this.disabled)return Yn(e,t)},create:function(e,t,r){var n={};n.setup=t,n.teardown=r;var i=this.getExtension(e,"OES_vertex_array_object");return null!=i&&(n._vao=i.createVertexArrayOES(),i.bindVertexArrayOES(n._vao)),n.setup(),n},getCurrentBinding:function(e){var t=this.bound_vao.filter(function(t){return t[0]===e})[0];return t&&t[1]},setCurrentBinding:function(e,t){var r=this.bound_vao,n=r.filter(function(t){return t[0]===e})[0];null==n?r.push([e,t]):n[1]=t;},bind:function(e,t){var r=this.getExtension(e,"OES_vertex_array_object");if(null!=t)null!=r&&null!=t._vao?(r.bindVertexArrayOES(t._vao),this.setCurrentBinding(e,t)):t.setup();else {var n=this.getCurrentBinding(e);null!=r?r.bindVertexArrayOES(null):null!=n&&"function"==typeof n.teardown&&n.teardown(),this.setCurrentBinding(e,null);}},destroy:function(e,t){var r=this.getExtension(e,"OES_vertex_array_object");null!=r&&null!=t&&null!=t._vao&&(r.deleteVertexArrayOES(t._vao),t._vao=null);}},ti=Ge(!1);D(D.S,"Object",{values:function(e){return ti(e)}});var ri,ni=Vn(6),ii="findIndex",oi=!0;function si(e){for(var t=0;t<(arguments.length<=1?0:arguments.length-1);t++){var r=t+1<1||arguments.length<=t+1?void 0:arguments[t+1];if(r)for(var n in r){var i=r[n];null===i||"object"!=typeof i||Array.isArray(i)?void 0!==i&&(e[n]=i):null===e[n]||"object"!=typeof e[n]||Array.isArray(e[n])?e[n]=si({},i):e[n]=si(e[n],i);}}return e}ii in[]&&Array(1)[ii](function(){oi=!1;}),D(D.P+D.F*oi,"Array",{findIndex:function(e){return ni(this,e,arguments.length>1?arguments[1]:void 0)}}),w(ii);var ai=ri={};ri.default_source_max_zoom=18,ri.default_view_max_zoom=20,ri.max_style_zoom=25,ri.tile_size=256,ri.half_circumference_meters=20037508.342789244,ri.circumference_meters=2*ri.half_circumference_meters,ri.min_zoom_meters_per_pixel=ri.circumference_meters/ri.tile_size;var li=[];ri.metersPerPixel=function(e){return li[e]=li[e]||ri.min_zoom_meters_per_pixel/Math.pow(2,e),li[e]};var ui=[];ri.metersPerTile=function(e){return ui[e]=ui[e]||ri.circumference_meters/Math.pow(2,e),ui[e]},ri.tile_scale=4096,ri.units_per_pixel=ri.tile_scale/ri.tile_size,ri.height_scale=16;var ci=[];ri.unitsPerMeter=function(e){return ci[e]=ci[e]||ri.tile_scale/(ri.tile_size*ri.metersPerPixel(e)),ci[e]},ri.metersForTile=function(e){return {x:e.x*ri.circumference_meters/Math.pow(2,e.z)-ri.half_circumference_meters,y:-(e.y*ri.circumference_meters/Math.pow(2,e.z)-ri.half_circumference_meters)}},ri.tileForMeters=function(e,t){var r=e[0],n=e[1];return {x:Math.floor((r+ri.half_circumference_meters)/(ri.circumference_meters/Math.pow(2,t))),y:Math.floor((-n+ri.half_circumference_meters)/(ri.circumference_meters/Math.pow(2,t))),z:t}},ri.wrapTile=function(e,t){var r=e.x,n=e.y,i=e.z;void 0===t&&(t={x:!0,y:!1});var o=(1<<i)-1;return t.x&&(r&=o),t.y&&(n&=o),{x:r,y:n,z:i}},ri.metersToLatLng=function(e){return e[0]/=ri.half_circumference_meters,e[1]/=ri.half_circumference_meters,e[1]=(2*Math.atan(Math.exp(e[1]*Math.PI))-Math.PI/2)/Math.PI,e[0]*=180,e[1]*=180,e},ri.latLngToMeters=function(e){return e[1]=Math.log(Math.tan(e[1]*Math.PI/360+Math.PI/4))/Math.PI,e[1]*=ri.half_circumference_meters,e[0]*=ri.half_circumference_meters/180,e},ri.tileSpaceToLatlng=function(e,t,r){var n=ri.unitsPerMeter(t);return ri.transformGeometry(e,function(e){e[0]=e[0]/n+r.x,e[1]=e[1]/n+r.y,ri.metersToLatLng(e);}),e},ri.copyGeometry=function(e){if(null!=e){var t={type:e.type};return "Point"===e.type?t.coordinates=[e.coordinates[0],e.coordinates[1]]:"LineString"===e.type||"MultiPoint"===e.type?t.coordinates=e.coordinates.map(function(e){return [e[0],e[1]]}):"Polygon"===e.type||"MultiLineString"===e.type?t.coordinates=e.coordinates.map(function(e){return e.map(function(e){return [e[0],e[1]]})}):"MultiPolygon"===e.type&&(t.coordinates=e.coordinates.map(function(e){return e.map(function(e){return e.map(function(e){return [e[0],e[1]]})})})),t}},ri.transformGeometry=function(e,t){null!=e&&("Point"===e.type?t(e.coordinates):"LineString"===e.type||"MultiPoint"===e.type?e.coordinates.forEach(t):"Polygon"===e.type||"MultiLineString"===e.type?e.coordinates.forEach(function(e){return e.forEach(t)}):"MultiPolygon"===e.type&&e.coordinates.forEach(function(e){e.forEach(function(e){return e.forEach(t)});}));},ri.boxIntersect=function(e,t){return !(t.sw.x>e.ne.x||t.ne.x<e.sw.x||t.sw.y>e.ne.y||t.ne.y<e.sw.y)},ri.findBoundingBox=function(e){for(var t=1/0,r=-1/0,n=1/0,i=-1/0,o=e[0].length,s=0;s<o;s++){var a=e[0][s];a[0]<t&&(t=a[0]),a[1]<n&&(n=a[1]),a[0]>r&&(r=a[0]),a[1]>i&&(i=a[1]);}return [t,n,r,i]},ri.geometryType=function(e){return "Polygon"===e||"MultiPolygon"===e?"polygon":"LineString"===e||"MultiLineString"===e?"line":"Point"===e||"MultiPoint"===e?"point":void 0},ri.centroid=function(e,t){if(void 0===t&&(t=!0),e&&0!==e.length){var r,n=0,i=0,o=0,s=e[0],a=s.length;t&&(r=s[0],s=s.map(function(e){return [e[0]-r[0],e[1]-r[1]]}));for(var l=0,u=a-1;l<a;u=l,l++){var c=s[l],f=s[u],h=c[1]*f[0]-f[1]*c[0];n+=(c[0]+f[0])*h,i+=(c[1]+f[1])*h,o+=3*h;}if(o){var d=[n/o,i/o];return t&&(d[0]+=r[0],d[1]+=r[1]),d}}},ri.multiCentroid=function(e){for(var t=0,r=null,n=0;n<e.length;n++){var i=ri.centroid(e[n]);i&&((r=r||[0,0])[0]+=i[0],r[1]+=i[1],t++);}return t>0&&(r[0]/=t,r[1]/=t),r},ri.signedPolygonRingAreaSum=function(e){for(var t=0,r=e.length,n=0;n<r-1;n++){var i=e[n],o=e[n+1];t+=i[0]*o[1]-o[0]*i[1];}return t+=e[r-1][0]*e[0][1]-e[0][0]*e[r-1][1]},ri.polygonRingArea=function(e){return Math.abs(ri.signedPolygonRingAreaSum(e))/2},ri.polygonArea=function(e){if(e)return ri.polygonRingArea(e[0])},ri.multiPolygonArea=function(e){for(var t=0,r=0;r<e.length;r++)t+=ri.polygonArea(e[r]);return t},ri.ringWinding=function(e){var t=ri.signedPolygonRingAreaSum(e);return t>0?"CW":t<0?"CCW":void 0};var fi="\t\n\v\f\r   ᠎             　\u2028\u2029\ufeff",hi="["+fi+"]",di=RegExp("^"+hi+hi+"*"),pi=RegExp(hi+hi+"*$"),_i=function(e,t,r){var n={},i=f(function(){return !!fi[e]()||"​"!="​"[e]()}),o=n[e]=i?t(mi):fi[e];r&&(n[r]=o),D(D.P+D.F*i,"String",n);},mi=_i.trim=function(e,t){return e=String(P(e)),1&t&&(e=e.replace(di,"")),2&t&&(e=e.replace(pi,"")),e},vi=_i,gi=ln.f,yi=rn.f,xi=y.f,bi=vi.trim,Ai=n.Number,Ti=Ai,wi=Ai.prototype,Ei="Number"==S(ae(wi)),Ri="trim"in String.prototype,Mi=function(e){var t=v(e,!1);if("string"==typeof t&&t.length>2){var r,n,i,o=(t=Ri?t.trim():bi(t,3)).charCodeAt(0);if(43===o||45===o){if(88===(r=t.charCodeAt(2))||120===r)return NaN}else if(48===o){switch(t.charCodeAt(1)){case 66:case 98:n=2,i=49;break;case 79:case 111:n=8,i=55;break;default:return +t}for(var s,a=t.slice(2),l=0,u=a.length;l<u;l++)if((s=a.charCodeAt(l))<48||s>i)return NaN;return parseInt(a,n)}}return +t};if(!Ai(" 0o1")||!Ai("0b1")||Ai("+0x1")){Ai=function(e){var t=arguments.length<1?0:e,r=this;return r instanceof Ai&&(Ei?f(function(){wi.valueOf.call(r);}):"Number"!=S(r))?sn(new Ti(Mi(t)),r,Ai):Mi(t)};for(var Si,zi=h?gi(Ti):"MAX_VALUE,MIN_VALUE,NaN,NEGATIVE_INFINITY,POSITIVE_INFINITY,EPSILON,isFinite,isInteger,isNaN,isSafeInteger,MAX_SAFE_INTEGER,MIN_SAFE_INTEGER,parseFloat,parseInt,isInteger".split(","),Pi=0;zi.length>Pi;Pi++)L(Ti,Si=zi[Pi])&&!L(Ai,Si)&&xi(Ai,Si,yi(Ti,Si));Ai.prototype=wi,wi.constructor=Ai,O(n,"Number",Ai);}D(D.S,"Number",{MIN_SAFE_INTEGER:-9007199254740991});var Ni=t(function(e){var t=a("meta"),r=y.f,n=0,i=Object.isExtensible||function(){return !0},o=!f(function(){return i(Object.preventExtensions({}))}),s=function(e){r(e,t,{value:{i:"O"+ ++n,w:{}}});},l=e.exports={KEY:t,NEED:!1,fastKey:function(e,r){if(!u(e))return "symbol"==typeof e?e:("string"==typeof e?"S":"P")+e;if(!L(e,t)){if(!i(e))return "F";if(!r)return "E";s(e);}return e[t].i},getWeak:function(e,r){if(!L(e,t)){if(!i(e))return !0;if(!r)return !1;s(e);}return e[t].w},onFreeze:function(e){return o&&l.NEED&&i(e)&&!L(e,t)&&s(e),e}};}),ki=(Ni.KEY,Ni.NEED,Ni.fastKey,Ni.getWeak,Ni.onFreeze,Ni.onFreeze);Lr("freeze",function(e){return function(t){return e&&u(t)?e(ki(t)):t}});var Li={functions:{},num_functions:0,num_cached:0};function Oi(e,t){if("string"==typeof e)e=Ii(e,t);else if(null!=e&&"object"==typeof e)for(var r in e)e[r]=Oi(e[r],t);return e}function Ii(e,t){var r="string"==typeof e&&e.match(/^\s*function[^(]*\(([^)]*)\)\s*?\{([\s\S]*)\}$/m);if(r&&r.length>2)try{var n=r[2],i="function"==typeof t?t(n):n,o=Zn(i);if(void 0===Li.functions[o]){var s=r[1].length>0&&r[1].split(",").map(function(e){return e.trim()}).filter(function(e){return e});s=s.length>0?s:["context"],Li.functions[o]=new Function(s.toString(),i),Li.functions[o].source=n,Li.num_functions++;}else Li.num_cached++;return Li.functions[o]}catch(t){return e}return e}var Fi=t(function(e,t){var r={transparent:[0,0,0,0],aliceblue:[240,248,255,1],antiquewhite:[250,235,215,1],aqua:[0,255,255,1],aquamarine:[127,255,212,1],azure:[240,255,255,1],beige:[245,245,220,1],bisque:[255,228,196,1],black:[0,0,0,1],blanchedalmond:[255,235,205,1],blue:[0,0,255,1],blueviolet:[138,43,226,1],brown:[165,42,42,1],burlywood:[222,184,135,1],cadetblue:[95,158,160,1],chartreuse:[127,255,0,1],chocolate:[210,105,30,1],coral:[255,127,80,1],cornflowerblue:[100,149,237,1],cornsilk:[255,248,220,1],crimson:[220,20,60,1],cyan:[0,255,255,1],darkblue:[0,0,139,1],darkcyan:[0,139,139,1],darkgoldenrod:[184,134,11,1],darkgray:[169,169,169,1],darkgreen:[0,100,0,1],darkgrey:[169,169,169,1],darkkhaki:[189,183,107,1],darkmagenta:[139,0,139,1],darkolivegreen:[85,107,47,1],darkorange:[255,140,0,1],darkorchid:[153,50,204,1],darkred:[139,0,0,1],darksalmon:[233,150,122,1],darkseagreen:[143,188,143,1],darkslateblue:[72,61,139,1],darkslategray:[47,79,79,1],darkslategrey:[47,79,79,1],darkturquoise:[0,206,209,1],darkviolet:[148,0,211,1],deeppink:[255,20,147,1],deepskyblue:[0,191,255,1],dimgray:[105,105,105,1],dimgrey:[105,105,105,1],dodgerblue:[30,144,255,1],firebrick:[178,34,34,1],floralwhite:[255,250,240,1],forestgreen:[34,139,34,1],fuchsia:[255,0,255,1],gainsboro:[220,220,220,1],ghostwhite:[248,248,255,1],gold:[255,215,0,1],goldenrod:[218,165,32,1],gray:[128,128,128,1],green:[0,128,0,1],greenyellow:[173,255,47,1],grey:[128,128,128,1],honeydew:[240,255,240,1],hotpink:[255,105,180,1],indianred:[205,92,92,1],indigo:[75,0,130,1],ivory:[255,255,240,1],khaki:[240,230,140,1],lavender:[230,230,250,1],lavenderblush:[255,240,245,1],lawngreen:[124,252,0,1],lemonchiffon:[255,250,205,1],lightblue:[173,216,230,1],lightcoral:[240,128,128,1],lightcyan:[224,255,255,1],lightgoldenrodyellow:[250,250,210,1],lightgray:[211,211,211,1],lightgreen:[144,238,144,1],lightgrey:[211,211,211,1],lightpink:[255,182,193,1],lightsalmon:[255,160,122,1],lightseagreen:[32,178,170,1],lightskyblue:[135,206,250,1],lightslategray:[119,136,153,1],lightslategrey:[119,136,153,1],lightsteelblue:[176,196,222,1],lightyellow:[255,255,224,1],lime:[0,255,0,1],limegreen:[50,205,50,1],linen:[250,240,230,1],magenta:[255,0,255,1],maroon:[128,0,0,1],mediumaquamarine:[102,205,170,1],mediumblue:[0,0,205,1],mediumorchid:[186,85,211,1],mediumpurple:[147,112,219,1],mediumseagreen:[60,179,113,1],mediumslateblue:[123,104,238,1],mediumspringgreen:[0,250,154,1],mediumturquoise:[72,209,204,1],mediumvioletred:[199,21,133,1],midnightblue:[25,25,112,1],mintcream:[245,255,250,1],mistyrose:[255,228,225,1],moccasin:[255,228,181,1],navajowhite:[255,222,173,1],navy:[0,0,128,1],oldlace:[253,245,230,1],olive:[128,128,0,1],olivedrab:[107,142,35,1],orange:[255,165,0,1],orangered:[255,69,0,1],orchid:[218,112,214,1],palegoldenrod:[238,232,170,1],palegreen:[152,251,152,1],paleturquoise:[175,238,238,1],palevioletred:[219,112,147,1],papayawhip:[255,239,213,1],peachpuff:[255,218,185,1],peru:[205,133,63,1],pink:[255,192,203,1],plum:[221,160,221,1],powderblue:[176,224,230,1],purple:[128,0,128,1],rebeccapurple:[102,51,153,1],red:[255,0,0,1],rosybrown:[188,143,143,1],royalblue:[65,105,225,1],saddlebrown:[139,69,19,1],salmon:[250,128,114,1],sandybrown:[244,164,96,1],seagreen:[46,139,87,1],seashell:[255,245,238,1],sienna:[160,82,45,1],silver:[192,192,192,1],skyblue:[135,206,235,1],slateblue:[106,90,205,1],slategray:[112,128,144,1],slategrey:[112,128,144,1],snow:[255,250,250,1],springgreen:[0,255,127,1],steelblue:[70,130,180,1],tan:[210,180,140,1],teal:[0,128,128,1],thistle:[216,191,216,1],tomato:[255,99,71,1],turquoise:[64,224,208,1],violet:[238,130,238,1],wheat:[245,222,179,1],white:[255,255,255,1],whitesmoke:[245,245,245,1],yellow:[255,255,0,1],yellowgreen:[154,205,50,1]};function n(e){return (e=Math.round(e))<0?0:e>255?255:e}function i(e){return e<0?0:e>1?1:e}function o(e){return "%"===e[e.length-1]?n(parseFloat(e)/100*255):n(parseInt(e))}function s(e){return "%"===e[e.length-1]?i(parseFloat(e)/100):i(parseFloat(e))}function a(e,t,r){return r<0?r+=1:r>1&&(r-=1),6*r<1?e+(t-e)*r*6:2*r<1?t:3*r<2?e+(t-e)*(2/3-r)*6:e}try{t.parseCSSColor=function(e){var t,i=e.replace(/ /g,"").toLowerCase();if(i in r)return r[i].slice();if("#"===i[0])return 4===i.length?(t=parseInt(i.substr(1),16))>=0&&t<=4095?[(3840&t)>>4|(3840&t)>>8,240&t|(240&t)>>4,15&t|(15&t)<<4,1]:null:7===i.length&&(t=parseInt(i.substr(1),16))>=0&&t<=16777215?[(16711680&t)>>16,(65280&t)>>8,255&t,1]:null;var l=i.indexOf("("),u=i.indexOf(")");if(-1!==l&&u+1===i.length){var c=i.substr(0,l),f=i.substr(l+1,u-(l+1)).split(","),h=1;switch(c){case"rgba":if(4!==f.length)return null;h=s(f.pop());case"rgb":return 3!==f.length?null:[o(f[0]),o(f[1]),o(f[2]),h];case"hsla":if(4!==f.length)return null;h=s(f.pop());case"hsl":if(3!==f.length)return null;var d=(parseFloat(f[0])%360+360)%360/360,p=s(f[1]),_=s(f[2]),m=_<=.5?_*(p+1):_+p-_*p,v=2*_-m;return [n(255*a(v,m,d+1/3)),n(255*a(v,m,d)),n(255*a(v,m,d-1/3)),h];default:return null}}return null};}catch(e){}}),Ui=(Fi.parseCSSColor,{}),Di=function(e){return Math.max(e,0)},Gi=function(e){return isNaN(e)?0:e},Ci=function(e){return Array.isArray(e)?e.map(parseFloat).map(Gi):Gi(parseFloat(e))},ji=function(e){return Array.isArray(e)?e.map(Ci).map(Di):Di(Ci(e))};Object.assign(Ui,{clampPositive:Di,noNaN:Gi,parseNumber:Ci,parsePositiveNumber:ji}),Ui.wrapFunction=function(e){return "\n        var feature = context.feature.properties;\n        var global = context.global;\n        var $zoom = context.zoom;\n        var $layer = context.layer;\n        var $source = context.source;\n        var $geometry = context.geometry;\n        var $meters_per_pixel = context.meters_per_pixel;\n        var $id = context.id;\n\n        var val = (function(){ "+e+" }());\n\n        if (typeof val === 'number' && isNaN(val)) {\n            val = null; // convert NaNs to nulls\n        }\n\n        return val;\n    "},Ui.zeroPair=Object.freeze([0,0]),Ui.defaults={color:[1,1,1,1],width:1,size:1,extrude:!1,height:20,min_height:0,order:0,z:0,outline:{color:[0,0,0,0],width:0},material:{ambient:1,diffuse:1}},Ui.macros={"Style.color.pseudoRandomColor":function(){return [parseInt(feature.id,16)/100%1*.7,parseInt(feature.id,16)/1e4%1*.7,parseInt(feature.id,16)/1e6%1*.7,1]},"Style.color.randomColor":function(){return [.7*Math.random(),.7*Math.random(),.7*Math.random(),1]}},Ui.getFeatureParseContext=function(e,t,r){return {feature:e,id:e.id,tile:t,global:r,zoom:t.style_z,geometry:ai.geometryType(e.geometry.type),meters_per_pixel:t.meters_per_pixel,meters_per_pixel_sq:t.meters_per_pixel_sq,units_per_meter_overzoom:t.units_per_meter_overzoom}};var Vi={STATIC:0,DYNAMIC:1,ZOOM:2};Ui.CACHE_TYPE=Vi,Ui.createPropertyCache=function(e,t,r){if(void 0===t&&(t=null),void 0===r&&(r=null),null!=e){if(e.value)return {value:e.value,zoom:e.zoom?{}:null,type:e.type};var n={value:e,type:Vi.STATIC};return Array.isArray(n.value)&&Array.isArray(n.value[0])?(n.zoom={},n.type=Vi.ZOOM):"function"==typeof n.value&&(n.type=Vi.DYNAMIC,n.dynamic_transform="function"==typeof r?r:null),"function"==typeof t&&(n.zoom?n.value=n.value.map(function(e,r){return [e[0],t(e[1],r)]}):"function"!=typeof n.value&&(n.value=t(n.value,0))),n}},Ui.createColorPropertyCache=function(e){return Ui.createPropertyCache(e,function(e){return "Style.color.pseudoRandomColor"===e?Ii(Ui.wrapFunction(Ui.macros["Style.color.pseudoRandomColor"])):"Style.color.randomColor"===e?Ui.macros["Style.color.randomColor"]:e})};var Bi=function(e){return "string"==typeof e&&"%"===e[e.length-1]},qi=function(e){return "auto"===e},Hi=function(e){return Bi(e)||qi(e)},Xi="'size' can specify either width or height as derived from aspect ratio, but not both";function Wi(e,t){return Ui.createPropertyCache(e.value,function(r,n){return Array.isArray(r)?(r=r.map(function(t,r){return e.has_ratio[n][r]?t:ji(t)}).map(function(r,i){return e.has_pct[n][i]?t.css_size[i]*r/100:r}),e.has_ratio[n][0]?r[0]=r[1]*t.aspect:e.has_ratio[n][1]&&(r[1]=r[0]/t.aspect)):(r=ji(r),r=e.has_pct[n]?t.css_size.map(function(e){return e*r/100}):[r,r]),r})}function Yi(e,t){try{return e(t)}catch(r){Zr("warn","Property function in layer '"+t.layers[t.layers.length-1]+"' failed with\n","error "+r.stack+"\n","function '"+e.source+"'\n",t.feature,t);}}Ui.createPointSizePropertyCache=function(e,t){var r=null,n=null;if(Bi(e))r=[!0];else if(Array.isArray(e)){if(Array.isArray(e[0])){if(e.some(function(e){return Array.isArray(e[1])?e[1].some(function(e){return Hi(e)}):Bi(e[1])})&&(r=e.map(function(e){return Array.isArray(e[1])?e[1].map(function(e){return Bi(e)}):Bi(e[1])}),(n=e.map(function(e){return Array.isArray(e[1])&&e[1].map(function(e){return qi(e)})})).some(function(e){return Array.isArray(e)&&e.every(function(e){return e})})))throw Xi}else if(e.some(Hi)&&(r=[e.map(Bi)],(n=[e.map(qi)])[0].every(function(e){return e})))throw Xi}else if(qi(e))throw "this value only allowed as half of an array, eg [16px, auto]:";if(r||n){if(!t)throw "% or 'auto' keywords can only be used to specify point size when a texture is defined";(e={value:e}).has_pct=r,e.has_ratio=n,e.sprites={};}else e=Ui.createPropertyCache(e,ji);return e},Ui.evalCachedPointSizeProperty=function(e,t,r,n){if(null!=e)return e.has_pct||e.has_ratio?t?(e.sprites[t.sprite]||(e.sprites[t.sprite]=Wi(e,t)),Ui.evalCachedProperty(e.sprites[t.sprite],n)):(e.texture=e.texture||Wi(e,r),Ui.evalCachedProperty(e.texture,n)):Ui.evalCachedProperty(e,n)},Ui.evalCachedProperty=function(e,t){return null==e?void 0:e.dynamic?Yi(e.dynamic,t):e.static?e.static:e.zoom&&e.zoom[t.zoom]?e.zoom[t.zoom]:"function"==typeof e.value?(e.dynamic_transform?e.dynamic=function(t){return e.dynamic_transform(e.value(t))}:e.dynamic=e.value,Yi(e.dynamic,t)):Array.isArray(e.value)&&Array.isArray(e.value[0])?(e.zoom=e.zoom||{},e.zoom[t.zoom]=Qr.interpolate(t.zoom,e.value),e.zoom[t.zoom]):(e.static=e.value,e.static)},Ui.convertUnits=function(e,t){if(null!=e.value)return "px"===e.units?e.value*ai.metersPerPixel(t.zoom):e.value;if("string"==typeof e)"px"===e.trim().slice(-2)?(e=Ci(e),e*=ai.metersPerPixel(t.zoom)):e=Ci(e);else if(Array.isArray(e))return Array.isArray(e[0])?e.map(function(e){return [e[0],Ui.convertUnits(e[1],t)]}):e.map(function(e){return Ui.convertUnits(e,t)});return e},Ui.parseUnits=function(e){var t={value:Ci(e)};return 0!==t.value&&"string"==typeof e&&"px"===e.trim().slice(-2)&&(t.units="px"),t},Ui.evalCachedDistanceProperty=function(e,t){return null==e?void 0:e.dynamic?Yi(e.dynamic,t):e.zoom&&e.zoom[t.zoom]?e.zoom[t.zoom]:"function"==typeof e.value?(e.dynamic=e.value,Yi(e.dynamic,t)):e.zoom?(e.zoom[t.zoom]=Qr.interpolate(t.zoom,e.value,function(e){return Ui.convertUnits(e,t)}),e.zoom[t.zoom]):Ui.convertUnits(e.value,t)},Ui.string_colors={},Ui.colorForString=function(e){if(Ui.string_colors[e])return Ui.string_colors[e];var t=Fi.parseCSSColor(e);return t&&4===t.length?(t[0]/=255,t[1]/=255,t[2]/=255):t=Ui.defaults.color,Ui.string_colors[e]=t,t},Ui.evalCachedColorProperty=function(e,t){if(void 0===t&&(t={}),null!=e){if(e.dynamic){var r=Yi(e.dynamic,t);return "string"==typeof r&&(r=Ui.colorForString(r)),r&&null==r[3]&&(r[3]=1),r}if(e.static)return e.static;if(e.zoom&&e.zoom[t.zoom])return e.zoom[t.zoom];if("function"==typeof e.value){e.dynamic=e.value;var n=Yi(e.dynamic,t);return "string"==typeof n&&(n=Ui.colorForString(n)),n&&null==n[3]&&(n[3]=1),n}if("string"==typeof e.value)return e.static=Ui.colorForString(e.value),e.static;if(e.zoom){if(!e.zoom_preprocessed){for(var i=0;i<e.value.length;i++){var o=e.value[i];o&&"string"==typeof o[1]&&(o[1]=Ui.colorForString(o[1]));}e.zoom_preprocessed=!0;}return e.zoom[t.zoom]=Qr.interpolate(t.zoom,e.value),e.zoom[t.zoom][3]=e.zoom[t.zoom][3]||1,e.zoom[t.zoom]}return e.static=e.value.map(function(e){return e}),e.static&&null==e.static[3]&&(e.static[3]=1),e.static}},Ui.evalCachedColorPropertyWithAlpha=function(e,t,r){var n=Ui.evalCachedColorProperty(e,r);if(null!=n&&null!=t){var i=Ui.evalCachedProperty(t,r);if(null!=i)return [n[0],n[1],n[2],i]}return n},Ui.parseColor=function(e,t){if(void 0===t&&(t={}),"function"==typeof e&&(e=Yi(e,t)),"string"==typeof e)e=Ui.colorForString(e);else if(Array.isArray(e)&&Array.isArray(e[0])){for(var r=0;r<e.length;r++){var n=e[r];"string"==typeof n[1]&&(n[1]=Ui.colorForString(n[1]));}t.zoom&&(e=Qr.interpolate(t.zoom,e));}return Array.isArray(e)?null==(e=e.map(function(e){return e}))[3]&&(e[3]=1):e=[0,0,0,1],e},Ui.calculateOrder=function(e,t){return "function"==typeof e?e=Yi(e,t):"string"==typeof e&&(e=t.feature.properties[e]?t.feature.properties[e]:ji(e)),e},Ui.evalProperty=function(e,t){return "function"==typeof e?Yi(e,t):e},D(D.P,"Array",{fill:Un}),w("fill");var Zi,Ji=function(){function e(e,t,r){this.gl=e,this.workers=t,this._lock_fn="function"==typeof r&&r,this.init();}var t=e.prototype;return t.init=function(){this.requests={},this.feature=null,this.read_delay=0,this.read_delay_timer=null,this.pixels=null,this.fbo=this.gl.createFramebuffer(),this.gl.bindFramebuffer(this.gl.FRAMEBUFFER,this.fbo),this.fbo_size={width:256,height:256};var e=Hn.create(this.gl,"__selection_fbo",{filtering:"nearest"});e.setData(this.fbo_size.width,this.fbo_size.height,null,{filtering:"nearest"}),this.gl.framebufferTexture2D(this.gl.FRAMEBUFFER,this.gl.COLOR_ATTACHMENT0,this.gl.TEXTURE_2D,e.texture,0);var t=this.gl.createRenderbuffer();this.gl.bindRenderbuffer(this.gl.RENDERBUFFER,t),this.gl.renderbufferStorage(this.gl.RENDERBUFFER,this.gl.DEPTH_COMPONENT16,this.fbo_size.width,this.fbo_size.height),this.gl.framebufferRenderbuffer(this.gl.FRAMEBUFFER,this.gl.DEPTH_ATTACHMENT,this.gl.RENDERBUFFER,t),this.gl.bindFramebuffer(this.gl.FRAMEBUFFER,null);},t.destroy=function(){this.gl&&this.fbo&&(this.gl.deleteFramebuffer(this.fbo),this.fbo=null,this.gl.bindFramebuffer(this.gl.FRAMEBUFFER,null));},t.bind=function(){var t;this.gl.bindFramebuffer(this.gl.FRAMEBUFFER,this.fbo),this.gl.viewport(0,0,this.fbo_size.width,this.fbo_size.height),(t=this.gl).clearColor.apply(t,e.defaultColor);},t.getFeatureAt=function(e,t){var r=this,n=t.radius;return !e||e.x<0||e.y<0||e.x>1||e.y>1?Promise.resolve({feature:null,changed:!1}):new Promise(function(t,i){r.selection_request_id=r.selection_request_id+1||0,r.requests[r.selection_request_id]={id:r.selection_request_id,point:e,radius:n,resolve:t,reject:i};})},t.pendingRequests=function(){return Object.keys(this.requests).length?this.requests:null},t.hasPendingRequests=function(){return null!=this.pendingRequests()},t.clearPendingRequests=function(){for(var e in this.requests){var t=this.requests[e];t.sent||(t.reject({request:t}),delete this.requests[e]);}},t.read=function(){var e=this;null!=this.read_delay_timer&&clearTimeout(this.read_delay_timer),this.read_delay_timer=setTimeout(function(){if(!e.locked){var t=e.gl;for(var r in t.bindFramebuffer(t.FRAMEBUFFER,e.fbo),e.requests){var n=e.requests[r];if(!n.sent){var i=void 0,o=255,s=n.point,a=n.radius,l=void 0;if(a){var u=Math.min(e.fbo_size.width,e.fbo_size.height);l={x:Math.min(Math.ceil(2*a.x*e.fbo_size.width),u),y:Math.min(Math.ceil(2*a.y*e.fbo_size.height),u)};}else a={x:0,y:0},l={x:1,y:1};if((null==e.pixels||e.pixels.byteLength<l.x*l.y*4)&&(e.pixels=new Uint8Array(l.x*l.y*4)),e.pixels.fill instanceof Function)e.pixels.fill(0);else for(var c=0;c<e.pixels.length;c++)e.pixels[c]=0;t.readPixels(Math.round((s.x-a.x)*e.fbo_size.width),Math.round((1-s.y-a.y)*e.fbo_size.height),l.x,l.y,t.RGBA,t.UNSIGNED_BYTE,e.pixels);var f=4*(Math.round(l.y/2)*l.x+Math.round(l.x/2)),h=e.pixels[f]+(e.pixels[f+1]<<8)+(e.pixels[f+2]<<16);if(h>0)i=h+(e.pixels[f+3]<<24)>>>0,o=e.pixels[f+3];else {var d=-1>>>0;f=0;for(var p=0;p<l.y;p++)for(var _=0;_<l.x;_++,f+=4)if((h=e.pixels[f]+(e.pixels[f+1]<<8)+(e.pixels[f+2]<<16))>0){var m=(_-l.x/2)*(_-l.x/2)+(p-l.y/2)*(p-l.y/2);m<=d&&(i=h+(e.pixels[f+3]<<24)>>>0,o=e.pixels[f+3],d=m);}}255!==o?null!=e.workers[o]&&jr.postMessage(e.workers[o],"self.getFeatureSelection",{id:n.id,key:i}).then(function(t){e.finishRead(t);}):e.finishRead({id:n.id}),n.sent=!0;}}t.bindFramebuffer(t.FRAMEBUFFER,null);}},this.read_delay);},t.finishRead=function(e){var t=this.requests[e.id];if(t){var r=e.feature,n=!1;(null!=r&&null==this.feature||null==r&&null!=this.feature||null!=r&&null!=this.feature&&JSON.stringify(r)!==JSON.stringify(this.feature))&&(n=!0),this.feature=r,t.resolve({feature:r,changed:n,request:t}),delete this.requests[e.id];}else Zr("error","FeatureSelection.finishRead(): could not find message",e);},e.makeEntry=function(e){this.map_entry++;var t=255&this.map_entry,r=this.map_entry>>8&255,n=this.map_entry>>16&255,i=this.map_prefix,o=t/255,s=r/255,a=n/255,l=i/255,u=t+(r<<8)+(n<<16)+(i<<24)>>>0;return this.map[u]={color:[o,s,a,l]},this.map_size++,this.tiles[e.key]||(this.tiles[e.key]={entries:[],tile:{key:e.key,coords:e.coords,style_z:e.style_z,source:e.source,generation:e.generation}}),this.tiles[e.key].entries.push(u),this.map[u]},e.makeColor=function(e,t,r){var n=this.makeEntry(t);return n.feature={id:e.id,properties:e.properties,source_name:r.source,source_layer:r.layer,layers:r.layers,tile:this.tiles[t.key].tile},n.color},e.reset=function(e){var t=this;Array.isArray(e)?e.forEach(function(e){return t.clearSource(e)}):(this.tiles={},this.map={},this.map_size=0,this.map_entry=0);},e.clearSource=function(e){for(var t in this.tiles)this.tiles[t].tile.source===e&&this.clearTile(t);},e.clearTile=function(e){var t=this;this.tiles[e]&&(this.tiles[e].entries.forEach(function(e){return delete t.map[e]}),this.map_size-=this.tiles[e].entries.length,delete this.tiles[e]);},e.getMapSize=function(){return this.map_size},e.setPrefix=function(e){this.map_prefix=e;},dt(e,[{key:"locked",get:function(){return this._lock_fn&&this._lock_fn()||!1}}]),e}();Ji.map={},Ji.tiles={},Ji.map_size=0,Ji.map_entry=0,Ji.map_prefix=0,Ji.defaultColor=[0,0,0,1];var Ki=Zi={};Zi.BYTE=5120,Zi.UNSIGNED_BYTE=5121,Zi.SHORT=5122,Zi.UNSIGNED_SHORT=5123,Zi.INT=5124,Zi.UNSIGNED_INT=5125,Zi.FLOAT=5126,qn("Uint16",2,function(e){return function(t,r,n){return e(this,t,r,n)}});var $i=function(){function e(e,t,r,n,i){i=i||{},this.gl=e,this.vertex_data=t,this.element_data=r,this.vertex_layout=n,this.vertex_buffer=this.gl.createBuffer(),this.buffer_size=this.vertex_data.byteLength,this.draw_mode=i.draw_mode||this.gl.TRIANGLES,this.data_usage=i.data_usage||this.gl.STATIC_DRAW,this.vertices_per_geometry=3,this.uniforms=i.uniforms,this.textures=i.textures,this.retain=i.retain||!1,this.created_at=+new Date,this.fade_in_time=i.fade_in_time||0,this.vertex_count=this.vertex_data.byteLength/this.vertex_layout.stride,this.element_count=0,this.vaos={},this.toggle_element_array=!1,this.element_data?(this.toggle_element_array=!0,this.element_count=this.element_data.length,this.geometry_count=this.element_count/this.vertices_per_geometry,this.element_type=this.element_data.constructor===Uint16Array?this.gl.UNSIGNED_SHORT:this.gl.UNSIGNED_INT,this.element_buffer=this.gl.createBuffer(),this.buffer_size+=this.element_data.byteLength,this.gl.bindBuffer(this.gl.ELEMENT_ARRAY_BUFFER,this.element_buffer),this.gl.bufferData(this.gl.ELEMENT_ARRAY_BUFFER,this.element_data,this.data_usage)):this.geometry_count=this.vertex_count/this.vertices_per_geometry,this.upload(),this.retain||(delete this.vertex_data,delete this.element_data),this.valid=!0;}var t=e.prototype;return t.render=function(e){if(void 0===e&&(e={}),!this.valid)return !1;var t=e.program||Qn.current;t.use(),this.uniforms&&(t.saveUniforms(this.uniforms),t.setUniforms(this.uniforms,!1));var r=(+new Date-this.created_at)/1e3;return t.uniform("1f","u_visible_time",r),this.bind(t),this.toggle_element_array?this.gl.drawElements(this.draw_mode,this.element_count,this.element_type,0):this.gl.drawArrays(this.draw_mode,0,this.vertex_count),ei.bind(this.gl,null),this.uniforms&&t.restoreUniforms(this.uniforms),r<this.fade_in_time},t.bind=function(e){var t=this,r=this.vaos[e.id];r?ei.bind(this.gl,r):this.vaos[e.id]=ei.create(this.gl,function(){t.gl.bindBuffer(t.gl.ARRAY_BUFFER,t.vertex_buffer),t.toggle_element_array&&t.gl.bindBuffer(t.gl.ELEMENT_ARRAY_BUFFER,t.element_buffer),t.vertex_layout.enableDynamicAttributes(t.gl,e);}),this.vertex_layout.enableStaticAttributes(this.gl,e);},t.upload=function(){this.gl.bindBuffer(this.gl.ARRAY_BUFFER,this.vertex_buffer),this.gl.bufferData(this.gl.ARRAY_BUFFER,this.vertex_data,this.data_usage);},t.destroy=function(){if(!this.valid)return !1;for(var e in this.valid=!1,this.vaos)ei.destroy(this.gl,this.vaos[e]);return this.gl.deleteBuffer(this.vertex_buffer),this.vertex_buffer=null,this.element_buffer&&(this.gl.deleteBuffer(this.element_buffer),this.element_buffer=null),delete this.vertex_data,delete this.element_data,this.textures&&this.textures.forEach(function(e){return Hn.release(e)}),!0},e}(),Qi=["emission","ambient","diffuse","specular"],eo=function(){function e(e){var t=this;e=e||{},Qi.forEach(function(r){var n=e[r];null!=n&&(n.texture?t[r]={texture:n.texture,mapping:n.mapping||"spheremap",scale:Xn.expandVec3(null!=n.scale?n.scale:1),amount:Xn.expandVec4(null!=n.amount?n.amount:1)}:"number"==typeof n||Array.isArray(n)?t[r]={amount:Xn.expandVec4(n)}:t[r]="string"==typeof n?{amount:Ui.parseColor(n)}:n);}),this.specular&&(this.specular.shininess=e.shininess?parseFloat(e.shininess):.2),null!=e.normal&&(this.normal={texture:e.normal.texture,mapping:e.normal.mapping||"triplanar",scale:Xn.expandVec3(null!=e.normal.scale?e.normal.scale:1),amount:null!=e.normal.amount?e.normal.amount:1});}e.isValid=function(e){return null!=e&&(null!=e.emission||null!=e.ambient||null!=e.diffuse||null!=e.specular)};var t=e.prototype;return t.inject=function(t){var r=this;Qi.forEach(function(e){var n="TANGRAM_MATERIAL_"+e.toUpperCase(),i=n+"_TEXTURE";t.defines[n]=null!=r[e],r[e]&&r[e].texture&&(t.defines[i]=!0,t.defines[i+"_"+r[e].mapping.toUpperCase()]=!0,t.defines["TANGRAM_MATERIAL_TEXTURE_"+r[e].mapping.toUpperCase()]=!0,t.texcoords=t.texcoords||"uv"===r[e].mapping);}),this.normal&&this.normal.texture&&(t.defines.TANGRAM_MATERIAL_NORMAL_TEXTURE=!0,t.defines["TANGRAM_MATERIAL_NORMAL_TEXTURE_"+this.normal.mapping.toUpperCase()]=!0,t.defines["TANGRAM_MATERIAL_TEXTURE_"+this.normal.mapping.toUpperCase()]=!0,t.texcoords=t.texcoords||"uv"===this.normal.mapping),t.replaceShaderBlock(e.block,"/*\n\nDefines globals:\nmaterial\nlight_accumulator_*\n\n*/\n\n\n// MATERIALS\n//\nstruct Material {\n    #ifdef TANGRAM_MATERIAL_EMISSION\n        vec4 emission;\n        #ifdef TANGRAM_MATERIAL_EMISSION_TEXTURE\n            vec3 emissionScale;\n        #endif\n    #endif\n\n    #ifdef TANGRAM_MATERIAL_AMBIENT\n        vec4 ambient;\n        #ifdef TANGRAM_MATERIAL_AMBIENT_TEXTURE\n            vec3 ambientScale;\n        #endif\n    #endif\n\n    #ifdef TANGRAM_MATERIAL_DIFFUSE\n        vec4 diffuse;\n        #ifdef TANGRAM_MATERIAL_DIFFUSE_TEXTURE\n            vec3 diffuseScale;\n        #endif\n    #endif\n\n    #ifdef TANGRAM_MATERIAL_SPECULAR\n        vec4 specular;\n        float shininess;\n        #ifdef TANGRAM_MATERIAL_SPECULAR_TEXTURE\n            vec3 specularScale;\n        #endif\n    #endif\n\n\n    #ifdef TANGRAM_MATERIAL_NORMAL_TEXTURE\n        vec3 normalScale;\n        float normalAmount;\n    #endif\n};\n\n// Note: uniform is copied to a global instance to allow modification\nuniform Material u_material;\nMaterial material;\n\n#ifdef TANGRAM_MATERIAL_EMISSION_TEXTURE\nuniform sampler2D u_material_emission_texture;\n#endif\n\n#ifdef TANGRAM_MATERIAL_AMBIENT_TEXTURE\nuniform sampler2D u_material_ambient_texture;\n#endif\n\n#ifdef TANGRAM_MATERIAL_DIFFUSE_TEXTURE\nuniform sampler2D u_material_diffuse_texture;\n#endif\n\n#ifdef TANGRAM_MATERIAL_SPECULAR_TEXTURE\nuniform sampler2D u_material_specular_texture;\n#endif\n\n#ifdef TANGRAM_MATERIAL_NORMAL_TEXTURE\nuniform sampler2D u_material_normal_texture;\n#endif\n\n// Global light accumulators for each property\nvec4 light_accumulator_ambient = vec4(vec3(0.0), 1.);\nvec4 light_accumulator_diffuse = vec4(vec3(0.0), 1.);\n#ifdef TANGRAM_MATERIAL_SPECULAR\n    vec4 light_accumulator_specular = vec4(vec3(0.0), 1.);\n#endif\n\n\n#ifdef TANGRAM_MATERIAL_TEXTURE_SPHEREMAP\nvec4 getSphereMap (in sampler2D _tex, in vec3 _eyeToPoint, in vec3 _normal, in vec2 _skew) {\n    // Normalized vector from camera to surface\n    vec3 eye = normalize(_eyeToPoint);\n\n    // Adjust for camera skew\n    eye.xy -= _skew;\n    eye = normalize(eye);\n\n    // Reflection of eye off of surface normal\n    vec3 r = reflect(eye, _normal);\n\n    // Map reflected vector onto the surface of a sphere\n    r.z += 1.0;\n    float m = 2. * length(r);\n\n    // Adjust xy to account for spherical shape, and center in middle of texture\n    vec2 uv = r.xy / m + .5;\n\n    // Sample the environment map\n    return texture2D(_tex, uv);\n}\n#endif\n\n\n#ifdef TANGRAM_MATERIAL_TEXTURE_TRIPLANAR\nvec3 getTriPlanarBlend (in vec3 _normal) {\n    vec3 blending = abs(_normal);\n    blending = normalize(max(blending, 0.00001));\n    float b = (blending.x + blending.y + blending.z);\n    return blending / b;\n}\n\nvec4 getTriPlanar (in sampler2D _tex, in vec3 _pos, in vec3 _normal, in vec3 _scale) {\n    vec3 blending = getTriPlanarBlend(_normal);\n    vec4 xaxis = texture2D(_tex, fract(_pos.yz * _scale.x));\n    vec4 yaxis = texture2D(_tex, fract(_pos.xz * _scale.y));\n    vec4 zaxis = texture2D(_tex, fract(_pos.xy * _scale.z));\n    return  xaxis * blending.x + yaxis * blending.y + zaxis * blending.z;\n}\n#endif\n\n\n#ifdef TANGRAM_MATERIAL_TEXTURE_PLANAR\nvec4 getPlanar (in sampler2D _tex, in vec3 _pos, in vec2 _scale) {\n    return texture2D( _tex, fract(_pos.xy * _scale.x) );\n}\n#endif\n\n\n#ifdef TANGRAM_MATERIAL_NORMAL_TEXTURE\nvoid calculateNormal (inout vec3 _normal) {\n    // Get NORMALMAP\n    //------------------------------------------------\n    #ifdef TANGRAM_MATERIAL_NORMAL_TEXTURE_UV\n    _normal += texture2D(u_material_normal_texture, fract(v_texcoord*material.normalScale.xy)).rgb*2.0-1.0;\n    #endif\n\n    #ifdef TANGRAM_MATERIAL_NORMAL_TEXTURE_PLANAR\n    vec3 normalTex = getPlanar(u_material_normal_texture, v_world_position.xyz, material.normalScale.xy).rgb*2.0-1.0;\n    _normal += normalTex;\n    #endif\n\n    #ifdef TANGRAM_MATERIAL_NORMAL_TEXTURE_TRIPLANAR\n    vec3 normalTex = getTriPlanar(u_material_normal_texture, v_world_position.xyz, _normal, material.normalScale).rgb*2.0-1.0;\n    _normal += normalTex;\n    #endif\n\n    _normal = normalize(_normal);\n}\n#endif\n\nvoid calculateMaterial (in vec3 _eyeToPoint, inout vec3 _normal) {\n    // get EMISSION TEXTUREMAP\n    //------------------------------------------------\n    #ifdef TANGRAM_MATERIAL_EMISSION_TEXTURE\n        #ifdef TANGRAM_MATERIAL_EMISSION_TEXTURE_UV\n        material.emission *= texture2D(u_material_emission_texture,v_texcoord);\n        #endif\n\n        #ifdef TANGRAM_MATERIAL_EMISSION_TEXTURE_PLANAR\n        material.emission *= getPlanar(u_material_emission_texture, v_world_position.xyz, material.emissionScale.xy);\n        #endif\n\n        #ifdef TANGRAM_MATERIAL_EMISSION_TEXTURE_TRIPLANAR\n        material.emission *= getTriPlanar(u_material_emission_texture, v_world_position.xyz, _normal, material.emissionScale);\n        #endif\n\n        #ifdef TANGRAM_MATERIAL_EMISSION_TEXTURE_SPHEREMAP\n        material.emission *= getSphereMap(u_material_emission_texture, _eyeToPoint, _normal, u_vanishing_point);\n        #endif\n    #endif\n\n    // get AMBIENT TEXTUREMAP\n    //------------------------------------------------\n    #ifdef TANGRAM_MATERIAL_AMBIENT_TEXTURE\n        #ifdef TANGRAM_MATERIAL_AMBIENT_TEXTURE_UV\n        material.ambient *= texture2D(u_material_ambient_texture,v_texcoord);\n        #endif\n\n        #ifdef TANGRAM_MATERIAL_AMBIENT_TEXTURE_PLANAR\n        material.ambient *= getPlanar(u_material_ambient_texture, v_world_position.xyz, material.ambientScale.xy);\n        #endif\n\n        #ifdef TANGRAM_MATERIAL_AMBIENT_TEXTURE_TRIPLANAR\n        material.ambient *= getTriPlanar(u_material_ambient_texture, v_world_position.xyz, _normal, material.ambientScale);\n        #endif\n\n        #ifdef TANGRAM_MATERIAL_AMBIENT_TEXTURE_SPHEREMAP\n        material.ambient *= getSphereMap(u_material_ambient_texture, _eyeToPoint, _normal, u_vanishing_point);\n        #endif\n    #endif\n\n    // get DIFFUSE TEXTUREMAP\n    //------------------------------------------------\n    #ifdef TANGRAM_MATERIAL_DIFFUSE_TEXTURE\n        #ifdef TANGRAM_MATERIAL_DIFFUSE_TEXTURE_UV\n        material.diffuse *= texture2D(u_material_diffuse_texture,v_texcoord);\n        #endif\n\n        #ifdef TANGRAM_MATERIAL_DIFFUSE_TEXTURE_PLANAR\n        material.diffuse *= getPlanar(u_material_diffuse_texture, v_world_position.xyz, material.diffuseScale.xy);\n        #endif\n\n        #ifdef TANGRAM_MATERIAL_DIFFUSE_TEXTURE_TRIPLANAR\n        material.diffuse *= getTriPlanar(u_material_diffuse_texture, v_world_position.xyz, _normal, material.diffuseScale);\n        #endif\n\n        #ifdef TANGRAM_MATERIAL_DIFFUSE_TEXTURE_SPHEREMAP\n        material.diffuse *= getSphereMap(u_material_diffuse_texture, _eyeToPoint, _normal, u_vanishing_point);\n        #endif\n    #endif\n\n    // get SPECULAR TEXTUREMAP\n    //------------------------------------------------\n    #ifdef TANGRAM_MATERIAL_SPECULAR_TEXTURE\n        #ifdef TANGRAM_MATERIAL_SPECULAR_TEXTURE_UV\n        material.specular *= texture2D(u_material_specular_texture,v_texcoord);\n        #endif\n\n        #ifdef TANGRAM_MATERIAL_SPECULAR_TEXTURE_PLANAR\n        material.specular *= getPlanar(u_material_specular_texture, v_world_position.xyz, material.specularScale.xy);\n        #endif\n\n        #ifdef TANGRAM_MATERIAL_SPECULAR_TEXTURE_TRIPLANAR\n        material.specular *= getTriPlanar(u_material_specular_texture, v_world_position.xyz, _normal, material.specularScale);\n        #endif\n\n        #ifdef TANGRAM_MATERIAL_SPECULAR_TEXTURE_SPHEREMAP\n        material.specular *= getSphereMap(u_material_specular_texture, _eyeToPoint, _normal, u_vanishing_point);\n        #endif\n    #endif\n}\n","Material"),t.addShaderBlock("setup","\nmaterial = u_material;\n","Material");},t.setupProgram=function(e){var t=this;Qi.forEach(function(r){t[r]&&(t[r].texture?(e.setTextureUniform("u_material_"+r+"_texture",t[r].texture),e.uniform("3fv","u_material."+r+"Scale",t[r].scale),e.uniform("4fv","u_material."+r,t[r].amount)):t[r].amount&&e.uniform("4fv","u_material."+r,t[r].amount));}),this.specular&&e.uniform("1f","u_material.shininess",this.specular.shininess),this.normal&&this.normal.texture&&(e.setTextureUniform("u_material_normal_texture",this.normal.texture),e.uniform("3fv","u_material.normalScale",this.normal.scale),e.uniform("1f","u_material.normalAmount",this.normal.amount));},e}();eo.block="material";var to,ro=/"/g,no=function(e,t,r,n){var i=String(P(e)),o="<"+t;return ""!==r&&(o+=" "+r+'="'+String(n).replace(ro,"&quot;")+'"'),o+">"+i+"</"+t+">"},io=function(e,t){var r={};r[e]=t(no),D(D.P+D.F*f(function(){var t=""[e]('"');return t!==t.toLowerCase()||t.split('"').length>3}),"String",r);};io("sub",function(e){return function(){return e(this,"sub","","")}});var oo=to={};to.copy=function(e){for(var t=[],r=e.length,n=0;n<r;n++)t[n]=e[n];return t},to.neg=function(e){for(var t=[],r=e.length,n=0;n<r;n++)t[n]=-e[n];return t},to.add=function(e,t){for(var r=[],n=Math.min(e.length,t.length),i=0;i<n;i++)r[i]=e[i]+t[i];return r},to.sub=function(e,t){for(var r=[],n=Math.min(e.length,t.length),i=0;i<n;i++)r[i]=e[i]-t[i];return r},to.signed_area=function(e,t,r){return (t[0]-e[0])*(r[1]-e[1])-(r[0]-e[0])*(t[1]-e[1])},to.mult=function(e,t){var r,n=[],i=e.length;if("number"==typeof t)for(r=0;r<i;r++)n[r]=e[r]*t;else for(i=Math.min(e.length,t.length),r=0;r<i;r++)n[r]=e[r]*t[r];return n},to.div=function(e,t){var r,n=[];if("number"==typeof t)for(r=0;r<e.length;r++)n[r]=e[r]/t;else {var i=Math.min(e.length,t.length);for(r=0;r<i;r++)n[r]=e[r]/t[r];}return n},to.perp=function(e,t){return [t[1]-e[1],e[0]-t[0]]},to.rot=function(e,t){var r=Math.cos(t),n=Math.sin(t);return [e[0]*r-e[1]*n,e[0]*n+e[1]*r]},to.angle=function(e){var t=e[0],r=e[1];return Math.atan2(r,t)},to.angleBetween=function(e,t){var r=to.dot(to.normalize(to.copy(e)),to.normalize(to.copy(t)));return r>1&&(r=1),Math.acos(r)},to.isEqual=function(e,t){for(var r=e.length,n=0;n<r;n++)if(e[n]!==t[n])return !1;return !0},to.lengthSq=function(e){return 2===e.length?e[0]*e[0]+e[1]*e[1]:e.length>=3?e[0]*e[0]+e[1]*e[1]+e[2]*e[2]:0},to.length=function(e){return Math.sqrt(to.lengthSq(e))},to.normalize=function(e){var t;if(2===e.length){if(1===(t=e[0]*e[0]+e[1]*e[1]))return e;0!==(t=Math.sqrt(t))?(e[0]/=t,e[1]/=t):(e[0]=0,e[1]=0);}else if(e.length>=3){if(1===(t=e[0]*e[0]+e[1]*e[1]+e[2]*e[2]))return e;0!==(t=Math.sqrt(t))?(e[0]/=t,e[1]/=t,e[2]/=t):(e[0]=0,e[1]=0,e[2]=0);}return e},to.cross=function(e,t){return 2===e.length?e[0]*t[1]-e[1]*t[0]:3===e.length?[e[1]*t[2]-e[2]*t[1],e[2]*t[0]-e[0]*t[2],e[0]*t[1]-e[1]*t[0]]:void 0},to.dot=function(e,t){for(var r=0,n=Math.min(e.length,t.length),i=0;i<n;i++)r+=e[i]*t[i];return r};var so=function(){function e(e,t){this.name=t.name,this.view=e,null==t.ambient||"number"==typeof t.ambient?this.ambient=Xn.expandVec3(t.ambient||0):this.ambient=Ui.parseColor(t.ambient).slice(0,3),null==t.diffuse||"number"==typeof t.diffuse?this.diffuse=Xn.expandVec3(null!=t.diffuse?t.diffuse:1):this.diffuse=Ui.parseColor(t.diffuse).slice(0,3),null==t.specular||"number"==typeof t.specular?this.specular=Xn.expandVec3(t.specular||0):this.specular=Ui.parseColor(t.specular).slice(0,3);}e.create=function(t,r){if(e.types[r.type])return new e.types[r.type](t,r)},e.setMode=function(t,r){!0===t&&(t="fragment"),t=e.enabled&&(null!=t?t:"fragment"),r.defines.TANGRAM_LIGHTING_FRAGMENT="fragment"===t,r.defines.TANGRAM_LIGHTING_VERTEX="vertex"===t;},e.inject=function(t){if(Qn.removeBlock(e.block),e.enabled){var r="";if(t&&Object.keys(t).length>0){var n={};for(var i in t)n[t[i].type]=!0;for(var o in n)e.types[o].inject();for(var s in t)t[s].inject(),r+="calculateLight("+s+", _eyeToPoint, _normal);\n";}var a="\n            vec4 calculateLighting(in vec3 _eyeToPoint, in vec3 _normal, in vec4 _color) {\n\n                // Do initial material calculations over normal, emission, ambient, diffuse and specular values\n                calculateMaterial(_eyeToPoint,_normal);\n\n                // Un roll the loop of individual ligths to calculate\n                "+r+"\n\n                //  Final light intensity calculation\n                vec4 color = vec4(vec3(0.), _color.a); // start with vertex color alpha\n\n                #ifdef TANGRAM_MATERIAL_EMISSION\n                    color.rgb = material.emission.rgb;\n                    color.a *= material.emission.a;\n                #endif\n\n                #ifdef TANGRAM_MATERIAL_AMBIENT\n                    color.rgb += light_accumulator_ambient.rgb * _color.rgb * material.ambient.rgb;\n                    color.a *= material.ambient.a;\n                #else\n                    #ifdef TANGRAM_MATERIAL_DIFFUSE\n                        color.rgb += light_accumulator_ambient.rgb * _color.rgb * material.diffuse.rgb;\n                    #endif\n                #endif\n\n                #ifdef TANGRAM_MATERIAL_DIFFUSE\n                    color.rgb += light_accumulator_diffuse.rgb * _color.rgb * material.diffuse.rgb;\n                    color.a *= material.diffuse.a;\n                #endif\n\n                #ifdef TANGRAM_MATERIAL_SPECULAR\n                    color.rgb += light_accumulator_specular.rgb * material.specular.rgb;\n                    color.a *= material.specular.a;\n                #endif\n\n                // Clamp final color\n                color = clamp(color, 0.0, 1.0);\n\n                return color;\n            }";Qn.addBlock(e.block,a);}};var t=e.prototype;return t.inject=function(){var t="\n            uniform "+this.struct_name+" u_"+this.name+";\n            "+this.struct_name+" "+this.name+";\n            ",r="\n            "+this.name+" = u_"+this.name+";\n\n        ";Qn.addBlock(e.block,t),Qn.addBlock("setup",r);},t.update=function(){},t.setupProgram=function(e){e.uniform("3fv","u_"+this.name+".ambient",this.ambient),e.uniform("3fv","u_"+this.name+".diffuse",this.diffuse),e.uniform("3fv","u_"+this.name+".specular",this.specular);},e}();so.types={},so.block="lighting",so.enabled=!0;var ao=function(e){function t(t,r){var n;return (n=e.call(this,t,r)||this).type="ambient",n.struct_name="AmbientLight",n}return pt(t,e),t.inject=function(){Qn.addBlock(so.block,"/*\n\nExpected globals:\nlight_accumulator_*\n\n*/\n\nstruct AmbientLight {\n    vec3 ambient;\n};\n\nvoid calculateLight(in AmbientLight _light, in vec3 _eyeToPoint, in vec3 _normal) {\n    light_accumulator_ambient.rgb += _light.ambient;\n}\n");},t.prototype.setupProgram=function(e){e.uniform("3fv","u_"+this.name+".ambient",this.ambient);},t}(so);so.types.ambient=ao;var lo=function(e){function t(t,r){var n;if((n=e.call(this,t,r)||this).type="directional",n.struct_name="DirectionalLight",r.direction)n._direction=r.direction;else {var i=Math.sin(60*Math.PI/180);n._direction=[Math.cos(135*Math.PI/180)*i,Math.sin(135*Math.PI/180)*i,-.5],null==r.ambient&&(n.ambient=Xn.expandVec3(.5));}return n.direction=n._direction.map(parseFloat),n}return pt(t,e),t.inject=function(){Qn.addBlock(so.block,"/*\n\nExpected globals:\nmaterial\nlight_accumulator_*\n\n*/\n\nstruct DirectionalLight {\n    vec3 ambient;\n    vec3 diffuse;\n    vec3 specular;\n    vec3 direction;\n};\n\nvoid calculateLight(in DirectionalLight _light, in vec3 _eyeToPoint, in vec3 _normal) {\n\n    light_accumulator_ambient.rgb += _light.ambient;\n\n    float nDotVP = clamp(dot(_normal, -_light.direction), 0.0, 1.0);\n\n    #ifdef TANGRAM_MATERIAL_DIFFUSE\n        light_accumulator_diffuse.rgb += _light.diffuse * nDotVP;\n    #endif\n\n    #ifdef TANGRAM_MATERIAL_SPECULAR\n        float pf = 0.0;\n        if (nDotVP > 0.0) {\n            vec3 reflectVector = reflect(_light.direction, _normal);\n            float eyeDotR = max(dot(normalize(_eyeToPoint), reflectVector), 0.0);\n            pf = pow(eyeDotR, material.shininess);\n        }\n        light_accumulator_specular.rgb += _light.specular * pf;\n    #endif\n}\n");},t.prototype.setupProgram=function(t){e.prototype.setupProgram.call(this,t),t.uniform("3fv","u_"+this.name+".direction",this.direction);},dt(t,[{key:"direction",get:function(){return this._direction},set:function(e){this._direction=oo.normalize(oo.copy(e));}}]),t}(so);so.types.directional=lo;var uo=function(e){function t(t,r){var n;return (n=e.call(this,t,r)||this).type="point",n.struct_name="PointLight",n.position=r.position||[0,0,"100px"],n.position_eye=[],n.origin=r.origin||"ground",n.attenuation=isNaN(parseFloat(r.attenuation))?0:parseFloat(r.attenuation),r.radius?Array.isArray(r.radius)&&2===r.radius.length?n.radius=r.radius:n.radius=[null,r.radius]:n.radius=null,n}pt(t,e),t.inject=function(){Qn.addBlock(so.block,"/*\n\nExpected globals:\nmaterial\nlight_accumulator_*\n\n*/\n\nstruct PointLight {\n    vec3 ambient;\n    vec3 diffuse;\n    vec3 specular;\n    vec4 position;\n\n#ifdef TANGRAM_POINTLIGHT_ATTENUATION_EXPONENT\n    float attenuationExponent;\n#endif\n\n#ifdef TANGRAM_POINTLIGHT_ATTENUATION_INNER_RADIUS\n    float innerRadius;\n#endif\n\n#ifdef TANGRAM_POINTLIGHT_ATTENUATION_OUTER_RADIUS\n    float outerRadius;\n#endif\n};\n\nvoid calculateLight(in PointLight _light, in vec3 _eyeToPoint, in vec3 _normal) {\n\n    float dist = length(_light.position.xyz - _eyeToPoint);\n\n    // Compute vector from surface to light position\n    vec3 VP = (_light.position.xyz - _eyeToPoint) / dist;\n\n    // Normalize the vector from surface to light position\n    float nDotVP = clamp(dot(VP, _normal), 0.0, 1.0);\n\n    // Attenuation defaults\n    float attenuation = 1.0;\n    #ifdef TANGRAM_POINTLIGHT_ATTENUATION_EXPONENT\n        float Rin = 1.0;\n        float e = _light.attenuationExponent;\n\n        #ifdef TANGRAM_POINTLIGHT_ATTENUATION_INNER_RADIUS\n            Rin = _light.innerRadius;\n        #endif\n\n        #ifdef TANGRAM_POINTLIGHT_ATTENUATION_OUTER_RADIUS\n            float Rdiff = _light.outerRadius-Rin;\n            float d = clamp(max(0.0,dist-Rin)/Rdiff, 0.0, 1.0);\n            attenuation = 1.0-(pow(d,e));\n        #else\n            // If no outer is provide behaves like:\n            // https://imdoingitwrong.wordpress.com/2011/01/31/light-attenuation/\n            float d = max(0.0,dist-Rin)/Rin+1.0;\n            attenuation = clamp(1.0/(pow(d,e)), 0.0, 1.0);\n        #endif\n    #else\n        float Rin = 0.0;\n\n        #ifdef TANGRAM_POINTLIGHT_ATTENUATION_INNER_RADIUS\n            Rin = _light.innerRadius;\n            #ifdef TANGRAM_POINTLIGHT_ATTENUATION_OUTER_RADIUS\n                float Rdiff = _light.outerRadius-Rin;\n                float d = clamp(max(0.0,dist-Rin)/Rdiff, 0.0, 1.0);\n                attenuation = 1.0-d*d;\n            #else\n                // If no outer is provide behaves like:\n                // https://imdoingitwrong.wordpress.com/2011/01/31/light-attenuation/\n                float d = max(0.0,dist-Rin)/Rin+1.0;\n                attenuation = clamp(1.0/d, 0.0, 1.0);\n            #endif\n        #else\n            #ifdef TANGRAM_POINTLIGHT_ATTENUATION_OUTER_RADIUS\n                float d = clamp(dist/_light.outerRadius, 0.0, 1.0);\n                attenuation = 1.0-d*d;\n            #else\n                attenuation = 1.0;\n            #endif\n        #endif\n    #endif\n\n    // Computer accumulators\n    light_accumulator_ambient.rgb += _light.ambient * attenuation;\n\n    #ifdef TANGRAM_MATERIAL_DIFFUSE\n        light_accumulator_diffuse.rgb += _light.diffuse * nDotVP * attenuation;\n    #endif\n\n    #ifdef TANGRAM_MATERIAL_SPECULAR\n        float pf = 0.0; // power factor for shiny speculars\n        if (nDotVP > 0.0) {\n            vec3 reflectVector = reflect(-VP, _normal);\n            float eyeDotR = max(0.0, dot(-normalize(_eyeToPoint), reflectVector));\n            pf = pow(eyeDotR, material.shininess);\n        }\n\n        light_accumulator_specular.rgb += _light.specular * pf * attenuation;\n    #endif\n}\n");};var r=t.prototype;return r.inject=function(){e.prototype.inject.call(this),Qn.defines.TANGRAM_POINTLIGHT_ATTENUATION_EXPONENT=0!==this.attenuation,Qn.defines.TANGRAM_POINTLIGHT_ATTENUATION_INNER_RADIUS=null!=this.radius&&null!=this.radius[0],Qn.defines.TANGRAM_POINTLIGHT_ATTENUATION_OUTER_RADIUS=null!=this.radius;},r.update=function(){this.updateEyePosition();},r.updateEyePosition=function(){if("world"===this.origin){var e=ai.latLngToMeters([].concat(this.position));this.position_eye[0]=e[0]-this.view.camera.position_meters[0],this.position_eye[1]=e[1]-this.view.camera.position_meters[1],this.position_eye[2]=Ui.convertUnits(this.position[2],{zoom:this.view.zoom,meters_per_pixel:ai.metersPerPixel(this.view.zoom)}),this.position_eye[2]=this.position_eye[2]-this.view.camera.position_meters[2];}else "ground"!==this.origin&&"camera"!==this.origin||(this.position_eye=Ui.convertUnits(this.position,{zoom:this.view.zoom,meters_per_pixel:ai.metersPerPixel(this.view.zoom)}),"ground"===this.origin&&(this.position_eye[2]=this.position_eye[2]-this.view.camera.position_meters[2]));this.position_eye[3]=1;},r.setupProgram=function(t){e.prototype.setupProgram.call(this,t),t.uniform("4fv","u_"+this.name+".position",this.position_eye),Qn.defines.TANGRAM_POINTLIGHT_ATTENUATION_EXPONENT&&t.uniform("1f","u_"+this.name+".attenuationExponent",this.attenuation),Qn.defines.TANGRAM_POINTLIGHT_ATTENUATION_INNER_RADIUS&&t.uniform("1f","u_"+this.name+".innerRadius",Ui.convertUnits(this.radius[0],{zoom:this.view.zoom,meters_per_pixel:ai.metersPerPixel(this.view.zoom)})),Qn.defines.TANGRAM_POINTLIGHT_ATTENUATION_OUTER_RADIUS&&t.uniform("1f","u_"+this.name+".outerRadius",Ui.convertUnits(this.radius[1],{zoom:this.view.zoom,meters_per_pixel:ai.metersPerPixel(this.view.zoom)}));},t}(so);so.types.point=uo;var co=function(e){function t(t,r){var n;return (n=e.call(this,t,r)||this).type="spotlight",n.struct_name="SpotLight",n.direction=n._direction=(r.direction||[0,0,-1]).map(parseFloat),n.exponent=r.exponent?parseFloat(r.exponent):.2,n.angle=r.angle?parseFloat(r.angle):20,n}return pt(t,e),t.inject=function(){Qn.addBlock(so.block,"/*\n\nExpected globals:\nmaterial\nlight_accumulator_*\n\n*/\n\nstruct SpotLight {\n    vec3 ambient;\n    vec3 diffuse;\n    vec3 specular;\n    vec4 position;\n\n#ifdef TANGRAM_POINTLIGHT_ATTENUATION_EXPONENT\n    float attenuationExponent;\n#endif\n\n#ifdef TANGRAM_POINTLIGHT_ATTENUATION_INNER_RADIUS\n    float innerRadius;\n#endif\n\n#ifdef TANGRAM_POINTLIGHT_ATTENUATION_OUTER_RADIUS\n    float outerRadius;\n#endif\n\n    vec3 direction;\n    float spotCosCutoff;\n    float spotExponent;\n};\n\nvoid calculateLight(in SpotLight _light, in vec3 _eyeToPoint, in vec3 _normal) {\n\n    float dist = length(_light.position.xyz - _eyeToPoint);\n\n    // Compute vector from surface to light position\n    vec3 VP = (_light.position.xyz - _eyeToPoint) / dist;\n\n    // normal . light direction\n    float nDotVP = clamp(dot(_normal, VP), 0.0, 1.0);\n\n    // Attenuation defaults\n    float attenuation = 1.0;\n    #ifdef TANGRAM_POINTLIGHT_ATTENUATION_EXPONENT\n        float Rin = 1.0;\n        float e = _light.attenuationExponent;\n\n        #ifdef TANGRAM_POINTLIGHT_ATTENUATION_INNER_RADIUS\n            Rin = _light.innerRadius;\n        #endif\n\n        #ifdef TANGRAM_POINTLIGHT_ATTENUATION_OUTER_RADIUS\n            float Rdiff = _light.outerRadius-Rin;\n            float d = clamp(max(0.0,dist-Rin)/Rdiff, 0.0, 1.0);\n            attenuation = 1.0-(pow(d,e));\n        #else\n            // If no outer is provide behaves like:\n            // https://imdoingitwrong.wordpress.com/2011/01/31/light-attenuation/\n            float d = max(0.0,dist-Rin)/Rin+1.0;\n            attenuation = clamp(1.0/(pow(d,e)), 0.0, 1.0);\n        #endif\n    #else\n        float Rin = 0.0;\n\n        #ifdef TANGRAM_POINTLIGHT_ATTENUATION_INNER_RADIUS\n            Rin = _light.innerRadius;\n            #ifdef TANGRAM_POINTLIGHT_ATTENUATION_OUTER_RADIUS\n                float Rdiff = _light.outerRadius-Rin;\n                float d = clamp(max(0.0,dist-Rin)/Rdiff, 0.0, 1.0);\n                attenuation = 1.0-d*d;\n            #else\n                // If no outer is provide behaves like:\n                // https://imdoingitwrong.wordpress.com/2011/01/31/light-attenuation/\n                float d = max(0.0,dist-Rin)/Rin+1.0;\n                attenuation = clamp(1.0/d, 0.0, 1.0);\n            #endif\n        #else\n            #ifdef TANGRAM_POINTLIGHT_ATTENUATION_OUTER_RADIUS\n                float d = clamp(dist/_light.outerRadius, 0.0, 1.0);\n                attenuation = 1.0-d*d;\n            #else\n                attenuation = 1.0;\n            #endif\n        #endif\n    #endif\n\n    // spotlight attenuation factor\n    float spotAttenuation = 0.0;\n\n    // See if point on surface is inside cone of illumination\n    float spotDot = clamp(dot(-VP, _light.direction), 0.0, 1.0);\n\n    if (spotDot >= _light.spotCosCutoff) {\n        spotAttenuation = pow(spotDot, _light.spotExponent);\n    }\n\n    light_accumulator_ambient.rgb += _light.ambient * attenuation * spotAttenuation;\n\n    #ifdef TANGRAM_MATERIAL_DIFFUSE\n        light_accumulator_diffuse.rgb += _light.diffuse * nDotVP * attenuation * spotAttenuation;\n    #endif\n\n    #ifdef TANGRAM_MATERIAL_SPECULAR\n        // Power factor for shiny speculars\n        float pf = 0.0;\n        if (nDotVP > 0.0) {\n            vec3 reflectVector = reflect(-VP, _normal);\n            float eyeDotR = max(dot(-normalize(_eyeToPoint), reflectVector), 0.0);\n            pf = pow(eyeDotR, material.shininess);\n        }\n        light_accumulator_specular.rgb += _light.specular * pf * attenuation * spotAttenuation;\n    #endif\n}\n");},t.prototype.setupProgram=function(t){e.prototype.setupProgram.call(this,t),t.uniform("3fv","u_"+this.name+".direction",this.direction),t.uniform("1f","u_"+this.name+".spotCosCutoff",Math.cos(3.14159*this.angle/180)),t.uniform("1f","u_"+this.name+".spotExponent",this.exponent);},dt(t,[{key:"direction",get:function(){return this._direction},set:function(e){this._direction=oo.normalize(oo.copy(e));}}]),t}(uo);so.types.spotlight=co,D(D.S,"Math",{log2:function(e){return Math.log(e)/Math.LN2}});var fo=function(e){function t(t){var r;return (r=e.call(this)||this).name="MethodNotImplemented",r.message="Method "+t+" must be implemented in subclass",r}return pt(t,e),t}(gt(Error)),ho=function(){function e(e,t){var r=this;(this.validate(e),this.config=e,this.sources=t,this.id=e.id,this.name=e.name,this.pad_scale=e.pad_scale||1e-5,this.default_winding=null,this.rasters=[],Array.isArray(e.rasters)&&e.rasters.forEach(function(e){-1===r.rasters.indexOf(e)&&r.rasters.push(e);}),this.preprocess=e.preprocess,"function"==typeof this.preprocess&&this.preprocess.bind(this),this.transform=e.transform,"function"==typeof this.transform&&this.transform.bind(this),this.extra_data=e.extra_data,this.scripts=e.scripts,this.setZooms(e),this.zoom_offset=null!=e.zoom_offset?e.zoom_offset:0,this.zoom_offset<0)&&(Zr({level:"warn",once:!0},"Data source '"+this.name+"' zoom_offset must not be negative – setting to 0."),this.zoom_offset=0);this.setTileSize(e.tile_size),this.min_display_zoom=Math.max(e.min_display_zoom||0,this.zooms[0]),this.max_display_zoom=null!=e.max_display_zoom?e.max_display_zoom:null;}e.register=function(t,r){t&&r&&(e.types[t]=r);},e.create=function(t,r){if("function"==typeof e.types[t.type]){var n=e.types[t.type](t);if(n)return new n(t,r)}},e.tileLayoutChanged=function(e,t){if(!e||!t)return !0;var r=["max_zoom","zooms","min_display_zoom","max_display_zoom","bounds","tile_size","zoom_offset"],n=Mn(e.config,r),i=Mn(t.config,r);return JSON.stringify(n)!==JSON.stringify(i)},e.projectData=function(e){var t=+new Date;for(var r in e.layers)for(var n=e.layers[r].features.length,i=0;i<n;i++){var o=e.layers[r].features[i];ai.transformGeometry(o.geometry,this.projectCoord);}void 0!==e.debug&&(e.debug.projection=+new Date-t);},e.projectCoord=function(e){ai.latLngToMeters(e);},e.scaleData=function(e,t){var r=t.coords.z,n=t.min,i=ai.unitsPerMeter(r);for(var o in e.layers)for(var s=e.layers[o].features.length,a=0;a<s;a++){var l=e.layers[o].features[a];ai.transformGeometry(l.geometry,function(e){e[0]=(e[0]-n.x)*i,e[1]=(e[1]-n.y)*i*-1;});}};var t=e.prototype;return t.load=function(e){var t=this;return e.source_data={},e.source_data.layers={},e.pad_scale=this.pad_scale,e.rasters=[].concat(this.rasters),this._load(e).then(function(e){for(var r in e.source_data.layers){var n=e.source_data.layers[r];n&&n.features&&n.features.forEach(function(e){ai.transformGeometry(e.geometry,function(e){e[1]=-e[1],t.pad_scale&&(e[0]=Math.round(e[0]*(1+t.pad_scale)-ai.tile_scale*t.pad_scale/2),e[1]=Math.round(e[1]*(1+t.pad_scale)-ai.tile_scale*t.pad_scale/2));}),t.updateDefaultWinding(e.geometry);});}return e.default_winding=t.default_winding||"CCW",e})},t._load=function(){throw new fo("_load")},t.copyTileData=function(e,t){return Zr("trace","Copy tile data from "+e.key+" to "+t.key),t.source_data={layers:e.source_data.layers},t.rasters=[].concat(e.rasters),t.pad_scale=e.pad_scale,t.default_winding=e.default_winding,t},t.setZooms=function(e){var t=e.max_zoom,r=e.zooms;if(this.max_zoom=null!=t?t:ai.default_source_max_zoom,Array.isArray(r))this.zooms=r,this.max_zoom=this.zooms[this.zooms.length-1];else {this.zooms=[];for(var n=0;n<=this.max_zoom;n++)this.zooms[n]=n;}},t.setTileSize=function(e){this.tile_size=e||256,("number"!=typeof this.tile_size||this.tile_size<256||!Qr.isPowerOf2(this.tile_size))&&(Zr({level:"warn",once:!0},"Data source '"+this.name+"': 'tile_size' parameter must be a number that is a power of 2 greater than or equal to 256, but was '"+e+"'"),this.tile_size=256),this.zoom_bias=Math.log2(this.tile_size)-8+this.zoom_offset;},t.updateDefaultWinding=function(e){return null==this.default_winding&&("Polygon"===e.type?this.default_winding=ai.ringWinding(e.coordinates[0]):"MultiPolygon"===e.type&&(this.default_winding=ai.ringWinding(e.coordinates[0][0]))),this.default_winding},t.includesTile=function(e,t){if(e.z<this.min_display_zoom||null!=this.max_display_zoom&&t>this.max_display_zoom)return !1;for(var r=0;r<this.rasters.length;r++){var n=this.rasters[r];if(this.sources[n]&&this.sources[n]!==this&&!this.sources[n].includesTile(e,e.z))return !1}return !0},t.validate=function(){},e}();ho.types={};var po=0,_o=function(e){function t(t,r){var n;(n=e.call(this,t,r)||this).response_type="";var i=function(e,t){if(!t||0===Object.keys(t).length)return [e,[]];var r=e.indexOf("?"),n=e.indexOf("#"),i="";n>-1&&(i=e.slice(n),e=e.slice(0,n)),-1===r&&(r=e.length,e+="?"),r++;var o="",s=[];for(var a in t)""===wn(a,e)?o+=a+"="+t[a]+"&":s.push([a,t[a]]);return [e=e.slice(0,r)+o+e.slice(r)+i,s]}(t.url,t.url_params),o=i[0],s=i[1];return n.url=o,s.forEach(function(e){var r=e[0],i=e[1];Zr({level:"warn",once:!0},"Data source '"+n.name+"': parameter '"+r+"' already present in URL '"+t.url+"', skipping value '"+r+"="+i+"' specified in 'url_params'");}),t.request_headers&&"object"==typeof t.request_headers&&(n.request_headers=t.request_headers),n}pt(t,e);var r=t.prototype;return r._load=function(e){var t=this,r=this.formatURL(this.url,e),n=e.source_data;return n.url=r,e.debug=e.debug||{},e.debug.network=+new Date,new Promise(function(i){var o=po+++"-"+r,s=Qr.io(r,6e4,t.response_type,"GET",t.request_headers,o);n.request_id=o,n.error=null,s.then(function(r){var o=r.body;e.debug.response_size=o&&(o.length||o.byteLength),e.debug.network=+new Date-e.debug.network,e.debug.parsing=+new Date,null!=o&&"function"==typeof t.preprocess&&(o=t.preprocess(o)),(o=o instanceof Promise?o:Promise.resolve(o)).then(function(r){null!=r?t.parseSourceData(e,n,r):n.layers={},e.debug.parsing=+new Date-e.debug.parsing,i(e);});}).catch(function(t){n.error=t.stack,i(e);});})},r.validate=function(e){if("string"!=typeof e.url)throw Error("Network data source must provide a string `url` property")},r.formatURL=function(){throw new fo("formatURL")},r.parseSourceData=function(){throw new fo("parseSourceData")},t}(ho),mo=function(e){function t(t,r){var n;return (n=e.call(this,t,r)||this).tiled=!0,n.bounds=n.parseBounds(t),n.builds_geometry_tiles=!1,n.tms=!0===t.tms,n.url&&n.url.search("{s}")>-1&&(Array.isArray(t.url_subdomains)&&t.url_subdomains.length>0?(n.url_subdomains=t.url_subdomains,n.next_url_subdomain=0):Zr({level:"warn",once:!0},"Data source '"+n.name+"': source URL includes '{s}' subdomain marker ('"+n.url+"'), but no subdomains were specified in 'url_subdomains' parameter")),n.url&&n.url.search("{r}")>-1&&(Array.isArray(t.url_density_scales)&&t.url_density_scales.length>0?n.url_density_scales=t.url_density_scales:n.url_density_scales=[1,2]),n}pt(t,e);var r=t.prototype;return r.parseBounds=function(e){if(Array.isArray(e.bounds)&&4===e.bounds.length){var t=e.bounds,r=t[0],n=t[1],i=t[2],o=t[3];return {latlng:[].concat(e.bounds),meters:{min:ai.latLngToMeters([r,o]),max:ai.latLngToMeters([i,n])},tiles:{min:{},max:{}}}}},r.checkBounds=function(e,t){if(t){e=ai.wrapTile(e);var r=t.tiles.min[e.z];r||(r=t.tiles.min[e.z]=ai.tileForMeters(t.meters.min,e.z));var n=t.tiles.max[e.z];if(n||(n=t.tiles.max[e.z]=ai.tileForMeters(t.meters.max,e.z)),e.y<r.y||e.y>n.y)return !1;if(r.x<=n.x){if(e.x<r.x||e.x>n.x)return !1}else if(e.x>n.x&&e.x<r.x)return !1}return !0},r.includesTile=function(t,r){return !!e.prototype.includesTile.call(this,t,r)&&!!this.checkBounds(t,this.bounds)},r.formatURL=function(e,t){var r=ai.wrapTile(t.coords,{x:!0});this.tms&&(r.y=Math.pow(2,r.z)-1-r.y);var n=e.replace("{x}",r.x).replace("{y}",r.y).replace("{z}",r.z).replace("{r}",this.getDensityModifier()).replace("{q}",this.toQuadKey(r));return null!=this.url_subdomains&&(n=n.replace("{s}",this.url_subdomains[this.next_url_subdomain]),this.next_url_subdomain=(this.next_url_subdomain+1)%this.url_subdomains.length),n},r.getDensityModifier=function(){if(this.url_density_scales){var e=Qr.device_pixel_ratio,t=this.url_density_scales.filter(function(t){return e>=t}).reverse()[0];if((t=null!=t?t:this.url_density_scales[0])>1)return "@"+t+"x"}return ""},r.toQuadKey=function(e){for(var t=e.x,r=e.y,n="",i=e.z;i>0;i--){var o=0,s=1<<i-1;0!=(t&s)&&o++,0!=(r&s)&&(o+=2),n+=o.toString();}return n},t.urlHasTilePattern=function(e){return e&&(e.search("{x}")>-1&&e.search("{y}")>-1&&e.search("{z}")>-1||e.search("{q}")>-1)},t}(_o),vo={coord:function(e){return {x:e.x,y:e.y,z:e.z,key:this.coordKey(e)}},coordKey:function(e){return e.x+"/"+e.y+"/"+e.z},key:function(e,t,r){if(!(e.y<0||e.y>=1<<e.z||e.z<0))return [t.name,e.x,e.y,e.z,r].join("/")},normalizedKey:function(e,t,r){return this.key(this.normalizedCoord(e,t),t,r)},normalizedCoord:function(e,t){return t.zoom_bias&&(e=this.coordAtZoom(e,Math.max(e.z-t.zoom_bias,t.zooms[0]))),this.coordForTileZooms(e,t.zooms)},coordAtZoom:function(e,t){var r=e.x,n=e.y,i=e.z;if(i!==(t=Math.max(0,t))){var o=Math.pow(2,i-t);r=Math.floor(r/o),n=Math.floor(n/o),i=t;}return this.coord({x:r,y:n,z:i})},coordForTileZooms:function(e,t){var r=e.x,n=e.y,i=e.z,o=this.findZoomInRange(i,t);return o!==i?this.coordAtZoom({x:r,y:n,z:i},o):this.coord({x:r,y:n,z:i})},findZoomInRange:function(e,t){return t.filter(function(t){return e>=t}).reverse()[0]||t[0]},isDescendant:function(e,t){if(t.z>e.z){var r=this.coordAtZoom(t,e.z),n=r.x,i=r.y;return e.x===n&&e.y===i}return !1},parent:function(e){var t=e.coords,r=e.source,n=e.style_z;if(n>0){n--;var i=Math.max(n-r.zoom_bias,r.zooms[0]),o=this.coordForTileZooms(this.coordAtZoom(t,i),r.zooms);return o.z>n?null:{key:this.key(o,r,n),coords:o,style_z:n,source:r}}},children:function(e,t){var r=e.coords,n=e.source,i=e.style_z;void 0===t&&(t={}),i++;var o=this.coordForTileZooms(this.coordAtZoom(r,i-n.zoom_bias),n.zooms);if(o.z===r.z)return [{key:this.key(o,n,i),coords:o,style_z:i,source:n}];var s=this.key(o,n,i);if(t[n.id]=t[n.id]||{},null==t[n.id][s]){for(var a=Math.pow(2,o.z-r.z),l=r.x*a,u=r.y*a,c=[],f=l;f<l+a;f++)for(var h=u;h<u+a;h++){var d=this.coord({x:f,y:h,z:o.z});c.push({key:this.key(d,n,i),coords:d,style_z:i,source:n});}t[n.id][s]=c;}return t[n.id][s]}},go=function(e){function t(t,r){var n;return -1===(n=e.call(this,t,r)||this).rasters.indexOf(n.name)&&n.rasters.unshift(n.name),n.filtering=t.filtering,n.textures={},n}pt(t,e);var r=t.prototype;return r.load=function(e){return new Promise(function(t,r){e.source_data={},e.source_data.layers={},e.pad_scale=this.pad_scale,e.rasters=[].concat(this.rasters);var n=ai.tile_scale;return e.source_data.layers={_default:{type:"FeatureCollection",features:[{geometry:{type:"Polygon",coordinates:[[[0,0],[n,0],[n,-n],[0,-n],[0,0]]]},properties:{}}]}},e.default_winding="CW",t(e)}.bind(this))},r.tileTexture=function(e){return new Promise(function(t,r){var n=this.adjustRasterTileZoom(e),i=n.key;if(!this.textures[i]){var o=this.formatURL(this.url,{coords:n});this.textures[i]={name:o,url:o,filtering:this.filtering,coords:n};}return t(this.textures[i])}.bind(this))},r.adjustRasterTileZoom=function(e){var t=e.coords,r=this.sources[e.source];if(r!==this){var n=this.zoom_bias-r.zoom_bias;n>0?t=vo.normalizedCoord(e.coords,{zoom_bias:n,zooms:this.zooms}):(n<0&&Zr({level:"warn",once:!0},"Raster source '"+this.name+"' supports higher zoom detail than source '"+r.name+"' it's attached to. Downsampling this source "+-n+" extra zoom levels to match."),t=vo.coordForTileZooms(t,this.zooms));}return t},t}(mo),yo=function(e){function t(t,r){var n;return (n=e.call(this,t,r)||this).load_image={},n.alpha=null!=t.alpha?Math.max(Math.min(t.alpha,1),0):null,n.mask_alpha=!0,n.preserve_tiles_within_zoom=0,n.max_display_density=t.max_display_density,Array.isArray(t.composite)?n.images=t.composite.map(function(e){return {url:e.url,bounds:n.parseBounds(e),alpha:null!=e.alpha?Math.max(Math.min(e.alpha,1),0):null}}):n.images=[{url:n.url,bounds:n.bounds,alpha:n.alpha}],n}pt(t,e);var r=t.prototype;return r.tileTexture=function(e,t){return new Promise(function(r,n){var i,o,s,a,l,u,c,f,h,d;return i=this,o=t.blend,s=t.generation,a=this.adjustRasterTileZoom(e),l="opaque"!==o,u="raster-"+this.name+"-"+a.key+"-"+(l?"alpha":"opaque")+"-"+s,Hn.textures[u]?r({name:u,coords:a,skip_create:!0}):(c=Qr.device_pixel_ratio,this.max_display_density&&(c=Math.min(c,this.max_display_density)),c*=2,f=document.createElement("canvas"),h=f.getContext("2d"),f.width=this.tile_size*c,f.height=this.tile_size*c,h.imageSmoothingEnabled="nearest"!==this.filtering,d=this.images.filter(function(t){return i.checkBounds(e.coords,t.bounds)}),Promise.resolve(Promise.all(d.map(function(t){var r=l?null!=t.alpha?t.alpha:i.alpha:1;return i.drawImage(t.url,t.bounds,r,e,c,h)}))).then(function(e){try{return r({name:u,element:f,filtering:this.filtering,coords:a})}catch(e){return n(e)}}.bind(this),n))}.bind(this))},r.drawImage=function(e,t,r,n,i,o){return new Promise(function(s,a){var l,u,c,f,h,d,p;return l=Zn(e),this.load_image[l]=this.load_image[l]||this.loadImage(e),Promise.resolve(this.load_image[l]).then(function(e){try{return u=e,c=ai.metersPerPixel(n.coords.z)/i/(this.tile_size/ai.tile_size),f=(t.meters.min[0]-n.min.x)/c,h=-(t.meters.min[1]-n.min.y)/c,d=(t.meters.max[0]-t.meters.min[0])/c,p=-(t.meters.max[1]-t.meters.min[1])/c,o.globalAlpha=null!=r?r:1,o.drawImage(u,f,h,d,p),s()}catch(e){return a(e)}}.bind(this),a)}.bind(this))},r.loadImage=function(e){var t=this;return new Promise(function(r){var n=new Image;n.onload=function(){return r(n)},n.onerror=function(n){Zr("warn","Raster source '"+t.name+"': failed to load url: '"+e+"'",n),r(null);},Qr.isSafari()&&"data:"===e.slice(0,5)||(n.crossOrigin="anonymous"),n.src=e;})},r.includesTile=function(e,t){var r=this;return !!ho.prototype.includesTile.call(this,e,t)&&this.images.some(function(t){return r.checkBounds(e,t.bounds)})},r.validate=function(e){var t="Raster data source must provide a string `url` parameter, or an array of `composite` raster ";t+="image objects that each have a `url` parameter";var r="Raster data source must provide a `bounds` parameter, or an array of `composite` raster ";r+="image objects that each have a `bounds` parameter";if("parameters, or an array of `composite` raster image objects, each with `url` and `bounds`.",Array.isArray(e.composite)){if(e.composite.some(function(e){return "string"!=typeof e.url}))throw Error(t);if(e.composite.some(function(e){return !(Array.isArray(e.bounds)&&4===e.bounds.length)}))throw Error(r);if(null!=e.url||null!=e.bounds)throw Error("Raster data source must have *either* a single image specified as `url` and `bounds `parameters, or an array of `composite` raster image objects, each with `url` and `bounds`.")}else {if("string"!=typeof e.url)throw Error(t);if(!Array.isArray(e.bounds)||4!==e.bounds.length)throw Error(r)}},t}(go);ho.register("Raster",function(e){return go.urlHasTilePattern(e.url)?go:yo});var xo={init:function(e){var t=void 0===e?{}:e,r=t.generation,n=t.styles,i=t.sources,o=void 0===i?{}:i,s=t.introspection;this.setGeneration(r),this.styles=n,this.sources=o,this.defines=Object.prototype.hasOwnProperty.call(this,"defines")&&this.defines||{},this.shaders=Object.prototype.hasOwnProperty.call(this,"shaders")&&this.shaders||{},this.introspection=s||!1,this.selection=this.selection||this.introspection||!1,this.compile_setup=!1,this.program=null,this.selection_program=null,this.feature_style={},this.vertex_template=[],this.tile_data={},this.stencil_proxy_tiles=!0,this.variants={},this.vertex_layouts={},this.defines.TANGRAM_WORLD_POSITION_WRAP=1e5,this.blend=this.blend||"opaque","opaque"!==this.blend?null==this.blend_order&&(this.blend_order=this.default_blend_orders[this.blend]):this.blend_order=this.default_blend_orders[this.blend],this.defines["TANGRAM_BLEND_"+this.blend.toUpperCase()]=!0,this.removeShaderBlock("setup"),this.material instanceof eo||(eo.isValid(this.material)||(this.material=Ui.defaults.material),this.material=new eo(this.material)),this.material.inject(this),so.setMode(this.lighting,this),this.setupRasters(),this.setupCustomAttributes(),this.initialized=!0;},destroy:function(){this.program&&(this.program.destroy(),this.program=null),this.selection_program&&(this.selection_program.destroy(),this.selection_program=null),jr.removeTarget(this.main_thread_target),this.gl=null,this.initialized=!1;},reset:function(){},baseStyle:function(){return this.base||this.name},setGeneration:function(e){this.generation=e,this.main_thread_target=["Style",this.name,this.generation].join("_"),qe.is_main&&jr.addTarget(this.main_thread_target,this);},startData:function(e){this.tile_data[e.id]=this.tile_data[e.id]||{meshes:{},uniforms:{},textures:[]};},endData:function(e){return new Promise(function(t,r){var n=this.tile_data[e.id];if(this.tile_data[e.id]=null,n&&Object.keys(n.meshes).length>0){for(var i in n.meshes){var o=n.meshes[i];0!==o.vertex_data.vertex_count?(o.vertex_data.end(),o.vertex_elements=o.vertex_data.element_buffer,o.vertex_data=o.vertex_data.vertex_buffer):delete n.meshes[i];}return t(this.buildRasterTextures(e,n))}return t(null)}.bind(this))},hasDataForTile:function(e){return null!=this.tile_data[e.id]},getTileMesh:function(e,t){var r=this.tile_data[e.id].meshes;if(null==r[t.key]){var n=this.vertexLayoutForMeshVariant(t);r[t.key]={variant:t,vertex_data:n.createVertexData()};}return r[t.key]},vertexLayoutForMeshVariant:function(){},meshVariantTypeForDraw:function(){},addFeature:function(e,t,r){var n=r.tile;if(n.generation===this.generation){this.tile_data[n.id]||this.startData(n);var i=this.parseFeature(e,t,r);i&&this.buildGeometry(e.geometry,i,r)>0&&(e.generation=this.generation);}},buildGeometry:function(e,t,r){var n,i=this;if("Polygon"===e.type?n=this.buildPolygons([e.coordinates],t,r):"MultiPolygon"===e.type?n=this.buildPolygons(e.coordinates,t,r):"LineString"===e.type?n=this.buildLines([e.coordinates],t,r):"MultiLineString"===e.type?n=this.buildLines(e.coordinates,t,r):"Point"===e.type?n=this.buildPoints([e.coordinates],t,r):"MultiPoint"===e.type&&(n=this.buildPoints(e.coordinates,t,r)),n>0&&en.layer_stats){var o=r.tile;o.debug.layers=o.debug.layers||{list:{},tree:{}};var s=o.debug.layers.list,a=o.debug.layers.tree,l={};r.layers.forEach(function(e){var t,r;bo(s,e,1,n,((t={})[i.name]=n,t),((r={})[i.baseStyle()]=n,r));for(var o=a,u=l,c=e.split(":"),f=0;f<c.length;f++){var h,d,p=c[f];if(o[p]=o[p]||{features:0,geoms:0,styles:{},base:{}},null==u[p])u[p]={},bo(o,p,1,n,((h={})[i.name]=n,h),((d={})[i.baseStyle()]=n,d));f<c.length-1&&(o[p].layers=o[p].layers||{}),o=o[p].layers,u=u[p];}});}return n},parseFeature:function(e,t,r){try{var n=this.feature_style;if(n.order=this.parseOrder(t.order,r),null==n.order&&"overlay"!==this.blend){var i="Layer '"+t.layers.join(", ")+"', draw group '"+t.group+"': ";return i+="'order' parameter is required unless blend mode is 'overlay'",null!=t.order&&(i+="; 'order' was set to a dynamic value (e.g. string tied to feature property, ",i+="or JS function), but evaluated to null for one or more features"),void Zr({level:"warn",once:!0},i)}if(!(n=this._parseFeature(e,t,r)))return;if(this.shaders.attributes)for(var o in n.attributes=n.attributes||{},this.shaders.attributes)n.attributes[o]=Ui.evalCachedProperty(t.attributes&&t.attributes[o],r),"number"!=typeof n.attributes[o]&&(n.attributes[o]=0);return this.selection?n.interactive=Ui.evalProperty(t.interactive,r):n.interactive=!1,!0===n.interactive?n.selection_color=Ji.makeColor(e,r.tile,r):n.selection_color=Ji.defaultColor,n}catch(t){Zr("error","Style.parseFeature: style parsing error",e,n,t.stack);}},_parseFeature:function(){return this.feature_style},preprocess:function(e){if(!e.preprocessed){if(this.draw)for(var t in this.draw){var r=this.draw[t];"object"!=typeof r||Array.isArray(r)?null==e[t]&&(e[t]=r):e[t]=si({},r,e[t]);}if(this.selection?this.introspection&&(e.interactive=!0):e.interactive=!1,!(e=this._preprocess(e)))return;if(this.shaders.attributes)for(var n in e.attributes=e.attributes||{},this.shaders.attributes)e.attributes[n]=Ui.createPropertyCache(null!=e.attributes[n]?e.attributes[n]:0);e.preprocessed=!0;}return e},_preprocess:function(e){return e},parseOrder:function(e,t){return "number"!=typeof e?Ui.calculateOrder(e,t):e},scaleOrder:function(e){return 2*e},parseColor:function(e,t){return e?Ui.evalCachedColorProperty(e,t):this.shaders.blocks.color||this.shaders.blocks.filter?Ui.defaults.color:void 0},buildPolygons:function(){return 0},buildLines:function(){return 0},buildPoints:function(){return 0},setGL:function(e){this.gl=e,this.max_texture_size=Hn.getMaxTextureSize(this.gl);},makeMesh:function(e,t,r){void 0===r&&(r={});var n=this.vertexLayoutForMeshVariant(r.variant);return en.wireframe?(t=function(e){for(var t=new Uint16Array(2*e.length),r=0;r<e.length;r+=3)t.set([e[r],e[r+1],e[r+1],e[r+2],e[r+2],e[r]],2*r);return t}(t),new $i(this.gl,e,t,n,Object.assign({},r,{draw_mode:this.gl.LINES}))):new $i(this.gl,e,t,n,r)},render:function(e){return e.render()},getProgram:function(e){void 0===e&&(e="program"),this.compileSetup();var t=this[e];if(t&&!t.error){if(!t.compiled){Zr("debug","Compiling style '"+this.name+"', program key '"+e+"'");try{t.compile();}catch(t){throw Zr("error","Style: error compiling program for style '"+this.name+"' (program key '"+e+"')",this,t.stack,t.type,t.shader_errors),t}}return t}},compileSetup:function(){if(!this.compile_setup){if(!this.gl)throw new Error("style.compile(): skipping for "+this.name+" because no GL context");var e=this.buildDefineList();if(this.selection){var t=Object.assign({},e);t.TANGRAM_FEATURE_SELECTION=!0;}var r=this.shaders&&this.shaders.blocks,n=this.shaders&&this.shaders.block_scopes,i=Object.assign({},this.shaders&&this.shaders.uniforms);for(var o in i)null==i[o]&&Zr({level:"warn",once:!0},"Style '"+this.name+"' has invalid uniform '"+o+"': uniform values must be non-null");var s=this.shaders&&this.shaders.extensions;"string"==typeof s&&(s=[s]),this.program=new Qn(this.gl,this.vertex_shader_src,this.fragment_shader_src,{name:this.name,defines:e,uniforms:i,blocks:r,block_scopes:n,extensions:s}),this.selection?this.selection_program=new Qn(this.gl,this.vertex_shader_src,"// Fragment shader for feature selection passes\n// Renders in silhouette according to selection (picking) color, or black if none defined\n\n#ifdef TANGRAM_FEATURE_SELECTION\n    varying vec4 v_selection_color;\n#endif\n\nvoid main (void) {\n    #ifdef TANGRAM_FEATURE_SELECTION\n        gl_FragColor = v_selection_color;\n    #else\n        gl_FragColor = vec4(0., 0., 0., 1.);\n    #endif\n}\n",{name:this.name+" (selection)",defines:t,uniforms:i,blocks:r,block_scopes:n,extensions:s}):this.selection_program=null,this.compile_setup=!0;}},addShaderBlock:function(e,t,r){void 0===r&&(r=null),this.shaders.blocks=this.shaders.blocks||{},this.shaders.blocks[e]=this.shaders.blocks[e]||[],this.shaders.blocks[e].push(t),this.shaders.block_scopes=this.shaders.block_scopes||{},this.shaders.block_scopes[e]=this.shaders.block_scopes[e]||[],this.shaders.block_scopes[e].push(r);},removeShaderBlock:function(e){this.shaders.blocks&&(this.shaders.blocks[e]=null),this.shaders.block_scopes&&(this.shaders.block_scopes[e]=null);},replaceShaderBlock:function(e,t,r){void 0===r&&(r=null),this.removeShaderBlock(e),this.addShaderBlock(e,t,r);},buildDefineList:function(){var e={};if(null!=this.defines)for(var t in this.defines)e[t]=this.defines[t];if(null!=this.shaders&&null!=this.shaders.defines)for(t in this.shaders.defines)e[t]=this.shaders.defines[t];return e},hasRasters:function(){return ["color","normal","custom"].indexOf(this.raster)>-1},setupRasters:function(){var e=this;if(this.hasRasters()){"color"===this.raster?this.defines.TANGRAM_RASTER_TEXTURE_COLOR=!0:"normal"===this.raster&&(this.defines.TANGRAM_RASTER_TEXTURE_NORMAL=!0);var t=Object.keys(this.sources).filter(function(t){return e.sources[t]instanceof go}).length;if(this.defines.TANGRAM_NUM_RASTER_SOURCES=""+t,t>0){var r=Object.keys(this.sources).filter(function(t){return e.sources[t].mask_alpha}).length;this.defines.TANGRAM_HAS_MASKED_RASTERS=r>0,this.defines.TANGRAM_ALL_MASKED_RASTERS=r===t,this.defines.TANGRAM_MODEL_POSITION_BASE_ZOOM_VARYING=!0,this.replaceShaderBlock("raster","// Uniforms defining raster textures and macros for accessing them\n\n#ifdef TANGRAM_FRAGMENT_SHADER\nuniform sampler2D u_rasters[TANGRAM_NUM_RASTER_SOURCES];    // raster tile texture samplers\nuniform vec2 u_raster_sizes[TANGRAM_NUM_RASTER_SOURCES];    // raster tile texture sizes (width/height in pixels)\nuniform vec3 u_raster_offsets[TANGRAM_NUM_RASTER_SOURCES];  // raster tile texture UV starting offset for tile\n\n// Raster sources can optionally mask by the alpha channel (render with only full or no alpha, based on a threshold),\n// which is used for handling transparency outside the raster image when rendering with opaque blending\n#if defined(TANGRAM_HAS_MASKED_RASTERS) && !defined(TANGRAM_ALL_MASKED_RASTERS) // only add uniform if we need it\nuniform bool u_raster_mask_alpha;\n#endif\n\n// Note: the raster accessors below are #defines rather than functions to\n// avoid issues with constant integer expressions for array indices\n\n// Adjusts UVs in model space to account for raster tile texture overzooming\n// (applies scale and offset adjustments)\n#define adjustRasterUV(raster_index, uv) \\\n    ((uv) * u_raster_offsets[raster_index].z + u_raster_offsets[raster_index].xy)\n\n// Returns the UVs of the current model position for a raster sampler\n#define currentRasterUV(raster_index) \\\n    (adjustRasterUV(raster_index, v_modelpos_base_zoom.xy))\n\n// Returns pixel location in raster tile texture at current model position\n#define currentRasterPixel(raster_index) \\\n    (currentRasterUV(raster_index) * rasterPixelSize(raster_index))\n\n// Samples a raster tile texture for the current model position\n#define sampleRaster(raster_index) \\\n    (texture2D(u_rasters[raster_index], currentRasterUV(raster_index)))\n\n// Samples a raster tile texture for a given pixel\n#define sampleRasterAtPixel(raster_index, pixel) \\\n    (texture2D(u_rasters[raster_index], (pixel) / rasterPixelSize(raster_index)))\n\n// Returns size of raster sampler in pixels\n#define rasterPixelSize(raster_index) \\\n    (u_raster_sizes[raster_index])\n\n#endif\n","Raster");}}},buildRasterTextures:function(e,t){return new Promise(function(r,n){var i,o,s,a;if(!this.hasRasters())return r(t);if(0===e.rasters.length)return r(t);var l=function(){try{return !i||i.length<1?r(t):i.some(function(e){return !e.loaded})?r(null):(t.uniforms.u_raster_mask_alpha=!0===this.sources[e.rasters[0]].mask_alpha,o=t.uniforms.u_rasters=[],s=t.uniforms.u_raster_sizes=[],a=t.uniforms.u_raster_offsets=[],i.forEach(function(r){var n=r.index;if(o[n]=r.name,t.textures.push(r.name),s[n]=[r.width,r.height],e.coords.z>r.coords.z){var i=e.coords.z-r.coords.z,l=Math.pow(2,i);a[n]=[(e.coords.x%l+l)%l/l,(l-1-e.coords.y%l)/l,1/l];}else a[n]=[0,0,1];}),r(t))}catch(e){return n(e)}}.bind(this),u=function(e){try{return r(t)}catch(e){return n(e)}};try{return Promise.resolve(jr.postMessage(this.main_thread_target+".loadTextures",{coords:e.coords,source:e.source,rasters:e.rasters,min:e.min,max:e.max})).then(function(e){try{return i=e,l()}catch(e){return u()}},u)}catch(e){u();}}.bind(this))},loadTextures:function(e){return new Promise(function(t,r){var n,i,o,s,a;return n=this,i={},o={},s=[],e.rasters.map(function(e){return n.sources[e]}).filter(function(e){return e}).forEach(function(t,r){t instanceof go&&s.push(t.tileTexture(e,n).then(function(e){i[e.name]=e,o[e.name]=r;}));}),Promise.resolve(Promise.all(s)).then(function(e){try{return Promise.resolve(Hn.createFromObject(this.gl,i)).then(function(e){try{return Promise.resolve(Promise.all(Object.keys(i).map(function(e){return Hn.textures[e]&&Hn.textures[e].load()}).filter(function(e){return e}))).then(function(e){try{return (a=e).forEach(function(e){return e.retain()}),t(a.map(function(e){return {name:e.name,width:e.width,height:e.height,loaded:e.loaded,index:o[e.name],coords:i[e.name].coords}}))}catch(e){return r(e)}},r)}catch(e){return r(e)}},r)}catch(e){return r(e)}}.bind(this),r)}.bind(this))},setupCustomAttributes:function(){if(this.shaders.attributes)for(var e=0,t=Object.entries(this.shaders.attributes);e<t.length;e++){var r=t[e],n=r[0],i=r[1];"float"===i.type&&(!1!==i.varying?(this.addShaderBlock("attributes","\n                            #ifdef TANGRAM_VERTEX_SHADER\n                                attribute float a_"+n+";\n                                varying float v_"+n+";\n                                #define "+n+" a_"+n+"\n                            #else\n                                varying float v_"+n+";\n                                #define "+n+" v_"+n+"\n                            #endif\n                        "),this.addShaderBlock("setup","#ifdef TANGRAM_VERTEX_SHADER\nv_"+n+" = a_"+n+";\n#endif")):this.addShaderBlock("attributes","\n                            #ifdef TANGRAM_VERTEX_SHADER\n                                attribute float a_"+n+";\n                                #define "+n+" a_"+n+"\n                            #endif\n                        "));}},addCustomAttributesToAttributeList:function(e){if(this.shaders.attributes)for(var t=0,r=Object.entries(this.shaders.attributes);t<r.length;t++){var n=r[t],i=n[0];"float"===n[1].type&&e.push({name:"a_"+i,size:1,type:Ki.FLOAT,normalized:!1});}return e},addCustomAttributesToVertexTemplate:function(e,t){if(this.shaders.attributes)for(var r in this.shaders.attributes)this.vertex_template[t++]=null!=e.attributes[r]?e.attributes[r]:0;},setup:function(){this.setUniforms(),this.material.setupProgram(Qn.current);},setUniforms:function(){var e=Qn.current;e&&e.setUniforms(this.shaders&&this.shaders.uniforms,!0);},render_states:{opaque:{depth_test:!0,depth_write:!0},translucent:{depth_test:!0,depth_write:!0},add:{depth_test:!0,depth_write:!1},multiply:{depth_test:!0,depth_write:!1},inlay:{depth_test:!0,depth_write:!1},overlay:{depth_test:!1,depth_write:!1}},default_blend_orders:{opaque:Number.MIN_SAFE_INTEGER,add:1,multiply:2,inlay:3,translucent:4,overlay:5},getBlendOrderForDraw:function(e){return "opaque"!==this.blend&&null!=e.blend_order?e.blend_order:this.blend_order}};function bo(e,t,r,n,i,o){for(var s in e[t]=e[t]||{features:0,geoms:0,styles:{},base:{}},e[t].features+=r,e[t].geoms+=n,i)e[t].styles[s]=e[t].styles[s]||0,e[t].styles[s]+=i[s];for(var a in o)e[t].base[a]=e[t].base[a]||0,e[t].base[a]+=o[a];}qn("Int16",2,function(e){return function(t,r,n){return e(this,t,r,n)}}),qn("Uint32",4,function(e){return function(t,r,n){return e(this,t,r,n)}}),qn("Int32",4,function(e){return function(t,r,n){return e(this,t,r,n)}}),qn("Int8",1,function(e){return function(t,r,n){return e(this,t,r,n)}}),qn("Float32",4,function(e){return function(t,r,n){return e(this,t,r,n)}});var Ao,To=Math.pow(2,16)-1,wo=!1,Eo=function(){function e(){this.array=[],this.has_overflown=!1;}var t=e.prototype;return t.push=function(e){this.has_overflown&&!wo||e>To&&(this.has_overflown=!0,!wo)||this.array.push(e);},t.end=function(){if(this.array.length){var e=(t=this.array,new(this.has_overflown&&wo?Uint32Array:Uint16Array)(t));return this.array=[],this.has_overflown=!1,e}return !1;var t;},e}();Eo.setElementIndexUint=function(e){wo=e;};var Ro=((Ao={})[Ki.FLOAT]=Float32Array,Ao[Ki.BYTE]=Int8Array,Ao[Ki.UNSIGNED_BYTE]=Uint8Array,Ao[Ki.INT]=Int32Array,Ao[Ki.UNSIGNED_INT]=Uint32Array,Ao[Ki.SHORT]=Int16Array,Ao[Ki.UNSIGNED_SHORT]=Uint16Array,Ao),Mo=function(){function e(t,r){var n=(void 0===r?{}:r).prealloc,i=void 0===n?500:n;this.vertex_layout=t,this.vertex_elements=new Eo,this.stride=this.vertex_layout.stride,e.array_pool.length>0?(this.vertex_buffer=e.array_pool.pop(),this.byte_length=this.vertex_buffer.byteLength,this.size=Math.floor(this.byte_length/this.stride),Zr("trace","VertexData: reused buffer of bytes "+this.byte_length+", "+this.size+" vertices")):(this.size=i,this.byte_length=this.stride*this.size,this.vertex_buffer=new Uint8Array(this.byte_length)),this.offset=0,this.vertex_count=0,this.realloc_count=0,this.setBufferViews(),this.setAddVertexFunction();}var t=e.prototype;return t.setBufferViews=function(){var e=this;this.views={},this.views[Ki.UNSIGNED_BYTE]=this.vertex_buffer,this.vertex_layout.dynamic_attribs.forEach(function(t){if(null==e.views[t.type]){var r=Ro[t.type];e.views[t.type]=new r(e.vertex_buffer.buffer);}});},t.checkBufferSize=function(){if(this.offset+this.stride>this.byte_length){this.size=Math.floor(1.5*this.size),this.size-=this.size%4,this.byte_length=this.stride*this.size;var t=new Uint8Array(this.byte_length);t.set(this.vertex_buffer),e.array_pool.push(this.vertex_buffer),this.vertex_buffer=t,this.setBufferViews(),this.realloc_count++;}},t.setAddVertexFunction=function(){this.vertexLayoutAddVertex=this.vertex_layout.getAddVertexFunction();},t.addVertex=function(e){this.checkBufferSize(),this.vertexLayoutAddVertex(e,this.views,this.offset),this.offset+=this.stride,this.vertex_count++;},t.end=function(){return this.vertex_buffer=this.vertex_buffer.subarray(0,this.offset),this.element_buffer=this.vertex_elements.end(),Zr("trace","VertexData: "+this.size+" vertices total, realloc count "+this.realloc_count),this},e}();Mo.array_pool=[];var So=function(){function e(e){this.attribs=e,this.dynamic_attribs=this.attribs.filter(function(e){return null==e.static}),this.static_attribs=this.attribs.filter(function(e){return null!=e.static}),this.components=[],this.index={},this.offset={},this.stride=0;for(var t=0,r=0,n=0;n<this.attribs.length;n++){var i=this.attribs[n];if(null==i.static){i.offset=this.stride,i.byte_size=i.size;var o=0;switch(i.type){case Ki.FLOAT:case Ki.INT:case Ki.UNSIGNED_INT:i.byte_size*=4,o=2;break;case Ki.SHORT:case Ki.UNSIGNED_SHORT:i.byte_size*=2,o=1;}3&i.byte_size&&(i.byte_size+=4-(3&i.byte_size)),this.stride+=i.byte_size;for(var s=i.offset>>o,a=0;a<i.size;a++)this.components.push({type:i.type,shift:o,offset:s++,index:r++});this.index[i.name]=t,t+=i.size,this.offset[i.name]=i.offset;}else i.static=Array.isArray(i.static)?i.static:[i.static],i.method="vertexAttrib"+i.static.length+"fv";}}var t=e.prototype;return t.enableDynamicAttributes=function(t,r){var n=this;for(var i in e.enabled_attribs)t.disableVertexAttribArray(i);e.enabled_attribs={},this.dynamic_attribs.forEach(function(i){var o=r.attribute(i.name).location;-1!==o&&(t.enableVertexAttribArray(o),t.vertexAttribPointer(o,i.size,i.type,i.normalized,n.stride,i.offset),e.enabled_attribs[o]=r);});},t.enableStaticAttributes=function(e,t){this.static_attribs.forEach(function(r){var n=t.attribute(r.name).location;-1!==n&&e[r.method]instanceof Function&&(e.enableVertexAttribArray(n),e[r.method](n,r.static),e.disableVertexAttribArray(n));});},t.createVertexData=function(){return new Mo(this)},t.getAddVertexFunction=function(){return null==this.addVertex&&this.createAddVertexFunction(),this.addVertex},t.createAddVertexFunction=function(){var t=Zn(JSON.stringify(this.attribs));if(null==e.add_vertex_funcs[t]){var r,n=["var t, o;"],i=[].concat(this.components);i.sort(function(e,t){return e.type!==t.type?e.type-t.type:e.index-t.index});for(var o=0;o<i.length;o++){var s=i[o];r!==s.type&&(n.push("t = vs["+s.type+"];"),n.push("o = off"+(s.shift?" >> "+s.shift:"")+";"),r=s.type),n.push("t[o + "+s.offset+"] = v["+s.index+"];");}n=n.join("\n");var a=new Function("v","vs","off",n);e.add_vertex_funcs[t]=a;}this.addVertex=e.add_vertex_funcs[t];},e}();So.enabled_attribs={},So.add_vertex_funcs={};var zo=[{x:0,y:0},{x:ai.tile_scale,y:-ai.tile_scale}],Po=[0,0,1,1];function No(e,t,r){var n=zo[0],i=zo[1];return e[0]<=n.x+r&&t[0]<=n.x+r||e[0]>=i.x-r&&t[0]>=i.x-r||e[1]>=n.y-r&&t[1]>=n.y-r||e[1]<=i.y+r&&t[1]<=i.y+r}function ko(e,t){t=t||0;var r=zo[0],n=zo[1];return e[0]<=r.x+t||e[0]>=n.x-t||e[1]>=r.y-t||e[1]<=n.y+t}var Lo=Io,Oo=Io;function Io(e,t,r){r=r||2;var n,i,o,s,a,l,u,c=t&&t.length,f=c?t[0]*r:e.length,h=Fo(e,0,f,r,!0),d=[];if(!h||h.next===h.prev)return d;if(c&&(h=function(e,t,r,n){var i,o,s,a,l,u=[];for(i=0,o=t.length;i<o;i++)s=t[i]*n,a=i<o-1?t[i+1]*n:e.length,(l=Fo(e,s,a,n,!1))===l.next&&(l.steiner=!0),u.push(Wo(l));for(u.sort(Bo),i=0;i<u.length;i++)qo(u[i],r),r=Uo(r,r.next);return r}(e,t,h,r)),e.length>80*r){n=o=e[0],i=s=e[1];for(var p=r;p<f;p+=r)(a=e[p])<n&&(n=a),(l=e[p+1])<i&&(i=l),a>o&&(o=a),l>s&&(s=l);u=0!==(u=Math.max(o-n,s-i))?1/u:0;}return Do(h,d,r,n,i,u),d}function Fo(e,t,r,n,i){var o,s;if(i===ss(e,t,r,n)>0)for(o=t;o<r;o+=n)s=ns(o,e[o],e[o+1],s);else for(o=r-n;o>=t;o-=n)s=ns(o,e[o],e[o+1],s);return s&&Ko(s,s.next)&&(is(s),s=s.next),s}function Uo(e,t){if(!e)return e;t||(t=e);var r,n=e;do{if(r=!1,n.steiner||!Ko(n,n.next)&&0!==Jo(n.prev,n,n.next))n=n.next;else {if(is(n),(n=t=n.prev)===n.next)break;r=!0;}}while(r||n!==t);return t}function Do(e,t,r,n,i,o,s){if(e){!s&&o&&function(e,t,r,n){var i=e;do{null===i.z&&(i.z=Xo(i.x,i.y,t,r,n)),i.prevZ=i.prev,i.nextZ=i.next,i=i.next;}while(i!==e);i.prevZ.nextZ=null,i.prevZ=null,function(e){var t,r,n,i,o,s,a,l,u=1;do{for(r=e,e=null,o=null,s=0;r;){for(s++,n=r,a=0,t=0;t<u&&(a++,n=n.nextZ);t++);for(l=u;a>0||l>0&&n;)0!==a&&(0===l||!n||r.z<=n.z)?(i=r,r=r.nextZ,a--):(i=n,n=n.nextZ,l--),o?o.nextZ=i:e=i,i.prevZ=o,o=i;r=n;}o.nextZ=null,u*=2;}while(s>1)}(i);}(e,n,i,o);for(var a,l,u=e;e.prev!==e.next;)if(a=e.prev,l=e.next,o?Co(e,n,i,o):Go(e))t.push(a.i/r),t.push(e.i/r),t.push(l.i/r),is(e),e=l.next,u=l.next;else if((e=l)===u){s?1===s?Do(e=jo(Uo(e),t,r),t,r,n,i,o,2):2===s&&Vo(e,t,r,n,i,o):Do(Uo(e),t,r,n,i,o,1);break}}}function Go(e){var t=e.prev,r=e,n=e.next;if(Jo(t,r,n)>=0)return !1;for(var i=e.next.next;i!==e.prev;){if(Yo(t.x,t.y,r.x,r.y,n.x,n.y,i.x,i.y)&&Jo(i.prev,i,i.next)>=0)return !1;i=i.next;}return !0}function Co(e,t,r,n){var i=e.prev,o=e,s=e.next;if(Jo(i,o,s)>=0)return !1;for(var a=i.x<o.x?i.x<s.x?i.x:s.x:o.x<s.x?o.x:s.x,l=i.y<o.y?i.y<s.y?i.y:s.y:o.y<s.y?o.y:s.y,u=i.x>o.x?i.x>s.x?i.x:s.x:o.x>s.x?o.x:s.x,c=i.y>o.y?i.y>s.y?i.y:s.y:o.y>s.y?o.y:s.y,f=Xo(a,l,t,r,n),h=Xo(u,c,t,r,n),d=e.prevZ,p=e.nextZ;d&&d.z>=f&&p&&p.z<=h;){if(d!==e.prev&&d!==e.next&&Yo(i.x,i.y,o.x,o.y,s.x,s.y,d.x,d.y)&&Jo(d.prev,d,d.next)>=0)return !1;if(d=d.prevZ,p!==e.prev&&p!==e.next&&Yo(i.x,i.y,o.x,o.y,s.x,s.y,p.x,p.y)&&Jo(p.prev,p,p.next)>=0)return !1;p=p.nextZ;}for(;d&&d.z>=f;){if(d!==e.prev&&d!==e.next&&Yo(i.x,i.y,o.x,o.y,s.x,s.y,d.x,d.y)&&Jo(d.prev,d,d.next)>=0)return !1;d=d.prevZ;}for(;p&&p.z<=h;){if(p!==e.prev&&p!==e.next&&Yo(i.x,i.y,o.x,o.y,s.x,s.y,p.x,p.y)&&Jo(p.prev,p,p.next)>=0)return !1;p=p.nextZ;}return !0}function jo(e,t,r){var n=e;do{var i=n.prev,o=n.next.next;!Ko(i,o)&&$o(i,n,n.next,o)&&ts(i,o)&&ts(o,i)&&(t.push(i.i/r),t.push(n.i/r),t.push(o.i/r),is(n),is(n.next),n=e=o),n=n.next;}while(n!==e);return Uo(n)}function Vo(e,t,r,n,i,o){var s=e;do{for(var a=s.next.next;a!==s.prev;){if(s.i!==a.i&&Zo(s,a)){var l=rs(s,a);return s=Uo(s,s.next),l=Uo(l,l.next),Do(s,t,r,n,i,o),void Do(l,t,r,n,i,o)}a=a.next;}s=s.next;}while(s!==e)}function Bo(e,t){return e.x-t.x}function qo(e,t){if(t=function(e,t){var r,n=t,i=e.x,o=e.y,s=-1/0;do{if(o<=n.y&&o>=n.next.y&&n.next.y!==n.y){var a=n.x+(o-n.y)*(n.next.x-n.x)/(n.next.y-n.y);if(a<=i&&a>s){if(s=a,a===i){if(o===n.y)return n;if(o===n.next.y)return n.next}r=n.x<n.next.x?n:n.next;}}n=n.next;}while(n!==t);if(!r)return null;if(i===s)return r;var l,u=r,c=r.x,f=r.y,h=1/0;n=r;do{i>=n.x&&n.x>=c&&i!==n.x&&Yo(o<f?i:s,o,c,f,o<f?s:i,o,n.x,n.y)&&(l=Math.abs(o-n.y)/(i-n.x),ts(n,e)&&(l<h||l===h&&(n.x>r.x||n.x===r.x&&Ho(r,n)))&&(r=n,h=l)),n=n.next;}while(n!==u);return r}(e,t)){var r=rs(t,e);Uo(t,t.next),Uo(r,r.next);}}function Ho(e,t){return Jo(e.prev,e,t.prev)<0&&Jo(t.next,e,e.next)<0}function Xo(e,t,r,n,i){return (e=1431655765&((e=858993459&((e=252645135&((e=16711935&((e=32767*(e-r)*i)|e<<8))|e<<4))|e<<2))|e<<1))|(t=1431655765&((t=858993459&((t=252645135&((t=16711935&((t=32767*(t-n)*i)|t<<8))|t<<4))|t<<2))|t<<1))<<1}function Wo(e){var t=e,r=e;do{(t.x<r.x||t.x===r.x&&t.y<r.y)&&(r=t),t=t.next;}while(t!==e);return r}function Yo(e,t,r,n,i,o,s,a){return (i-s)*(t-a)-(e-s)*(o-a)>=0&&(e-s)*(n-a)-(r-s)*(t-a)>=0&&(r-s)*(o-a)-(i-s)*(n-a)>=0}function Zo(e,t){return e.next.i!==t.i&&e.prev.i!==t.i&&!function(e,t){var r=e;do{if(r.i!==e.i&&r.next.i!==e.i&&r.i!==t.i&&r.next.i!==t.i&&$o(r,r.next,e,t))return !0;r=r.next;}while(r!==e);return !1}(e,t)&&(ts(e,t)&&ts(t,e)&&function(e,t){var r=e,n=!1,i=(e.x+t.x)/2,o=(e.y+t.y)/2;do{r.y>o!=r.next.y>o&&r.next.y!==r.y&&i<(r.next.x-r.x)*(o-r.y)/(r.next.y-r.y)+r.x&&(n=!n),r=r.next;}while(r!==e);return n}(e,t)&&(Jo(e.prev,e,t.prev)||Jo(e,t.prev,t))||Ko(e,t)&&Jo(e.prev,e,e.next)>0&&Jo(t.prev,t,t.next)>0)}function Jo(e,t,r){return (t.y-e.y)*(r.x-t.x)-(t.x-e.x)*(r.y-t.y)}function Ko(e,t){return e.x===t.x&&e.y===t.y}function $o(e,t,r,n){var i=es(Jo(e,t,r)),o=es(Jo(e,t,n)),s=es(Jo(r,n,e)),a=es(Jo(r,n,t));return i!==o&&s!==a||(!(0!==i||!Qo(e,r,t))||(!(0!==o||!Qo(e,n,t))||(!(0!==s||!Qo(r,e,n))||!(0!==a||!Qo(r,t,n)))))}function Qo(e,t,r){return t.x<=Math.max(e.x,r.x)&&t.x>=Math.min(e.x,r.x)&&t.y<=Math.max(e.y,r.y)&&t.y>=Math.min(e.y,r.y)}function es(e){return e>0?1:e<0?-1:0}function ts(e,t){return Jo(e.prev,e,e.next)<0?Jo(e,t,e.next)>=0&&Jo(e,e.prev,t)>=0:Jo(e,t,e.prev)<0||Jo(e,e.next,t)<0}function rs(e,t){var r=new os(e.i,e.x,e.y),n=new os(t.i,t.x,t.y),i=e.next,o=t.prev;return e.next=t,t.prev=e,r.next=i,i.prev=r,n.next=r,r.prev=n,o.next=n,n.prev=o,n}function ns(e,t,r,n){var i=new os(e,t,r);return n?(i.next=n.next,i.prev=n,n.next.prev=i,n.next=i):(i.prev=i,i.next=i),i}function is(e){e.next.prev=e.prev,e.prev.next=e.next,e.prevZ&&(e.prevZ.nextZ=e.nextZ),e.nextZ&&(e.nextZ.prevZ=e.prevZ);}function os(e,t,r){this.i=e,this.x=t,this.y=r,this.prev=null,this.next=null,this.z=null,this.prevZ=null,this.nextZ=null,this.steiner=!1;}function ss(e,t,r,n){for(var i=0,o=t,s=r-n;o<r;o+=n)i+=(e[s]-e[o])*(e[o+1]+e[s+1]),s=o;return i}Io.deviation=function(e,t,r,n){var i=t&&t.length,o=i?t[0]*r:e.length,s=Math.abs(ss(e,0,o,r));if(i)for(var a=0,l=t.length;a<l;a++){var u=t[a]*r,c=a<l-1?t[a+1]*r:e.length;s-=Math.abs(ss(e,u,c,r));}var f=0;for(a=0;a<n.length;a+=3){var h=n[a]*r,d=n[a+1]*r,p=n[a+2]*r;f+=Math.abs((e[h]-e[p])*(e[d+1]-e[h+1])-(e[h]-e[d])*(e[p+1]-e[h+1]));}return 0===s&&0===f?0:Math.abs((f-s)/s)},Io.flatten=function(e){for(var t=e[0][0].length,r={vertices:[],holes:[],dimensions:t},n=0,i=0;i<e.length;i++){for(var o=0;o<e[i].length;o++)for(var s=0;s<t;s++)r.vertices.push(e[i][o][s]);i>0&&(n+=e[i-1].length,r.holes.push(n));}return r},Lo.default=Oo;var as=[0,0,1];function ls(e,t,r,n){var i,o,s,a,l,u,c,f,h,d=n.texcoord_index,p=n.texcoord_scale,_=n.texcoord_normalize,m=t.vertex_elements,v=e.length,g=0;if(d){_=_||1;var y=p||Po;i=y[0],o=y[1],s=y[2],a=y[3];}for(var x=0;x<v;x++){var b=e[x],A=t.vertex_count,T=(h=Lo.flatten(b),Lo(h.vertices,h.holes,h.dimensions)),w=T.length;if(w){var E;if(d)l=(E=ai.findBoundingBox(b))[0],u=E[1],c=(s-i)/(E[2]-l),f=(a-o)/(E[3]-u);for(var R=0;R<b.length;R++)for(var M=b[R],S=0;S<M.length;S++){var z=M[S];r[0]=z[0],r[1]=z[1],d&&(r[d+0]=((z[0]-l)*c+i)*_,r[d+1]=((z[1]-u)*f+o)*_),t.addVertex(r);}for(var P=0;P<w;P++)m.push(A+T[P]);g+=w/3;}}return g}var us='uniform vec2 u_resolution;\nuniform float u_time;\nuniform vec3 u_map_position;\nuniform vec4 u_tile_origin;\nuniform float u_tile_proxy_order_offset;\nuniform float u_meters_per_pixel;\nuniform float u_device_pixel_ratio;\n\nuniform mat4 u_model;\nuniform mat4 u_modelView;\nuniform mat3 u_normalMatrix;\nuniform mat3 u_inverseNormalMatrix;\n\nattribute vec4 a_position;\nattribute vec4 a_color;\n\n// Optional normal attribute, otherwise default to up\n#ifdef TANGRAM_NORMAL_ATTRIBUTE\n    attribute vec3 a_normal;\n    #define TANGRAM_NORMAL a_normal\n#else\n    #define TANGRAM_NORMAL vec3(0., 0., 1.)\n#endif\n\n// Optional dynamic line extrusion\n#ifdef TANGRAM_EXTRUDE_LINES\n    attribute vec2 a_extrude; // extrusion direction in xy plane\n    attribute vec2 a_offset;  // offset direction in xy plane\n\n    // Polygon and line styles have slightly different VBO layouts, saving memory by optimizing vertex packing.\n    // All lines have a width scaling factor, but only some have a height (position.z) or offset.\n    // The vertex height is stored in different attributes to account for this.\n    attribute vec2 a_z_and_offset_scale; // stores vertex height in x, and offset scaling factor in y\n    #define TANGRAM_POSITION_Z a_z_and_offset_scale.x // vertex height is stored in separate line-specific attrib\n    #define TANGRAM_OFFSET_SCALING a_z_and_offset_scale.y // zoom scaling factor for line offset\n    #define TANGRAM_WIDTH_SCALING a_position.z // zoom scaling factor for line width (stored in position attrib)\n\n    uniform float u_v_scale_adjust; // scales texture UVs for line dash patterns w/fractional pixel width\n#else\n    #define TANGRAM_POSITION_Z a_position.z // vertex height\n#endif\n\nvarying vec4 v_position;\nvarying vec3 v_normal;\nvarying vec4 v_color;\nvarying vec4 v_world_position;\n\n// Optional texture UVs\n#if defined(TANGRAM_TEXTURE_COORDS) || defined(TANGRAM_EXTRUDE_LINES)\n    attribute vec2 a_texcoord;\n    varying vec2 v_texcoord;\n#endif\n\n// Optional model position varying for tile coordinate zoom\n#ifdef TANGRAM_MODEL_POSITION_BASE_ZOOM_VARYING\n    varying vec4 v_modelpos_base_zoom;\n#endif\n\n#if defined(TANGRAM_LIGHTING_VERTEX)\n    varying vec4 v_lighting;\n#endif\n\n#define TANGRAM_UNPACK_SCALING(x) (x / 1024.)\n\n#pragma tangram: attributes\n#pragma tangram: camera\n#pragma tangram: material\n#pragma tangram: lighting\n#pragma tangram: raster\n#pragma tangram: global\n\nvoid main() {\n    // Initialize globals\n    #pragma tangram: setup\n\n    // Texture UVs\n    #ifdef TANGRAM_TEXTURE_COORDS\n        v_texcoord = a_texcoord;\n        #ifdef TANGRAM_EXTRUDE_LINES\n            v_texcoord.y *= u_v_scale_adjust;\n        #endif\n    #endif\n\n    // Pass model position to fragment shader\n    #ifdef TANGRAM_MODEL_POSITION_BASE_ZOOM_VARYING\n        v_modelpos_base_zoom = modelPositionBaseZoom();\n    #endif\n\n    // Position\n    vec4 position = vec4(a_position.xy, TANGRAM_POSITION_Z / TANGRAM_HEIGHT_SCALE, 1.); // convert height back to meters\n\n    #ifdef TANGRAM_EXTRUDE_LINES\n        vec2 _extrude = a_extrude.xy;\n        vec2 _offset = a_offset.xy;\n\n        // Adjust line width based on zoom level, to prevent proxied lines\n        // from being either too small or too big.\n        // "Flattens" the zoom between 1-2 to peg it to 1 (keeps lines from\n        // prematurely shrinking), then interpolate and clamp to 4 (keeps lines\n        // from becoming too small when far away).\n        float _dz = clamp(u_map_position.z - u_tile_origin.z, 0., 4.);\n        _dz += step(1., _dz) * (1. - _dz) + mix(0., 2., clamp((_dz - 2.) / 2., 0., 1.));\n\n        // Interpolate line width between zooms\n        float _mdz = (_dz - 0.5) * 2.; // zoom from mid-point\n        _extrude -= _extrude * TANGRAM_UNPACK_SCALING(TANGRAM_WIDTH_SCALING) * _mdz;\n\n        // Interpolate line offset between zooms\n        // Scales from the larger value to the smaller one\n        float _dwdz = TANGRAM_UNPACK_SCALING(TANGRAM_OFFSET_SCALING);\n        float _sdwdz = sign(step(0., _dwdz) - 0.5); // sign indicates "direction" of scaling\n        _offset -= _offset * abs(_dwdz) * ((1.-step(0., _sdwdz)) - (_dz * -_sdwdz)); // scale "up" or "down"\n\n        // Scale line width and offset to be consistent in screen space\n        float _ssz = exp2(-_dz - (u_tile_origin.z - u_tile_origin.w));\n        _extrude *= _ssz;\n        _offset *= _ssz;\n\n        // Modify line width before extrusion\n        #ifdef TANGRAM_BLOCK_WIDTH\n            float width = 1.;\n            #pragma tangram: width\n            _extrude *= width;\n        #endif\n\n        position.xy += _extrude + _offset;\n    #endif\n\n    // World coordinates for 3d procedural textures\n    v_world_position = wrapWorldPosition(u_model * position);\n\n    // Adjust for tile and view position\n    position = u_modelView * position;\n\n    // Modify position before camera projection\n    #pragma tangram: position\n\n    // Setup varyings\n    v_position = position;\n    v_normal = normalize(u_normalMatrix * TANGRAM_NORMAL);\n    v_color = a_color;\n\n    #if defined(TANGRAM_LIGHTING_VERTEX)\n        // Vertex lighting\n        vec3 normal = v_normal;\n\n        // Modify normal before lighting\n        #pragma tangram: normal\n\n        // Pass lighting intensity to fragment shader\n        v_lighting = calculateLighting(position.xyz - u_eye, normal, vec4(1.));\n    #endif\n\n    // Camera\n    cameraProjection(position);\n\n    // +1 is to keep all layers including proxies > 0\n    applyLayerOrder(a_position.w + u_tile_proxy_order_offset + 1., position);\n\n    gl_Position = position;\n}\n',cs="uniform vec2 u_resolution;\nuniform float u_time;\nuniform vec3 u_map_position;\nuniform vec4 u_tile_origin;\nuniform float u_meters_per_pixel;\nuniform float u_device_pixel_ratio;\n\nuniform mat3 u_normalMatrix;\nuniform mat3 u_inverseNormalMatrix;\n\nvarying vec4 v_position;\nvarying vec3 v_normal;\nvarying vec4 v_color;\nvarying vec4 v_world_position;\n\n#ifdef TANGRAM_EXTRUDE_LINES\n    uniform bool u_has_line_texture;\n    uniform sampler2D u_texture;\n    uniform float u_texture_ratio;\n    uniform vec4 u_dash_background_color;\n    uniform float u_has_dash;\n#endif\n\n#define TANGRAM_NORMAL v_normal\n\n#if defined(TANGRAM_TEXTURE_COORDS) || defined(TANGRAM_EXTRUDE_LINES)\n    varying vec2 v_texcoord;\n#endif\n\n#ifdef TANGRAM_MODEL_POSITION_BASE_ZOOM_VARYING\n    varying vec4 v_modelpos_base_zoom;\n#endif\n\n#if defined(TANGRAM_LIGHTING_VERTEX)\n    varying vec4 v_lighting;\n#endif\n\n#pragma tangram: attributes\n#pragma tangram: camera\n#pragma tangram: material\n#pragma tangram: lighting\n#pragma tangram: raster\n#pragma tangram: global\n\nvoid main (void) {\n    // Initialize globals\n    #pragma tangram: setup\n\n    vec4 color = v_color;\n    vec3 normal = TANGRAM_NORMAL;\n\n    // Apply raster to vertex color\n    #ifdef TANGRAM_RASTER_TEXTURE_COLOR\n        vec4 _raster_color = sampleRaster(0);\n\n        #if defined(TANGRAM_BLEND_OPAQUE) || defined(TANGRAM_BLEND_TRANSLUCENT) || defined(TANGRAM_BLEND_MULTIPLY)\n            // Raster sources can optionally mask by the alpha channel, which will render with only full or no alpha.\n            // This is used for handling transparency outside the raster image in some blend modes,\n            // which either don't support alpha, or would cause transparent pixels to write to the depth buffer,\n            // obscuring geometry underneath.\n            #ifdef TANGRAM_HAS_MASKED_RASTERS   // skip masking logic if no masked raster sources\n            #ifndef TANGRAM_ALL_MASKED_RASTERS  // skip source check for masking if *all* raster sources are masked\n            if (u_raster_mask_alpha) {\n            #else\n            {\n            #endif\n                #if defined(TANGRAM_BLEND_TRANSLUCENT) || defined(TANGRAM_BLEND_MULTIPLY)\n                if (_raster_color.a < TANGRAM_EPSILON) {\n                    discard;\n                }\n                #else // TANGRAM_BLEND_OPAQUE\n                if (_raster_color.a < 1. - TANGRAM_EPSILON) {\n                    discard;\n                }\n                // only allow full alpha in opaque blend mode (avoids artifacts blending w/canvas tile background)\n                _raster_color.a = 1.;\n                #endif\n            }\n            #endif\n        #endif\n\n        color *= _raster_color; // multiplied to tint texture color\n    #endif\n\n    // Apply line texture\n    #ifdef TANGRAM_EXTRUDE_LINES\n    { // enclose in scope to avoid leakage of internal variables\n        if (u_has_line_texture) {\n            vec2 _line_st = vec2(v_texcoord.x, fract(v_texcoord.y / u_texture_ratio));\n            vec4 _line_color = texture2D(u_texture, _line_st);\n\n            // If the line has a dash pattern, the line texture indicates if the current fragment should be\n            // the dash foreground or background color. If the line doesn't have a dash pattern,\n            // the line texture color is used directly (but also tinted by the vertex color).\n            color = mix(\n                color * _line_color, // no dash: tint the line texture with the vertex color\n                mix(u_dash_background_color, color, _line_color.a), // choose dash foreground or background color\n                u_has_dash // 0 if no dash, 1 if has dash\n            );\n\n            // Use alpha discard test as a lower-quality substitute for blending\n            #if defined(TANGRAM_BLEND_OPAQUE)\n                if (color.a < TANGRAM_ALPHA_TEST) {\n                    discard;\n                }\n            #endif\n        }\n    }\n    #endif\n\n    // First, get normal from raster tile (if applicable)\n    #ifdef TANGRAM_RASTER_TEXTURE_NORMAL\n        normal = normalize(sampleRaster(0).rgb * 2. - 1.);\n    #endif\n\n    // Second, alter normal with normal map texture (if applicable)\n    #if defined(TANGRAM_LIGHTING_FRAGMENT) && defined(TANGRAM_MATERIAL_NORMAL_TEXTURE)\n        calculateNormal(normal);\n    #endif\n\n    // Normal modification applied here for fragment lighting or no lighting,\n    // and in vertex shader for vertex lighting\n    #if !defined(TANGRAM_LIGHTING_VERTEX)\n        #pragma tangram: normal\n    #endif\n\n    // Color modification before lighting is applied\n    #pragma tangram: color\n\n    #if defined(TANGRAM_LIGHTING_FRAGMENT)\n        // Calculate per-fragment lighting\n        color = calculateLighting(v_position.xyz - u_eye, normal, color);\n    #elif defined(TANGRAM_LIGHTING_VERTEX)\n        // Apply lighting intensity interpolated from vertex shader\n        color *= v_lighting;\n    #endif\n\n    // Post-processing effects (modify color after lighting)\n    #pragma tangram: filter\n\n    gl_FragColor = color;\n}\n",fs=Object.create(xo);Object.assign(fs,{name:"polygons",built_in:!0,vertex_shader_src:us,fragment_shader_src:cs,selection:!0,init:function(){xo.init.apply(this,arguments),this.defines.TANGRAM_NORMAL_ATTRIBUTE=!0,this.defines.TANGRAM_TEXTURE_COORDS=this.texcoords;},_parseFeature:function(e,t,r){var n=this.feature_style;return n.color=this.parseColor(t.color,r),n.color?(n.alpha=Ui.evalCachedProperty(t.alpha,r),n.variant=t.variant,n.z=Ui.evalCachedDistanceProperty(t.z,r)||Ui.defaults.z,n.z*=ai.height_scale,n.extrude=Ui.evalProperty(t.extrude,r),n.extrude&&(!0===n.extrude?(n.height=e.properties.height||Ui.defaults.height,n.min_height=e.properties.min_height||Ui.defaults.min_height):"number"==typeof n.extrude?(n.height=n.extrude,n.min_height=0):Array.isArray(n.extrude)&&(n.min_height=n.extrude[0],n.height=n.extrude[1]),n.height*=ai.height_scale,n.min_height*=ai.height_scale),n.tile_edges=t.tile_edges,n):null},_preprocess:function(e){return e.color=Ui.createColorPropertyCache(e.color),e.alpha=Ui.createPropertyCache(e.alpha),e.z=Ui.createPropertyCache(e.z,Ui.parseUnits),this.computeVariant(e),e},computeVariant:function(e){var t=e.interactive?1:0,r=null!=e.extrude?1:0,n=this.texcoords?1:0,i=this.getBlendOrderForDraw(e),o=[t,r,n,i].join("/");e.variant=o,null==this.variants[o]&&(this.variants[o]={key:o,blend_order:i,mesh_order:0,selection:t,normal:r,texcoords:n});},vertexLayoutForMeshVariant:function(e){if(null==this.vertex_layouts[e.key]){var t=[{name:"a_position",size:4,type:Ki.SHORT,normalized:!1},{name:"a_normal",size:3,type:Ki.BYTE,normalized:!0,static:e.normal?null:[0,0,1]},{name:"a_color",size:4,type:Ki.UNSIGNED_BYTE,normalized:!0},{name:"a_selection_color",size:4,type:Ki.UNSIGNED_BYTE,normalized:!0,static:e.selection?null:[0,0,0,0]},{name:"a_texcoord",size:2,type:Ki.UNSIGNED_SHORT,normalized:!0,static:e.texcoords?null:[0,0]}];this.addCustomAttributesToAttributeList(t),this.vertex_layouts[e.key]=new So(t);}return this.vertex_layouts[e.key]},meshVariantTypeForDraw:function(e){return this.variants[e.variant]},makeVertexTemplate:function(e,t){var r=0;return this.vertex_template[r++]=0,this.vertex_template[r++]=0,this.vertex_template[r++]=e.z||0,this.vertex_template[r++]=this.scaleOrder(e.order),t.variant.normal&&(this.vertex_template[r++]=0,this.vertex_template[r++]=0,this.vertex_template[r++]=127),this.vertex_template[r++]=255*e.color[0],this.vertex_template[r++]=255*e.color[1],this.vertex_template[r++]=255*e.color[2],this.vertex_template[r++]=255*(null!=e.alpha?e.alpha:e.color[3]),t.variant.selection&&(this.vertex_template[r++]=255*e.selection_color[0],this.vertex_template[r++]=255*e.selection_color[1],this.vertex_template[r++]=255*e.selection_color[2],this.vertex_template[r++]=255*e.selection_color[3]),t.variant.texcoords&&(this.vertex_template[r++]=0,this.vertex_template[r++]=0),this.addCustomAttributesToVertexTemplate(e,r),this.vertex_template},buildPolygons:function(e,t,r){var n=this.getTileMesh(r.tile,this.meshVariantTypeForDraw(t)),i=n.vertex_data,o=i.vertex_layout,s=this.makeVertexTemplate(t,n),a={texcoord_index:o.index.a_texcoord,texcoord_normalize:65535,remove_tile_edges:!t.tile_edges,tile_edge_tolerance:ai.tile_scale*r.tile.pad_scale*4,winding:r.winding};return t.extrude&&t.height?function(e,t,r,n,i,o,s,a,l){var u=l.remove_tile_edges,c=l.tile_edge_tolerance,f=l.texcoord_index,h=l.texcoord_scale,d=l.texcoord_normalize,p=l.winding,_=t+(n||0),m=t+r;o[2]=m;var v=ls(e,i,o,{texcoord_index:f,texcoord_scale:h,texcoord_normalize:d}),g=i.vertex_elements,y=i.vertex_count;if(f){d=d||1;var x=h||Po,b=x[0],A=x[1],T=x[2],w=x[3],E=[[b,w],[b,A],[T,A],[T,w]];}for(var R=e.length,M=0;M<R;M++)for(var S=e[M],z=0;z<S.length;z++)for(var P=S[z],N=0;N<P.length-1;N++)if(!u||!No(P[N],P[N+1],c)){var k=void 0,L=void 0;"CCW"===p?(k=N,L=N+1):(k=N+1,L=N);var O=[[P[L][0],P[L][1],m],[P[L][0],P[L][1],_],[P[k][0],P[k][1],_],[P[k][0],P[k][1],m]],I=oo.normalize([P[L][0]-P[k][0],P[L][1]-P[k][1],0]),F=oo.cross(as,I);o[s+0]=F[0]*a,o[s+1]=F[1]*a,o[s+2]=F[2]*a;for(var U=0;U<O.length;U++)o[0]=O[U][0],o[1]=O[U][1],o[2]=O[U][2],f&&(o[f+0]=E[U][0]*d,o[f+1]=E[U][1]*d),i.addVertex(o);g.push(y+0),g.push(y+1),g.push(y+2),g.push(y+2),g.push(y+3),g.push(y+0),y+=4,v+=2;}return v}(e,t.z,t.height,t.min_height,i,s,o.index.a_normal,127,a):ls(e,i,s,a)}});var hs=[0,0],ds={butt:0,square:1,round:2},ps={miter:0,bevel:1,round:2},_s=3,ms=5,vs=65535,gs=ai.tile_scale,ys=[0,0],xs=[1,0],bs=[.5,0];function As(e,t){if(!(e.length<2)){var r,n,i,o,s=t.join_type,a=t.cap_type,l=t.closed_polygon,u=t.remove_tile_edges,c=t.tile_edge_tolerance,f=t.v_scale,h=t.miter_len_sq,d=null!=t.texcoord_index,p=0;if(l&&s===ps.miter){var _=function(e){if(ko(e[0]))return 0;for(var t=0;t<e.length;t++){var r=e[e.length-1-t];if(ko(r))return e.length-1-t}return 0}(e);if(0!==_){var m=function(e,t){for(var r=[],n=0;n<e.length;n++){var i=(n+t)%e.length;0!==i&&r.push(e[i]);}return r.push(r[0]),r}(e,_);return t.extra_lines=t.extra_lines||[],void t.extra_lines.push(m)}}var v=0,g=e.length-1,y=0;for(r=e[v],n=e[v+1];oo.isEqual(r,n);)if(r=n,n=e[++v+1],y++,v===e.length-1)return;for(;oo.isEqual(e[g],e[g-1]);)if(y++,0===--g)return;if(!(e.length<2+y))if(o=oo.normalize(oo.perp(r,n)),u&&No(r,n,c)){var x=Ts(e,v,c);x&&(t.extra_lines=t.extra_lines||[],t.extra_lines.push(x));}else {l?function(e,t,r,n,i){if(void 0===n||ko(e))Ss(e,r,r,1,0,i,1),Ss(e,r,r,0,0,i,-1);else {n===ps.miter?Es(0,e,t,r,i.miter_len_sq,!0,i):Rs(n,0,e,t,r,!0,i);}}(r,i=oo.normalize(oo.perp(e[g-1],r)),o,s,t):(ko(r)||(Ns(r,p,o,a,!0,t),d&&a!==ds.butt&&(p+=.5*f*t.texcoord_width)),Ss(r,o,o,1,p,t,1),Ss(r,o,o,0,p,t,-1)),d&&(p+=f*oo.length(oo.sub(n,r)));for(var b=v+1;b<g;b++){var A=b,T=b+1;if(r=e[A],n=e[T],!oo.isEqual(r,n)){if(u&&No(r,n,c)){Ss(r,o,o,1,p,t,1),Ss(r,o,o,0,p,t,-1),Ms(1,t);var w=Ts(e,A+1,c);return void(w&&(t.extra_lines=t.extra_lines||[],t.extra_lines.push(w)))}i=o,o=oo.normalize(oo.perp(r,n)),s===ps.miter?Es(p,r,i,o,h,!1,t):Rs(s,p,r,i,o,!1,t),d&&(p+=f*oo.length(oo.sub(n,r)));}}r=n,i=o,l?function(e,t,r,n,i,o){if(ko(e))Ss(e,t,t,1,i,o,1),Ss(e,t,t,0,i,o,-1),Ms(1,o);else {var s=ws(t,r);n===ps.miter&&oo.lengthSq(s)>o.miter_len_sq&&(n=ps.bevel),n===ps.miter?(Ss(e,s,t,1,i,o,1),Ss(e,s,t,0,i,o,-1),Ms(1,o)):(Ss(e,t,t,1,i,o,1),Ss(e,t,t,0,i,o,-1),Ms(1,o));}}(r,i,o=oo.normalize(oo.perp(r,e[1])),s,p,t):(Ss(r,i,o,1,p,t,1),Ss(r,i,o,0,p,t,-1),Ms(1,t),ko(r)||Ns(r,p,i,a,!1,t));}}}function Ts(e,t,r){for(var n=t;e[n+1]&&No(e[n],e[n+1],r);)n++;return e.length-n>=2&&e.slice(n)}function ws(e,t){var r=oo.normalize(oo.add(e,t)),n=2/(1+Math.abs(oo.dot(e,r)));return oo.mult(r,n*n)}function Es(e,t,r,n,i,o,s){var a=ws(r,n);oo.lengthSq(a)>i?Rs(ps.bevel,e,t,r,n,o,s):(Ss(t,a,a,1,e,s,1),Ss(t,a,a,0,e,s,-1),o||Ms(1,s));}function Rs(e,t,r,n,i,o,s){var a=ws(n,i),l=i[0]*n[1]-i[1]*n[0]>0;null!=s.texcoord_index&&(ys[1]=t,xs[1]=t),l?(Ss(r,a,a,1,t,s,1),Ss(r,n,a,0,t,s,-1),o||Ms(1,s),Ps(r,oo.neg(n),a,oo.neg(i),a,ys,xs,ys,!1,e===ps.bevel,s),Ss(r,a,a,1,t,s,1),Ss(r,i,a,0,t,s,-1)):(Ss(r,n,a,1,t,s,1),Ss(r,a,a,0,t,s,-1),o||Ms(1,s),Ps(r,n,oo.neg(a),i,a,xs,ys,xs,!1,e===ps.bevel,s),Ss(r,i,a,1,t,s,1),Ss(r,a,a,0,t,s,-1));}function Ms(e,t){for(var r=t.vertex_data.vertex_elements,n=t.vertex_data.vertex_count-2*e-2,i=0;i<e;i++)r.push(n+2*i+2),r.push(n+2*i+1),r.push(n+2*i+0),r.push(n+2*i+2),r.push(n+2*i+3),r.push(n+2*i+1),t.geom_count+=2;}function Ss(e,t,r,n,i,o,s){var a=o.vertex_template,l=o.vertex_data;a[0]=e[0],a[1]=e[1];var u=o.half_width*s;a[o.extrude_index+0]=t[0]*u,a[o.extrude_index+1]=t[1]*u,o.offset&&(a[o.offset_index+0]=r[0]*o.offset,a[o.offset_index+1]=r[1]*o.offset),null!=o.texcoord_index&&(a[o.texcoord_index+0]=n*vs,a[o.texcoord_index+1]=i*vs),l.addVertex(a);}var zs=[0,0];function Ps(e,t,r,n,i,o,s,a,l,u,c){for(var f=t[0]*n[1]-t[1]*n[0],h=oo.dot(t,n),d=Math.atan2(f,h);d>=Math.PI;)d-=2*Math.PI;if(u)p=1;else {var p=function(e,t){e<0&&(e=-e);var r=t>2*ms?Math.log2(t/ms):1;return Math.ceil(e/Math.PI*r)}(d,c.half_width);if(p<1)return}var _=c.vertex_data.vertex_count,m=c.vertex_data.vertex_elements;Ss(e,r,i,s[0],s[1],c,1),Ss(e,t,i,o[0],o[1],c,1);var v=t,g=null!=c.texcoord_index;if(g)if(l)var y=oo.sub(o,s);else {zs=oo.copy(o);var x=oo.div(oo.sub(a,o),p);}var b,A,T=d/p,w=d<0?-1:1;f>0?(b=2,A=1):(b=1,A=2);for(var E=0;E<p;E++)0===E&&d<0&&(v=oo.neg(v)),v=oo.rot(v,T),g&&(l?(y=oo.rot(y,T),zs[0]=y[0]+s[0],zs[1]=y[1]*c.texcoord_width*c.v_scale+s[1]):zs=oo.add(zs,x)),Ss(e,v,i,zs[0],zs[1],c,w),m.push(_+E+b),m.push(_),m.push(_+E+A);}function Ns(e,t,r,n,i,o){var s=oo.neg(r),a=null!=o.texcoord_index;switch(n){case ds.square:var l;i?(l=[r[1],-r[0]],Ss(e,oo.add(r,l),r,1,t,o,1),Ss(e,oo.add(s,l),r,0,t,o,1),a&&(t+=.5*o.texcoord_width*o.v_scale),Ss(e,r,r,1,t,o,1),Ss(e,s,r,0,t,o,1)):(l=[-r[1],r[0]],Ss(e,r,r,1,t,o,1),Ss(e,s,r,0,t,o,1),a&&(t+=.5*o.texcoord_width*o.v_scale),Ss(e,oo.add(r,l),r,1,t,o,1),Ss(e,oo.add(s,l),r,0,t,o,1)),Ms(1,o);break;case ds.round:var u,c,f=ys,h=xs,d=bs;i?(u=r,c=s,a&&(t+=.5*o.texcoord_width*o.v_scale,f=xs,h=ys,d=bs)):(u=s,c=r),a&&(ys[1]=t,xs[1]=t,bs[1]=t),Ps(e,u,hs,c,r,f,d,h,!0,!1,o);break;case ds.butt:return}}var ks=[255,255,255,255],Ls=[0,0,0,0];var Os=Object.create(xo);Object.assign(Os,{name:"lines",built_in:!0,vertex_shader_src:us,fragment_shader_src:cs,selection:!0,init:function(){xo.init.apply(this,arguments),this.defines.TANGRAM_EXTRUDE_LINES=!0,this.defines.TANGRAM_TEXTURE_COORDS=!0,this.outline_feature_style={},this.inline_feature_style=this.feature_style,this.dash_textures={};},calcDistance:function(e,t){return Ui.evalCachedDistanceProperty(e,t)||0},calcDistanceNextZoom:function(e,t){t.zoom++;var r=this.calcDistance(e,t);return t.zoom--,r},calcWidth:function(e,t,r){var n=this.calcDistance(e.width,r);if(!(n<0)){var i;if(i=e.next_width?this.calcDistanceNextZoom(e.next_width,r):n/2,0===n&&0===i||i<0)return !1;if(t.width_unscaled=n,t.next_width_unscaled=i,e.next_width){var o=.5*(n+(i*=2));t.width=o*r.units_per_meter_overzoom,t.width_scale=1-i/o;}else t.width=n*r.units_per_meter_overzoom,t.width_scale=0;return e.texcoords&&(e.inline_texcoord_width?t.texcoord_width=e.inline_texcoord_width:t.texcoord_width=(t.width_unscaled||t.next_width_unscaled)*r.units_per_meter_overzoom/r.tile.overzoom2),!0}},calcOffset:function(e,t,r){if(e.offset_precalc)t.offset=e.offset_precalc,t.offset_scale=e.offset_scale_precalc;else if(e.offset){var n=this.calcDistance(e.offset,r);if(e.next_offset){var i=2*this.calcDistanceNextZoom(e.next_offset,r);Math.abs(n)>=Math.abs(i)?(t.offset=n*r.units_per_meter_overzoom,t.offset_scale=0!==n?1-i/n:0):(t.offset=i*r.units_per_meter_overzoom,t.offset_scale=0!==i?-1*(1-n/i):0);}else t.offset=n*r.units_per_meter_overzoom,t.offset_scale=0;}else t.offset=0,t.offset_scale=0;},_parseFeature:function(e,t,r){var n=this.feature_style;if(!1!==this.calcWidth(t,n,r)&&(this.calcOffset(t,n,r),n.color=this.parseColor(t.color,r),n.color)){if(n.alpha=Ui.evalCachedProperty(t.alpha,r),n.variant=t.variant,n.z=Ui.evalCachedDistanceProperty(t.z,r)||Ui.defaults.z,n.height=e.properties.height||Ui.defaults.height,n.extrude=Ui.evalProperty(t.extrude,r),n.extrude&&("number"==typeof n.extrude?n.height=n.extrude:Array.isArray(n.extrude)&&(n.height=n.extrude[1])),n.extrude&&n.height&&(n.z+=n.height),n.z*=ai.height_scale,n.cap=t.cap,n.join=t.join,n.miter_limit=t.miter_limit,n.tile_edges=t.tile_edges,n.outline=n.outline||{width:{},next_width:{},preprocessed:!0},t.outline&&!1!==t.outline.visible&&t.outline.color&&t.outline.width){var i=2*this.calcDistance(t.outline.width,r),o=2*this.calcDistanceNextZoom(t.outline.next_width,r);0===i&&0===o||i<0||o<0?(n.outline.width.value=null,n.outline.next_width.value=null,n.outline.color=null,n.outline.inline_texcoord_width=null,n.outline.texcoords=!1):(n.outline.width.value=i+n.width_unscaled,n.outline.next_width.value=o+n.next_width_unscaled,n.outline.inline_texcoord_width=n.texcoord_width,n.outline.offset_precalc=n.offset,n.outline.offset_scale_precalc=n.offset_scale,n.outline.color=t.outline.color,n.outline.alpha=t.outline.alpha,n.outline.interactive=t.outline.interactive,n.outline.cap=t.outline.cap,n.outline.join=t.outline.join,n.outline.miter_limit=t.outline.miter_limit,n.outline.texcoords=t.outline.texcoords,n.outline.extrude=t.outline.extrude,n.outline.z=t.outline.z,n.outline.style=t.outline.style,n.outline.variant=t.outline.variant,t.outline.order?n.outline.order=this.parseOrder(t.outline.order,r):n.outline.order=n.order,n.outline.order>n.order&&(n.outline.order=n.order),n.outline.order-=.5);}else n.outline.width.value=null,n.outline.next_width.value=null,n.outline.color=null,n.outline.inline_texcoord_width=null;return n}},_preprocess:function(e){if(e.color=Ui.createColorPropertyCache(e.color),e.alpha=Ui.createPropertyCache(e.alpha),e.width=Ui.createPropertyCache(e.width,Ui.parseUnits),e.width&&e.width.type!==Ui.CACHE_TYPE.STATIC&&(e.next_width=Ui.createPropertyCache(e.width,Ui.parseUnits)),e.offset=e.offset&&Ui.createPropertyCache(e.offset,Ui.parseUnits),e.offset&&e.offset.type!==Ui.CACHE_TYPE.STATIC&&(e.next_offset=Ui.createPropertyCache(e.offset,Ui.parseUnits)),e.z=Ui.createPropertyCache(e.z,Ui.parseUnits),e.dash=void 0!==e.dash?e.dash:this.dash,e.dash_key=e.dash&&this.dashTextureKey(e.dash),e.dash_background_color=void 0!==e.dash_background_color?e.dash_background_color:this.dash_background_color,e.dash_background_color=e.dash_background_color&&Ui.parseColor(e.dash_background_color),e.texture_merged=e.dash_key||(void 0!==e.texture?e.texture:this.texture),e.texcoords=this.texcoords||e.texture_merged?1:0,this.computeVariant(e),e.outline){e.outline.is_outline=!0,e.outline.style=e.outline.style||this.name,e.outline.color=Ui.createColorPropertyCache(e.outline.color),e.outline.alpha=Ui.createPropertyCache(e.outline.alpha),e.outline.width=Ui.createPropertyCache(e.outline.width,Ui.parseUnits),e.outline.next_width=Ui.createPropertyCache(e.outline.width,Ui.parseUnits),e.outline.interactive=null!=e.outline.interactive?e.outline.interactive:e.interactive,e.outline.cap=e.outline.cap||e.cap,e.outline.join=e.outline.join||e.join,e.outline.miter_limit=null!=e.outline.miter_limit?e.outline.miter_limit:e.miter_limit,e.outline.offset=e.offset,e.outline.extrude=e.extrude,e.outline.z=e.z;var t=this.styles[e.outline.style];t?(e.outline.dash=void 0!==e.outline.dash?e.outline.dash:t.dash,e.outline.texture=void 0!==e.outline.texture?e.outline.texture:t.texture,null!=e.outline.dash?(e.outline.dash_key=e.outline.dash&&this.dashTextureKey(e.outline.dash),e.outline.texture_merged=e.outline.dash_key):null===e.outline.dash?(e.outline.dash_key=null,e.outline.texture_merged=e.outline.texture):null!=e.outline.texture?(e.outline.dash_key=null,e.outline.texture_merged=e.outline.texture):(e.outline.dash=e.dash,e.outline.dash_key=e.outline.dash&&this.dashTextureKey(e.outline.dash),e.outline.texture_merged=e.outline.dash_key),e.outline.dash_background_color=void 0!==e.outline.dash_background_color?e.outline.dash_background_color:t.dash_background_color,e.outline.dash_background_color=void 0!==e.outline.dash_background_color?e.outline.dash_background_color:e.dash_background_color,e.outline.dash_background_color=e.outline.dash_background_color&&Ui.parseColor(e.outline.dash_background_color),e.outline.texcoords=t.texcoords||e.outline.texture_merged?1:0,void 0===e.outline.blend_order&&null!=e.blend_order&&(e.outline.blend_order=e.blend_order),t.computeVariant(e.outline)):(Zr({level:"warn",once:!0},"Layer group '"+e.layers.join(", ")+"': line 'outline' specifies non-existent draw style '"+e.outline.style+"' (or maybe the style is defined but is missing a 'base' or has another error), skipping outlines for features matching this layer group"),e.outline=null);}return e},dashTextureKey:function(e){return "__dash_"+JSON.stringify(e)},getDashTexture:function(e){var t=this.dashTextureKey(e);if(null==this.dash_textures[t]){this.dash_textures[t]=!0;var r=function(e,t){void 0===t&&(t={});var r=t.dash_color||ks,n=t.background_color||Ls,i=e,o=t.scale||1;i.length%2==1&&Array.prototype.push.apply(i,i);for(var s=!0,a=[],l=0;l<i.length;l++){for(var u=Math.floor(i[l]*o),c=0;c<u;c++)Array.prototype.push.apply(a,s?r:n);s=!s;}return a.reverse(),{pixels:a=new Uint8Array(a),length:a.length/4}}(e,{scale:20});Hn.create(this.gl,t,{data:r.pixels,height:r.length,width:1,filtering:"nearest"});}},endData:function(e){return new Promise(function(t,r){var n,i,o,s;return n=this,Promise.resolve(xo.endData.call(this,e)).then(function(e){try{if(i=e){i.uniforms.u_has_line_texture=!1,i.uniforms.u_texture=Hn.default,i.uniforms.u_v_scale_adjust=ai.tile_scale,o=[],s=function(e){return new Promise(function(t,r){var s,a,l;if((s=i.meshes[e].variant).texture){if((a=i.meshes[e].uniforms=i.meshes[e].uniforms||{}).u_has_line_texture=!0,a.u_texture=s.texture,a.u_texture_ratio=1,s.dash&&(a.u_v_scale_adjust=20*ai.tile_scale,a.u_has_dash=null!=s.dash_background_color?1:0,a.u_dash_background_color=s.dash_background_color||[0,0,0,0]),s.dash_key&&null==n.dash_textures[s.dash_key]){n.dash_textures[s.dash_key]=!0;var u=function(){try{return f.call(this)}catch(e){return r(e)}}.bind(this),c=function(e){try{return Zr("trace",n.name+": line dash texture create failed because style no longer on main thread"),u()}catch(e){return r(e)}};try{return Promise.resolve(jr.postMessage(n.main_thread_target+".getDashTexture",s.dash)).then(function(e){try{return u()}catch(e){return c()}},c)}catch(e){c();}}function f(){return null==Hn.textures[s.texture]?o.push(Hn.syncTexturesToWorker([s.texture]).then(function(e){var t=e[s.texture];t&&(a.u_texture_ratio=t.height/t.width);})):(l=Hn.textures[s.texture],a.u_texture_ratio=l.height/l.width),h.call(this)}return f.call(this)}function h(){return t()}return h.call(this)})};var a,l,u,c=[];for(a in i.meshes)c.push(a);function f(){return c.length?(l=c.shift(),Promise.resolve(s(l)).then(function(e){try{return f}catch(e){return r(e)}},r)):[1]}return (u=function(e){for(;e;){if(e.then)return void e.then(u,r);try{if(e.pop){if(e.length)return e.pop()?h.call(this):e;e=f;}else e=e.call(this);}catch(e){return r(e)}}}.bind(this))(f);function h(){return Promise.resolve(Promise.all(o)).then(function(e){try{return d.call(this)}catch(e){return r(e)}}.bind(this),r)}}function d(){return t(i)}return d.call(this)}catch(e){return r(e)}}.bind(this),r)}.bind(this))},computeVariant:function(e){var t=e.offset?1:0;t+="/"+e.texcoords,t+="/"+(e.interactive?1:0),t+="/"+(e.extrude||e.z?1:0),t+="/"+e.is_outline,e.dash_key&&(t+=e.dash_key,e.dash_background_color&&(t+=e.dash_background_color)),e.texture_merged&&(t+=e.texture_merged);var r=this.getBlendOrderForDraw(e);t=Zn(t+="/"+r),e.variant=t,null==this.variants[t]&&(this.variants[t]={key:t,blend_order:r,mesh_order:e.is_outline?0:1,selection:e.interactive?1:0,offset:e.offset?1:0,z_or_offset:e.offset||e.extrude||e.z?1:0,texcoords:e.texcoords,texture:e.texture_merged,dash:e.dash,dash_key:e.dash_key,dash_background_color:e.dash_background_color});},vertexLayoutForMeshVariant:function(e){if(null==this.vertex_layouts[e.key]){var t=[{name:"a_position",size:4,type:Ki.SHORT,normalized:!1},{name:"a_extrude",size:2,type:Ki.SHORT,normalized:!1},{name:"a_offset",size:2,type:Ki.SHORT,normalized:!1,static:e.offset?null:[0,0]},{name:"a_z_and_offset_scale",size:2,type:Ki.SHORT,normalized:!1,static:e.z_or_offset?null:[0,0]},{name:"a_texcoord",size:2,type:Ki.UNSIGNED_SHORT,normalized:!0,static:e.texcoords?null:[0,0]},{name:"a_color",size:4,type:Ki.UNSIGNED_BYTE,normalized:!0},{name:"a_selection_color",size:4,type:Ki.UNSIGNED_BYTE,normalized:!0,static:e.selection?null:[0,0,0,0]}];this.addCustomAttributesToAttributeList(t),this.vertex_layouts[e.key]=new So(t);}return this.vertex_layouts[e.key]},meshVariantTypeForDraw:function(e){return this.variants[e.variant]},makeVertexTemplate:function(e,t){var r=0;return this.vertex_template[r++]=0,this.vertex_template[r++]=0,this.vertex_template[r++]=1024*e.width_scale,this.vertex_template[r++]=this.scaleOrder(e.order),this.vertex_template[r++]=0,this.vertex_template[r++]=0,t.variant.offset&&(this.vertex_template[r++]=0,this.vertex_template[r++]=0),t.variant.z_or_offset&&(this.vertex_template[r++]=e.z||0,this.vertex_template[r++]=1024*e.offset_scale),t.variant.texcoords&&(this.vertex_template[r++]=0,this.vertex_template[r++]=0),this.vertex_template[r++]=255*e.color[0],this.vertex_template[r++]=255*e.color[1],this.vertex_template[r++]=255*e.color[2],this.vertex_template[r++]=255*(null!=e.alpha?e.alpha:e.color[3]),t.variant.selection&&(this.vertex_template[r++]=255*e.selection_color[0],this.vertex_template[r++]=255*e.selection_color[1],this.vertex_template[r++]=255*e.selection_color[2],this.vertex_template[r++]=255*e.selection_color[3]),this.addCustomAttributesToVertexTemplate(e,r),this.vertex_template},buildLines:function(e,t,r,n){if(this.feature_style=this.outline_feature_style,t.outline&&null!=t.outline.color&&null!=t.outline.width.value){var i=this.styles[t.outline.style];i&&i.addFeature(r.feature,t.outline,r);}this.feature_style=this.inline_feature_style;var o=this.getTileMesh(r.tile,this.meshVariantTypeForDraw(t)),s=o.vertex_data,a=s.vertex_layout;return function(e,t,r,n,i,o,s,a){var l,u=t.cap?ds[t.cap]:ds.butt,c=t.join?ps[t.join]:ps.miter;if(c===ps.miter)var f=t.miter_limit||_s,h=f*f;i.a_texcoord&&(l=1/(t.texcoord_width*gs));for(var d={closed_polygon:o,remove_tile_edges:s,tile_edge_tolerance:a,miter_len_sq:h,join_type:c,cap_type:u,vertex_data:r,vertex_template:n,half_width:t.width/2,extrude_index:i.a_extrude,offset_index:i.a_offset,v_scale:l,texcoord_index:i.a_texcoord,texcoord_width:t.texcoord_width,offset:t.offset,geom_count:0},p=0;p<e.length;p++)As(e[p],d);if(d.extra_lines)for(var _=0;_<d.extra_lines.length;_++)As(d.extra_lines[_],d);return d.geom_count}(e,t,s,this.makeVertexTemplate(t,o),a.index,n&&n.closed_polygon,!t.tile_edges&&n&&n.remove_tile_edges,ai.tile_scale*r.tile.pad_scale*2)},buildPolygons:function(e,t,r){for(var n=0,i=0;i<e.length;i++)n+=this.buildLines(e[i],t,r,{closed_polygon:!0,remove_tile_edges:!0});return n}}),io("anchor",function(e){return function(t){return e(this,"a","name",t)}});var Is=128/Math.PI,Fs=16384/Math.PI,Us=64,Ds=65535,Gs=128,Cs=[0,2,2,0],js=[1,1,3,3],Vs=new Array(4);var Bs=["left","top-left","bottom-left"],qs=["right","top-right","bottom-right"],Hs=["top","top-left","top-right"],Xs=["bottom","bottom-left","bottom-right"],Ws={computeOffset:function(e,t,r,n){if(void 0===n&&(n=null),!r||"center"===r)return e;var i=[e[0],e[1]];return n=n||this.default_buffer,this.isLeftAnchor(r)?(i[0]-=t[0]/2,"left"===r&&(i[0]-=n[0])):this.isRightAnchor(r)&&(i[0]+=t[0]/2,"right"===r&&(i[0]+=n[1])),this.isTopAnchor(r)?(i[1]-=t[1]/2,"top"===r&&(i[1]-=n[2])):this.isBottomAnchor(r)&&(i[1]+=t[1]/2,"bottom"===r&&(i[1]+=n[3])),i},alignForAnchor:function(e){if(e&&"center"!==e){if(this.isLeftAnchor(e))return "right";if(this.isRightAnchor(e))return "left"}return "center"},isLeftAnchor:function(e){return Bs.indexOf(e)>-1},isRightAnchor:function(e){return qs.indexOf(e)>-1},isTopAnchor:function(e){return Hs.indexOf(e)>-1},isBottomAnchor:function(e){return Xs.indexOf(e)>-1},default_buffer:[2.5,2.5,1.5,.75],zero_buffer:[0,0,0,0]};function Ys(e,t){return !(e[2]<t[0]||e[0]>t[2]||e[3]<t[1]||e[1]>t[3])}var Zs,Js,Ks,$s,Qs=[[1,0],[0,1]],ea=[],ta=[],ra=function(){function e(e,t,r,n,i){this.dimension=[n/2,i/2],this.angle=r,this.centroid=[e,t],this.quad=null,this.axis_0=null,this.axis_1=null,this.update();}var t=e.prototype;return t.toJSON=function(){return {x:this.centroid[0],y:this.centroid[1],a:this.angle,w:this.dimension[0],h:this.dimension[1]}},t.getExtent=function(){return 0===this.angle?[this.quad[0],this.quad[1],this.quad[4],this.quad[5]]:[Math.min(this.quad[0],this.quad[2],this.quad[4],this.quad[6]),Math.min(this.quad[1],this.quad[3],this.quad[5],this.quad[7]),Math.max(this.quad[0],this.quad[2],this.quad[4],this.quad[6]),Math.max(this.quad[1],this.quad[3],this.quad[5],this.quad[7])]},t.updateAxes=function(){this.axis_0=oo.normalize([this.quad[4]-this.quad[6],this.quad[5]-this.quad[7]]),this.axis_1=oo.normalize([this.quad[4]-this.quad[2],this.quad[5]-this.quad[3]]);},t.update=function(){var e=this.centroid,t=this.dimension[0],r=this.dimension[1];if(0===this.angle)this.quad=[e[0]-t,e[1]-r,e[0]+t,e[1]-r,e[0]+t,e[1]+r,e[0]-t,e[1]+r],this.axis_0=Qs[0],this.axis_1=Qs[1];else {var n=Math.cos(this.angle)*t,i=Math.sin(this.angle)*t,o=-Math.sin(this.angle)*r,s=Math.cos(this.angle)*r;this.quad=[e[0]-n-o,e[1]-i-s,e[0]+n-o,e[1]+i-s,e[0]+n+o,e[1]+i+s,e[0]-n+o,e[1]-i+s],this.updateAxes();}},e.projectToAxis=function(e,t,r){var n=e.quad;return Zs=n[0]*t[0]+n[1]*t[1],Js=n[2]*t[0]+n[3]*t[1],Ks=n[4]*t[0]+n[5]*t[1],$s=n[6]*t[0]+n[7]*t[1],r[0]=Math.min(Zs,Js,Ks,$s),r[1]=Math.max(Zs,Js,Ks,$s),r},e.axisCollide=function(t,r,n,i){return e.projectToAxis(t,n,ea),e.projectToAxis(r,n,ta),!(ta[0]>ea[1]||ta[1]<ea[0])&&(e.projectToAxis(t,i,ea),e.projectToAxis(r,i,ta),!(ta[0]>ea[1]||ta[1]<ea[0]))},e.intersect=function(t,r){return e.axisCollide(t,r,t.axis_0,t.axis_1)&&e.axisCollide(t,r,r.axis_0,r.axis_1)},e}(),na=function(){function e(t,r){void 0===r&&(r={}),this.id=e.nextLabelId(),this.type="",this.size=t,this.layout=r,this.position=null,this.angle=0,this.anchor=Array.isArray(this.layout.anchor)?this.layout.anchor[0]:this.layout.anchor,this.placed=null,this.offset=r.offset,this.unit_scale=this.layout.units_per_pixel,this.aabb=null,this.obb=null,this.align="center",this.throw_away=!1;}var t=e.prototype;return t.toJSON=function(){return {id:this.id,type:this.type,obb:this.obb.toJSON(),position:this.position,angle:this.angle,size:this.size,offset:this.offset,breach:this.breach,may_repeat_across_tiles:this.may_repeat_across_tiles,layout:ia(this.layout)}},t.update=function(){this.align=this.layout.align||Ws.alignForAnchor(this.anchor);},t.occluded=function(e,t){var r=this;void 0===t&&(t=null);var n=!1,i=e.aabb,o=e.obb;return i.length>0&&function(e,t,r){for(var n=0;n<t.length&&(!Ys(e,t[n])||null==r(n));n++);}(this.aabb,i,function(e){if(!t||i[e]!==t.aabb)return 0===r.obb.angle&&0===o[e].angle?(n=!0,!0):ra.intersect(r.obb,o[e])?(n=!0,!0):void 0}),n},t.inTileBounds=function(){return this.aabb[0]>=0&&this.aabb[1]>-ai.tile_scale&&this.aabb[0]<ai.tile_scale&&this.aabb[1]<=0||this.aabb[2]>=0&&this.aabb[3]>-ai.tile_scale&&this.aabb[2]<ai.tile_scale&&this.aabb[3]<=0},t.mayRepeatAcrossTiles=function(){if(this.layout.collide)return !0;var e=this.layout.repeat_distance;return 0!==e&&(Math.abs(this.position[0])<e||Math.abs(this.position[0]-ai.tile_scale)<e||Math.abs(this.position[1])<e||Math.abs(-(this.position[1]-ai.tile_scale))<e)},t.discard=function(e,t){return void 0===t&&(t=null),!!this.throw_away||this.occluded(e,t)},e}();function ia(e){return {priority:e.priority,collide:e.collide,repeat_distance:e.repeat_distance,repeat_group:e.repeat_group,buffer:e.buffer,italic:e.italic}}na.add=function(e,t){if(e.placed=!0,e.aabb&&(t.aabb.push(e.aabb),t.obb.push(e.obb)),e.aabbs)for(var r=0;r<e.aabbs.length;r++)t.aabb.push(e.aabbs[r]),t.obb.push(e.obbs[r]);},na.id=0,na.id_prefix=0,na.id_multiplier=0,na.nextLabelId=function(){return na.id_prefix+na.id++*na.id_multiplier},na.epsilon=.9999;var oa=function(){function e(e,t){this.key=e,this.repeat_dist=t,this.repeat_dist_sq=this.repeat_dist*this.repeat_dist,this.positions=[];}var t=e.prototype;return t.check=function(e){for(var t=e.position,r=0;r<this.positions.length;r++){var n=this.positions[r],i=t[0]-n[0],o=t[1]-n[1];if(i*i+o*o<this.repeat_dist_sq)return !0}},t.add=function(e){e&&e.position&&this.positions.push(e.position);},e.clear=function(e){this.groups[e]={};},e.check=function(e,t,r){if(t.repeat_distance&&t.repeat_group&&this.groups[r][t.repeat_group])return this.groups[r][t.repeat_group].check(e)},e.add=function(t,r,n){r.repeat_distance&&r.repeat_group&&(null==this.groups[n][r.repeat_group]&&(this.groups[n][r.repeat_group]=new e(r.repeat_group,r.repeat_distance*r.repeat_scale)),this.groups[n][r.repeat_group].add(t));},e}();oa.groups={};var sa=function(){function e(e,t){this.anchor=e,this.span=t,this.cells={};}var t=e.prototype;return t.addLabel=function(e){var t=this;e.aabb&&this.addLabelBboxes(e,e.aabb),e.aabbs&&e.aabbs.forEach(function(r){return t.addLabelBboxes(e,r)});},t.addLabelBboxes=function(e,t){var r=[Math.max(Math.floor((t[0]-this.anchor.x)/this.span),0),Math.max(Math.floor(-(t[1]-this.anchor.y)/this.span),0),Math.max(Math.floor((t[2]-this.anchor.x)/this.span),0),Math.max(Math.floor(-(t[3]-this.anchor.y)/this.span),0)];e.cells=[];for(var n=r[1];n<=r[3];n++){this.cells[n]=this.cells[n]||{};for(var i=r[0];i<=r[2];i++)this.cells[n][i]=this.cells[n][i]||{aabb:[],obb:[]},e.cells.push(this.cells[n][i]);}},e}(),aa={tiles:{},grid:null,initGrid:function(e){this.grid=null==e?null:new sa(e.anchor,e.span);},startTile:function(e,t){var r=void 0===t?{}:t,n=r.apply_repeat_groups,i=void 0===n||n,o=r.return_hidden,s=void 0!==o&&o,a=this.tiles[e]={bboxes:{aabb:[],obb:[]},objects:{},labels:{},styles:{},repeat:i,return_hidden:s};null==a.complete&&(a.complete=new Promise(function(e,t){a.resolve=e,a.reject=t;}));},resetTile:function(e){delete this.tiles[e];},abortTile:function(e){this.tiles[e]&&this.tiles[e].resolve&&this.tiles[e].resolve([]),this.resetTile(e);},addStyle:function(e,t){this.tiles[t].styles[e]=!0;},collide:function(e,t,r){var n=this.tiles[r];if(!n)return Zr("trace","Collision.collide() called with null tile",r,this.tiles,t,e),Promise.resolve([]);for(var i=n.objects,o=0;o<e.length;o++){var s=e[o],a=s.label.layout.priority;i[a]=i[a]||{},i[a][t]=i[a][t]||[],i[a][t].push(s);}return delete n.styles[t],0===Object.keys(n.styles).length&&this.endTile(r),n.complete.then(function(){return n.resolve=null,n.labels[t]||[]})},endTile:function(e){var t=this.tiles[e],r=t.labels;this.grid&&this.addLabelsToGrid(e),t.repeat&&oa.clear(e);for(var n=Object.keys(t.objects).sort(function(e,t){return e-t}),i=0;i<n.length;i++){var o=t.objects[n[i]];if(o)for(var s in o){var a=o[s];r[s]=r[s]||[];for(var l=0;l<a.length;l++){var u=a[l];this.canBePlaced(u,e,u.linked,t)?u.linked?this.canBePlaced(u.linked,e,u,t)?(u.show=!0,(u.label.breach||u.linked.label.breach)&&(u.label.breach=!0,u.linked.label.breach=!0),(u.label.may_repeat_across_tiles||u.linked.label.may_repeat_across_tiles)&&(u.label.may_repeat_across_tiles=!0,u.linked.label.may_repeat_across_tiles=!0),r[s].push(u),this.place(u,e,t),this.place(u.linked,e,t)):t.return_hidden&&(u.show=!1,r[s].push(u)):(u.show=!0,r[s].push(u),this.place(u,e,t)):t.return_hidden&&(u.show=!1,r[s].push(u));}}}delete this.tiles[e],t.resolve();},addLabelsToGrid:function(e){var t=this,r=this.tiles[e];for(var n in r.objects){var i=r.objects[n];if(i)for(var o in i){i[o].forEach(function(e){return t.grid.addLabel(e.label)});}}},canBePlaced:function(e,t,r,n){void 0===r&&(r=null);var i=(void 0===n?{}:n).repeat,o=void 0===i||i,s=e.label,a=e.label.layout;if(null!=s.placed)return s.placed;var l=!a.collide;if(l||(l=this.grid&&s.cells?s.cells.reduce(function(e,t){return e&&s.discard(t,r&&r.label)&&(e=!1),e},!0):!s.discard(this.tiles[t].bboxes,r&&r.label)),l){if(!o||!oa.check(s,a,t))return !0;s.placed=!1;}else a.collide&&(s.placed=!1);return s.placed},place:function(e,t,r){var n=e.label,i=r.repeat,o=void 0===i||i;null==n.placed&&(o&&oa.add(n,n.layout,t),this.grid&&n.cells?n.cells.forEach(function(e){return na.add(n,e)}):na.add(n,this.tiles[t].bboxes));}},la=function(e){function t(t,r,n,i){var o;return void 0===i&&(i=0),(o=e.call(this,r,n)||this).type="point",o.position=[t[0],t[1]],o.angle=i,o.parent=o.layout.parent,o.update(),o.start_anchor_index=1,o.degenerate=!(o.size[0]||o.size[1]||o.layout.buffer[0]||o.layout.buffer[1]),o.throw_away=!1,o}pt(t,e);var r=t.prototype;return r.update=function(){e.prototype.update.call(this),this.computeOffset(),this.updateBBoxes();},r.computeOffset=function(){if(this.offset=[this.layout.offset[0],this.layout.offset[1]],this.parent){var e=this.parent;this.offset=Ws.computeOffset(this.offset,e.size,e.anchor,Ws.zero_buffer),this.offset=Ws.computeOffset(this.offset,e.size,this.anchor,Ws.zero_buffer),e.offset!==Ui.zeroPair&&(this.offset===Ui.zeroPair?this.offset=e.offset:(this.offset[0]+=e.offset[0],this.offset[1]+=e.offset[1]));}this.offset=Ws.computeOffset(this.offset,this.size,this.anchor);},r.updateBBoxes=function(){var e=(this.size[0]+2*this.layout.buffer[0])*this.unit_scale*na.epsilon,t=(this.size[1]+2*this.layout.buffer[1])*this.unit_scale*na.epsilon;this.layout.italic&&(e+=5*this.unit_scale),this.obb=new ra(this.position[0]+this.offset[0]*this.unit_scale,this.position[1]-this.offset[1]*this.unit_scale,-this.angle,e,t),this.aabb=this.obb.getExtent(),this.inTileBounds&&(this.breach=!this.inTileBounds()),this.mayRepeatAcrossTiles&&(this.may_repeat_across_tiles=this.mayRepeatAcrossTiles());},r.discard=function(t,r){if(void 0===r&&(r=null),this.degenerate)return !1;if(e.prototype.discard.call(this,t,r)){if(Array.isArray(this.layout.anchor))for(var n=this.start_anchor_index;n<this.layout.anchor.length;n++)if(this.anchor=this.layout.anchor[n],this.update(),!e.prototype.discard.call(this,t,r))return !1;return !0}return !1},t}(na);la.PLACEMENT={VERTEX:0,MIDPOINT:1,SPACED:2,CENTROID:3};var ua=la.PLACEMENT,ca=80;function fa(e,t,r){var n=[],i=r.placement,o=Math.max(t[0],t[1])*r.placement_min_length_ratio*r.units_per_pixel;if(i===ua.SPACED){var s=function(e,t,r){var n=r.units_per_pixel,i=(r.placement_spacing||ca)*n,o=function(e){for(var t=0,r=0;r<e.length-1;r++)t+=da(e[r],e[r+1]);return t}(e);if(o<=t)return !1;for(var s=Math.max(Math.floor(o/i),1),a=[],l=[],u=.5*(o-(s-1)*i),c=0;c<s;c++){var f=pa(e,u,t,r),h=f.position,d=f.angle;null!=h&&null!=d&&(a.push(h),l.push(d)),u+=i;}return {positions:a,angles:l}}(e,o,r);if(!s)return [];for(var a=s.positions,l=s.angles,u=0;u<a.length;u++){var c=a[u],f=l[u];!0!==r.tile_edges&&ko(c)||n.push(new la(c,t,r,f));}}else if(i===ua.VERTEX){for(var h,d,p=0;p<e.length-1;p++)if(h=e[p],d=e[p+1],!0===r.tile_edges||!ko(h)){var _=ha(h,d,r.angle);n.push(new la(h,t,r,_));}var m=ha(h,d,r.angle);n.push(new la(d,t,r,m));}else if(i===ua.MIDPOINT)for(var v=0;v<e.length-1;v++){var g=e[v],y=e[v+1],x=[.5*(g[0]+y[0]),.5*(g[1]+y[1])];if((!0===r.tile_edges||!ko(x))&&(!o||da(g,y)>o)){var b=ha(g,y,r.angle);n.push(new la(x,t,r,b));}}return n}function ha(e,t,r){return void 0===r&&(r=0),"auto"===r?Math.atan2(t[0]-e[0],t[1]-e[1]):r}function da(e,t){return Math.sqrt(Math.pow(e[0]-t[0],2)+Math.pow(e[1]-t[1],2))}function pa(e,t,r,n){for(var i,o,s=0,a=0;a<e.length-1;a++){var l=e[a],u=e[a+1],c=da(l,u);if(!(c<=r)&&(s+=c)>t){i=_a(l,u,s-t),o=ha(l,u,n.angle);break}}return {position:i,angle:o}}function _a(e,t,r){var n=r/da(e,t);return [n*e[0]+(1-n)*t[0],n*e[1]+(1-n)*t[1]]}var ma={key:function(e){return [e.style,e.weight,e.family,e.px_size,e.fill,e.stroke,e.stroke_width,e.underline_width,e.background_color,e.background_width,e.background_stroke_color,e.background_stroke_width,e.transform,e.text_wrap,e.max_lines,e.supersample,Qr.device_pixel_ratio].join("/")},defaults:{style:"normal",weight:"normal",size:"12px",px_size:12,family:"Helvetica",fill:[1,1,1,1],text_wrap:15,max_lines:5,align:"center"},compute:function(e,t){var r={};e.font=e.font||this.defaults,r.supersample=e.supersample_text?1.5:1,r.can_articulate=e.can_articulate,r.fill=Ui.evalCachedColorPropertyWithAlpha(e.font.fill,e.font.alpha,t),r.fill=Qr.toCSSColor(r.fill),e.font.stroke&&e.font.stroke.color&&(r.stroke=Ui.evalCachedColorPropertyWithAlpha(e.font.stroke.color,e.font.stroke.alpha,t),r.stroke=Qr.toCSSColor(r.stroke),r.stroke_width=Ui.evalCachedProperty(e.font.stroke.width,t)),!0!==e.font.underline||r.can_articulate||(r.underline_width=1.5*r.supersample),e.font.background&&!r.can_articulate&&(r.background_color=Ui.evalCachedColorPropertyWithAlpha(e.font.background.color,e.font.background.alpha,t),r.background_color=Qr.toCSSColor(r.background_color),r.background_color&&(r.background_width=Ui.evalCachedProperty(e.font.background.width,t)),r.background_stroke_color=e.font.background.stroke&&e.font.background.stroke.color&&Ui.evalCachedColorPropertyWithAlpha(e.font.background.stroke.color,e.font.background.stroke.alpha,t),r.background_stroke_color&&(r.background_stroke_color=Qr.toCSSColor(r.background_stroke_color),r.background_stroke_width=null!=e.font.background.stroke.width?Ui.evalCachedProperty(e.font.background.stroke.width,t):1)),r.weight=Ui.evalCachedProperty(e.font.weight,t)||this.defaults.weight,"number"==typeof r.weight&&(r.weight=Math.min(Math.max(r.weight,1),1e3)),e.font.family?(r.family=e.font.family,r.family!==this.defaults.family&&(r.family+=", "+this.defaults.family)):r.family=this.defaults.family,r.style=e.font.style||this.defaults.style,r.transform=e.font.transform,r.px_size=Ui.evalCachedProperty(e.font.px_size,t)*r.supersample,r.font_css=this.fontCSS(r);var n=e.text_wrap;return null!=n||r.can_articulate||(n=!0),!0===n&&(n=this.defaults.text_wrap),r.text_wrap=n,r.max_lines=e.max_lines||this.defaults.max_lines,r},fontCSS:function(e){return [e.style,e.weight,e.px_size+"px",e.family].filter(function(e){return e}).join(" ")}},va=t(function(e){!function(){function t(e,t){document.addEventListener?e.addEventListener("scroll",t,!1):e.attachEvent("scroll",t);}function r(e){this.a=document.createElement("div"),this.a.setAttribute("aria-hidden","true"),this.a.appendChild(document.createTextNode(e)),this.b=document.createElement("span"),this.c=document.createElement("span"),this.h=document.createElement("span"),this.f=document.createElement("span"),this.g=-1,this.b.style.cssText="max-width:none;display:inline-block;position:absolute;height:100%;width:100%;overflow:scroll;font-size:16px;",this.c.style.cssText="max-width:none;display:inline-block;position:absolute;height:100%;width:100%;overflow:scroll;font-size:16px;",this.f.style.cssText="max-width:none;display:inline-block;position:absolute;height:100%;width:100%;overflow:scroll;font-size:16px;",this.h.style.cssText="display:inline-block;width:200%;height:200%;font-size:16px;max-width:none;",this.b.appendChild(this.h),this.c.appendChild(this.f),this.a.appendChild(this.b),this.a.appendChild(this.c);}function n(e,t){e.a.style.cssText="max-width:none;min-width:20px;min-height:20px;display:inline-block;overflow:hidden;position:absolute;width:auto;margin:0;padding:0;top:-999px;left:-999px;white-space:nowrap;font:"+t+";";}function i(e){var t=e.a.offsetWidth,r=t+100;return e.f.style.width=r+"px",e.c.scrollLeft=r,e.b.scrollLeft=e.b.scrollWidth+100,e.g!==t&&(e.g=t,!0)}function o(e,r){function n(){var e=o;i(e)&&e.a.parentNode&&r(e.g);}var o=e;t(e.b,n),t(e.c,n),i(e);}function s(e,t){var r=t||{};this.family=e,this.style=r.style||"normal",this.weight=r.weight||"normal",this.stretch=r.stretch||"normal";}var a=null,l=null,u=null,c=null;function f(){if(null===u){var e=document.createElement("div");try{e.style.font="condensed 100px sans-serif";}catch(e){}u=""!==e.style.font;}return u}function h(e,t){return [e.style,e.weight,f()?e.stretch:"","100px",t].join(" ")}s.prototype.load=function(e,t){var i=this,s=e||"BESbswy",u=0,f=t||3e3,d=(new Date).getTime();return new Promise(function(e,t){var p;if(null===c&&(c=!!document.fonts),(p=c)&&(null===l&&(l=/OS X.*Version\/10\..*Safari/.test(navigator.userAgent)&&/Apple/.test(navigator.vendor)),p=!l),p){p=new Promise(function(e,t){!function r(){(new Date).getTime()-d>=f?t():document.fonts.load(h(i,'"'+i.family+'"'),s).then(function(t){1<=t.length?e():setTimeout(r,25);},function(){t();});}();});var _=new Promise(function(e,t){u=setTimeout(t,f);});Promise.race([_,p]).then(function(){clearTimeout(u),e(i);},function(){t(i);});}else !function(e){document.body?e():document.addEventListener?document.addEventListener("DOMContentLoaded",function t(){document.removeEventListener("DOMContentLoaded",t),e();}):document.attachEvent("onreadystatechange",function t(){"interactive"!=document.readyState&&"complete"!=document.readyState||(document.detachEvent("onreadystatechange",t),e());});}(function(){function l(){var t;(t=-1!=m&&-1!=v||-1!=m&&-1!=g||-1!=v&&-1!=g)&&((t=m!=v&&m!=g&&v!=g)||(null===a&&(t=/AppleWebKit\/([0-9]+)(?:\.([0-9]+))/.exec(window.navigator.userAgent),a=!!t&&(536>parseInt(t[1],10)||536===parseInt(t[1],10)&&11>=parseInt(t[2],10))),t=a&&(m==y&&v==y&&g==y||m==x&&v==x&&g==x||m==b&&v==b&&g==b)),t=!t),t&&(A.parentNode&&A.parentNode.removeChild(A),clearTimeout(u),e(i));}var c=new r(s),p=new r(s),_=new r(s),m=-1,v=-1,g=-1,y=-1,x=-1,b=-1,A=document.createElement("div");A.dir="ltr",n(c,h(i,"sans-serif")),n(p,h(i,"serif")),n(_,h(i,"monospace")),A.appendChild(c.a),A.appendChild(p.a),A.appendChild(_.a),document.body.appendChild(A),y=c.a.offsetWidth,x=p.a.offsetWidth,b=_.a.offsetWidth,function e(){if((new Date).getTime()-d>=f)A.parentNode&&A.parentNode.removeChild(A),t(i);else {var r=document.hidden;!0!==r&&void 0!==r||(m=c.a.offsetWidth,v=p.a.offsetWidth,g=_.a.offsetWidth,l()),u=setTimeout(e,50);}}(),o(c,function(e){m=e,l();}),n(c,h(i,'"'+i.family+'",sans-serif')),o(p,function(e){v=e,l();}),n(p,h(i,'"'+i.family+'",serif')),o(_,function(e){g=e,l();}),n(_,h(i,'"'+i.family+'",monospace'));});})},e.exports=s;}();}),ga={fonts_loaded:Promise.resolve(),last_loaded:null,loadFonts:function(e){var t=this,r=JSON.stringify(e)===this.last_loaded;return e&&!r&&function(){var r=[],n=function(n){Array.isArray(e[n])?e[n].forEach(function(e){return r.push(t.loadFontFace(n,e))}):r.push(t.loadFontFace(n,e[n]));};for(var i in e)n(i);t.last_loaded=JSON.stringify(e),t.fonts_loaded=Promise.all(r.filter(function(e){return e}));}(),this.fonts_loaded},loadFontFace:function(e,t){return new Promise(function(r,n){var i,o;if(null==t||"object"!=typeof t&&"external"!==t)return r();if(i={family:e},"object"==typeof t){if(Object.assign(i,t),"string"==typeof t.url)return Promise.resolve(this.injectFontFace(i)).then(function(e){try{return s.call(this)}catch(e){return n(e)}}.bind(this),n);function s(){return a.call(this)}return s.call(this)}function a(){var t=function(){try{return r()}catch(e){return n(e)}},s=function(r){try{return Zr("warn","Font face '"+e+"' is NOT available",i,r),t()}catch(e){return n(e)}};try{return i.weight="string"==typeof i.weight?i.weight.split(" ")[0]:i.weight,o=new va(e,i),Promise.resolve(o.load()).then(function(r){try{return Zr("debug","Font face '"+e+"' is available",i),t()}catch(e){return s(e)}},s)}catch(e){s(e);}}return a.call(this)}.bind(this))},injectFontFace:function(e){return new Promise(function(t,r){var n,i,o,s,a,l,u,c,f,h,d;if(n=e.family,i=e.url,o=e.weight,s=e.style,void 0===this.supports_native_font_loading&&(this.supports_native_font_loading=void 0!==window.FontFace),a=i,"blob:"===i.slice(0,5))return Promise.resolve(Qr.io(i,6e4,"arraybuffer")).then(function(e){try{if(a=e.body,l=new Uint8Array(a),this.supports_native_font_loading)a=l;else {for(u="",c=0;c<l.length;c++)u+=String.fromCharCode(l[c]);a="data:font/opentype;base64,"+btoa(u);}return p.call(this)}catch(e){return r(e)}}.bind(this),r);function p(){return this.supports_native_font_loading?("string"==typeof a?f=new FontFace(n,"url("+encodeURI(a)+")",{weight:o,style:s}):a instanceof Uint8Array&&(f=new FontFace(n,a,{weight:o,style:s})),document.fonts.add(f),Zr("trace","Adding FontFace to document.fonts:",f)):(h="\n                @font-face {\n                    font-family: '"+n+"';\n                    font-weight: "+(o||"normal")+";\n                    font-style: "+(s||"normal")+";\n                    src: url("+encodeURI(a)+");\n                }",(d=document.createElement("style")).appendChild(document.createTextNode("")),document.head.appendChild(d),d.sheet.insertRule(h,0),Zr("trace","Injecting CSS font face:",h)),t()}return p.call(this)}.bind(this))}},ya=new RegExp("[֑-߿‏‫‮יִ-﷽ﹰ-ﻼ]");function xa(e){return ya.test(e)}var ba="\0-/:-@[-`{-¿×÷ʹ-˿ -⯿‐-\u2029‬ -⯿",Aa=new RegExp("["+ba+"]+");function Ta(e){return Aa.test(e)}var wa=new RegExp("^["+ba+"؀-ۿ]+"),Ea=new RegExp("["+ba+"آ-إاد-زوٱ-ٷڈ-ڙۄ-ۋۏےۓۮۯ]"),Ra=new RegExp("^[ؐ-ًؚ-ٰٟۖ-ۜ۟-۪ۤۧۨ-ۭ]+"),Ma="[̀-֑ͯ-ׇֽֿׁׂׅׄަ-ްऀ-ःऺ-ौॎॏ॑-ॗॢॣঁ-ঃ়া-ৌৗৢৣਁ-ਃ਼-ੌੑઁ-ઃ઼ા-ૌૢૣଁ-ଃ଼ା-ୌୖୗୢୣஂா-்ௗఀ-ఃా-ౌౕౖౢౣಁ-ಃ಼ಾ-ೌೕೖೢೣഁ-ഃാ-ൌൎൗൢൣංඃ්-ෟෲෳัิ-ฺ็-๎ັິ-ຼ່-ໍ༹༘༙༵༷༾༿ཱ-ྃ྆྇ྍ-ྼ࿆ါ-း်-ှၖ-ၙၞ-ၠၢ-ၤၧ-ၭၱ-ၴႂ-ႍႏႚ-ႝ឴-៑៓ᩕ-ᩞᩡ-᩼᷀-᷿⃐-⃿]",Sa=new RegExp("^.(?:"+Ma+"+)?([्্੍્୍్್്྄္្᩠᩿]\\W(?:"+Ma+"+)?)*"),za={Mongolian:"᠀-᢯"},Pa=Object.keys(za).map(function(e){return za[e]}).join(""),Na=new RegExp("["+Pa+"]");var ka=2;function La(e,t,r){var n=t?1:ka;if(e.length<n)return [e];var i=e;if(r.segment[i])return r.stats.segment_hits++,r.segment[i];var o=[];if(wa.exec(e)){o=e.split(Ea);for(var s=-1,a=0;a<o.length-1;a++){if(a>0){var l=Ra.exec(o[a]);l&&(o[a]=o[a].substring(l[0].length),o[a-1]+=l[0],s+=l[0].length);}s+=1+o[a].length,o[a]+=e.slice(s,s+1);}e="";}for(;e.length;){for(var u="",c=e,f=0;f<n&&c.length;f++){var h=(Sa.exec(c)||c)[0];u+=h,c=c.substring(h.length);}o.push(u),e=e.substring(u.length);}return t&&o.reverse(),r.stats.segment_misses++,r.segment[i]=o,o}var Oa=function(){function e(e,t,r){void 0===t&&(t=1/0),void 0===r&&(r=1/0),this.width=0,this.height=0,this.lines=[],this.max_lines=t,this.text_wrap=r,this.context=e;}var t=e.prototype;return t.createLine=function(e){return this.lines.length<this.max_lines&&new Ia(e,this.text_wrap)},t.push=function(e){if(this.lines.length<this.max_lines){var t=this.context.measureText(e.text).width;return e.width=t,t>this.width&&(this.width=Math.ceil(t)),this.lines.push(e),this.height+=e.height,!0}return this.addEllipsis(),!1},t.advance=function(e,t){return !!this.push(e)&&this.createLine(t)},t.addEllipsis=function(){var t=this.lines[this.lines.length-1],r=Math.ceil(this.context.measureText(e.ellipsis).width);t.append(e.ellipsis),t.width+=r,t.width>this.width&&(this.width=t.width);},t.finish=function(e){e?this.push(e):this.addEllipsis();},e.parse=function(t,r,n,i,o){var s;s="number"==typeof r?t.split(" "):[t];for(var a=new e(o,n,r),l=a.createLine(i),u=0;u<s.length;u++){for(var c=s[u].split("\n"),f=0===u,h=0;h<c.length&&l;h++){var d=c[h];xa(d)&&Ta(d[d.length-1])&&(d+="‏");var p=f?d:" "+d;if(r&&u>0&&l.exceedsTextwrap(p)){if(!(l=a.advance(l,i)))break;l.append(d),f=!0;}else l.append(p);h<c.length-1&&(l=a.advance(l,i),f=!0);}u===s.length-1&&a.finish(l);}return a},e}();Oa.ellipsis="...";var Ia=function(){function e(e,t){void 0===e&&(e=0),void 0===t&&(t=0),this.chars=0,this.text="",this.height=Math.ceil(e),this.text_wrap=t;}var t=e.prototype;return t.append=function(e){this.chars+=e.length,this.text+=e;},t.exceedsTextwrap=function(e){return e.length+this.chars>this.text_wrap},e}(),Fa=function(){function e(){this.createCanvas(),this.vertical_text_buffer=8,this.horizontal_text_buffer=4,this.background_size=4;}var t=e.prototype;return t.createCanvas=function(){this.canvas=document.createElement("canvas"),this.canvas.style.backgroundColor="transparent",this.context=this.canvas.getContext("2d");},t.resize=function(e,t){this.canvas.width=e,this.canvas.height=t,this.context.clearRect(0,0,e,t);},t.setFont=function(e){var t=e.font_css,r=e.fill,n=e.stroke,i=e.stroke_width,o=e.px_size,s=e.supersample;this.px_size=o;var a=this.context,l=Qr.device_pixel_ratio*s;n&&i>0&&(a.strokeStyle=n,a.lineWidth=i*l),a.fillStyle=r,a.font=t,a.miterLimit=2;},t.textSizes=function(e,t){return new Promise(function(r,n){return Promise.resolve(ga.loadFonts()).then(function(i){try{return r(En.add({type:"textSizes",run:this.processTextSizesTask.bind(this),texts:t,tile_id:e,cursor:{styles:Object.keys(t),texts:null,style_idx:null,text_idx:null}}))}catch(e){return n(e)}}.bind(this),n)}.bind(this))},t.processTextSizesTask=function(t){var r,n=t.cursor,i=t.texts;for(n.style_idx=n.style_idx||0;n.style_idx<n.styles.length;){var o=n.styles[n.style_idx];null==n.text_idx&&(n.text_idx=0,n.texts=Object.keys(i[o]));for(var s=i[o],a=!0;n.text_idx<n.texts.length;){var l=n.texts[n.text_idx],u=s[l],c=u.text_settings;if(a&&(this.setFont(c),a=!1),u.size=this.textSize(o,l,c).size,c.can_articulate){var f=!1,h=!1;if(xa(l)&&(Ta(l)?f=!0:h=!0),u.isRTL=f,u.no_curving=h||(r=l,Na.test(r)),u.vertical_buffer=this.vertical_text_buffer,u.segment_sizes=[],!u.no_curving){var d=La(l,f,e.cache);u.segments=d;for(var p=0;p<d.length;p++)u.segment_sizes.push(this.textSize(o,d[p],c).size);}}if(n.text_idx++,!En.shouldContinue(t))return !1}n.text_idx=null,n.style_idx++;}return En.finish(t,i),!0},t.textSize=function(t,r,n){var i=n.transform,o=n.text_wrap,s=n.max_lines,a=n.stroke_width,l=void 0===a?0:a,u=n.background_color,c=n.background_stroke_width,f=void 0===c?0:c,h=n.background_width,d=n.underline_width,p=void 0===d?0:d,_=n.supersample;if(e.cache.text[t]=e.cache.text[t]||{},e.cache.text[t][r])return e.cache.stats.text_hits++,e.cache.text[t][r];e.cache.stats.text_misses++,e.cache.text_count++;var m=Qr.device_pixel_ratio*_,v=this.applyTextTransform(r,i),g=this.context,y=this.vertical_text_buffer*m,x=(l+this.horizontal_text_buffer)*m;h=null!=h?h:this.background_size;var b=u||f?(h+f)*m:0,A=(2+p+(p?l+1:0))*m,T=this.px_size+A,w=Oa.parse(v,o,s,T,g),E=w.width,R=w.height,M=w.lines,S=[(E+=2*b)/m,(R+=2*b)/m],z=[E+2*x,R+2*y],P=[z[0]/m,z[1]/m];return e.cache.text[t][r]={lines:M,size:{collision_size:S,texture_size:z,logical_size:P,horizontal_buffer:x,vertical_buffer:y,dpr:m,line_height:T,background_size:b}},e.cache.text[t][r]},t.drawTextMultiLine=function(e,t,r,n,i){var o=t[0],s=t[1],a=r.dpr,l=r.collision_size,u=r.texture_size,c=r.line_height,f=r.horizontal_buffer,h=r.vertical_buffer;if(n.background_color||n.background_stroke_color){var d=n.background_stroke_color,p=(n.background_stroke_width||0)*a;this.context.save(),n.background_color&&(this.context.fillStyle=n.background_color,this.context.fillRect(o+f+("curved"===i?u[0]:0)+p,s+h+p,a*l[0]-2*p,a*l[1]-2*p)),d&&p&&(this.context.strokeStyle=d,this.context.lineWidth=p,this.context.strokeRect(o+f+("curved"===i?u[0]:0)+.5*p,s+h+.5*p,a*l[0]-p,a*l[1]-p)),this.context.restore();}for(var _=n.underline_width||0,m=n.stroke_width||0,v=s-(_?.5*(_+m+1)*a:0),g=0;g<e.length;g++){var y=e[g];this.drawTextLine(y,[o,v],r,n,i),v+=c;}this.drawTextDebug([o,s],r,i);},t.drawTextLine=function(e,t,r,n,i){var o,s=t[0],a=t[1],l=n.stroke,u=n.stroke_width,c=n.transform,f=n.align,h=void 0===f?"center":f,d=r.horizontal_buffer,p=r.vertical_buffer,_=r.texture_size,m=r.background_size,v=r.line_height,g=r.dpr,y=(n.underline_width||0)*g,x=this.applyTextTransform(e.text,c);"left"===h?o=s+d+m:"center"===h?o=s+_[0]/2-e.width/2:"right"===h&&(o=s+_[0]-e.width-d-m);var b=a+.75*p+v+m-.5*y,A=l&&u>0&&"curved"===i?_[0]:0;if(y){this.context.save(),this.context.strokeStyle=this.context.fillStyle,this.context.lineWidth=y;var T=b+(.5*u+2)*g+.5*this.context.lineWidth;this.context.beginPath(),this.context.moveTo(o+A,T),this.context.lineTo(o+A+e.width,T),this.context.stroke(),this.context.restore();}l&&u>0&&this.context.strokeText(x,o+A,b),this.context.fillText(x,o,b);},t.drawTextDebug=function(e,t,r){var n=e[0],i=e[1],o=t.dpr,s=t.horizontal_buffer,a=t.vertical_buffer,l=t.texture_size,u=t.collision_size;en.draw_label_collision_boxes&&(this.context.save(),this.context.strokeStyle="blue",this.context.lineWidth=2,this.context.strokeRect(n+s,i+a,o*u[0],o*u[1]),"curved"===r&&this.context.strokeRect(n+l[0]+s,i+a,o*u[0],o*u[1]),this.context.restore()),en.draw_label_texture_boxes&&(this.context.save(),this.context.strokeStyle="green",this.context.lineWidth=2,this.context.strokeRect(n+2,i+2,l[0]-4,l[1]-4),"curved"===r&&this.context.strokeRect(n+2+l[0],i+2,l[0]-4,l[1]-4),this.context.restore());},t.rasterize=function(e,t,r,n,i){return En.add({type:"rasterizeLabels",run:this.processRasterizeTask.bind(this),cancel:this.cancelRasterizeTask.bind(this),pause_factor:2,user_moving_view:!1,texts:e,textures:t,texture_prefix:n,gl:i,tile_id:r,cursor:{styles:Object.keys(e),texts:null,style_idx:0,text_idx:null,texture_idx:0,texture_resize:!0,texture_names:[]}})},t.processRasterizeTask=function(e){for(var t,r=e.cursor,n=e.texts,i=e.textures;r.texture_idx<e.textures.length;){for(t=i[r.texture_idx],r.texture_resize&&(r.texture_resize=!1,this.resize.apply(this,t.texture_size));r.style_idx<r.styles.length;){var o=r.styles[r.style_idx];null==r.text_idx&&(r.text_idx=0,r.texts=Object.keys(n[o]));for(var s=n[o],a=!0;r.text_idx<r.texts.length;){var l=r.texts[r.text_idx],u=s[l],c=u.text_settings;if(a&&(this.setFont(c),a=!1),c.can_articulate){u.texcoords=u.texcoords||{};for(var f=0;f<u.type.length;f++){var h=u.type[f];if("straight"===h){if(u.textures[f]!==r.texture_idx)continue;var d=u.isRTL?l.split().reverse().join():l,p=t.texcoord_cache[o][d],_=void 0;if(p.texcoord)_=p.texcoord;else {var m=p.texture_position,v=this.textSize(o,d,c),g=v.size,y=v.lines;this.drawTextMultiLine(y,m,g,c,h),_=Hn.getTexcoordsForSprite(m,g.texture_size,t.texture_size),p.texcoord=_;}u.texcoords[h]={texcoord:_,texture_id:p.texture_id};}else if("curved"===h){var x=u.segments;u.texcoords.curved=u.texcoords.curved||[],u.texcoords_stroke=u.texcoords_stroke||[];for(var b=0;b<x.length;b++)if(u.textures[f][b]===r.texture_idx){var A=x[b],T=t.texcoord_cache[o][A],w=void 0,E=void 0;if(T.texcoord)w=T.texcoord,E=T.texcoord_stroke,u.texcoords_stroke.push(E);else {var R=T.texture_position,M=this.textSize(o,A,c),S=M.size,z=M.lines;this.drawTextMultiLine(z,R,S,c,h),w=Hn.getTexcoordsForSprite(R,S.texture_size,t.texture_size);var P=[R[0]+S.texture_size[0],R[1]];E=Hn.getTexcoordsForSprite(P,S.texture_size,t.texture_size),T.texcoord=w,T.texcoord_stroke=E,u.texcoords_stroke.push(E);}u.texcoords.curved.push({texcoord:w,texture_id:T.texture_id});}}}}else {var N=this.textSize(o,l,c).lines,k=Object.assign({},c);for(var L in u.align)u.align[L].texture_id===r.texture_idx&&(k.align=L,this.drawTextMultiLine(N,u.align[L].texture_position,u.size,k),u.align[L].texcoords=Hn.getTexcoordsForSprite(u.align[L].texture_position,u.size.texture_size,t.texture_size));}if(r.text_idx++,!En.shouldContinue(e))return !1}r.text_idx=null,r.style_idx++;}var O=e.texture_prefix+r.texture_idx;Hn.create(e.gl,O,{element:this.canvas,filtering:"linear",UNPACK_PREMULTIPLY_ALPHA_WEBGL:!0}),Hn.retain(O),r.texture_names.push(O),r.texture_idx++,r.texture_resize=!0,r.style_idx=0;}return En.finish(e,r.texture_names),!0},t.cancelRasterizeTask=function(e){Zr("trace","RasterizeTask: release textures ["+e.cursor.texture_names.join(", ")+"]"),e.cursor.texture_names.forEach(function(e){return Hn.release(e)});},t.setTextureTextPositions=function(e,t){var r={cx:0,cy:0,width:0,height:0,column_width:0,texture_id:0,texcoord_cache:{}},n=[];for(var i in e){var o=e[i];for(var s in o){var a=o[s],l=void 0;if(a.text_settings.can_articulate){a.textures=[],r.texcoord_cache[i]=r.texcoord_cache[i]||{};for(var u=0;u<a.type.length;u++){var c=a.type[u];if("straight"===c){var f=a.isRTL?s.split().reverse().join():s;if(!r.texcoord_cache[i][f]){var h=a.size.texture_size;l=this.placeText(h[0],h[1],i,r,n,t),r.texcoord_cache[i][f]={texture_id:r.texture_id,texture_position:l};}a.textures[u]=r.texture_id;}else if("curved"===c){a.textures[u]=[];for(var d=0;d<a.segment_sizes.length;d++){var p=a.segments[d];if(!r.texcoord_cache[i][p]){var _=a.segment_sizes[d].texture_size,m=2*_[0];l=this.placeText(m,_[1],i,r,n,t),r.texcoord_cache[i][p]={texture_id:r.texture_id,texture_position:l};}a.textures[u].push(r.texture_id);}}}}else {var v=a.size.texture_size;for(var g in a.align)l=this.placeText(v[0],v[1],i,r,n,t),a.align[g].texture_id=r.texture_id,a.align[g].texture_position=l;}}}return r.column_width>0&&r.height>0&&(n[r.texture_id]={texture_size:[r.width,r.height],texcoord_cache:r.texcoord_cache}),n},t.placeText=function(e,t,r,n,i,o){var s;return n.cy+t>o?(n.cx+=n.column_width,n.cy=0,n.column_width=e):n.column_width=Math.max(n.column_width,e),n.cx+n.column_width<=o?(s=[n.cx,n.cy],n.cy+=t,n.height=Math.max(n.height,n.cy),n.width=Math.max(n.width,n.cx+n.column_width)):(i[n.texture_id]={texture_size:[n.width,n.height],texcoord_cache:n.texcoord_cache},n.texcoord_cache={},n.texcoord_cache[r]={},n.texture_id++,n.cx=0,n.cy=t,n.column_width=e,n.width=e,n.height=t,s=[0,0]),s},t.applyTextTransform=function(e,t){return "capitalize"===t?e.replace(/\w\S*/g,function(e){return e.charAt(0).toUpperCase()+e.substr(1)}):"uppercase"===t?e.toUpperCase():"lowercase"===t?e.toLowerCase():e},e.fontPixelSize=function(t){if(null!=t){var r=(t="string"==typeof t?t:String(t)).match(e.font_size_re)||[],n=r[1],i=r[2];return "em"===(i=i||"px")?n*=16:"pt"===i?n/=.75:"%"===i&&(n/=6.25),n=Ui.parsePositiveNumber(n),n*=Qr.device_pixel_ratio}},e.pruneTextCache=function(){e.cache.text_count>e.cache.text_count_max&&(e.cache.text={},e.cache.text_count=0,Zr("debug","TextCanvas: pruning text cache")),Object.keys(e.cache.segment).length>e.cache.segment_count_max&&(e.cache.segment={},Zr("debug","TextCanvas: pruning segment cache"));},e}();Fa.font_size_re=/((?:[0-9]*\.)?[0-9]+)\s*(px|pt|em|%)?/,Fa.cache={text:{},text_count:0,text_count_max:2e3,segment:{},segment_count_max:2e3,stats:{text_hits:0,text_misses:0,segment_hits:0,segment_misses:0}};var Ua=0,Da={resetText:function(){qe.is_main?this.canvas=new Fa:qe.is_worker&&(this.texts={});},freeText:function(e){delete this.texts[e.id];},parseTextFeature:function(e,t,r,n){var i=this.parseTextSource(e,t,r);if(null!=i&&""!==i){var o=ma.compute(t,r),s=ma.key(o);this.texts[n.id]=this.texts[n.id]||{};var a=this.texts[n.id][s]=this.texts[n.id][s]||{};if(i instanceof Object){var l=[],u=i.left+"-"+i.right;for(var c in i){var f=i[c];if(f){var h=this.computeTextLayout({},e,t,r,n,f,o,u,c);a[f]||(a[f]={text_settings:o,ref:0}),l.push({draw:t,text:f,text_settings_key:s,layout:h});}}return l.length>0&&l}var d=this.computeTextLayout({},e,t,r,n,i,o);return a[i]||(a[i]={text_settings:o,ref:0}),{draw:t,text:i,text_settings_key:s,layout:d}}},parseTextSource:function(e,t,r){var n,i=t.text_source||"name";if(null==i||Array.isArray(i)||"object"!=typeof i)n=this.parseTextSourceValue(i,e,r);else for(var o in n={},i)n[o]=this.parseTextSourceValue(i[o],e,r);return n},parseTextSourceValue:function(e,t,r){var n;if(Array.isArray(e)){for(var i=0;i<e.length;i++)if("string"==typeof e[i]?n=t.properties[e[i]]:"function"==typeof e[i]&&(n=e[i](r)),n)return n}else "string"==typeof e?n=t.properties[e]:e instanceof Function&&(n=e(r));return n},prepareTextLabels:function(e,t){return new Promise(function(r,n){var i;if(0===Object.keys(this.texts[e.id]||{}).length)return r([]);var o=function(t){try{return aa.abortTile(e.id),r([])}catch(e){return n(e)}};try{return Promise.resolve(jr.postMessage(this.main_thread_target+".calcTextSizes",e.id,this.texts[e.id])).then(function(n){try{return i=n,e.canceled?(Zr("trace","Style "+this.name+": stop tile build because tile was canceled: "+e.key+", post-calcTextSizes()"),r([])):(this.texts[e.id]=i||[],i?r(this.buildTextLabels(e,t)):(aa.abortTile(e.id),r([])))}catch(e){return o()}}.bind(this),o)}catch(e){o();}}.bind(this))},collideAndRenderTextLabels:function(e,t,r){return new Promise(function(n,i){var o,s,a;return Promise.resolve(this.prepareTextLabels(e,r)).then(function(r){try{return 0===(o=r).length?(aa.collide([],t,e.id),n({})):Promise.resolve(aa.collide(o,t,e.id)).then(function(t){try{if(o=t,e.canceled)return Zr("trace","stop tile build because tile was canceled: "+e.key+", post-collide()"),n({});if(null==(s=this.texts[e.id])||0===o.length)return n({});this.cullTextStyles(s,o),o.forEach(function(e){var t=e.text_settings_key,r=s[t]&&s[t][e.text];r.text_settings.can_articulate?(r.type||(r.type=[]),-1===r.type.indexOf(e.label.type)&&r.type.push(e.label.type)):(r.align=r.align||{},r.align[e.label.align]={});});var r=function(e){try{return n({})}catch(e){return i(e)}};try{return Promise.resolve(jr.postMessage(this.main_thread_target+".rasterizeTexts",e.id,e.key,s)).then(function(t){try{return a=t,e.canceled?(Zr("trace","stop tile build because tile was canceled: "+e.key+", post-rasterizeTexts()"),n({})):n(Object.assign({labels:o},a))}catch(e){return r()}},r)}catch(e){r();}}catch(e){return i(e)}}.bind(this),i)}catch(e){return i(e)}}.bind(this),i)}.bind(this))},cullTextStyles:function(e,t){for(var r=0;r<t.length;r++){var n=t[r];e[n.text_settings_key][n.text].ref++;}for(var i in e)for(var o in e[i])e[i][o].ref<1&&delete e[i][o];for(var s in e)0===Object.keys(e[s]).length&&delete e[s];},calcTextSizes:function(e,t){return this.canvas.textSizes(e,t)},rasterizeTexts:function(e,t,r){return new Promise(function(n,i){var o,s,a,l;return o=new Fa,s=Math.min(this.max_texture_size,2048),a=o.setTextureTextPositions(r,s),l=["labels",this.name,t,e,Ua,""].join("-"),Ua++,Promise.resolve(o.rasterize(r,a,e,l,this.gl)).then(function(e){try{return n((a=e)?{texts:r,textures:a}:{})}catch(e){return i(e)}},i)}.bind(this))},preprocessText:function(e){if(e&&e.font&&"object"==typeof e.font)return e.font.weight=Ui.createPropertyCache(e.font.weight),e.font.fill=Ui.createPropertyCache(e.font.fill||ma.defaults.fill),e.font.alpha=Ui.createPropertyCache(e.font.alpha),e.font.stroke&&(e.font.stroke.color=Ui.createPropertyCache(e.font.stroke.color),e.font.stroke.alpha=Ui.createPropertyCache(e.font.stroke.alpha)),e.font.background&&(e.font.background.color=Ui.createPropertyCache(e.font.background.color),e.font.background.alpha=Ui.createPropertyCache(e.font.background.alpha),e.font.background.width=Ui.createPropertyCache(e.font.background.width,Ui.parsePositiveNumber),e.font.background.stroke&&(e.font.background.stroke.color=Ui.createPropertyCache(e.font.background.stroke.color),e.font.background.stroke.alpha=Ui.createPropertyCache(e.font.background.stroke.alpha))),e.font.px_size=Ui.createPropertyCache(e.font.size||ma.defaults.size,Fa.fontPixelSize,Fa.fontPixelSize),e.font.stroke&&null!=e.font.stroke.width&&(e.font.stroke.width=Ui.createPropertyCache(e.font.stroke.width,Ui.parsePositiveNumber)),e.font.background&&e.font.background.stroke&&null!=e.font.background.stroke.width&&(e.font.background.stroke.width=Ui.createPropertyCache(e.font.background.stroke.width,Ui.parsePositiveNumber)),e.offset=Ui.createPropertyCache(e.offset,function(e){return Array.isArray(e)&&e.map(Ui.parseNumber)}),e.buffer=Ui.createPropertyCache(e.buffer,function(e){return (Array.isArray(e)?e:[e,e]).map(Ui.parsePositiveNumber)}),e.repeat_distance=Ui.createPropertyCache(e.repeat_distance,Ui.parsePositiveNumber),e},computeTextLayout:function(e,t,r,n,i,o,s,a,l){var u=e||{};return u=this.computeLayout(u,t,r,n,i),null==r.repeat_distance&&(u.repeat_distance="point"===n.geometry?0:ai.tile_size,u.repeat_distance&&(u.repeat_distance*=u.units_per_pixel,u.repeat_scale=1,"function"==typeof r.repeat_group?u.repeat_group=r.repeat_group(n):u.repeat_group=r.repeat_group)),u.repeat_distance&&(a&&(u.repeat_group+="/"+a),u.repeat_group+="/"+o),u.subdiv=i.overzoom2,u.align=r.align,u.italic="normal"!==s.style,"right"===l?u.orientation=1:"left"===l&&(u.orientation=-1),u}};qn("Float64",8,function(e){return function(t,r,n){return e(this,t,r,n)}});var Ga=function(e){return e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=1,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=1,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e};var Ca=function(e,t,r){var n=new Float64Array(3);return n[0]=e,n[1]=t,n[2]=r,n},ja={normalFromMat4:function(e,t){var r=t[0],n=t[1],i=t[2],o=t[3],s=t[4],a=t[5],l=t[6],u=t[7],c=t[8],f=t[9],h=t[10],d=t[11],p=t[12],_=t[13],m=t[14],v=t[15],g=r*a-n*s,y=r*l-i*s,x=r*u-o*s,b=n*l-i*a,A=n*u-o*a,T=i*u-o*l,w=c*_-f*p,E=c*m-h*p,R=c*v-d*p,M=f*m-h*_,S=f*v-d*_,z=h*v-d*m,P=g*z-y*S+x*M+b*R-A*E+T*w;return P?(P=1/P,e[0]=(a*z-l*S+u*M)*P,e[1]=(l*R-s*z-u*E)*P,e[2]=(s*S-a*R+u*w)*P,e[3]=(i*S-n*z-o*M)*P,e[4]=(r*z-i*R+o*E)*P,e[5]=(n*R-r*S-o*w)*P,e[6]=(_*T-m*A+v*b)*P,e[7]=(m*x-p*T-v*y)*P,e[8]=(p*A-_*x+v*g)*P,e):null},invert:function(e,t){var r=t[0],n=t[1],i=t[2],o=t[3],s=t[4],a=t[5],l=t[6],u=t[7],c=t[8],f=c*s-a*u,h=-c*o+a*l,d=u*o-s*l,p=r*f+n*h+i*d;return p?(p=1/p,e[0]=f*p,e[1]=(-c*n+i*u)*p,e[2]=(a*n-i*s)*p,e[3]=h*p,e[4]=(c*r-i*l)*p,e[5]=(-a*r+i*o)*p,e[6]=d*p,e[7]=(-u*r+n*l)*p,e[8]=(s*r-n*o)*p,e):null}},Va={multiply:function(e,t,r){var n=t[0],i=t[1],o=t[2],s=t[3],a=t[4],l=t[5],u=t[6],c=t[7],f=t[8],h=t[9],d=t[10],p=t[11],_=t[12],m=t[13],v=t[14],g=t[15],y=r[0],x=r[1],b=r[2],A=r[3];return e[0]=y*n+x*a+b*f+A*_,e[1]=y*i+x*l+b*h+A*m,e[2]=y*o+x*u+b*d+A*v,e[3]=y*s+x*c+b*p+A*g,y=r[4],x=r[5],b=r[6],A=r[7],e[4]=y*n+x*a+b*f+A*_,e[5]=y*i+x*l+b*h+A*m,e[6]=y*o+x*u+b*d+A*v,e[7]=y*s+x*c+b*p+A*g,y=r[8],x=r[9],b=r[10],A=r[11],e[8]=y*n+x*a+b*f+A*_,e[9]=y*i+x*l+b*h+A*m,e[10]=y*o+x*u+b*d+A*v,e[11]=y*s+x*c+b*p+A*g,y=r[12],x=r[13],b=r[14],A=r[15],e[12]=y*n+x*a+b*f+A*_,e[13]=y*i+x*l+b*h+A*m,e[14]=y*o+x*u+b*d+A*v,e[15]=y*s+x*c+b*p+A*g,e},translate:function(e,t,r){var n,i,o,s,a,l,u,c,f,h,d,p,_=r[0],m=r[1],v=r[2];t===e?(e[12]=t[0]*_+t[4]*m+t[8]*v+t[12],e[13]=t[1]*_+t[5]*m+t[9]*v+t[13],e[14]=t[2]*_+t[6]*m+t[10]*v+t[14],e[15]=t[3]*_+t[7]*m+t[11]*v+t[15]):(n=t[0],i=t[1],o=t[2],s=t[3],a=t[4],l=t[5],u=t[6],c=t[7],f=t[8],h=t[9],d=t[10],p=t[11],e[0]=n,e[1]=i,e[2]=o,e[3]=s,e[4]=a,e[5]=l,e[6]=u,e[7]=c,e[8]=f,e[9]=h,e[10]=d,e[11]=p,e[12]=n*_+a*m+f*v+t[12],e[13]=i*_+l*m+h*v+t[13],e[14]=o*_+u*m+d*v+t[14],e[15]=s*_+c*m+p*v+t[15]);return e},scale:function(e,t,r){var n=r[0],i=r[1],o=r[2];return e[0]=t[0]*n,e[1]=t[1]*n,e[2]=t[2]*n,e[3]=t[3]*n,e[4]=t[4]*i,e[5]=t[5]*i,e[6]=t[6]*i,e[7]=t[7]*i,e[8]=t[8]*o,e[9]=t[9]*o,e[10]=t[10]*o,e[11]=t[11]*o,e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e},perspective:function(e,t,r,n,i){var o=1/Math.tan(t/2),s=1/(n-i);return e[0]=o/r,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=o,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=(i+n)*s,e[11]=-1,e[12]=0,e[13]=0,e[14]=2*i*n*s,e[15]=0,e},lookAt:function(e,t,r,n){var i,o,s,a,l,u,c,f,h,d,p=t[0],_=t[1],m=t[2],v=n[0],g=n[1],y=n[2],x=r[0],b=r[1],A=r[2];if(Math.abs(p-x)<1e-6&&Math.abs(_-b)<1e-6&&Math.abs(m-A)<1e-6)return Ga(e);c=p-x,f=_-b,h=m-A,d=1/Math.sqrt(c*c+f*f+h*h),i=g*(h*=d)-y*(f*=d),o=y*(c*=d)-v*h,s=v*f-g*c,(d=Math.sqrt(i*i+o*o+s*s))?(i*=d=1/d,o*=d,s*=d):(i=0,o=0,s=0);a=f*s-h*o,l=h*i-c*s,u=c*o-f*i,(d=Math.sqrt(a*a+l*l+u*u))?(a*=d=1/d,l*=d,u*=d):(a=0,l=0,u=0);return e[0]=i,e[1]=a,e[2]=c,e[3]=0,e[4]=o,e[5]=l,e[6]=f,e[7]=0,e[8]=s,e[9]=u,e[10]=h,e[11]=0,e[12]=-(i*p+o*_+s*m),e[13]=-(a*p+l*_+u*m),e[14]=-(c*p+f*_+h*m),e[15]=1,e},identity:Ga,copy:function(e,t){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e}},Ba=function(){function e(e,t,r){void 0===r&&(r={}),this.view=t,this.position=r.position,this.zoom=r.zoom;}e.create=function(e,t,r){switch(r.type){case"isometric":return new Ha(e,t,r);case"flat":return new Xa(e,t,r);case"perspective":default:return new qa(e,t,r)}};var t=e.prototype;return t.update=function(){},t.setupProgram=function(){},t.updateView=function(){if(this.position||this.zoom){var e={};this.position&&(e={lng:this.position[0],lat:this.position[1],zoom:this.position[2]}),this.zoom&&(e.zoom=this.zoom),this.view.setView(e);}},t.setupMatrices=function(e,t){Va.multiply(e.model_view32,this.view_matrix,e.model),t.uniform("Matrix4fv","u_modelView",e.model_view32),ja.normalFromMat4(e.normal32,e.model_view32),ja.invert(e.inverse_normal32,e.normal32),t.uniform("Matrix3fv","u_normalMatrix",e.normal32),t.uniform("Matrix3fv","u_inverseNormalMatrix",e.inverse_normal32);},e}(),qa=function(e){function t(t,r,n){var i;return void 0===n&&(n={}),(i=e.call(this,t,r,n)||this).type="perspective",i.focal_length=n.focal_length,i.fov=n.fov,i.focal_length||i.fov||(i.focal_length=[[16,2],[17,2.5],[18,3],[19,4],[20,6]]),i.vanishing_point=n.vanishing_point||[0,0],i.vanishing_point=i.vanishing_point.map(parseFloat),i.vanishing_point_skew=[],i.position_meters=null,i.view_matrix=new Float64Array(16),i.projection_matrix=new Float32Array(16),Qn.replaceBlock("camera","\n            uniform mat4 u_projection;\n            uniform vec3 u_eye;\n            uniform vec2 u_vanishing_point;\n\n            void cameraProjection (inout vec4 position) {\n                position = u_projection * position;\n            }"),i}pt(t,e);var r=t.prototype;return r.constrainCamera=function(e){var t=e.view_height,r=e.height,n=e.focal_length,i=e.fov;return r?(n=2*r/t,i=2*Math.atan(1/n)):(n?i=2*Math.atan(1/n):i&&(i=i*Math.PI/180,n=1/Math.tan(i/2)),r=t/2*n),{view_height:t,height:r,focal_length:n,fov:i}},r.updateMatrices=function(){var e=this.view.size.css.height*this.view.meters_per_pixel,t=this.constrainCamera({view_height:e,focal_length:Qr.interpolate(this.view.zoom,this.focal_length),fov:Qr.interpolate(this.view.zoom,this.fov)}),r=t.height,n=t.fov,i=[this.view.center.meters.x,this.view.center.meters.y,r];this.position_meters=i,Va.lookAt(this.view_matrix,Ca(i[0],i[1],0),Ca(i[0],i[1],-1),Ca(0,1,0)),Va.perspective(this.projection_matrix,n,this.view.aspect,1,2*r),this.vanishing_point_skew[0]=this.vanishing_point[0]/this.view.size.css.width,this.vanishing_point_skew[1]=this.vanishing_point[1]/this.view.size.css.height,this.projection_matrix[8]=2*-this.vanishing_point_skew[0],this.projection_matrix[9]=2*-this.vanishing_point_skew[1],Va.translate(this.projection_matrix,this.projection_matrix,Ca(e/2*this.view.aspect*(2*-this.vanishing_point_skew[0]),e/2*(2*-this.vanishing_point_skew[1]),0)),Va.translate(this.projection_matrix,this.projection_matrix,Ca(0,0,-r));},r.update=function(){e.prototype.update.call(this),this.updateMatrices();},r.setupProgram=function(e){e.uniform("Matrix4fv","u_projection",this.projection_matrix),e.uniform("3f","u_eye",[0,0,this.position_meters[2]]),e.uniform("2fv","u_vanishing_point",this.vanishing_point_skew);},t}(Ba),Ha=function(e){function t(t,r,n){var i;return void 0===n&&(n={}),(i=e.call(this,t,r,n)||this).type="isometric",i.axis=n.axis||{x:0,y:1},2===i.axis.length&&(i.axis={x:i.axis[0],y:i.axis[1]}),i.position_meters=null,i.viewport_height=null,i.view_matrix=new Float64Array(16),i.projection_matrix=new Float32Array(16),Qn.replaceBlock("camera","\n            uniform mat4 u_projection;\n            uniform vec3 u_eye;\n            uniform vec2 u_vanishing_point;\n\n            void cameraProjection (inout vec4 position) {\n                position = u_projection * position;\n                // position.xy += position.z * u_isometric_axis;\n\n                // Reverse z for depth buffer so up is negative,\n                // and scale down values so objects higher than one screen height will not get clipped\n                // pull forward slightly to avoid going past far clipping plane\n                position.z = -position.z / 100. + 1. - 0.001;\n            }"),i}pt(t,e);var r=t.prototype;return r.update=function(){e.prototype.update.call(this),this.viewport_height=this.view.size.css.height*this.view.meters_per_pixel;var t=[this.view.center.meters.x,this.view.center.meters.y,this.viewport_height];this.position_meters=t,Va.identity(this.view_matrix),Va.translate(this.view_matrix,this.view_matrix,Ca(-t[0],-t[1],0)),Va.identity(this.projection_matrix),this.projection_matrix[8]=this.axis.x/this.view.aspect,this.projection_matrix[9]=this.axis.y,Va.scale(this.projection_matrix,this.projection_matrix,Ca(2/this.view.size.meters.x,2/this.view.size.meters.y,2/this.view.size.meters.y));},r.setupProgram=function(e){e.uniform("Matrix4fv","u_projection",this.projection_matrix),e.uniform("3fv","u_eye",[0,0,this.viewport_height]),e.uniform("2fv","u_vanishing_point",[0,0]);},t}(Ba),Xa=function(e){function t(t,r,n){var i;return void 0===n&&(n={}),(i=e.call(this,t,r,n)||this).type="flat",i}return pt(t,e),t.prototype.update=function(){this.axis.x=0,this.axis.y=0,e.prototype.update.call(this);},t}(Ha),Wa=function(){function e(e,t){Rn(this),this.scene=e,this.createMatrices(),this.zoom=null,this.center=null,this.bounds=null,this.meters_per_pixel=null,this.panning=!1,this.panning_stop_at=0,this.pan_snap_timer=0,this.zoom_direction=0,this.user_input_at=0,this.user_input_timeout=50,this.user_input_active=!1,this.size={css:{},device:{},meters:{}},this.aspect=null,this.buffer=0,this.continuous_zoom="boolean"!=typeof t.continuousZoom||t.continuousZoom,this.wrap=!1!==t.wrapView,this.preserve_tiles_within_zoom=1,this.reset();}var t=e.prototype;return t.reset=function(){this.createCamera();},t.createCamera=function(){var e=this.getActiveCamera();e&&(this.camera=Ba.create(e,this,this.scene.config.cameras[e]),this.camera.updateView());},t.getActiveCamera=function(){if(this.scene.config&&this.scene.config.cameras){for(var e in this.scene.config.cameras)if(this.scene.config.cameras[e].active)return e;var t=Object.keys(this.scene.config.cameras);return t.length&&t[0]}},t.setActiveCamera=function(e){var t=this.getActiveCamera();return t===e?e:(this.scene.config.cameras[e]&&(this.scene.config.cameras[e].active=!0,t&&this.scene.config.cameras[t]&&delete this.scene.config.cameras[t].active),this.scene.updateConfig({rebuild:!1,normalize:!1}),this.getActiveCamera())},t.update=function(){null!=this.camera&&this.ready()&&this.camera.update(),this.pan_snap_timer=(+new Date-this.panning_stop_at)/1e3,this.user_input_active=+new Date-this.user_input_at<this.user_input_timeout;},t.setViewportSize=function(e,t){this.size.css={width:e,height:t},this.size.device={width:Math.round(this.size.css.width*Qr.device_pixel_ratio),height:Math.round(this.size.css.height*Qr.device_pixel_ratio)},this.aspect=this.size.css.width/this.size.css.height,this.updateBounds();},t.setView=function(e){var t=void 0===e?{}:e,r=t.lng,n=t.lat,i=t.zoom,o=!1;return "number"==typeof r&&"number"==typeof n&&(this.center&&r===this.center.lng&&n===this.center.lat||(o=!0,this.center={lng:r,lat:n})),"number"==typeof i&&i!==this.zoom&&(o=!0,this.setZoom(i)),o&&this.updateBounds(),o},t.setZoom=function(e){var t=this.tile_zoom,r=this.baseZoom(e);this.continuous_zoom||(e=r),r!==t&&(this.zoom_direction=r>t?1:-1),this.zoom=e,this.tile_zoom=r,this.updateBounds(),this.scene.requestRedraw();},t.baseZoom=function(e){return Math.floor(e)},t.setPanning=function(e){this.panning=e,this.panning||(this.panning_stop_at=+new Date);},t.markUserInput=function(){this.user_input_at=+new Date;},t.ready=function(){return "number"==typeof this.size.css.width&&"number"==typeof this.size.css.height&&null!=this.center&&"number"==typeof this.zoom},t.updateBounds=function(){if(this.ready()){this.meters_per_pixel=ai.metersPerPixel(this.zoom),this.size.meters={x:this.size.css.width*this.meters_per_pixel,y:this.size.css.height*this.meters_per_pixel};var e=ai.latLngToMeters([this.center.lng,this.center.lat]);this.center.meters={x:e[0],y:e[1]},this.center.tile=ai.tileForMeters([this.center.meters.x,this.center.meters.y],this.tile_zoom),this.bounds={sw:{x:this.center.meters.x-this.size.meters.x/2,y:this.center.meters.y-this.size.meters.y/2},ne:{x:this.center.meters.x+this.size.meters.x/2,y:this.center.meters.y+this.size.meters.y/2}},this.scene.tile_manager.updateTilesForView(),this.trigger("move"),this.scene.requestRedraw();}},t.findVisibleTileCoordinates=function(){if(!this.bounds)return [];var e=this.tile_zoom,t=ai.tileForMeters([this.bounds.sw.x,this.bounds.sw.y],e),r=ai.tileForMeters([this.bounds.ne.x,this.bounds.ne.y],e),n=[t.x-this.buffer,r.x+this.buffer,r.y-this.buffer,t.y+this.buffer];if(!1===this.wrap){var i=(1<<e)-1;n=n.map(function(e){return Math.min(Math.max(0,e),i)});}for(var o=[],s=n[0];s<=n[1];s++)for(var a=n[2];a<=n[3];a++)o.push(vo.coord({x:s,y:a,z:e}));return o},t.pruneTilesForView=function(){var e=this;this.ready()&&this.scene.tile_manager.removeTiles(function(t){if(t.visible||t.isProxy())return !1;if(t.loading&&t.style_z!==e.tile_zoom)return !0;if(Math.abs(t.style_z-e.tile_zoom)>(null!=t.preserve_tiles_within_zoom?t.preserve_tiles_within_zoom:e.preserve_tiles_within_zoom))return !0;var r=e.meters_per_pixel*ai.tile_size,n=vo.coordAtZoom(ai.tileForMeters([e.center.meters.x-e.size.meters.x/2-r,e.center.meters.y+e.size.meters.y/2+r],e.tile_zoom),t.coords.z),i=vo.coordAtZoom(ai.tileForMeters([e.center.meters.x+e.size.meters.x/2+r,e.center.meters.y-e.size.meters.y/2-r],e.tile_zoom),t.coords.z);return (t.coords.x<n.x||t.coords.x>i.x||t.coords.y<n.y||t.coords.y>i.y)&&(Zr("trace","View: remove tile "+t.key+" (as "+t.coords.key+") for being too far out of visible area ("+n.key+", "+i.key+")"),!0)});},t.createMatrices=function(){this.matrices={},this.matrices.model=new Float64Array(16),this.matrices.model32=new Float32Array(16),this.matrices.model_view=new Float64Array(16),this.matrices.model_view32=new Float32Array(16),this.matrices.normal=new Float64Array(9),this.matrices.normal32=new Float32Array(9),this.matrices.inverse_normal32=new Float32Array(9);},t.setupTile=function(e,t){e.setupProgram(this.matrices,t),this.camera.setupMatrices(this.matrices,t);},t.setupProgram=function(e){e.uniform("2fv","u_resolution",[this.size.device.width,this.size.device.height]),e.uniform("3fv","u_map_position",[this.center.meters.x,this.center.meters.y,this.zoom]),e.uniform("1f","u_meters_per_pixel",this.meters_per_pixel),e.uniform("1f","u_device_pixel_ratio",Qr.device_pixel_ratio),e.uniform("1f","u_view_pan_snap_timer",this.pan_snap_timer),e.uniform("1i","u_view_panning",this.panning),this.camera.setupProgram(e);},t.isAnimating=function(){return this.pan_snap_timer<=.5},e}(),Ya=la.PLACEMENT,Za=Object.create(xo);Object.assign(Za,Da),Object.assign(Za,{name:"points",built_in:!0,vertex_shader_src:"uniform vec2 u_resolution;\nuniform float u_time;\nuniform vec3 u_map_position;\nuniform vec4 u_tile_origin;\nuniform float u_tile_proxy_order_offset;\nuniform bool u_tile_fade_in;\nuniform float u_meters_per_pixel;\nuniform float u_device_pixel_ratio;\nuniform float u_visible_time;\nuniform bool u_view_panning;\nuniform float u_view_pan_snap_timer;\n\nuniform mat4 u_model;\nuniform mat4 u_modelView;\nuniform mat3 u_normalMatrix;\nuniform mat3 u_inverseNormalMatrix;\n\nattribute vec4 a_position;\nattribute vec4 a_shape;\nattribute vec4 a_color;\nattribute vec2 a_texcoord;\nattribute vec2 a_offset;\n\nuniform float u_point_type;\n\n#ifdef TANGRAM_CURVED_LABEL\n    attribute vec4 a_offsets;\n    attribute vec4 a_pre_angles;\n    attribute vec4 a_angles;\n#endif\n\nvarying vec4 v_color;\nvarying vec2 v_texcoord;\nvarying vec4 v_world_position;\nvarying float v_alpha_factor;\n\n#ifdef TANGRAM_HAS_SHADER_POINTS\n    attribute float a_outline_edge;\n    attribute vec4 a_outline_color;\n\n    varying float v_outline_edge;\n    varying vec4 v_outline_color;\n    varying float v_aa_offset;\n#endif\n\n#ifdef TANGRAM_SHOW_HIDDEN_LABELS\n    varying float v_label_hidden;\n#endif\n\n#define TANGRAM_PI 3.14159265359\n#define TANGRAM_NORMAL vec3(0., 0., 1.)\n\n#pragma tangram: attributes\n#pragma tangram: camera\n#pragma tangram: material\n#pragma tangram: lighting\n#pragma tangram: raster\n#pragma tangram: global\n\nvec2 rotate2D(vec2 _st, float _angle) {\n    return mat2(cos(_angle),-sin(_angle),\n                sin(_angle),cos(_angle)) * _st;\n}\n\n#ifdef TANGRAM_CURVED_LABEL\n    // Assumes stops are [0, 0.33, 0.66, 0.99];\n    float mix4linear(vec4 v, float x) {\n        x = clamp(x, 0., 1.);\n        return mix(mix(v[0], v[1], 3. * x),\n                   mix(v[1],\n                       mix(v[2], v[3], 3. * (max(x, .66) - .66)),\n                       3. * (clamp(x, .33, .66) - .33)),\n                   step(0.33, x)\n                );\n    }\n#endif\n\nvoid main() {\n    // Initialize globals\n    #pragma tangram: setup\n\n    // discard hidden labels by collapsing into degenerate triangle\n    #ifndef TANGRAM_SHOW_HIDDEN_LABELS\n        if (a_shape.w == 0.) {\n            gl_Position = vec4(0., 0., 0., 1.);\n            return;\n        }\n    #else\n        // highlight hidden label in fragment shader for debugging\n        if (a_shape.w == 0.) {\n            v_label_hidden = 1.; // label debug testing\n        }\n        else {\n            v_label_hidden = 0.;\n        }\n    #endif\n\n    v_alpha_factor = 1.0;\n    v_color = a_color;\n    v_texcoord = a_texcoord; // UV from vertex attribute\n\n    #ifdef TANGRAM_HAS_SHADER_POINTS\n        v_outline_color = a_outline_color;\n        v_outline_edge = a_outline_edge;\n\n        if (u_point_type == TANGRAM_POINT_TYPE_SHADER) { // shader point\n            // use point dimensions for UVs instead (ignore attribute), add antialiasing info for fragment shader\n            float _size = abs(a_shape.x / 128.); // radius in pixels\n            v_texcoord = sign(a_shape.xy) * (_size + 1.) / _size;\n            _size += 2.;\n            v_aa_offset = 2. / _size;\n        }\n    #endif\n\n    // Position\n    vec4 position = u_modelView * vec4(a_position.xyz, 1.);\n\n    // Apply positioning and scaling in screen space\n    vec2 _shape = a_shape.xy / 256.;                 // values have an 8-bit fraction\n    vec2 _offset = vec2(a_offset.x, -a_offset.y);    // flip y to make it point down\n    float _theta = a_shape.z / 4096.;\n\n    #ifdef TANGRAM_CURVED_LABEL\n        //TODO: potential bug? null is passed in for non-curved labels, otherwise the first offset will be 0\n        if (a_offsets[0] != 0.){\n            vec4 _angles_scaled = (TANGRAM_PI / 16384.) * a_angles;\n            vec4 _pre_angles_scaled = (TANGRAM_PI / 128.) * a_pre_angles;\n            vec4 _offsets_scaled = (1. / 64.) * a_offsets;\n\n            float _zoom = clamp(u_map_position.z - u_tile_origin.z, 0., 1.); //fract(u_map_position.z);\n            float _pre_angle = mix4linear(_pre_angles_scaled, _zoom);\n            float _angle = mix4linear(_angles_scaled, _zoom);\n            float _offset_curve = mix4linear(_offsets_scaled, _zoom);\n\n            _shape = rotate2D(_shape, _pre_angle); // rotate in place\n            _shape.x += _offset_curve;            // offset for curved label segment\n            _shape = rotate2D(_shape, _angle);     // rotate relative to curved label anchor\n            _shape += rotate2D(_offset, _theta);   // offset if specified in the scene file\n        }\n        else {\n            _shape = rotate2D(_shape + _offset, _theta);\n        }\n    #else\n        _shape = rotate2D(_shape + _offset, _theta);\n    #endif\n\n    // Fade in (if requested) based on time mesh has been visible.\n    // Value passed to fragment shader in the v_alpha_factor varying\n    #ifdef TANGRAM_FADE_IN_RATE\n        if (u_tile_fade_in) {\n            v_alpha_factor *= clamp(u_visible_time * TANGRAM_FADE_IN_RATE, 0., 1.);\n        }\n    #endif\n\n    // World coordinates for 3d procedural textures\n    v_world_position = u_model * position;\n    v_world_position.xy += _shape * u_meters_per_pixel;\n    v_world_position = wrapWorldPosition(v_world_position);\n\n    // Modify position before camera projection\n    #pragma tangram: position\n\n    cameraProjection(position);\n\n    #ifdef TANGRAM_LAYER_ORDER\n        // +1 is to keep all layers including proxies > 0\n        applyLayerOrder(a_position.w + u_tile_proxy_order_offset + 1., position);\n    #endif\n\n    // Apply pixel offset in screen-space\n    // Multiply by 2 is because screen is 2 units wide Normalized Device Coords (and u_resolution device pixels wide)\n    // Device pixel ratio adjustment is because shape is in logical pixels\n    position.xy += _shape * position.w * 2. * u_device_pixel_ratio / u_resolution;\n    #ifdef TANGRAM_HAS_SHADER_POINTS\n        if (u_point_type == TANGRAM_POINT_TYPE_SHADER) { // shader point\n            // enlarge by 1px to catch missed MSAA fragments\n            position.xy += sign(_shape) * position.w * u_device_pixel_ratio / u_resolution;\n        }\n    #endif\n\n    // Snap to pixel grid\n    // Only applied to fully upright sprites/labels (not shader-drawn points), while panning is not active\n    #ifdef TANGRAM_HAS_SHADER_POINTS\n    if (!u_view_panning && (abs(_theta) < TANGRAM_EPSILON) && u_point_type != TANGRAM_POINT_TYPE_SHADER) {\n    #else\n    if (!u_view_panning && (abs(_theta) < TANGRAM_EPSILON)) {\n    #endif\n        vec2 _position_fract = fract((((position.xy / position.w) + 1.) * .5) * u_resolution);\n        vec2 _position_snap = position.xy + ((step(0.5, _position_fract) - _position_fract) * position.w * 2. / u_resolution);\n\n        // Animate the snapping to smooth the transition and make it less noticeable\n        #ifdef TANGRAM_VIEW_PAN_SNAP_RATE\n            position.xy = mix(position.xy, _position_snap, clamp(u_view_pan_snap_timer * TANGRAM_VIEW_PAN_SNAP_RATE, 0., 1.));\n        #else\n            position.xy = _position_snap;\n        #endif\n    }\n\n    gl_Position = position;\n}\n",fragment_shader_src:"uniform vec2 u_resolution;\nuniform float u_time;\nuniform vec3 u_map_position;\nuniform vec4 u_tile_origin;\nuniform float u_meters_per_pixel;\nuniform float u_device_pixel_ratio;\nuniform float u_visible_time;\n\nuniform mat3 u_normalMatrix;\nuniform mat3 u_inverseNormalMatrix;\n\nuniform sampler2D u_texture;\nuniform float u_point_type;\nuniform bool u_apply_color_blocks;\n\nvarying vec4 v_color;\nvarying vec2 v_texcoord;\nvarying vec4 v_world_position;\nvarying float v_alpha_factor;\n\n#ifdef TANGRAM_HAS_SHADER_POINTS\n    varying vec4 v_outline_color;\n    varying float v_outline_edge;\n    varying float v_aa_offset;\n#endif\n\n#ifdef TANGRAM_SHOW_HIDDEN_LABELS\n    varying float v_label_hidden;\n#endif\n\n#define TANGRAM_NORMAL vec3(0., 0., 1.)\n\n#pragma tangram: attributes\n#pragma tangram: camera\n#pragma tangram: material\n#pragma tangram: lighting\n#pragma tangram: raster\n#pragma tangram: global\n\n#ifdef TANGRAM_HAS_SHADER_POINTS\n    //l is the distance from the center to the fragment, R is the radius of the drawn point\n    float _tangram_antialias(float l, float R){\n        float low  = R - v_aa_offset;\n        float high = R + v_aa_offset;\n        return 1. - smoothstep(low, high, l);\n    }\n#endif\n\nvoid main (void) {\n    // Initialize globals\n    #pragma tangram: setup\n\n    vec4 color = v_color;\n\n    #ifdef TANGRAM_HAS_SHADER_POINTS\n        // Only apply shader blocks to point, not to attached text (N.B.: for compatibility with ES)\n        if (u_point_type == TANGRAM_POINT_TYPE_TEXTURE) { // sprite texture\n            color *= texture2D(u_texture, v_texcoord);\n        }\n        else if (u_point_type == TANGRAM_POINT_TYPE_LABEL) { // label texture\n            color = texture2D(u_texture, v_texcoord);\n            color.rgb /= max(color.a, 0.001); // un-multiply canvas texture\n        }\n        else if (u_point_type == TANGRAM_POINT_TYPE_SHADER) { // shader point\n            // Mask of outermost circle, either outline or point boundary\n            float _d = length(v_texcoord); // distance to this fragment from the point center\n            float _outer_alpha = _tangram_antialias(_d, 1.);\n            float _fill_alpha = _tangram_antialias(_d, 1. - (v_outline_edge * 0.5)) * color.a;\n            float _stroke_alpha = (_outer_alpha - _tangram_antialias(_d, 1. - v_outline_edge)) * v_outline_color.a;\n\n            // Apply alpha compositing with stroke 'over' fill.\n            #ifdef TANGRAM_BLEND_ADD\n                color.a = _stroke_alpha + _fill_alpha;\n                color.rgb = color.rgb * _fill_alpha + v_outline_color.rgb * _stroke_alpha;\n            #else // TANGRAM_BLEND_OVERLAY (and fallback for not implemented blending modes)\n                color.a = _stroke_alpha + _fill_alpha * (1. - _stroke_alpha);\n                color.rgb = mix(color.rgb * _fill_alpha, v_outline_color.rgb, _stroke_alpha) / max(color.a, 0.001); // avoid divide by zero\n            #endif\n        }\n    #else\n        // If shader points not supported, assume label texture\n        color = texture2D(u_texture, v_texcoord);\n        color.rgb /= max(color.a, 0.001); // un-multiply canvas texture\n    #endif\n\n    // Shader blocks for color/filter are only applied for sprites, shader points, and standalone text,\n    // NOT for text attached to a point (N.B.: for compatibility with ES)\n    if (u_apply_color_blocks) {\n        #pragma tangram: color\n        #pragma tangram: filter\n    }\n\n    color.a *= v_alpha_factor;\n\n    // highlight hidden label in fragment shader for debugging\n    #ifdef TANGRAM_SHOW_HIDDEN_LABELS\n        if (v_label_hidden > 0.) {\n            color.a *= 0.5;\n            color.rgb = vec3(1., 0., 0.);\n        }\n    #endif\n\n    // Use alpha test as a lower-quality substitute\n    // For opaque and translucent: avoid transparent pixels writing to depth buffer, obscuring geometry underneath\n    // For multiply: avoid transparent pixels multiplying geometry underneath to zero/full black\n    #if defined(TANGRAM_BLEND_OPAQUE) || defined(TANGRAM_BLEND_TRANSLUCENT) || defined(TANGRAM_BLEND_MULTIPLY)\n        if (color.a < TANGRAM_ALPHA_TEST) {\n            discard;\n        }\n    #endif\n\n    // Make points more visible in wireframe debug mode\n    #ifdef TANGRAM_WIREFRAME\n        color = vec4(vec3(0.5), 1.); // use gray outline for textured points\n        #ifdef TANGRAM_HAS_SHADER_POINTS\n            if (u_point_type == TANGRAM_POINT_TYPE_SHADER) {\n                color = vec4(v_color.rgb, 1.); // use original vertex color outline for shader points\n            }\n        #endif\n    #endif\n\n    gl_FragColor = color;\n}\n",selection:!0,collision:!0,blend:"overlay",init:function(e){void 0===e&&(e={}),xo.init.call(this,e),this.setupDefines(),this.defines.TANGRAM_HAS_SHADER_POINTS=!0,this.defines.TANGRAM_POINT_TYPE_TEXTURE=1,this.defines.TANGRAM_POINT_TYPE_LABEL=2,this.defines.TANGRAM_POINT_TYPE_SHADER=3,this.collision_group_points=this.name+"-points",this.collision_group_text=this.name+"-text",this.stencil_proxy_tiles=!1,this.reset();},setupDefines:function(){"overlay"!==this.blend&&(this.defines.TANGRAM_LAYER_ORDER=!0),!0===en.suppress_label_fade_in?(this.fade_in_time=0,this.defines.TANGRAM_FADE_IN_RATE=null):(this.fade_in_time=.15,this.defines.TANGRAM_FADE_IN_RATE=1/this.fade_in_time),!0!==en.suppress_label_snap_animation&&(this.defines.TANGRAM_VIEW_PAN_SNAP_RATE=2),!0===en.show_hidden_labels&&(this.defines.TANGRAM_SHOW_HIDDEN_LABELS=!0),!0===en.wireframe&&(this.defines.TANGRAM_WIREFRAME=!0);},reset:function(){this.queues={},this.resetText(),this.texture_missing_sprites={};},addFeature:function(e,t,r){var n=r.tile;if(n.generation===this.generation){var i={};if(i.color=this.parseColor(t.color,r),i.texture=t.texture,i.label_texture=null,i.blend_order=t.blend_order,i.color||i.texture){var o;if(i.alpha=Ui.evalCachedProperty(t.alpha,r),this.hasSprites(i)){if(!(o=this.parseSprite(i,t,r)))return void Zr({level:"debug",once:!0},"Layer group '"+t.layers.join(", ")+"' uses a texture '"+i.texture+"', but doesn't specify which sprite to draw. Features that match this layer group won't be drawn without specifying the sprite with the 'sprite' or 'sprite_default' properties. The merged draw parameters for this layer group are:",t).then(function(r){r&&Zr("debug","Example feature for layer group '"+t.layers.join(", ")+"'",e);});i.texcoords=o.texcoords;}else if(t.sprite)return void Zr({level:"warn",once:!0},"Layer group '"+t.layers.join(", ")+"' specifies sprite '"+t.sprite+"', but the texture '"+t.texture+"' doesn't define any sprites. Features that match this layer group won't be drawn. The merged draw parameters for this layer group are:",t);if(this.calcSize(t,i,o,r),t.outline&&(i.outline_width=Ui.evalCachedProperty(t.outline.width,r)||Ui.defaults.outline.width,i.outline_color=this.parseColor(t.outline.color,r)),i.outline_edge_pct=0,i.outline_width&&i.outline_color){var s=i.outline_width;i.size[0]+=s,i.size[1]+=s,i.outline_edge_pct=s/Math.min(i.size[0],i.size[1])*2,i.outline_alpha=Ui.evalCachedProperty(t.outline.alpha,r);}i.size[0]=Math.min(i.size[0],256),i.size[1]=Math.min(i.size[1],256),i.placement=t.placement,i.placement_min_length_ratio=Ui.evalCachedProperty(t.placement_min_length_ratio,r),i.placement===Ya.SPACED&&t.placement_spacing&&(i.placement_spacing=Ui.evalCachedProperty(t.placement_spacing,r)),i.angle=Ui.evalProperty(t.angle,r)||0,i.z=Ui.evalCachedDistanceProperty(t.z,r)||Ui.defaults.z,i.tile_edges=t.tile_edges,this.computeLayout(i,e,t,r,n);var a=t.text&&!1!==t.text.visible&&this.parseTextFeature(e,t.text,r,n);Array.isArray(a)&&(a=null,Zr({level:"warn",once:!0},"Layer group '"+t.layers.join(", ")+"': cannot use boundary labels (e.g. 'text_source: { left: ..., right: ... }') for 'text' labels attached to 'points'; provided 'text_source' value was "+JSON.stringify(t.text.text_source))),a&&(a.layout.parent=i,a.layout.priority=t.text.priority?Math.max(a.layout.priority,i.priority+.5):i.priority+.5,aa.addStyle(this.collision_group_text,n.id)),this.queueFeature({feature:e,draw:t,context:r,style:i,text_feature:a},n),aa.addStyle(this.collision_group_points,n.id);}}},calcSize:function(e,t,r,n){if(t.size=e.size,t.size){if(t.size=Ui.evalCachedPointSizeProperty(e.size,r,Hn.textures[t.texture],n),null==t.size)return void Zr({level:"warn",once:!0},"Layer group '"+e.layers.join(", ")+"': 'size' ("+JSON.stringify(e.size.value)+") couldn't be interpreted, features that match this layer group won't be drawn");"number"==typeof t.size&&(t.size=[t.size,t.size]);}else t.size=r&&r.css_size||[16,16];},hasSprites:function(e){return e.texture&&Hn.textures[e.texture]&&Hn.textures[e.texture].sprites},getSpriteInfo:function(e,t){var r=Hn.textures[e.texture].sprites[t]&&Hn.getSpriteInfo(e.texture,t);return t&&!r?(this.texture_missing_sprites[e.texture]=this.texture_missing_sprites[e.texture]||{},this.texture_missing_sprites[e.texture][t]||(Zr("debug","Style: in style '"+this.name+"', could not find sprite '"+t+"' for texture '"+e.texture+"'"),this.texture_missing_sprites[e.texture][t]=!0)):r&&(r.sprite=t),r},parseSprite:function(e,t,r){var n=Ui.evalProperty(t.sprite,r);return this.getSpriteInfo(e,n)||this.getSpriteInfo(e,t.sprite_default)},queueFeature:function(e,t){this.tile_data[t.id]&&this.queues[t.id]||this.startData(t),this.queues[t.id]=this.queues[t.id]||[],this.queues[t.id].push(e);},endData:function(e){return new Promise(function(t,r){var n,i,o,s,a,l,u,c,f,h;return n=this,e.canceled?(Zr("trace","Style "+this.name+": stop tile build because tile was canceled: "+e.key),t(null)):(i=this.queues[e.id],delete this.queues[e.id],o=[],s=[],i.forEach(function(e){for(var t=e.style,r=e.feature,i=r.geometry,a=n.buildLabels(t.size,i,t),l=0;l<a.length;l++){var u=a[l],c={feature:r,draw:e.draw,context:e.context,style:t,label:u};if(s.push(c),e.text_feature){var f={feature:r,draw:e.text_feature.draw,context:e.context,text:e.text_feature.text,text_settings_key:e.text_feature.text_settings_key,layout:e.text_feature.layout,point_label:u,linked:c};o.push(f),e.draw.text.optional||(c.linked=f);}}}),Promise.resolve(Promise.all([aa.collide(s,this.collision_group_points,e.id).then(function(e){e.forEach(function(e){n.feature_style=e.style,n.feature_style.label=e.label,n.feature_style.linked=e.linked,xo.addFeature.call(n,e.feature,e.draw,e.context);});}),this.collideAndRenderTextLabels(e,this.collision_group_text,o)])).then(function(i){try{return a=i[1],l=a.labels,u=a.texts,c=a.textures,l&&u&&l.forEach(function(e){var t=e.text_settings_key,r=u[t]&&u[t][e.text],i=n.feature_style;i.label=e.label,i.linked=e.linked,i.size=r.size.logical_size,i.texcoords=r.align[e.label.align].texcoords,i.label_texture=c[r.align[e.label.align].texture_id],i.blend_order=e.draw.blend_order,xo.addFeature.call(n,e.feature,e.draw,e.context);}),this.freeText(e),Promise.resolve(xo.endData.call(this,e)).then(function(e){try{return (f=e)&&c&&c.length&&(f.textures=f.textures||[],(h=f.textures).push.apply(h,c)),t(f)}catch(e){return r(e)}},r)}catch(e){return r(e)}}.bind(this),r))}.bind(this))},_preprocess:function(e){e.color=Ui.createColorPropertyCache(e.color),e.alpha=Ui.createPropertyCache(e.alpha),e.texture=void 0!==e.texture?e.texture:this.texture,e.blend_order=this.getBlendOrderForDraw(e),e.outline&&(e.outline.color=Ui.createColorPropertyCache(e.outline.color),e.outline.alpha=Ui.createPropertyCache(e.outline.alpha),e.outline.width=Ui.createPropertyCache(e.outline.width,Ui.parsePositiveNumber)),e.z=Ui.createPropertyCache(e.z,Ui.parseUnits);try{e.size=Ui.createPointSizePropertyCache(e.size,e.texture);}catch(t){return Zr({level:"warn",once:!0},"Layer group '"+e.layers.join(", ")+"': "+t+" ("+JSON.stringify(e.size)+"), features that match this layer group won't be drawn."),null}if(e.offset=Ui.createPropertyCache(e.offset,function(e){return Array.isArray(e)&&e.map(Ui.parseNumber)}),e.buffer=Ui.createPropertyCache(e.buffer,function(e){return (Array.isArray(e)?e:[e,e]).map(Ui.parsePositiveNumber)}),e.repeat_distance=Ui.createPropertyCache(e.repeat_distance,Ui.parseNumber),e.placement=Ya[e.placement&&e.placement.toUpperCase()],null==e.placement&&(e.placement=Ya.VERTEX),e.placement_spacing=null!=e.placement_spacing?e.placement_spacing:80,e.placement_spacing=Ui.createPropertyCache(e.placement_spacing,Ui.parsePositiveNumber),e.placement_min_length_ratio=null!=e.placement_min_length_ratio?e.placement_min_length_ratio:1,e.placement_min_length_ratio=Ui.createPropertyCache(e.placement_min_length_ratio,Ui.parsePositiveNumber),"number"==typeof e.angle)e.angle=e.angle*Math.PI/180;else if("function"==typeof e.angle){var t=e.angle;e.angle=function(e){return t(e)*Math.PI/180};}else e.angle=e.angle||0;return e.text=this.preprocessText(e.text),e.text&&(e.text.key=e.key,e.text.group=e.group,e.text.layers=e.layers,e.text.order=e.order,e.text.blend_order=e.blend_order,e.text.repeat_group=null!=e.text.repeat_group?e.text.repeat_group:e.repeat_group,e.text.anchor=e.text.anchor||this.default_anchor,e.text.optional="boolean"==typeof e.text.optional&&e.text.optional,e.text.interactive=e.text.interactive||e.interactive),e},default_anchor:["bottom","top","right","left"],computeLayout:function(e,t,r,n,i){var o=e||{};o.id=t,o.units_per_pixel=i.units_per_pixel||1,o.collide=!1!==r.collide,o.anchor=r.anchor,o.offset=Ui.evalCachedProperty(r.offset,n)||Ui.zeroPair,o.buffer=Ui.evalCachedProperty(r.buffer,n)||Ui.zeroPair,o.repeat_distance=Ui.evalCachedProperty(r.repeat_distance,n),o.repeat_distance&&(o.repeat_distance*=o.units_per_pixel,o.repeat_scale=1,"function"==typeof r.repeat_group?o.repeat_group=r.repeat_group(n):o.repeat_group=r.repeat_group||n.layer);var s=r.priority;return null!=s?"function"==typeof s&&(s=s(n)):s=-1>>>0,o.priority=s,o},buildTextLabels:function(e,t){for(var r=[],n=0;n<t.length;n++){var i=t[n],o=this.texts[e.id][i.text_settings_key][i.text].size.collision_size;i.label=new la(i.point_label.position,o,i.layout),r.push(i);}return r},buildLabels:function(e,t,r){var n=[];if("Point"===t.type)n.push(new la(t.coordinates,e,r,r.angle));else if("MultiPoint"===t.type)for(var i=t.coordinates,o=0;o<i.length;++o){var s=i[o];n.push(new la(s,e,r,r.angle));}else if("LineString"===t.type)for(var a=fa(t.coordinates,e,r),l=0;l<a.length;++l)n.push(a[l]);else if("MultiLineString"===t.type)for(var u=t.coordinates,c=0;c<u.length;c++)for(var f=fa(u[c],e,r),h=0;h<f.length;++h)n.push(f[h]);else if("Polygon"===t.type)if(r.placement===Ya.CENTROID){var d=ai.centroid(t.coordinates);d&&n.push(new la(d,e,r,r.angle));}else for(var p=t.coordinates,_=0;_<p.length;_++)for(var m=fa(p[_],e,r),v=0;v<m.length;++v)n.push(m[v]);else if("MultiPolygon"===t.type)if(r.placement===Ya.CENTROID){var g=ai.multiCentroid(t.coordinates);g&&n.push(new la(g,e,r,r.angle));}else for(var y=t.coordinates,x=0;x<y.length;x++)for(var b=y[x],A=0;A<b.length;A++)for(var T=fa(b[A],e,r),w=0;w<T.length;++w)n.push(T[w]);return n},makeVertexTemplate:function(e,t,r){void 0===r&&(r=!0);var n=0;this.vertex_template[n++]=0,this.vertex_template[n++]=0,this.vertex_template[n++]=e.z||0,this.vertex_template[n++]=this.scaleOrder(e.order),this.vertex_template[n++]=0,this.vertex_template[n++]=0,this.vertex_template[n++]=0,this.vertex_template[n++]=e.label.layout.collide?0:1,t.variant.shader_point||(this.vertex_template[n++]=0,this.vertex_template[n++]=0),this.vertex_template[n++]=0,this.vertex_template[n++]=0;var i=e.color||Ui.defaults.color;if(this.vertex_template[n++]=255*i[0],this.vertex_template[n++]=255*i[1],this.vertex_template[n++]=255*i[2],this.vertex_template[n++]=255*(null!=e.alpha?e.alpha:i[3]),t.variant.selection&&(this.vertex_template[n++]=255*e.selection_color[0],this.vertex_template[n++]=255*e.selection_color[1],this.vertex_template[n++]=255*e.selection_color[2],this.vertex_template[n++]=255*e.selection_color[3]),t.variant.shader_point){var o=e.outline_color||Ui.defaults.outline.color;this.vertex_template[n++]=255*o[0],this.vertex_template[n++]=255*o[1],this.vertex_template[n++]=255*o[2],this.vertex_template[n++]=255*(null!=e.outline_alpha?e.outline_alpha:o[3]),this.vertex_template[n++]=e.outline_edge_pct||Ui.defaults.outline.width;}return r&&this.addCustomAttributesToVertexTemplate(e,n),this.vertex_template},buildQuad:function(e,t,r,n,i,o,s,a,l,u,c){return t[0]<=0||t[1]<=0?0:function(e,t,r,n,i,o,s,a,l,u,c,f){var h=i[0]*Gs,d=i[1]*Gs;Vs[0]=-h,Vs[1]=-d,Vs[2]=h,Vs[3]=d;for(var p=c||Po,_=t.vertex_elements,m=t.vertex_count,v=0;v<4;v++)r[n.a_position+0]=e[0],r[n.a_position+1]=e[1],r[n.a_shape+0]=Vs[Cs[v]],r[n.a_shape+1]=Vs[js[v]],r[n.a_shape+2]=l,r[n.a_offset+0]=o[0],r[n.a_offset+1]=o[1],n.a_texcoord&&(r[n.a_texcoord+0]=p[Cs[v]]*Ds,r[n.a_texcoord+1]=p[js[v]]*Ds),f&&(r[n.a_pre_angles+0]=Is*a[0],r[n.a_pre_angles+1]=Is*a[1],r[n.a_pre_angles+2]=Is*a[2],r[n.a_pre_angles+3]=Is*a[3],r[n.a_angles+0]=Fs*u[0],r[n.a_angles+1]=Fs*u[1],r[n.a_angles+2]=Fs*u[2],r[n.a_angles+3]=Fs*u[3],r[n.a_offsets+0]=Us*s[0],r[n.a_offsets+1]=Us*s[1],r[n.a_offsets+2]=Us*s[2],r[n.a_offsets+3]=Us*s[3]),t.addVertex(r);return _.push(m+0),_.push(m+1),_.push(m+2),_.push(m+2),_.push(m+3),_.push(m+0),2}(e,u,c,u.vertex_layout.index,t,o,s,i,4096*r,n,a,l)},build:function(e,t){var r=e.label;return "curved"===r.type?this.buildCurvedLabel(r,e,t):this.buildStraightLabel(r,e,t)},buildStraightLabel:function(e,t,r){var n,i,o=this.getTileMesh(r.tile,this.meshVariantTypeForDraw(t)),s=this.makeVertexTemplate(t,o);"point"!==e.type?(n=t.size[e.type],i=t.texcoords[e.type].texcoord):(n=t.size,i=t.texcoords),o.uniforms=o.uniforms||{},t.label_texture?(o.uniforms.u_texture=t.label_texture,o.uniforms.u_point_type=2,o.uniforms.u_apply_color_blocks=!1):t.texture?(o.uniforms.u_texture=t.texture,o.uniforms.u_point_type=1,o.uniforms.u_apply_color_blocks=!0):(o.uniforms.u_texture=Hn.default,o.uniforms.u_point_type=3,o.uniforms.u_apply_color_blocks=!0);var a=e.offset,l=this.buildQuad(e.position,n,e.angle,null,null,a,null,i,!1,o.vertex_data,s),u=t.linked&&t.linked.label.id;return this.trackLabel(e,u,o,l,r),l},buildCurvedLabel:function(e,t,r){for(var n,i,o=0,s=0;s<e.num_segments;s++){var a=t.size[e.type][s],l=t.texcoords_stroke[s];t.label_texture=t.label_textures[s],n=this.getTileMesh(r.tile,this.meshVariantTypeForDraw(t)),i=this.makeVertexTemplate(t,n),n.uniforms=n.uniforms||{},n.uniforms.u_texture=t.label_texture,n.uniforms.u_point_type=2,n.uniforms.u_apply_color_blocks=!1;var u=e.offset||[0,0],c=e.position,f=e.angles[s],h=e.offsets[s],d=e.pre_angles[s],p=this.buildQuad(c,a,e.angle,f,d,u,h,l,!0,n.vertex_data,i);o+=p;var _=t.linked&&t.linked.label.id;this.trackLabel(e,_,n,p,r);}for(var m=0;m<e.num_segments;m++){var v=t.size[e.type][m],g=t.texcoords[e.type][m].texcoord;t.label_texture=t.label_textures[m],n=this.getTileMesh(r.tile,this.meshVariantTypeForDraw(t)),i=this.makeVertexTemplate(t,n),n.uniforms=n.uniforms||{},n.uniforms.u_texture=t.label_texture,n.uniforms.u_point_type=2,n.uniforms.u_apply_color_blocks=!1;var y=e.offset||[0,0],x=e.position,b=e.angles[m],A=e.offsets[m],T=e.pre_angles[m],w=this.buildQuad(x,v,e.angle,b,T,y,A,g,!0,n.vertex_data,i);o+=w;var E=t.linked&&t.linked.label.id;this.trackLabel(e,E,n,w,r);}return o},trackLabel:function(e,t,r,n){if(e.layout.collide||e.may_repeat_across_tiles){r.labels=r.labels||{},r.labels[e.id]=r.labels[e.id]||{container:{label:e.toJSON(),linked:t},ranges:[]};var i=2*n,o=r.vertex_data.offset-r.vertex_data.stride*i;r.labels[e.id].ranges.push([o,i]);}},buildLines:function(e,t,r){return this.build(t,r)},buildPoints:function(e,t,r){return this.build(t,r)},buildPolygons:function(e,t,r){return this.build(t,r)},vertexLayoutForMeshVariant:function(e){if(null==this.vertex_layouts[e.shader_point]){var t=[{name:"a_position",size:4,type:Ki.SHORT,normalized:!1},{name:"a_shape",size:4,type:Ki.SHORT,normalized:!1},{name:"a_texcoord",size:2,type:Ki.UNSIGNED_SHORT,normalized:!0,static:e.shader_point?[0,0]:null},{name:"a_offset",size:2,type:Ki.SHORT,normalized:!1},{name:"a_color",size:4,type:Ki.UNSIGNED_BYTE,normalized:!0},{name:"a_selection_color",size:4,type:Ki.UNSIGNED_BYTE,normalized:!0,static:e.selection?null:[0,0,0,0]},{name:"a_outline_color",size:4,type:Ki.UNSIGNED_BYTE,normalized:!0,static:e.shader_point?null:[0,0,0,0]},{name:"a_outline_edge",size:1,type:Ki.FLOAT,normalized:!1,static:e.shader_point?null:0}];this.addCustomAttributesToAttributeList(t),this.vertex_layouts[e.shader_point]=new So(t);}return this.vertex_layouts[e.shader_point]},meshVariantTypeForDraw:function(e){var t=e.label_texture||e.texture||"__shader_point",r=t+"/"+e.blend_order;return null==this.variants[r]&&(this.variants[r]={key:r,selection:1,shader_point:"__shader_point"===t,blend_order:e.blend_order,mesh_order:e.label_texture?1:0}),this.variants[r]},makeMesh:function(e,t,r){return void 0===r&&(r={}),r=Object.assign({},r,{fade_in_time:this.fade_in_time}),xo.makeMesh.call(this,e,t,r)}});var Ja=Math.abs;D(D.S,"Math",{hypot:function(e,t){for(var r,n,i=0,o=0,s=arguments.length,a=0;o<s;)a<(r=Ja(arguments[o++]))?(i=i*(n=a/r)*n+1,a=r):i+=r>0?(n=r/a)*n:r;return a===1/0?1/0:a*Math.sqrt(i)}});var Ka=[0,.33,.66,.99],$a=function(e,t,r,n){for(var i=[{type:"straight",tolerance:n.no_curving?1.8:1.5},{type:"curved"},{type:"straight",tolerance:2.3}],o=0;o<i.length;o++){var s=i[o],a=void 0;if("straight"===s.type?a=new el(t,r,n,s.tolerance):"curved"===s.type&&!n.no_curving&&r.length>2&&(a=new tl(e,r,n)),a&&!a.throw_away)return a}return !1},Qa=function(){function e(e){this.id=na.nextLabelId(),this.layout=e,this.position=[],this.angle=0,this.offset=e.offset.slice(),this.unit_scale=this.layout.units_per_pixel,this.obbs=[],this.aabbs=[],this.type="",this.throw_away=!1;}var t=e.prototype;return t.toJSON=function(){return {id:this.id,type:this.type,position:this.position,size:this.size,offset:this.offset,angle:this.angle,breach:this.breach,may_repeat_across_tiles:this.may_repeat_across_tiles,layout:ia(this.layout)}},e.splitLineByOrientation=function(e){for(var t=[e[0]],r=0,n=0,i=0,o=t,s=!1,a=1;a<e.length;a++){var l=e[a],u=e[a-1],c=oo.length(oo.sub(l,u));l[0]>u[0]?1===i?(t.push(l),(r+=c)>n&&(o=t,n=r,s=!1)):(t=[u,l],(r=c)>n&&(o=t,n=r,s=!1),i=1):l[0]<u[0]?-1===i?(t.unshift(l),(r+=c)>n&&(o=t,n=r,s=!0)):(t=[l,u],(r=c)>n&&(o=t,n=r,s=!0),i=-1):(-1===i?t.unshift(l):(t.push(l),i=1),(r+=c)>n&&(o=t,n=r,s=-1===i));}return [o,s]},t.discard=function(e,t){if(void 0===t&&(t=null),this.throw_away)return !0;for(var r=0;r<this.obbs.length;r++){var n={aabb:this.aabbs[r],obb:this.obbs[r]};if(na.prototype.occluded.call(n,e,t))return !0}return !1},t.inTileBounds=function(){for(var e=0;e<this.aabbs.length;e++){var t={aabb:this.aabbs[e]};if(!na.prototype.inTileBounds.call(t))return !1}return !0},e.createOBB=function(e,t,r,n,i,o,s){var a=e[0],l=e[1];return !o||0===o[0]&&0===o[1]||(a+=(o=oo.rot(o,i))[0]*s,l-=o[1]*s),new ra(a,l,-n,t,r)},e}(),el=function(e){function t(t,r,n,i){var o;return (o=e.call(this,n)||this).type="straight",o.size=t,o.throw_away=!o.fit(t,r,n,i),o}pt(t,e);var r=t.prototype;return r.fit=function(e,t,r,n){var i,o=this.unit_scale,s=Qa.splitLineByOrientation(t);t=s[0],i=s[1],"number"==typeof r.orientation&&(this.offset[1]+=1.2*(e[1]-r.vertical_buffer),i&&(this.offset[1]*=-1),-1===r.orientation&&(this.offset[1]*=-1));for(var a=il(t),l=e[0]*o,u=0;u<t.length-1;u++)for(var c=t[u],f=0,h=0,d=u+1,p=void 0;d<t.length;){var _=t[d-1],m=t[d],v=nl(_,m);if(d!==u+1&&(f+=ol(v,p)),Math.abs(f)>.1)break;if(rl(h+=a[d-1],l)<n){var g=oo.mult(oo.add(c,m),.5);return this.angle=-v,Math.abs(this.angle-Math.PI/2)<.01&&(this.angle=-Math.PI/2,"number"==typeof r.orientation&&(this.offset[1]*=-1)),this.position=g,this.updateBBoxes(this.position,e,this.angle,this.angle,this.offset),!0}p=v,d++;}return !1},r.updateBBoxes=function(e,t,r,n,i){var o=this.unit_scale;this.obbs=[],this.aabbs=[];var s=(t[0]+2*this.layout.buffer[0])*o*na.epsilon,a=(t[1]+2*this.layout.buffer[1])*o*na.epsilon,l=Qa.createOBB(e,s,a,r,n,i,o),u=l.getExtent();this.obbs.push(l),this.aabbs.push(u),this.inTileBounds&&(this.breach=!this.inTileBounds()),this.mayRepeatAcrossTiles&&(this.may_repeat_across_tiles=this.mayRepeatAcrossTiles());},t}(Qa),tl=function(e){function t(t,r,n){var i;return (i=e.call(this,n)||this).type="curved",i.angles=[],i.pre_angles=[],i.offsets=[],i.num_segments=t.length,i.sizes=t,i.throw_away=!i.fit(i.sizes,r,n),i}pt(t,e);var r=t.prototype;return r.toJSON=function(){return {id:this.id,type:this.type,obbs:this.obbs.map(function(e){return e.toJSON()}),position:this.position,breach:this.breach,may_repeat_across_tiles:this.may_repeat_across_tiles,layout:ia(this.layout)}},r.fit=function(e,r,n){var i,o=this.unit_scale,s=Math.max.apply(Math,e.map(function(e){return e[1]})),a=s*o,l=Qa.splitLineByOrientation(r);r=l[0],i=l[1],"number"==typeof n.orientation&&(this.offset[1]+=1.2*(s-n.vertical_buffer),i&&(this.offset[1]*=-1),-1===n.orientation&&(this.offset[1]*=-1));var u=il(r),c=e.map(function(e){return e[0]*o}),f=u.reduce(function(e,t){return e+t},0),h=c.reduce(function(e,t){return e+t},0);if(h>f)return !1;var d=r.length-1;if(d-0<2)return !1;var p=t.curvaturePlacement(r,f,u,h,0,d),_=r[p];if(-1===p||d-p<2)return !1;this.position=_;for(var m=0;m<c.length;m++){this.offsets[m]=[],this.angles[m]=[],this.pre_angles[m]=[];for(var v=0;v<Ka.length;v++){var g=Ka[v],y=t.scaleLine(g,r),x=y[0],b=y[1];_=x[p];var A=t.placeAtIndex(p,x,b,c),T=A.positions,w=A.offsets,E=A.angles,R=A.pre_angles,M=w.map(function(e){return Math.sqrt(e[0]*e[0]+e[1]*e[1])/o});if(0===g){this.angle=1/E.length*E.reduce(function(e,t){return e+t});for(var S=0;S<T.length;S++){var z=T[S],P=R[S],N=c[S],k=P+E[S],L=this.angle,O=Qa.createOBB(z,N,a,k,L,this.offset,o),I=O.getExtent();this.obbs.push(O),this.aabbs.push(I);}}this.offsets[m].push(M[m]),this.angles[m].push(E[m]),this.pre_angles[m].push(R[m]);}}return !0},t.curvaturePlacement=function(e,t,r,n,i,o){i=i||0,o=o||e.length-1;for(var s=[],a=i+1;a<o;a++){var l=e[a-1],u=e[a],c=e[a+1],f=oo.perp(u,l),h=oo.perp(c,u),d=oo.angleBetween(f,h);d>1&&(d=1/0),s.push(d);}s.push(1/0);for(var p=[],_=[],m=i,v=0,g=0;g<i;g++)v+=r[g];for(;v+n<t;){for(var y=v+n,x=v,b=m,A=0;b<o&&x+r[b]<y&&(A+=s[b])!==1/0;)x+=r[b],b++;if(0===A)return m;var T=A/(b-m);p.push(A),_.push(T),v+=r[m],m++;}if(0===p.length)return -1;var w=Math.min.apply(null,p),E=_[p.indexOf(w)];return w<1.3&&E<.4?p.indexOf(w):-1},t.scaleLine=function(e,t){var r=[t[0]],n=[];return t.forEach(function(i,o){if(o!==t.length-1){var s=oo.sub(t[o+1],t[o]),a=oo.mult(s,1+e);r.push(oo.add(r[o],a)),n.push(oo.length(a));}}),[r,n]},t.placeAtIndex=function(e,r,n,i){var o=r[e],s=t.getIndicesAndOffsets(e,n,i),a=s[0],l=s[1],u=t.getPositionsFromIndicesAndOffsets(r,a,l),c=t.getAnglesFromIndicesAndOffsets(o,a,r,u);return {positions:u,offsets:c[0],angles:c[1],pre_angles:c[2]}},t.getIndicesAndOffsets=function(e,t,r){for(var n=r.length,i=[],o=[],s=0,a=0,l=0;s<n;){for(var u=r[s];s<n&&a+.5*u<=l+t[e];){var c=a-l+.5*u;o.push(c),i.push(e),a+=u,u=r[++s];}l+=t[e],e++;}return [i,o]},t.getPositionsFromIndicesAndOffsets=function(e,t,r){for(var n=[],i=0;i<t.length;i++){var o=t[i],s=r[i],a=nl(e[o],e[o+1]),l=oo.rot([s,0],a),u=oo.add(e[o],l);n.push(u);}return n},t.getAnglesFromIndicesAndOffsets=function(e,t,r,n){for(var i,o,s=[],a=[],l=[],u=0;u<n.length;u++){var c=n[u],f=t[u],h=oo.sub(c,e),d=-oo.angle(h),p=(i=r[f],o=r[f+1],-nl(i,o))-d;if(u>0){var _=s[u-1],m=a[u-1];Math.abs(d-_)>Math.PI&&(d+=d>_?-2*Math.PI:2*Math.PI),Math.abs(m-p)>Math.PI&&(p+=p>m?-2*Math.PI:2*Math.PI);}s.push(d),a.push(p),l.push(h);}return [l,s,a]},t}(Qa);function rl(e,t){return t/e}function nl(e,t){var r=oo.sub(t,e);return oo.angle(r)}function il(e){for(var t=[],r=0;r<e.length-1;r++){var n=e[r],i=e[r+1],o=Math.hypot(n[0]-i[0],n[1]-i[1]);t.push(o);}return t}function ol(e,t){var r,n;for(e>t?(r=t,n=e):(r=e,n=t);n-r>Math.PI;)r+=2*Math.PI;return Math.abs(n-r)}var sl=Object.create(Za);Object.assign(sl,{name:"text",super:Za,built_in:!0,init:function(e){void 0===e&&(e={}),xo.init.call(this,e),this.setupDefines(),this.defines.TANGRAM_HAS_SHADER_POINTS=!1,this.defines.TANGRAM_CURVED_LABEL=!0,this.reset();},makeVertexTemplate:function(e,t){this.super.makeVertexTemplate.call(this,e,t,!1);for(var r=t.vertex_data.vertex_layout.index.a_pre_angles,n=0;n<12;n++)this.vertex_template[r++]=0;return this.addCustomAttributesToVertexTemplate(e,r),this.vertex_template},reset:function(){this.queues={},this.resetText();},addFeature:function(e,t,r){var n=this,i=r.tile;if(i.generation===this.generation){var o=e.geometry.type;t.can_articulate="LineString"===o||"MultiLineString"===o,t.supersample_text="LineString"===o||"MultiLineString"===o;var s=this.parseTextFeature(e,t,r,i);s&&(s instanceof Array?s.forEach(function(t){t.feature=e,t.context=r,t.layout.vertex=!1,n.queueFeature(t,i);}):(s.feature=e,s.context=r,s.layout.vertex=!1,this.queueFeature(s,i)),aa.addStyle(this.name,i.id));}},endData:function(e){return new Promise(function(t,r){var n,i,o,s,a,l,u,c;return n=this,i=this.queues[e.id],delete this.queues[e.id],Promise.resolve(this.collideAndRenderTextLabels(e,this.name,i)).then(function(i){try{return s=(o=i).labels,a=o.texts,l=o.textures,s&&a&&(this.texts[e.id]=a,s.forEach(function(t){var r=t.text_settings_key,i=n.texts[e.id][r]&&n.texts[e.id][r][t.text],o=n.feature_style;o.label=t.label,i.text_settings.can_articulate?(o.size={},o.texcoords={},"straight"===t.label.type?(o.size.straight=i.size.logical_size,o.texcoords.straight=i.texcoords.straight,o.label_texture=l[i.texcoords.straight.texture_id]):(o.size.curved=i.segment_sizes.map(function(e){return e.logical_size}),o.texcoords_stroke=i.texcoords_stroke,o.texcoords.curved=i.texcoords.curved,o.label_textures=i.texcoords.curved.map(function(e){return l[e.texture_id]}))):(o.size=i.size.logical_size,o.texcoords=i.align[t.label.align].texcoords,o.label_texture=l[i.align[t.label.align].texture_id]),o.blend_order=t.draw.blend_order,xo.addFeature.call(n,t.feature,t.draw,t.context);})),this.freeText(e),Promise.resolve(xo.endData.call(this,e)).then(function(e){try{if(u=e)for(var n in l&&l.length&&(c=u.textures).push.apply(c,l),u.meshes)u.meshes[n].uniforms.u_apply_color_blocks=!0;return t(u)}catch(e){return r(e)}},r)}catch(e){return r(e)}}.bind(this),r)}.bind(this))},_preprocess:function(e){return e.blend_order=this.getBlendOrderForDraw(e),this.preprocessText(e)},buildTextLabels:function(e,t){for(var r=[],n=0;n<t.length;n++){var i=t[n],o=this.texts[e.id][i.text_settings_key][i.text],s=void 0;if(i.layout.vertical_buffer=o.vertical_buffer,o.text_settings.can_articulate){var a=o.segment_sizes.map(function(e){return e.collision_size});i.layout.no_curving=o.no_curving,s=this.buildLabels(a,i.feature.geometry,i.layout,o.size.collision_size);}else s=this.buildLabels(o.size.collision_size,i.feature.geometry,i.layout);for(var l=0;l<s.length;l++){var u=Object.create(i);u.label=s[l],r.push(u);}}return r},buildLabels:function(e,t,r,n){var i=[];if("LineString"===t.type)Array.prototype.push.apply(i,this.buildLineLabels(t.coordinates,e,r,n));else if("MultiLineString"===t.type)for(var o=t.coordinates,s=0;s<o.length;++s)Array.prototype.push.apply(i,this.buildLineLabels(o[s],e,r,n));else if("Point"===t.type)i.push(new la(t.coordinates,e,r));else if("MultiPoint"===t.type)for(var a=t.coordinates,l=0;l<a.length;++l)i.push(new la(a[l],e,r));else if("Polygon"===t.type){var u=ai.centroid(t.coordinates);u&&i.push(new la(u,e,r));}else if("MultiPolygon"===t.type){var c=ai.multiCentroid(t.coordinates);c&&i.push(new la(c,e,r));}return i},buildLineLabels:function(e,t,r,n){var i=[],o=Math.min(r.subdiv,e.length-1);if(o>1)for(var s=(e.length-1)/o,a=0;a<o;a++){var l=Math.floor(a*s),u=Math.floor((a+1)*s)+1,c=e.slice(l,u),f=$a(t,n,c,r);f&&i.push(f);}if(i.length<o){var h=$a(t,n,e,r);h&&i.push(h);}return i},vertexLayoutForMeshVariant:function(e){if(null==this.vertex_layouts[e.shader_point]){var t=[{name:"a_position",size:4,type:Ki.SHORT,normalized:!1},{name:"a_shape",size:4,type:Ki.SHORT,normalized:!1},{name:"a_texcoord",size:2,type:Ki.UNSIGNED_SHORT,normalized:!0},{name:"a_offset",size:2,type:Ki.SHORT,normalized:!1},{name:"a_color",size:4,type:Ki.UNSIGNED_BYTE,normalized:!0},{name:"a_selection_color",size:4,type:Ki.UNSIGNED_BYTE,normalized:!0,static:e.selection?null:[0,0,0,0]},{name:"a_pre_angles",size:4,type:Ki.BYTE,normalized:!1},{name:"a_angles",size:4,type:Ki.SHORT,normalized:!1},{name:"a_offsets",size:4,type:Ki.UNSIGNED_SHORT,normalized:!1}];this.addCustomAttributesToAttributeList(t),this.vertex_layouts[e.shader_point]=new So(t);}return this.vertex_layouts[e.shader_point]}}),sl.texture_id=0;var al=Object.create(fs);Object.assign(al,{name:"raster",super:fs,built_in:!0,init:function(){this.raster=this.raster||"color",this.super.init.apply(this,arguments),this.selection=!1;},_preprocess:function(e){return e.color=e.color||Ui.defaults.color,this.super._preprocess.apply(this,arguments)}});var ll=function(){function e(){this.styles={},this.base_styles={},this.active_styles=[],this.active_blend_orders=[],this.register(Object.create(fs)),this.register(Object.create(Os)),this.register(Object.create(Za)),this.register(Object.create(sl)),this.register(Object.create(al));}var t=e.prototype;return t.init=function(){Qn.removeBlock("global"),Qn.removeBlock("setup"),Qn.addBlock("global","#ifdef TANGRAM_VERTEX_SHADER\n\n// Apply layer ordering to avoid z-fighting\nvoid applyLayerOrder (float layer, inout vec4 position) {\n    position.z -= layer * TANGRAM_LAYER_DELTA * position.w;\n}\n\n// Vertex position in model space: [0, 1] range over the local tile\n// Note positions can be outside that range due to unclipped geometry, geometry higher than a unit cube, etc.\nvec4 modelPosition() {\n    return\n        vec4(\n            a_position.xyz / TANGRAM_TILE_SCALE         // scale coords to ~0-1 range\n            * exp2(u_tile_origin.z - u_tile_origin.w),  // adjust for tile overzooming\n        1.)\n        + vec4(0., 1., 0., 0.);\n        // NB: additional offset to account for unusual Tangram JS y coords,\n        // should be refactored to remove\n}\n\n// Position in model space as above, but according to tile coordinate (as opposed to style) zoom\n// e.g. unadjusted for tile overzooming\nvec4 modelPositionBaseZoom() {\n    return\n        vec4(\n            a_position.xyz / TANGRAM_TILE_SCALE,    // scale coords to ~0-1 range\n        1.)\n        + vec4(0., 1., 0., 0.); // see note on offset above\n}\n\n#endif\n\n// Vertex position in world coordinates, useful for 3d procedural textures, etc.\nvec4 worldPosition() {\n    return v_world_position;\n}\n\n// Optionally wrap world coordinates (allows more precision at higher zooms)\n// e.g. at wrap 1000, the world space will wrap every 1000 meters\n#ifdef TANGRAM_VERTEX_SHADER\n\nvec4 wrapWorldPosition(vec4 world_position) {\n    #if defined(TANGRAM_WORLD_POSITION_WRAP)\n    vec2 anchor = u_tile_origin.xy - mod(u_tile_origin.xy, TANGRAM_WORLD_POSITION_WRAP);\n        world_position.xy -= anchor;\n    #endif\n    return world_position;\n}\n\n#endif\n\n// Normal in world space\n#if defined(TANGRAM_VERTEX_SHADER)\n\nvec3 worldNormal() {\n    return TANGRAM_NORMAL;\n}\n\n#elif defined(TANGRAM_FRAGMENT_SHADER)\n\nvec3 worldNormal() {\n    return u_inverseNormalMatrix * TANGRAM_NORMAL;\n}\n\n#endif\n"),Qn.addBlock("global","// Vertex attribute + varying for feature selection\n#if defined(TANGRAM_FEATURE_SELECTION) && defined(TANGRAM_VERTEX_SHADER)\n    attribute vec4 a_selection_color;\n    varying vec4 v_selection_color;\n#endif\n"),Qn.replaceBlock("setup","// Selection pass-specific rendering\n#if defined(TANGRAM_FEATURE_SELECTION) && defined(TANGRAM_VERTEX_SHADER)\n    if (a_selection_color.rgb == vec3(0.)) {\n        // Discard by forcing invalid triangle if we're in the feature\n        // selection pass but have no selection info\n        // TODO: in some cases we may actually want non-selectable features to occlude selectable ones?\n        gl_Position = vec4(0., 0., 0., 1.);\n        return;\n    }\n    v_selection_color = a_selection_color;\n#endif\n"),Qn.defines.TANGRAM_EPSILON=1e-5,Qn.defines.TANGRAM_LAYER_DELTA=1/16384,Qn.defines.TANGRAM_TILE_SCALE="vec3("+ai.tile_scale+"., "+ai.tile_scale+"., u_meters_per_pixel * "+ai.tile_size+".)",Qn.defines.TANGRAM_HEIGHT_SCALE=ai.height_scale,Qn.defines.TANGRAM_ALPHA_TEST=.5;},t.destroy=function(e){var t=this;Object.keys(this.styles).forEach(function(r){var n=t.styles[r];n.gl===e&&(Zr("trace","StyleManager.destroy: destroying render style "+n.name),n.base&&t.remove(n.name),n.destroy());});},t.register=function(e){this.styles[e.name]=e,this.base_styles[e.name]=e;},t.remove=function(e){delete this.styles[e];},t.getActiveStyles=function(){return this.active_styles},t.updateActiveStyles=function(e){return this.active_styles=Object.keys(e.reduce(function(e,t){return Object.keys(t.meshes).forEach(function(t){return e[t]=!0}),e},{})),this.active_styles},t.getActiveBlendOrders=function(){return this.active_blend_orders},t.updateActiveBlendOrders=function(e){var t=[];e.forEach(function(e){Object.entries(e.meshes).forEach(function(e){var r=e[0];e[1].forEach(function(e){var n=e.variant.blend_order,i=t.findIndex(function(e){return e.blend_order===n});i=i>-1?i:t.push({blend_order:n,styles:[]})-1,-1===t[i].styles.indexOf(r)&&t[i].styles.push(r);});});}),this.active_blend_orders=t.sort(function(e,t){return e.blend_order-t.blend_order});},t.mix=function(e,t){if(e.mixed)return e;e.mixed={};var r=[];if(e.mix){var n;if(Array.isArray(e.mix))(n=r).push.apply(n,e.mix);else r.push(e.mix);(r=r.map(function(e){return t[e]}).filter(function(t){return t&&t!==e})).forEach(function(t){return e.mixed[t.name]=!0});}r.push(e),e.animated=r.some(function(e){return e&&e.animated}),e.texcoords=r.some(function(e){return e&&e.texcoords}),e.base=r.map(function(e){return e.base}).filter(function(e){return e}).pop(),e.lighting=r.map(function(e){return e.lighting}).filter(function(e){return null!=e}).pop(),e.texture=r.map(function(e){return e.texture}).filter(function(e){return e}).pop(),e.raster=r.map(function(e){return e.raster}).filter(function(e){return null!=e}).pop(),e.dash=r.map(function(e){return e.dash}).filter(function(e){return null!=e}).pop(),e.dash_background_color=r.map(function(e){return e.dash_background_color}).filter(function(e){return null!=e}).pop(),r.some(function(e){return Object.prototype.hasOwnProperty.call(e,"blend")&&e.blend})&&(e.blend=r.map(function(e){return Object.prototype.hasOwnProperty.call(e,"blend")&&e.blend}).filter(function(e){return e}).pop()),e.blend_order=r.map(function(e){return e.blend_order}).filter(function(e){return null!=e}).pop(),e.defines=Object.assign.apply(Object,[{}].concat(r.map(function(e){return e.defines}).filter(function(e){return e}))),e.material=Object.assign.apply(Object,[{}].concat(r.map(function(e){return e.material}).filter(function(e){return e})));var i=r.map(function(e){return e.draw}).filter(function(e){return e});return i.length>0&&(e.draw=si.apply(void 0,[{}].concat(i))),this.mixShaders(e,t,r),e},t.mixShaders=function(e,t,r){var n={},i=r.map(function(e){return e.shaders}).filter(function(e){return e});if(n.defines=Object.assign.apply(Object,[{}].concat(i.map(function(e){return e.defines}).filter(function(e){return e}))),n.attributes=Object.assign.apply(Object,[{}].concat(i.map(function(e){return e.attributes}).filter(function(e){return e}))),n.uniforms={},n._uniforms=e.shaders&&e.shaders.uniforms||{},n._uniform_scopes={},r.filter(function(e){return e.shaders&&e.shaders.uniforms}).forEach(function(e){var r=function(r){n._uniform_scopes[r]=e.name,Object.defineProperty(n.uniforms,r,{enumerable:!0,configurable:!0,get:function(){return void 0!==n._uniforms[r]?n._uniforms[r]:t[n._uniform_scopes[r]].shaders.uniforms!==n.uniforms?t[n._uniform_scopes[r]].shaders.uniforms[r]:void 0},set:function(e){n._uniforms[r]=e;}});};for(var i in e.shaders.uniforms)r(i);}),n.extensions=Object.keys(i.map(function(e){return e.extensions}).filter(function(e){return e}).reduce(function(e,t){return "string"==typeof t?e[t]=!0:t.forEach(function(t){return e[t]=!0}),e},{})||{}),e.shaders&&e.shaders.blocks)for(var o in e.shaders.block_scopes=e.shaders.block_scopes||{},e.shaders.blocks){var s,a=e.shaders.blocks[o];if(e.shaders.block_scopes[o]=e.shaders.block_scopes[o]||[],Array.isArray(a))(s=e.shaders.block_scopes[o]).push.apply(s,a.map(function(){return e.name}));else e.shaders.block_scopes[o].push(e.name);}var l={};return i.forEach(function(e){if(e.blocks){n.blocks=n.blocks||{},n.block_scopes=n.block_scopes||{};var t={};for(var r in e.blocks){var i=e.blocks[r],o=e.block_scopes[r];n.blocks[r]=n.blocks[r]||[],n.block_scopes[r]=n.block_scopes[r]||[],i=Array.isArray(i)?i:[i],o=Array.isArray(o)?o:[o];for(var s=0;s<i.length;s++)l[o[s]]||(t[o[s]]=!0,n.blocks[r].push(i[s]),n.block_scopes[r].push(o[s]));}Object.assign(l,t);}}),Object.assign(e.mixed,l),e.shaders=n,e},t.create=function(e,t,r){void 0===r&&(r={});var n=si({},t);return n.name=e,(n=this.mix(n,r)).base&&this.base_styles[n.base]?this.styles[e]=n=Object.assign(Object.create(this.base_styles[n.base]),n):n.base=null,n},t.build=function(e){var t=this,r=Object.assign({},e);this.styles&&Object.values(this.styles).forEach(function(e){return jr.removeTarget(e.main_thread_target)});for(var n=["polygons","lines","points","text","raster"],i=0,o=["opaque","add","multiply","overlay","inlay","translucent"];i<o.length;i++)for(var s,a=o[i],l=xt(n);!(s=l()).done;){var u=s.value,c=a+"_"+u;null==r[c]&&(r[c]={base:u,blend:a});}var f=Object.keys(r).sort(function(e,n){return t.inheritanceDepth(e,r)-t.inheritanceDepth(n,r)});for(var h in this.styles)this.base_styles[h]?this.styles[h].reset():delete this.styles[h];var d={};return f.forEach(function(e){d[e]=t.create(e,r[e],d);}),this.styles},t.initStyles=function(e){for(var t in void 0===e&&(e={}),this.styles)this.styles[t].init(e);},t.inheritanceDepth=function(e,t){for(var r=this,n=0;;){var i=t[e];if(!i)break;if(!i.mix)break;if(n++,Array.isArray(i.mix)){n+=Math.max.apply(Math,i.mix.map(function(n){if(e!==n)return r.inheritanceDepth(n,t)}));break}if(e===i.mix)break;e=i.mix;}return n},e}();function ul(e){return null!=e}function cl(e){return "("+e+")"}function fl(e){return "string"==typeof e?'"'+e+'"':e}function hl(e){return "$"===e[0]?"context['"+e.substring(1)+"']":e.indexOf(".")>-1?-1===e.indexOf("\\.")?"context.feature.properties"+e.split(".").map(function(e){return "['"+e+"']"}).join(""):"context.feature.properties"+e.replace(/\\\./g,"__TANGRAM_DELIMITER__").split(".").map(function(e){return e.replace(/__TANGRAM_DELIMITER__/g,".")}).map(function(e){return "['"+e+"']"}).join(""):"context.feature.properties['"+e+"']"}function dl(e,t){return cl(fl(t)+" === "+hl(e))}function pl(e,t){return cl("["+t.map(fl).join(",")+"]"+".indexOf("+hl(e)+") > -1")}function _l(e,t){return cl(e.filter(ul).map(function(e){return cl(e.join(" && "))}).join(" "+t+" "))}function ml(e,t,r){return t&&t.length>0?_l(t.map(function(e){return Tl(e,r)}),"||"):"true"}function vl(e,t,r){return t&&t.length>0?_l(t.map(function(e){return Tl(e,r)}),"&&"):"true"}function gl(e,t,r){return "!"+cl(Tl(t,r).join(" && "))}function yl(e,t,r){return "!"+cl(ml(0,t,r))}function xl(e,t){return cl(hl(e)+(t?" != ":" == ")+"null")}function bl(e,t,r){var n=[],i=r&&"function"==typeof r.rangeTransform&&r.rangeTransform;if(t.max){var o=i?i(t.max):t.max;n.push(hl(e)+" < "+o);}if(t.min){var s=i?s=i(t.min):t.min;n.push(hl(e)+" >= "+s);}return cl(n.join(" && "))}function Al(e,t){var r=[];if(t.includes_any){var n="["+(Array.isArray(t.includes_any)?t.includes_any:[t.includes_any]).map(fl).join(",")+"]";r.push(hl(e)+" != null && "+n+".some(function(v) { return "+hl(e)+".indexOf(v) > -1 })");}if(t.includes_all){var i="["+(Array.isArray(t.includes_all)?t.includes_all:[t.includes_all]).map(fl).join(",")+"]";r.push(hl(e)+" != null && "+i+".every(function(v) { return "+hl(e)+".indexOf(v) > -1 })");}return cl(r.join(" && "))}function Tl(e,t){var r=[];if("function"==typeof e)return [cl(e.toString()+"(context)")];if(Array.isArray(e))return [ml(0,e,t)];if(null==e)return ["true"];for(var n=Object.keys(e),i=0;i<n.length;i++){var o=n[i],s=e[o],a=typeof s;if("string"===a||"number"===a)r.push(dl(o,s));else if("boolean"===a)r.push(xl(o,s));else if("not"===o)r.push(gl(0,s,t));else if("any"===o)r.push(ml(0,s,t));else if("all"===o)r.push(vl(0,s,t));else if("none"===o)r.push(yl(0,s,t));else if(Array.isArray(s))r.push(pl(o,s));else if("object"===a&&null!=s)s.max||s.min?r.push(bl(o,s,t)):(s.includes_any||s.includes_all)&&r.push(Al(o,s));else {if(null!=s)throw new Error("Unknown Query syntax: "+s);r.push(" true ");}}return 0===n.length?["true"]:r}function wl(e,t){return null==e?function(){return !0}:new Function("context","return "+cl(Tl(e,t).join(" && "))+";")}D(D.S,"Number",{MAX_SAFE_INTEGER:9007199254740991});var El=["filter","draw","visible","enabled","data","exclusive","priority"],Rl={};function Ml(e,t){for(var r,n=0,i=0;i<e.length;i++)e[i].length>n&&(n=e[i].length);if(0===n)return null;for(var o={visible:!0},s=function(n){if(r=[],e.forEach(function(e){e[n]&&e[n][t]&&-1===r.indexOf(e[n][t])&&r.push(e[n][t]);}),0===r.length)return "continue";si.apply(void 0,[o].concat(r));},a=0;a<n;a++)s(a);return !1===o.visible?null:o}var Sl=["any","all","not","none"],zl=function(){function e(t){var r=t.layer,n=t.name,i=t.parent,o=t.draw,s=t.visible,a=t.enabled,l=t.filter,u=t.exclusive,c=t.priority,f=t.styles;if(this.id=e.id++,this.config_data=r.data,this.parent=i,this.name=n,this.full_name=this.parent?this.parent.full_name+":"+this.name:this.name,this.draw=o,this.filter=l,this.exclusive=!0===u,this.priority=null!=c?c:Number.MAX_SAFE_INTEGER,this.styles=f,this.is_built=!1,a=void 0===a?s:a,this.enabled=!1!==a,this.draw)for(var h in this.draw)if(this.draw[h]=null==this.draw[h]?{}:this.draw[h],"object"!=typeof this.draw[h]){var d="Draw group '"+h+"' for layer "+this.full_name+" is invalid, must be an object, ";Zr("warn",d+="but was set to `"+h+": "+this.draw[h]+"` instead"),delete this.draw[h];}}var t=e.prototype;return t.build=function(){Zr("trace","Building layer '"+this.full_name+"'"),this.buildFilter(),this.buildDraw(),this.is_built=!0;},t.buildDraw=function(){this.draw=Oi(this.draw,Ui.wrapFunction),this.calculatedDraw=function(e){var t=[];if(e.parent){var r=e.parent.calculatedDraw||[];t.push.apply(t,r);}return t.push(e.draw),t}(this);},t.buildFilter=function(){this.filter_original=this.filter,this.filter=Oi(this.filter,Ui.wrapFunction);var e=typeof this.filter;if(null==this.filter||"object"===e||"function"===e)try{this.buildZooms(),this.buildPropMatches(),null!=this.filter&&("function"==typeof this.filter||Object.keys(this.filter).length>0)?this.filter=wl(this.filter,kl):this.filter=null;}catch(e){var t="Filter for layer "+this.full_name+" is invalid, `filter: "+JSON.stringify(this.filter)+"` ";Zr("warn",t+="failed with error '"+e.message+"', stack trace: "+e.stack);}else {var r="Filter for layer "+this.full_name+" is invalid, filter value must be an object or function, ";Zr("warn",r+="but was set to `filter: "+this.filter+"` instead");}},t.buildZooms=function(){var e=this.filter&&this.filter.$zoom,t=typeof e;if(null!=e){if(this.zooms={},"number"===t)this.zooms[e]=!0;else if(Array.isArray(e))for(var r=0;r<e.length;r++)this.zooms[e[r]]=!0;else if("object"===t&&(null!=e.min||null!=e.max))for(var n=e.min||0,i=e.max||ai.max_style_zoom,o=n;o<i;o++)this.zooms[o]=!0;delete this.filter.$zoom;}},t.buildPropMatches=function(){var e=this;this.filter&&!Array.isArray(this.filter)&&"function"!=typeof this.filter&&Object.keys(this.filter).forEach(function(t){if(-1===Sl.indexOf(t)){var r=e.filter[t],n=typeof r,i=Array.isArray(r);if(!i&&"string"!==n&&"number"!==n)return;"$"===t[0]?(e.context_prop_matches=e.context_prop_matches||[],e.context_prop_matches.push([t.substring(1),i?r:[r]]),delete e.filter[t]):-1===t.indexOf(".")&&(e.feature_prop_matches=e.feature_prop_matches||[],e.feature_prop_matches.push([t,i?r:[r]]),delete e.filter[t]);}});},t.doPropMatches=function(e){if(this.feature_prop_matches)for(var t=0;t<this.feature_prop_matches.length;t++){var r=this.feature_prop_matches[t],n=e.feature.properties[r[0]];if(null==n||-1===r[1].indexOf(n))return !1}if(this.context_prop_matches)for(var i=0;i<this.context_prop_matches.length;i++){var o=this.context_prop_matches[i],s=e[o[0]];if(null==s||-1===o[1].indexOf(s))return !1}return !0},t.doesMatch=function(e){if(!this.enabled)return !1;if(this.is_built||this.build(),null!=this.zooms&&!this.zooms[e.zoom])return !1;if(!this.doPropMatches(e))return !1;var t;if(this.filter instanceof Function)try{t=this.filter(e);}catch(t){var r="Filter for this "+this.full_name+": `filter: "+this.filter_original+"` ";Zr("error",r+="failed with error '"+t.message+"', stack trace: "+t.stack,e.feature);}else t=null==this.filter;return !!t&&(this.children_to_parse&&(!function(e,t,r){for(var n in t){var i=t[n];if("object"!=typeof i||Array.isArray(i)){var o="Layer value must be an object: cannot create layer '"+n+": "+JSON.stringify(i)+"'";o+=", under parent layer '"+e.full_name+"'.",r[e.name]&&(o+=" The parent name '"+e.name+"' is also the name of a style, did you mean to create a 'draw' group",e.parent&&(o+=" under '"+e.parent.name+"'"),o+=" instead?"),Zr("warn",o);}else Ol(n,i,e,r);}e.layers.sort(function(e,t){if(e.exclusive<t.exclusive)return 1;if(e.exclusive>t.exclusive)return -1;var r=e.exclusive?1:-1;return e.priority>t.priority?r:e.priority<t.priority?-r:e.full_name<t.full_name?r:e.full_name>t.full_name?-r:void 0});}(this,this.children_to_parse,this.styles),delete this.children_to_parse),!0)},e}();zl.id=0;var Pl=function(e){function t(t){var r;return (r=e.call(this,t)||this).is_leaf=!0,r}return pt(t,e),t}(zl),Nl=function(e){function t(t){var r;return (r=e.call(this,t)||this).is_tree=!0,r.layers=t.layers||[],r}pt(t,e);var r=t.prototype;return r.addLayer=function(e){this.layers.push(e);},r.buildDrawGroups=function(e){var t=[],r=[];if(function e(t,r,n,i){var o=!1;if(0===r.length)return;for(var s=0;s<r.length;s++){var a=r[s];if(a.is_leaf){if(a.doesMatch(t)&&(o=!0,n.push(a),i.push(a.id),a.exclusive))break}else if(a.is_tree&&a.doesMatch(t)&&(o=!0,e(t,a.layers,n,i)||(n.push(a),i.push(a.id)),a.exclusive))break}return o}(e,[this],t,r),t.length>0){var n=function(e){if(e.length>1){for(var t=e[0],r=1;r<e.length;r++)t+="/"+e[r];return t}return e[0]}(r);if(void 0===Rl[n]){for(var i=t.map(function(e){return e&&!1!==e.visible&&e.calculatedDraw}),o={},s=0;s<i.length;s++){var a=i[s];if(a)for(var l=0;l<a.length;l++){var u=a[l];for(var c in u)o[c]=!0;}}for(var f in o)Rl[n]=Rl[n]||{},Rl[n][f]=Ml(i,f),Rl[n][f]?(Rl[n][f].key=n+"/"+f,Rl[n][f].layers=t.map(function(e){return e&&e.full_name}),Rl[n][f].group=f):delete Rl[n][f];Rl[n]&&0===Object.keys(Rl[n]).length&&(Rl[n]=null);}return Rl[n]}},t}(zl),kl={rangeTransform:function(e){return "string"==typeof e&&"px2"===e.trim().slice(-3)?parseFloat(e)+" * context.meters_per_pixel_sq":e}};function Ll(e){return El.indexOf(e)>-1}function Ol(e,t,r,n){var i,o={name:e,layer:t=null==t?{}:t,parent:r,styles:n},s=function(e){var t={},r={};for(var n in e)Ll(n)?t[n]=e[n]:r[n]=e[n];return [t,r]}(t),a=s[0],l=s[1],u=(i=l,0===Object.keys(i).length),c=new(u&&null!=r?Pl:Nl)(Object.assign(o,a));return c.enabled&&(r&&r.addLayer(c),c.children_to_parse=u?null:l),c}var Il=0,Fl=0,Ul=function(){function e(e){var t=e.coords,r=e.style_z,n=e.source,i=e.workers,o=e.view;this.id=Il++,this.view=o,this.source=n,this.generation=null,this.valid=!0,this.visible=!1,this.proxy_for=null,this.proxied_as=null,this.proxy_level=0,this.proxy_order_offset=0,this.fade_in=!0,this.loading=!1,this.loaded=!1,this.built=!1,this.labeled=!1,this.error=null,this.debug={},this.style_z=r,this.coords=vo.normalizedCoord(t,this.source),this.key=vo.key(this.coords,this.source,this.style_z),this.overzoom=Math.max(this.style_z-this.coords.z,0),this.overzoom2=Math.pow(2,this.overzoom),this.min=ai.metersForTile(this.coords),this.max=ai.metersForTile({x:this.coords.x+1,y:this.coords.y+1,z:this.coords.z}),this.span={x:this.max.x-this.min.x,y:-(this.max.y-this.min.y)},this.bounds={sw:{x:this.min.x,y:this.max.y},ne:{x:this.max.x,y:this.min.y}},this.meters_per_pixel=ai.metersPerPixel(this.style_z),this.meters_per_pixel_sq=this.meters_per_pixel*this.meters_per_pixel,this.units_per_pixel=ai.units_per_pixel/this.overzoom2,this.units_per_meter_overzoom=ai.unitsPerMeter(this.coords.z)*this.overzoom2,this.preserve_tiles_within_zoom=this.source.preserve_tiles_within_zoom,this.meshes={},this.new_mesh_styles=[],this.pending_label_meshes=null,this.setWorker(i);}var t=e.prototype;return t.freeResources=function(){for(var e in this.meshes)this.meshes[e].forEach(function(e){return e.destroy()});if(this.meshes={},this.pending_label_meshes)for(var t in this.pending_label_meshes)this.pending_label_meshes[t].forEach(function(e){return e.destroy()});this.pending_label_meshes=null;},t.destroy=function(){En.removeForTile(this.id),this.workerMessage("self.removeTile",this.key),this.freeResources(),this.worker=null,this.valid=!1;},t.buildAsMessage=function(){return {id:this.id,key:this.key,source:this.source.name,coords:this.coords,min:this.min,max:this.max,units_per_pixel:this.units_per_pixel,meters_per_pixel:this.meters_per_pixel,meters_per_pixel_sq:this.meters_per_pixel_sq,units_per_meter_overzoom:this.units_per_meter_overzoom,style_z:this.style_z,overzoom:this.overzoom,overzoom2:this.overzoom2,generation:this.generation,debug:this.debug}},t.setWorker=function(e){this.source.tiled?this.worker_id=Math.abs(this.coords.x+this.coords.y+this.coords.z)%e.length:this.worker_id=this.source.id%e.length,this.worker=e[this.worker_id];},t.workerMessage=function(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return jr.postMessage.apply(jr,[this.worker].concat(t))},t.build=function(e,t){var r=(void 0===t?{}:t).fade_in,n=void 0===r||r;return this.generation=e,this.fade_in=n,this.loaded||(this.loading=!0,this.built=!1,this.labeled=!1),this.workerMessage("self.buildTile",{tile:this.buildAsMessage()}).catch(function(e){throw e})},e.cancel=function(t){t&&(t.canceled=!0,t.source_data&&t.source_data.request_id&&(Qr.cancelRequest(t.source_data.request_id),t.source_data.request_id=null),e.abortBuild(t));},e.buildGeometry=function(t,r){var n=r.scene_id,i=r.layers,o=r.styles,s=r.global,a=t.source_data;for(var l in t.debug.building=+new Date,t.debug.feature_count=0,t.debug.layers=null,aa.startTile(t.id,{apply_repeat_groups:!0}),i){var u=i[l];if(u&&u.config_data){if(u.config_data.source===t.source)for(var c=e.getDataForSource(a,u.config_data,l),f=0;f<c.length;f++){var h=c[f],d=h.geom;if(d)for(var p=0;p<d.features.length;p++){var _=d.features[p];if(null!=_.geometry){var m=Ui.getFeatureParseContext(_,t,s);m.winding=t.default_winding,m.source=t.source,m.layer=h.layer;var v=u.buildDrawGroups(m,!0);if(v){for(var g in v){var y=v[g],x=y.style||g,b=o[x];b?null!=(y=b.preprocess(y))&&!1!==y.visible&&(m.layers=y.layers,b.addFeature(_,y,m)):Zr("warn","Style '"+x+"' not found, skipping layer '"+l+"':",y,_);}t.debug.feature_count++;}}}}}else Zr("warn","Layer "+l+" was defined without a geometry data source and will not be rendered.");}t.debug.building=+new Date-t.debug.building;var A=this.stylesForTile(t,o).map(function(e){return o[e]});e.buildStyleGroups(t,A,n,function(e){return e.collision?"collision":"non-collision"});},e.stylesForTile=function(e,t){var r=[];for(var n in t)t[n].hasDataForTile(e)&&r.push(n);return r},e.buildStyleGroups=function(t,r,n,i){var o=r.reduce(function(e,t){var r=i(t);return e[r]=e[r]||[],e[r].push(t),e},{});if(0===Object.keys(o).length)return jr.postMessage("TileManager_"+n+".buildTileStylesCompleted",jr.withTransferables({tile:e.slice(t),progress:{start:!0,done:!0}})),void aa.resetTile(t.id);var s={};for(var a in o)e.buildStyleGroup({group_name:a,groups:o,tile:t,progress:s,scene_id:n});},e.buildStyleGroup=function(t){return new Promise(function(r,n){var i,o,s,a,l,u,c;i=t.group_name,o=t.groups,s=t.tile,a=t.progress,l=t.scene_id,u=o[i],c={};var f=function(){try{return r()}catch(e){return n(e)}},h=function(e){try{return Zr("error","Error for style group '"+i+"' for tile "+s.key,e&&e.stack||e),f()}catch(e){return n(e)}};try{return Promise.resolve(Promise.all(u.map(function(e){return new Promise(function(t,r){var n;return Promise.resolve(e.endData(s)).then(function(i){try{return (n=i)&&(c[e.name]=n),t()}catch(e){return r(e)}},r)})}))).then(function(t){try{return Zr("trace","Finished style group '"+i+"' for tile "+s.key),o[i]=null,Object.keys(o).every(function(e){return null==o[e]})&&(a.done=!0),jr.postMessage("TileManager_"+l+".buildTileStylesCompleted",jr.withTransferables({tile:Object.assign({},e.slice(s),{mesh_data:c}),progress:a})),a.done&&aa.resetTile(s.id),f()}catch(e){return h(e)}},h)}catch(e){h(e);}})},e.getDataForSource=function(e,t,r){var n=[];if(null!=t&&null!=e&&null!=e.layers)if(!0===t.all_layers){if(null!=t.layer)Zr({level:"warn",once:!0},"Layer "+r+" includes both 'all_layers: true' and an explicit 'layer' keyword in its 'data' block. 'all_layers: true' takes precedence, 'layer' will be ignored.");for(var i in e.layers)n.push({layer:i,geom:e.layers[i]});}else !t.layer&&e.layers._default?n.push({geom:e.layers._default}):!t.layer&&r?n.push({layer:r,geom:e.layers[r]}):"string"==typeof t.layer?n.push({layer:t.layer,geom:e.layers[t.layer]}):Array.isArray(t.layer)&&t.layer.forEach(function(t){n.push({layer:t,geom:e.layers[t]});});return n},t.buildMeshes=function(e,t){if(!this.error){this.build_id=Fl++,t.start&&(this.debug.geometry_count=0,this.debug.buffer_size=0);var r={},n=this.mesh_data;if(n)for(var i in n){for(var o in n[i].meshes){var s=n[i].meshes[o];if(s.vertex_data){if(!e[i]){Zr("warn","Could not create mesh because style '"+i+"' not found, for tile "+this.key+", aborting tile");break}var a=Object.assign({},n[i]);a.uniforms=Object.assign({},a.uniforms,s.uniforms),a.variant=s.variant,s.labels&&(a.retain=!0);var l=e[i].makeMesh(s.vertex_data,s.vertex_elements,a);l.variant=a.variant,l.labels=s.labels,r[i]=r[i]||[],r[i].push(l),null==l.variant.mesh_order&&(l.variant.mesh_order=r[i].length-1),this.debug.buffer_size+=l.buffer_size,this.debug.geometry_count+=l.geometry_count;}}r[i]&&r[i].sort(function(e,t){var r=e.variant.mesh_order,n=t.variant.mesh_order;return null==r?1:null==n?-1:r<n?-1:1});}for(var u in delete this.mesh_data,r)e[u].collision?(this.pending_label_meshes=this.pending_label_meshes||{},this.pending_label_meshes[u]=r[u]):(this.meshes[u]&&this.meshes[u].forEach(function(e){return e.destroy()}),this.meshes[u]=r[u],this.new_mesh_styles.push(u));if(t.done){for(var c in this.meshes)-1!==this.new_mesh_styles.indexOf(c)||this.pending_label_meshes&&null!=this.pending_label_meshes[c]||(this.meshes[c].forEach(function(e){return e.destroy()}),delete this.meshes[c]);this.new_mesh_styles=[],this.debug.geometry_ratio=(this.debug.geometry_count/this.debug.feature_count).toFixed(1);}this.printDebug(t);}},t.pendingLabelStyleCount=function(){return this.pending_label_meshes?Object.keys(this.pending_label_meshes).length:0},t.swapPendingLabels=function(){if(this.labeled=!0,this.pending_label_meshes){for(var e in this.pending_label_meshes)this.meshes[e]&&this.meshes[e].forEach(function(e){return e.destroy()}),this.meshes[e]=this.pending_label_meshes[e];this.pending_label_meshes=null;}},e.abortBuild=function(e){if(En.removeForTile(e.id),aa.abortTile(e.id),e.mesh_data)for(var t in e.mesh_data){var r=e.mesh_data[t].textures;r&&r.forEach(function(t){var r=Hn.textures[t];r&&(Zr("trace","releasing texture "+t+" for tile "+e.key),r.release());});}},t.setProxyFor=function(e){e?(this.visible=!0,this.proxy_for=this.proxy_for||[],this.proxy_for.push(e),this.proxy_order_offset=1,e.proxied_as=e.style_z>this.style_z?"child":"parent",this.proxy_level=Math.abs(e.style_z-this.style_z)):(this.proxy_for=null,this.proxy_order_offset=0,this.proxy_level=0);},t.isProxy=function(){return null!=this.proxy_for},t.shouldProxyForStyle=function(e){return !this.proxy_for||this.proxy_for.some(function(t){return null==t.meshes[e]})},t.setupProgram=function(e,t){var r=e.model,n=e.model32;t.uniform("4fv","u_tile_origin",[this.min.x,this.min.y,this.style_z,this.coords.z]),t.uniform("1f","u_tile_proxy_order_offset",this.proxy_order_offset),Va.identity(r),Va.translate(r,r,Ca(this.min.x,this.min.y,0)),Va.scale(r,r,Ca(this.span.x/ai.tile_scale,this.span.y/ai.tile_scale,1)),Va.copy(n,r),t.uniform("Matrix4fv","u_model",n),t.uniform("1i","u_tile_fade_in",this.fade_in&&"child"!==this.proxied_as);},e.slice=function(e,t){var r=["id","key","loading","loaded","generation","error","debug"];Array.isArray(t)&&r.push.apply(r,t);for(var n={},i=0;i<r.length;i++){var o=r[i];n[o]=e[o];}return n},t.merge=function(e){return this.loading=e.loading,this.loaded=e.loaded,this.generation=e.generation,this.error=e.error,this.mesh_data=e.mesh_data,this.debug=si(this.debug,e.debug),this},t.printDebug=function(e){var t=["layers"],r={};for(var n in this.debug)-1===t.indexOf(n)&&(r[n]=this.debug[n]);Zr("debug","Tile "+(e.done?"(done)":"")+": debug for "+this.key+": [  "+JSON.stringify(r)+" ]");},e}();Ul.coord_children={};var Dl=function(e,t,r,n,i){var o,s,a=8*i-n-1,l=(1<<a)-1,u=l>>1,c=-7,f=r?i-1:0,h=r?-1:1,d=e[t+f];for(f+=h,o=d&(1<<-c)-1,d>>=-c,c+=a;c>0;o=256*o+e[t+f],f+=h,c-=8);for(s=o&(1<<-c)-1,o>>=-c,c+=n;c>0;s=256*s+e[t+f],f+=h,c-=8);if(0===o)o=1-u;else {if(o===l)return s?NaN:1/0*(d?-1:1);s+=Math.pow(2,n),o-=u;}return (d?-1:1)*s*Math.pow(2,o-n)},Gl=function(e,t,r,n,i,o){var s,a,l,u=8*o-i-1,c=(1<<u)-1,f=c>>1,h=23===i?Math.pow(2,-24)-Math.pow(2,-77):0,d=n?0:o-1,p=n?1:-1,_=t<0||0===t&&1/t<0?1:0;for(t=Math.abs(t),isNaN(t)||t===1/0?(a=isNaN(t)?1:0,s=c):(s=Math.floor(Math.log(t)/Math.LN2),t*(l=Math.pow(2,-s))<1&&(s--,l*=2),(t+=s+f>=1?h/l:h*Math.pow(2,1-f))*l>=2&&(s++,l/=2),s+f>=c?(a=0,s=c):s+f>=1?(a=(t*l-1)*Math.pow(2,i),s+=f):(a=t*Math.pow(2,f-1)*Math.pow(2,i),s=0));i>=8;e[r+d]=255&a,d+=p,a/=256,i-=8);for(s=s<<i|a,u+=i;u>0;e[r+d]=255&s,d+=p,s/=256,u-=8);e[r+d-p]|=128*_;},Cl=jl;function jl(e){this.buf=ArrayBuffer.isView&&ArrayBuffer.isView(e)?e:new Uint8Array(e||0),this.pos=0,this.type=0,this.length=this.buf.length;}jl.Varint=0,jl.Fixed64=1,jl.Bytes=2,jl.Fixed32=5;function Vl(e){return e.type===jl.Bytes?e.readVarint()+e.pos:e.pos+1}function Bl(e,t,r){return r?4294967296*t+(e>>>0):4294967296*(t>>>0)+(e>>>0)}function ql(e,t,r){var n=t<=16383?1:t<=2097151?2:t<=268435455?3:Math.ceil(Math.log(t)/(7*Math.LN2));r.realloc(n);for(var i=r.pos-1;i>=e;i--)r.buf[i+n]=r.buf[i];}function Hl(e,t){for(var r=0;r<e.length;r++)t.writeVarint(e[r]);}function Xl(e,t){for(var r=0;r<e.length;r++)t.writeSVarint(e[r]);}function Wl(e,t){for(var r=0;r<e.length;r++)t.writeFloat(e[r]);}function Yl(e,t){for(var r=0;r<e.length;r++)t.writeDouble(e[r]);}function Zl(e,t){for(var r=0;r<e.length;r++)t.writeBoolean(e[r]);}function Jl(e,t){for(var r=0;r<e.length;r++)t.writeFixed32(e[r]);}function Kl(e,t){for(var r=0;r<e.length;r++)t.writeSFixed32(e[r]);}function $l(e,t){for(var r=0;r<e.length;r++)t.writeFixed64(e[r]);}function Ql(e,t){for(var r=0;r<e.length;r++)t.writeSFixed64(e[r]);}function eu(e,t){return (e[t]|e[t+1]<<8|e[t+2]<<16)+16777216*e[t+3]}function tu(e,t,r){e[r]=t,e[r+1]=t>>>8,e[r+2]=t>>>16,e[r+3]=t>>>24;}function ru(e,t){return (e[t]|e[t+1]<<8|e[t+2]<<16)+(e[t+3]<<24)}jl.prototype={destroy:function(){this.buf=null;},readFields:function(e,t,r){for(r=r||this.length;this.pos<r;){var n=this.readVarint(),i=n>>3,o=this.pos;this.type=7&n,e(i,t,this),this.pos===o&&this.skip(n);}return t},readMessage:function(e,t){return this.readFields(e,t,this.readVarint()+this.pos)},readFixed32:function(){var e=eu(this.buf,this.pos);return this.pos+=4,e},readSFixed32:function(){var e=ru(this.buf,this.pos);return this.pos+=4,e},readFixed64:function(){var e=eu(this.buf,this.pos)+4294967296*eu(this.buf,this.pos+4);return this.pos+=8,e},readSFixed64:function(){var e=eu(this.buf,this.pos)+4294967296*ru(this.buf,this.pos+4);return this.pos+=8,e},readFloat:function(){var e=Dl(this.buf,this.pos,!0,23,4);return this.pos+=4,e},readDouble:function(){var e=Dl(this.buf,this.pos,!0,52,8);return this.pos+=8,e},readVarint:function(e){var t,r,n=this.buf;return t=127&(r=n[this.pos++]),r<128?t:(t|=(127&(r=n[this.pos++]))<<7,r<128?t:(t|=(127&(r=n[this.pos++]))<<14,r<128?t:(t|=(127&(r=n[this.pos++]))<<21,r<128?t:function(e,t,r){var n,i,o=r.buf;if(i=o[r.pos++],n=(112&i)>>4,i<128)return Bl(e,n,t);if(i=o[r.pos++],n|=(127&i)<<3,i<128)return Bl(e,n,t);if(i=o[r.pos++],n|=(127&i)<<10,i<128)return Bl(e,n,t);if(i=o[r.pos++],n|=(127&i)<<17,i<128)return Bl(e,n,t);if(i=o[r.pos++],n|=(127&i)<<24,i<128)return Bl(e,n,t);if(i=o[r.pos++],n|=(1&i)<<31,i<128)return Bl(e,n,t);throw new Error("Expected varint not more than 10 bytes")}(t|=(15&(r=n[this.pos]))<<28,e,this))))},readVarint64:function(){return this.readVarint(!0)},readSVarint:function(){var e=this.readVarint();return e%2==1?(e+1)/-2:e/2},readBoolean:function(){return Boolean(this.readVarint())},readString:function(){var e=this.readVarint()+this.pos,t=function(e,t,r){var n="",i=t;for(;i<r;){var o,s,a,l=e[i],u=null,c=l>239?4:l>223?3:l>191?2:1;if(i+c>r)break;1===c?l<128&&(u=l):2===c?128==(192&(o=e[i+1]))&&(u=(31&l)<<6|63&o)<=127&&(u=null):3===c?(o=e[i+1],s=e[i+2],128==(192&o)&&128==(192&s)&&((u=(15&l)<<12|(63&o)<<6|63&s)<=2047||u>=55296&&u<=57343)&&(u=null)):4===c&&(o=e[i+1],s=e[i+2],a=e[i+3],128==(192&o)&&128==(192&s)&&128==(192&a)&&((u=(15&l)<<18|(63&o)<<12|(63&s)<<6|63&a)<=65535||u>=1114112)&&(u=null)),null===u?(u=65533,c=1):u>65535&&(u-=65536,n+=String.fromCharCode(u>>>10&1023|55296),u=56320|1023&u),n+=String.fromCharCode(u),i+=c;}return n}(this.buf,this.pos,e);return this.pos=e,t},readBytes:function(){var e=this.readVarint()+this.pos,t=this.buf.subarray(this.pos,e);return this.pos=e,t},readPackedVarint:function(e,t){var r=Vl(this);for(e=e||[];this.pos<r;)e.push(this.readVarint(t));return e},readPackedSVarint:function(e){var t=Vl(this);for(e=e||[];this.pos<t;)e.push(this.readSVarint());return e},readPackedBoolean:function(e){var t=Vl(this);for(e=e||[];this.pos<t;)e.push(this.readBoolean());return e},readPackedFloat:function(e){var t=Vl(this);for(e=e||[];this.pos<t;)e.push(this.readFloat());return e},readPackedDouble:function(e){var t=Vl(this);for(e=e||[];this.pos<t;)e.push(this.readDouble());return e},readPackedFixed32:function(e){var t=Vl(this);for(e=e||[];this.pos<t;)e.push(this.readFixed32());return e},readPackedSFixed32:function(e){var t=Vl(this);for(e=e||[];this.pos<t;)e.push(this.readSFixed32());return e},readPackedFixed64:function(e){var t=Vl(this);for(e=e||[];this.pos<t;)e.push(this.readFixed64());return e},readPackedSFixed64:function(e){var t=Vl(this);for(e=e||[];this.pos<t;)e.push(this.readSFixed64());return e},skip:function(e){var t=7&e;if(t===jl.Varint)for(;this.buf[this.pos++]>127;);else if(t===jl.Bytes)this.pos=this.readVarint()+this.pos;else if(t===jl.Fixed32)this.pos+=4;else {if(t!==jl.Fixed64)throw new Error("Unimplemented type: "+t);this.pos+=8;}},writeTag:function(e,t){this.writeVarint(e<<3|t);},realloc:function(e){for(var t=this.length||16;t<this.pos+e;)t*=2;if(t!==this.length){var r=new Uint8Array(t);r.set(this.buf),this.buf=r,this.length=t;}},finish:function(){return this.length=this.pos,this.pos=0,this.buf.subarray(0,this.length)},writeFixed32:function(e){this.realloc(4),tu(this.buf,e,this.pos),this.pos+=4;},writeSFixed32:function(e){this.realloc(4),tu(this.buf,e,this.pos),this.pos+=4;},writeFixed64:function(e){this.realloc(8),tu(this.buf,-1&e,this.pos),tu(this.buf,Math.floor(e*(1/4294967296)),this.pos+4),this.pos+=8;},writeSFixed64:function(e){this.realloc(8),tu(this.buf,-1&e,this.pos),tu(this.buf,Math.floor(e*(1/4294967296)),this.pos+4),this.pos+=8;},writeVarint:function(e){(e=+e||0)>268435455||e<0?function(e,t){var r,n;e>=0?(r=e%4294967296|0,n=e/4294967296|0):(n=~(-e/4294967296),4294967295^(r=~(-e%4294967296))?r=r+1|0:(r=0,n=n+1|0));if(e>=0x10000000000000000||e<-0x10000000000000000)throw new Error("Given varint doesn't fit into 10 bytes");t.realloc(10),function(e,t,r){r.buf[r.pos++]=127&e|128,e>>>=7,r.buf[r.pos++]=127&e|128,e>>>=7,r.buf[r.pos++]=127&e|128,e>>>=7,r.buf[r.pos++]=127&e|128,e>>>=7,r.buf[r.pos]=127&e;}(r,0,t),function(e,t){var r=(7&e)<<4;if(t.buf[t.pos++]|=r|((e>>>=3)?128:0),!e)return;if(t.buf[t.pos++]=127&e|((e>>>=7)?128:0),!e)return;if(t.buf[t.pos++]=127&e|((e>>>=7)?128:0),!e)return;if(t.buf[t.pos++]=127&e|((e>>>=7)?128:0),!e)return;if(t.buf[t.pos++]=127&e|((e>>>=7)?128:0),!e)return;t.buf[t.pos++]=127&e;}(n,t);}(e,this):(this.realloc(4),this.buf[this.pos++]=127&e|(e>127?128:0),e<=127||(this.buf[this.pos++]=127&(e>>>=7)|(e>127?128:0),e<=127||(this.buf[this.pos++]=127&(e>>>=7)|(e>127?128:0),e<=127||(this.buf[this.pos++]=e>>>7&127))));},writeSVarint:function(e){this.writeVarint(e<0?2*-e-1:2*e);},writeBoolean:function(e){this.writeVarint(Boolean(e));},writeString:function(e){e=String(e),this.realloc(4*e.length),this.pos++;var t=this.pos;this.pos=function(e,t,r){for(var n,i,o=0;o<t.length;o++){if((n=t.charCodeAt(o))>55295&&n<57344){if(!i){n>56319||o+1===t.length?(e[r++]=239,e[r++]=191,e[r++]=189):i=n;continue}if(n<56320){e[r++]=239,e[r++]=191,e[r++]=189,i=n;continue}n=i-55296<<10|n-56320|65536,i=null;}else i&&(e[r++]=239,e[r++]=191,e[r++]=189,i=null);n<128?e[r++]=n:(n<2048?e[r++]=n>>6|192:(n<65536?e[r++]=n>>12|224:(e[r++]=n>>18|240,e[r++]=n>>12&63|128),e[r++]=n>>6&63|128),e[r++]=63&n|128);}return r}(this.buf,e,this.pos);var r=this.pos-t;r>=128&&ql(t,r,this),this.pos=t-1,this.writeVarint(r),this.pos+=r;},writeFloat:function(e){this.realloc(4),Gl(this.buf,e,this.pos,!0,23,4),this.pos+=4;},writeDouble:function(e){this.realloc(8),Gl(this.buf,e,this.pos,!0,52,8),this.pos+=8;},writeBytes:function(e){var t=e.length;this.writeVarint(t),this.realloc(t);for(var r=0;r<t;r++)this.buf[this.pos++]=e[r];},writeRawMessage:function(e,t){this.pos++;var r=this.pos;e(t,this);var n=this.pos-r;n>=128&&ql(r,n,this),this.pos=r-1,this.writeVarint(n),this.pos+=n;},writeMessage:function(e,t,r){this.writeTag(e,jl.Bytes),this.writeRawMessage(t,r);},writePackedVarint:function(e,t){this.writeMessage(e,Hl,t);},writePackedSVarint:function(e,t){this.writeMessage(e,Xl,t);},writePackedBoolean:function(e,t){this.writeMessage(e,Zl,t);},writePackedFloat:function(e,t){this.writeMessage(e,Wl,t);},writePackedDouble:function(e,t){this.writeMessage(e,Yl,t);},writePackedFixed32:function(e,t){this.writeMessage(e,Jl,t);},writePackedSFixed32:function(e,t){this.writeMessage(e,Kl,t);},writePackedFixed64:function(e,t){this.writeMessage(e,$l,t);},writePackedSFixed64:function(e,t){this.writeMessage(e,Ql,t);},writeBytesField:function(e,t){this.writeTag(e,jl.Bytes),this.writeBytes(t);},writeFixed32Field:function(e,t){this.writeTag(e,jl.Fixed32),this.writeFixed32(t);},writeSFixed32Field:function(e,t){this.writeTag(e,jl.Fixed32),this.writeSFixed32(t);},writeFixed64Field:function(e,t){this.writeTag(e,jl.Fixed64),this.writeFixed64(t);},writeSFixed64Field:function(e,t){this.writeTag(e,jl.Fixed64),this.writeSFixed64(t);},writeVarintField:function(e,t){this.writeTag(e,jl.Varint),this.writeVarint(t);},writeSVarintField:function(e,t){this.writeTag(e,jl.Varint),this.writeSVarint(t);},writeStringField:function(e,t){this.writeTag(e,jl.Bytes),this.writeString(t);},writeFloatField:function(e,t){this.writeTag(e,jl.Fixed32),this.writeFloat(t);},writeDoubleField:function(e,t){this.writeTag(e,jl.Fixed64),this.writeDouble(t);},writeBooleanField:function(e,t){this.writeVarintField(e,Boolean(t));}};var nu=iu;function iu(e,t){this.x=e,this.y=t;}iu.prototype={clone:function(){return new iu(this.x,this.y)},add:function(e){return this.clone()._add(e)},sub:function(e){return this.clone()._sub(e)},multByPoint:function(e){return this.clone()._multByPoint(e)},divByPoint:function(e){return this.clone()._divByPoint(e)},mult:function(e){return this.clone()._mult(e)},div:function(e){return this.clone()._div(e)},rotate:function(e){return this.clone()._rotate(e)},rotateAround:function(e,t){return this.clone()._rotateAround(e,t)},matMult:function(e){return this.clone()._matMult(e)},unit:function(){return this.clone()._unit()},perp:function(){return this.clone()._perp()},round:function(){return this.clone()._round()},mag:function(){return Math.sqrt(this.x*this.x+this.y*this.y)},equals:function(e){return this.x===e.x&&this.y===e.y},dist:function(e){return Math.sqrt(this.distSqr(e))},distSqr:function(e){var t=e.x-this.x,r=e.y-this.y;return t*t+r*r},angle:function(){return Math.atan2(this.y,this.x)},angleTo:function(e){return Math.atan2(this.y-e.y,this.x-e.x)},angleWith:function(e){return this.angleWithSep(e.x,e.y)},angleWithSep:function(e,t){return Math.atan2(this.x*t-this.y*e,this.x*e+this.y*t)},_matMult:function(e){var t=e[0]*this.x+e[1]*this.y,r=e[2]*this.x+e[3]*this.y;return this.x=t,this.y=r,this},_add:function(e){return this.x+=e.x,this.y+=e.y,this},_sub:function(e){return this.x-=e.x,this.y-=e.y,this},_mult:function(e){return this.x*=e,this.y*=e,this},_div:function(e){return this.x/=e,this.y/=e,this},_multByPoint:function(e){return this.x*=e.x,this.y*=e.y,this},_divByPoint:function(e){return this.x/=e.x,this.y/=e.y,this},_unit:function(){return this._div(this.mag()),this},_perp:function(){var e=this.y;return this.y=this.x,this.x=-e,this},_rotate:function(e){var t=Math.cos(e),r=Math.sin(e),n=t*this.x-r*this.y,i=r*this.x+t*this.y;return this.x=n,this.y=i,this},_rotateAround:function(e,t){var r=Math.cos(e),n=Math.sin(e),i=t.x+r*(this.x-t.x)-n*(this.y-t.y),o=t.y+n*(this.x-t.x)+r*(this.y-t.y);return this.x=i,this.y=o,this},_round:function(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this}},iu.convert=function(e){return e instanceof iu?e:Array.isArray(e)?new iu(e[0],e[1]):e};var ou=su;function su(e,t,r,n,i){this.properties={},this.extent=r,this.type=0,this._pbf=e,this._geometry=-1,this._keys=n,this._values=i,e.readFields(au,this,t);}function au(e,t,r){1==e?t.id=r.readVarint():2==e?function(e,t){var r=e.readVarint()+e.pos;for(;e.pos<r;){var n=t._keys[e.readVarint()],i=t._values[e.readVarint()];t.properties[n]=i;}}(r,t):3==e?t.type=r.readVarint():4==e&&(t._geometry=r.pos);}function lu(e){for(var t,r,n=0,i=0,o=e.length,s=o-1;i<o;s=i++)t=e[i],n+=((r=e[s]).x-t.x)*(t.y+r.y);return n}su.types=["Unknown","Point","LineString","Polygon"],su.prototype.loadGeometry=function(){var e=this._pbf;e.pos=this._geometry;for(var t,r=e.readVarint()+e.pos,n=1,i=0,o=0,s=0,a=[];e.pos<r;){if(!i){var l=e.readVarint();n=7&l,i=l>>3;}if(i--,1===n||2===n)o+=e.readSVarint(),s+=e.readSVarint(),1===n&&(t&&a.push(t),t=[]),t.push(new nu(o,s));else {if(7!==n)throw new Error("unknown command "+n);t&&t.push(t[0].clone());}}return t&&a.push(t),a},su.prototype.bbox=function(){var e=this._pbf;e.pos=this._geometry;for(var t=e.readVarint()+e.pos,r=1,n=0,i=0,o=0,s=1/0,a=-1/0,l=1/0,u=-1/0;e.pos<t;){if(!n){var c=e.readVarint();r=7&c,n=c>>3;}if(n--,1===r||2===r)(i+=e.readSVarint())<s&&(s=i),i>a&&(a=i),(o+=e.readSVarint())<l&&(l=o),o>u&&(u=o);else if(7!==r)throw new Error("unknown command "+r)}return [s,l,a,u]},su.prototype.toGeoJSON=function(e,t,r){var n,i,o=this.extent*Math.pow(2,r),s=this.extent*e,a=this.extent*t,l=this.loadGeometry(),u=su.types[this.type];function c(e){for(var t=0;t<e.length;t++){var r=e[t],n=180-360*(r.y+a)/o;e[t]=[360*(r.x+s)/o-180,360/Math.PI*Math.atan(Math.exp(n*Math.PI/180))-90];}}switch(this.type){case 1:var f=[];for(n=0;n<l.length;n++)f[n]=l[n][0];c(l=f);break;case 2:for(n=0;n<l.length;n++)c(l[n]);break;case 3:for(l=function(e){var t=e.length;if(t<=1)return [e];for(var r,n,i=[],o=0;o<t;o++){var s=lu(e[o]);0!==s&&(void 0===n&&(n=s<0),n===s<0?(r&&i.push(r),r=[e[o]]):r.push(e[o]));}r&&i.push(r);return i}(l),n=0;n<l.length;n++)for(i=0;i<l[n].length;i++)c(l[n][i]);}1===l.length?l=l[0]:u="Multi"+u;var h={type:"Feature",geometry:{type:u,coordinates:l},properties:this.properties};return "id"in this&&(h.id=this.id),h};var uu=cu;function cu(e,t){this.version=1,this.name=null,this.extent=4096,this.length=0,this._pbf=e,this._keys=[],this._values=[],this._features=[],e.readFields(fu,this,t),this.length=this._features.length;}function fu(e,t,r){15===e?t.version=r.readVarint():1===e?t.name=r.readString():5===e?t.extent=r.readVarint():2===e?t._features.push(r.pos):3===e?t._keys.push(r.readString()):4===e&&t._values.push(function(e){var t=null,r=e.readVarint()+e.pos;for(;e.pos<r;){var n=e.readVarint()>>3;t=1===n?e.readString():2===n?e.readFloat():3===n?e.readDouble():4===n?e.readVarint64():5===n?e.readVarint():6===n?e.readSVarint():7===n?e.readBoolean():null;}return t}(r));}function hu(e,t,r){if(3===e){var n=new uu(r,r.readVarint()+r.pos);n.length&&(t[n.name]=n);}}cu.prototype.feature=function(e){if(e<0||e>=this._features.length)throw new Error("feature index out of bounds");this._pbf.pos=this._features[e];var t=this._pbf.readVarint()+this._pbf.pos;return new ou(this._pbf,t,this.extent,this._keys,this._values)};var du=function(e,t){this.layers=e.readFields(hu,{},t);},pu=ou,_u={NONE:0,ALL:1,SOME:2},mu=["{","["],vu=function(e){function t(t,r){var n;if((n=e.call(this,t,r)||this).response_type="arraybuffer",!0===t.parse_json)n.parse_json_type=_u.ALL;else if(Array.isArray(t.parse_json))n.parse_json_type=_u.SOME,n.parse_json_prop_list=t.parse_json;else {if(null!=t.parse_json)Zr({level:"warn",once:!0},"Data source '"+n.name+"': 'parse_json' parameter should be 'true', or an array of property names (was '"+JSON.stringify(t.parse_json)+"')");n.parse_json_type=_u.NONE;}return n}pt(t,e);var r=t.prototype;return r.parseSourceData=function(e,t,r){var n=new Uint8Array(r),i=new Cl(n);if(t.data=new du(i),t.layers=this.toGeoJSON(t.data),"function"==typeof this.transform){var o={min:Object.assign({},e.min),max:Object.assign({},e.max),coords:Object.assign({},e.coords)};t.layers=this.transform(t.layers,this.extra_data,o);}delete t.data;},r.toGeoJSON=function(e){var t={};for(var r in e.layers){for(var n=e.layers[r],i=ai.tile_scale/n.extent,o={type:"FeatureCollection",features:[]},s=0;s<n.length;s++){var a=n.feature(s),l={type:"Feature",geometry:{},id:a.id,properties:a.properties};this.parseJSONProperties(l);for(var u=l.geometry,c=a.loadGeometry(),f=0;f<c.length;f++)for(var h=c[f],d=0;d<h.length;d++)h[d]=[h[d].x*i,h[d].y*i];u.coordinates=c,"Point"===pu.types[a.type]?1===c.length?(u.type="Point",u.coordinates=u.coordinates[0][0]):(u.type="MultiPoint",u.coordinates=u.coordinates[0]):"LineString"===pu.types[a.type]?1===c.length?(u.type="LineString",u.coordinates=u.coordinates[0]):u.type="MultiLineString":"Polygon"===pu.types[a.type]&&(u=gu(u)),o.features.push(l);}t[r]=o;}return t},r.parseJSONProperties=function(e){if(this.parse_json_type!==_u.NONE){var t=e.properties;if(this.parse_json_type===_u.SOME)this.parse_json_prop_list.forEach(function(e){try{t[e]=JSON.parse(t[e]);}catch(e){}});else for(var r in t)if(mu.indexOf(t[r][0])>-1)try{t[r]=JSON.parse(t[r]);}catch(e){}}},t}(mo);function gu(e){for(var t,r=[],n=[],i=0;i<e.coordinates.length;i++){var o=e.coordinates[i],s=ai.ringWinding(o);null!=s&&(s===(t=t||s)&&n.length>0&&(r.push(n),n=[]),n.push(o));}return n.length>0&&r.push(n),1===r.length?(e.type="Polygon",e.coordinates=r[0]):r.length>1?(e.type="MultiPolygon",e.coordinates=r):e=null,e}function yu(e,t,r,n,i,o){var s=i-r,a=o-n;if(0!==s||0!==a){var l=((e-r)*s+(t-n)*a)/(s*s+a*a);l>1?(r=i,n=o):l>0&&(r+=s*l,n+=a*l);}return (s=e-r)*s+(a=t-n)*a}function xu(e,t,r,n){var i={id:void 0===e?null:e,type:t,geometry:r,tags:n,minX:1/0,minY:1/0,maxX:-1/0,maxY:-1/0};return function(e){var t=e.geometry,r=e.type;if("Point"===r||"MultiPoint"===r||"LineString"===r)bu(e,t);else if("Polygon"===r||"MultiLineString"===r)for(var n=0;n<t.length;n++)bu(e,t[n]);else if("MultiPolygon"===r)for(n=0;n<t.length;n++)for(var i=0;i<t[n].length;i++)bu(e,t[n][i]);}(i),i}function bu(e,t){for(var r=0;r<t.length;r+=3)e.minX=Math.min(e.minX,t[r]),e.minY=Math.min(e.minY,t[r+1]),e.maxX=Math.max(e.maxX,t[r]),e.maxY=Math.max(e.maxY,t[r+1]);}function Au(e,t,r,n){if(t.geometry){var i=t.geometry.coordinates,o=t.geometry.type,s=Math.pow(r.tolerance/((1<<r.maxZoom)*r.extent),2),a=[],l=t.id;if(r.promoteId?l=t.properties[r.promoteId]:r.generateId&&(l=n||0),"Point"===o)Tu(i,a);else if("MultiPoint"===o)for(var u=0;u<i.length;u++)Tu(i[u],a);else if("LineString"===o)wu(i,a,s,!1);else if("MultiLineString"===o){if(r.lineMetrics){for(u=0;u<i.length;u++)a=[],wu(i[u],a,s,!1),e.push(xu(l,"LineString",a,t.properties));return}Eu(i,a,s,!1);}else if("Polygon"===o)Eu(i,a,s,!0);else {if("MultiPolygon"!==o){if("GeometryCollection"===o){for(u=0;u<t.geometry.geometries.length;u++)Au(e,{id:l,geometry:t.geometry.geometries[u],properties:t.properties},r,n);return}throw new Error("Input data is not a valid GeoJSON object.")}for(u=0;u<i.length;u++){var c=[];Eu(i[u],c,s,!0),a.push(c);}}e.push(xu(l,o,a,t.properties));}}function Tu(e,t){t.push(Ru(e[0])),t.push(Mu(e[1])),t.push(0);}function wu(e,t,r,n){for(var i,o,s=0,a=0;a<e.length;a++){var l=Ru(e[a][0]),u=Mu(e[a][1]);t.push(l),t.push(u),t.push(0),a>0&&(s+=n?(i*u-l*o)/2:Math.sqrt(Math.pow(l-i,2)+Math.pow(u-o,2))),i=l,o=u;}var c=t.length-3;t[2]=1,function e(t,r,n,i){for(var o,s=i,a=n-r>>1,l=n-r,u=t[r],c=t[r+1],f=t[n],h=t[n+1],d=r+3;d<n;d+=3){var p=yu(t[d],t[d+1],u,c,f,h);if(p>s)o=d,s=p;else if(p===s){var _=Math.abs(d-a);_<l&&(o=d,l=_);}}s>i&&(o-r>3&&e(t,r,o,i),t[o+2]=s,n-o>3&&e(t,o,n,i));}(t,0,c,r),t[c+2]=1,t.size=Math.abs(s),t.start=0,t.end=t.size;}function Eu(e,t,r,n){for(var i=0;i<e.length;i++){var o=[];wu(e[i],o,r,n),t.push(o);}}function Ru(e){return e/360+.5}function Mu(e){var t=Math.sin(e*Math.PI/180),r=.5-.25*Math.log((1+t)/(1-t))/Math.PI;return r<0?0:r>1?1:r}function Su(e,t,r,n,i,o,s,a){if(n/=t,o>=(r/=t)&&s<n)return e;if(s<r||o>=n)return null;for(var l=[],u=0;u<e.length;u++){var c=e[u],f=c.geometry,h=c.type,d=0===i?c.minX:c.minY,p=0===i?c.maxX:c.maxY;if(d>=r&&p<n)l.push(c);else if(!(p<r||d>=n)){var _=[];if("Point"===h||"MultiPoint"===h)zu(f,_,r,n,i);else if("LineString"===h)Pu(f,_,r,n,i,!1,a.lineMetrics);else if("MultiLineString"===h)ku(f,_,r,n,i,!1);else if("Polygon"===h)ku(f,_,r,n,i,!0);else if("MultiPolygon"===h)for(var m=0;m<f.length;m++){var v=[];ku(f[m],v,r,n,i,!0),v.length&&_.push(v);}if(_.length){if(a.lineMetrics&&"LineString"===h){for(m=0;m<_.length;m++)l.push(xu(c.id,h,_[m],c.tags));continue}"LineString"!==h&&"MultiLineString"!==h||(1===_.length?(h="LineString",_=_[0]):h="MultiLineString"),"Point"!==h&&"MultiPoint"!==h||(h=3===_.length?"Point":"MultiPoint"),l.push(xu(c.id,h,_,c.tags));}}}return l.length?l:null}function zu(e,t,r,n,i){for(var o=0;o<e.length;o+=3){var s=e[o+i];s>=r&&s<=n&&(t.push(e[o]),t.push(e[o+1]),t.push(e[o+2]));}}function Pu(e,t,r,n,i,o,s){for(var a,l,u=Nu(e),c=0===i?Ou:Iu,f=e.start,h=0;h<e.length-3;h+=3){var d=e[h],p=e[h+1],_=e[h+2],m=e[h+3],v=e[h+4],g=0===i?d:p,y=0===i?m:v,x=!1;s&&(a=Math.sqrt(Math.pow(d-m,2)+Math.pow(p-v,2))),g<r?y>r&&(l=c(u,d,p,m,v,r),s&&(u.start=f+a*l)):g>n?y<n&&(l=c(u,d,p,m,v,n),s&&(u.start=f+a*l)):Lu(u,d,p,_),y<r&&g>=r&&(l=c(u,d,p,m,v,r),x=!0),y>n&&g<=n&&(l=c(u,d,p,m,v,n),x=!0),!o&&x&&(s&&(u.end=f+a*l),t.push(u),u=Nu(e)),s&&(f+=a);}var b=e.length-3;d=e[b],p=e[b+1],_=e[b+2],(g=0===i?d:p)>=r&&g<=n&&Lu(u,d,p,_),b=u.length-3,o&&b>=3&&(u[b]!==u[0]||u[b+1]!==u[1])&&Lu(u,u[0],u[1],u[2]),u.length&&t.push(u);}function Nu(e){var t=[];return t.size=e.size,t.start=e.start,t.end=e.end,t}function ku(e,t,r,n,i,o){for(var s=0;s<e.length;s++)Pu(e[s],t,r,n,i,o,!1);}function Lu(e,t,r,n){e.push(t),e.push(r),e.push(n);}function Ou(e,t,r,n,i,o){var s=(o-t)/(n-t);return e.push(o),e.push(r+(i-r)*s),e.push(1),s}function Iu(e,t,r,n,i,o){var s=(o-r)/(i-r);return e.push(t+(n-t)*s),e.push(o),e.push(1),s}function Fu(e,t){for(var r=[],n=0;n<e.length;n++){var i,o=e[n],s=o.type;if("Point"===s||"MultiPoint"===s||"LineString"===s)i=Uu(o.geometry,t);else if("MultiLineString"===s||"Polygon"===s){i=[];for(var a=0;a<o.geometry.length;a++)i.push(Uu(o.geometry[a],t));}else if("MultiPolygon"===s)for(i=[],a=0;a<o.geometry.length;a++){for(var l=[],u=0;u<o.geometry[a].length;u++)l.push(Uu(o.geometry[a][u],t));i.push(l);}r.push(xu(o.id,s,i,o.tags));}return r}function Uu(e,t){var r=[];r.size=e.size,void 0!==e.start&&(r.start=e.start,r.end=e.end);for(var n=0;n<e.length;n+=3)r.push(e[n]+t,e[n+1],e[n+2]);return r}function Du(e,t){if(e.transformed)return e;var r,n,i,o=1<<e.z,s=e.x,a=e.y;for(r=0;r<e.features.length;r++){var l=e.features[r],u=l.geometry,c=l.type;if(l.geometry=[],1===c)for(n=0;n<u.length;n+=2)l.geometry.push(Gu(u[n],u[n+1],t,o,s,a));else for(n=0;n<u.length;n++){var f=[];for(i=0;i<u[n].length;i+=2)f.push(Gu(u[n][i],u[n][i+1],t,o,s,a));l.geometry.push(f);}}return e.transformed=!0,e}function Gu(e,t,r,n,i,o){return [Math.round(r*(e*n-i)),Math.round(r*(t*n-o))]}function Cu(e,t,r,n,i){for(var o=t===i.maxZoom?0:i.tolerance/((1<<t)*i.extent),s={features:[],numPoints:0,numSimplified:0,numFeatures:0,source:null,x:r,y:n,z:t,transformed:!1,minX:2,minY:1,maxX:-1,maxY:0},a=0;a<e.length;a++){s.numFeatures++,ju(s,e[a],o,i);var l=e[a].minX,u=e[a].minY,c=e[a].maxX,f=e[a].maxY;l<s.minX&&(s.minX=l),u<s.minY&&(s.minY=u),c>s.maxX&&(s.maxX=c),f>s.maxY&&(s.maxY=f);}return s}function ju(e,t,r,n){var i=t.geometry,o=t.type,s=[];if("Point"===o||"MultiPoint"===o)for(var a=0;a<i.length;a+=3)s.push(i[a]),s.push(i[a+1]),e.numPoints++,e.numSimplified++;else if("LineString"===o)Vu(s,i,e,r,!1,!1);else if("MultiLineString"===o||"Polygon"===o)for(a=0;a<i.length;a++)Vu(s,i[a],e,r,"Polygon"===o,0===a);else if("MultiPolygon"===o)for(var l=0;l<i.length;l++){var u=i[l];for(a=0;a<u.length;a++)Vu(s,u[a],e,r,!0,0===a);}if(s.length){var c=t.tags||null;if("LineString"===o&&n.lineMetrics){for(var f in c={},t.tags)c[f]=t.tags[f];c.mapbox_clip_start=i.start/i.size,c.mapbox_clip_end=i.end/i.size;}var h={geometry:s,type:"Polygon"===o||"MultiPolygon"===o?3:"LineString"===o||"MultiLineString"===o?2:1,tags:c};null!==t.id&&(h.id=t.id),e.features.push(h);}}function Vu(e,t,r,n,i,o){var s=n*n;if(n>0&&t.size<(i?s:n))r.numPoints+=t.length/3;else {for(var a=[],l=0;l<t.length;l+=3)(0===n||t[l+2]>s)&&(r.numSimplified++,a.push(t[l]),a.push(t[l+1])),r.numPoints++;i&&function(e,t){for(var r=0,n=0,i=e.length,o=i-2;n<i;o=n,n+=2)r+=(e[n]-e[o])*(e[n+1]+e[o+1]);if(r>0===t)for(n=0,i=e.length;n<i/2;n+=2){var s=e[n],a=e[n+1];e[n]=e[i-2-n],e[n+1]=e[i-1-n],e[i-2-n]=s,e[i-1-n]=a;}}(a,o),e.push(a);}}function Bu(e,t){return new qu(e,t)}function qu(e,t){var r=(t=this.options=function(e,t){for(var r in t)e[r]=t[r];return e}(Object.create(this.options),t)).debug;if(r&&console.time("preprocess data"),t.maxZoom<0||t.maxZoom>24)throw new Error("maxZoom should be in the 0-24 range");if(t.promoteId&&t.generateId)throw new Error("promoteId and generateId cannot be used together.");var n=function(e,t){var r=[];if("FeatureCollection"===e.type)for(var n=0;n<e.features.length;n++)Au(r,e.features[n],t,n);else "Feature"===e.type?Au(r,e,t):Au(r,{geometry:e},t);return r}(e,t);this.tiles={},this.tileCoords=[],r&&(console.timeEnd("preprocess data"),console.log("index: maxZoom: %d, maxPoints: %d",t.indexMaxZoom,t.indexMaxPoints),console.time("generate tiles"),this.stats={},this.total=0),(n=function(e,t){var r=t.buffer/t.extent,n=e,i=Su(e,1,-1-r,r,0,-1,2,t),o=Su(e,1,1-r,2+r,0,-1,2,t);return (i||o)&&(n=Su(e,1,-r,1+r,0,-1,2,t)||[],i&&(n=Fu(i,1).concat(n)),o&&(n=n.concat(Fu(o,-1)))),n}(n,t)).length&&this.splitTile(n,0,0,0),r&&(n.length&&console.log("features: %d, points: %d",this.tiles[0].numFeatures,this.tiles[0].numPoints),console.timeEnd("generate tiles"),console.log("tiles generated:",this.total,JSON.stringify(this.stats)));}function Hu(e,t,r){return 32*((1<<e)*r+t)+e}ho.register("MVT",function(){return vu}),qu.prototype.options={maxZoom:14,indexMaxZoom:5,indexMaxPoints:1e5,tolerance:3,extent:4096,buffer:64,lineMetrics:!1,promoteId:null,generateId:!1,debug:0},qu.prototype.splitTile=function(e,t,r,n,i,o,s){for(var a=[e,t,r,n],l=this.options,u=l.debug;a.length;){n=a.pop(),r=a.pop(),t=a.pop(),e=a.pop();var c=1<<t,f=Hu(t,r,n),h=this.tiles[f];if(!h&&(u>1&&console.time("creation"),h=this.tiles[f]=Cu(e,t,r,n,l),this.tileCoords.push({z:t,x:r,y:n}),u)){u>1&&(console.log("tile z%d-%d-%d (features: %d, points: %d, simplified: %d)",t,r,n,h.numFeatures,h.numPoints,h.numSimplified),console.timeEnd("creation"));var d="z"+t;this.stats[d]=(this.stats[d]||0)+1,this.total++;}if(h.source=e,i){if(t===l.maxZoom||t===i)continue;var p=1<<i-t;if(r!==Math.floor(o/p)||n!==Math.floor(s/p))continue}else if(t===l.indexMaxZoom||h.numPoints<=l.indexMaxPoints)continue;if(h.source=null,0!==e.length){u>1&&console.time("clipping");var _,m,v,g,y,x,b=.5*l.buffer/l.extent,A=.5-b,T=.5+b,w=1+b;_=m=v=g=null,y=Su(e,c,r-b,r+T,0,h.minX,h.maxX,l),x=Su(e,c,r+A,r+w,0,h.minX,h.maxX,l),e=null,y&&(_=Su(y,c,n-b,n+T,1,h.minY,h.maxY,l),m=Su(y,c,n+A,n+w,1,h.minY,h.maxY,l),y=null),x&&(v=Su(x,c,n-b,n+T,1,h.minY,h.maxY,l),g=Su(x,c,n+A,n+w,1,h.minY,h.maxY,l),x=null),u>1&&console.timeEnd("clipping"),a.push(_||[],t+1,2*r,2*n),a.push(m||[],t+1,2*r,2*n+1),a.push(v||[],t+1,2*r+1,2*n),a.push(g||[],t+1,2*r+1,2*n+1);}}},qu.prototype.getTile=function(e,t,r){var n=this.options,i=n.extent,o=n.debug;if(e<0||e>24)return null;var s=1<<e,a=Hu(e,t=(t%s+s)%s,r);if(this.tiles[a])return Du(this.tiles[a],i);o>1&&console.log("drilling down to z%d-%d-%d",e,t,r);for(var l,u=e,c=t,f=r;!l&&u>0;)u--,c=Math.floor(c/2),f=Math.floor(f/2),l=this.tiles[Hu(u,c,f)];return l&&l.source?(o>1&&console.log("found parent tile z%d-%d-%d",u,c,f),o>1&&console.time("drilling down"),this.splitTile(l.source,u,c,f,e,t,r),o>1&&console.timeEnd("drilling down"),this.tiles[a]?Du(this.tiles[a],i):null):null};var Xu=function(e){function t(t,r){var n;return (n=e.call(this,t,r)||this).load_data=null,n.tile_indexes={},n.setTileSize(512),n.pad_scale=0,n}pt(t,e);var r=t.prototype;return r._load=function(t){var r=this;return this.load_data||(this.load_data=e.prototype._load.call(this,{source_data:{layers:{}}}).then(function(e){e.source_data.error&&Zr("warn","data source load error(s) for source '"+r.name+"', URL '"+r.url+"': "+e.source_data.error);var t=e.source_data.layers;for(var n in t)r.tile_indexes[n]=Bu(t[n],{maxZoom:r.max_zoom,tolerance:1.5,extent:ai.tile_scale,buffer:1e-4});return r.loaded=!0,e})),this.load_data.then(function(){for(var e in r.tile_indexes)t.source_data.layers[e]=r.getTileFeatures(t,e);return t})},r.getTileFeatures=function(e,t){var r,n=ai.wrapTile(e.coords,{x:!0}),i=this.tile_indexes[t].getTile(n.z,n.x,n.y);if(i&&i.features){r={type:"FeatureCollection",features:[]};for(var o=0;o<i.features.length;o++){var s=i.features[o],a={type:"Feature",geometry:{},id:s.id,properties:s.tags};if(1===s.type)a.geometry.coordinates=s.geometry.map(function(e){return [e[0],e[1]]}),a.geometry.type="MultiPoint";else {if(2!==s.type&&3!==s.type)continue;if(a.geometry.coordinates=s.geometry.map(function(e){return e.map(function(e){return [e[0],e[1]]})}),2===s.type)a.geometry.type="MultiLineString";else if(a.geometry=gu(a.geometry),null==a.geometry)continue}r.features.push(a);}}return r},r.formatURL=function(){return this.url},r.parseSourceData=function(e,t,r){var n="string"==typeof r?JSON.parse(r):r,i=this.getLayers(n);t.layers=this.preprocessLayers(i,e);},r.preprocessLayers=function(e,t){for(var r in e){var n=e[r];n.features=this.preprocessFeatures(n.features);}if("function"==typeof this.transform){var i={min:Object.assign({},t.min),max:Object.assign({},t.max),coords:Object.assign({},t.coords)};1===Object.keys(e).length&&e._default?e._default=this.transform(e._default,this.extra_data,i):e=this.transform(e,this.extra_data,i);}return e},r.preprocessFeatures=function(e){if(e=e.filter(function(e){return null!=e.geometry}),this.config.generate_label_centroids){var t=[],r={label_placement:!0};e.forEach(function(e){var n,i;if("Polygon"===e.geometry.type)i=Yu(n=e.geometry.coordinates,e.id,e.properties,r),t.push(i);else if("MultiPolygon"===e.geometry.type){n=e.geometry.coordinates;for(var o=-1/0,s=0,a=0;a<n.length;a++){var l=ai.polygonArea(n[a]);l>o&&(o=l,s=a);}i=Yu(n[s],e.id,e.properties,r),t.push(i);}}),t=t.filter(function(e){return e}),Array.prototype.push.apply(e,t);}return e},r.getLayers=function(e){return "Feature"===e.type?{_default:{type:"FeatureCollection",features:[e]}}:"FeatureCollection"===e.type?{_default:e}:e},t}(_o),Wu=function(e){function t(t,r){return e.call(this,t,r)||this}pt(t,e);var r=t.prototype;return r.parseSourceData=function(e,t,r){var n="string"==typeof r?JSON.parse(r):r;this.prepareGeoJSON(n,e,t);},r.prepareGeoJSON=function(e,t,r){if("function"==typeof this.transform){var n={min:Object.assign({},t.min),max:Object.assign({},t.max),coords:Object.assign({},t.coords)};e=this.transform(e,this.extra_data,n);}r.layers=Xu.prototype.getLayers(e);var i={coords:t.coords,min:ai.metersForTile(ai.wrapTile(t.coords,{x:!0}))};ho.projectData(r),ho.scaleData(r,i);},t}(mo);function Yu(e,t,r,n){var i=ai.centroid(e);if(i){var o={};return Object.assign(o,r,n),{type:"Feature",id:t,properties:o,geometry:{type:"Point",coordinates:i}}}}function Zu(e){return e}function Ju(e,t){var r=t.id,n=t.bbox,i=null==t.properties?{}:t.properties,o=function(e,t){var r=function(e){if(null==(t=e.transform))return Zu;var t,r,n,i=t.scale[0],o=t.scale[1],s=t.translate[0],a=t.translate[1];return function(e,t){return t||(r=n=0),e[0]=(r+=e[0])*i+s,e[1]=(n+=e[1])*o+a,e}}(e),n=e.arcs;function i(e,t){t.length&&t.pop();for(var i=n[e<0?~e:e],o=0,s=i.length;o<s;++o)t.push(r(i[o].slice(),o));e<0&&function(e,t){for(var r,n=e.length,i=n-t;i<--n;)r=e[i],e[i++]=e[n],e[n]=r;}(t,s);}function o(e){return r(e.slice())}function s(e){for(var t=[],r=0,n=e.length;r<n;++r)i(e[r],t);return t.length<2&&t.push(t[0].slice()),t}function a(e){for(var t=s(e);t.length<4;)t.push(t[0].slice());return t}function l(e){return e.map(a)}return function e(t){var r,n=t.type;switch(n){case"GeometryCollection":return {type:n,geometries:t.geometries.map(e)};case"Point":r=o(t.coordinates);break;case"MultiPoint":r=t.coordinates.map(o);break;case"LineString":r=s(t.arcs);break;case"MultiLineString":r=t.arcs.map(s);break;case"Polygon":r=l(t.arcs);break;case"MultiPolygon":r=t.arcs.map(l);break;default:return null}return {type:n,coordinates:r}}(t)}(e,t);return null==r&&null==n?{type:"Feature",properties:i,geometry:o}:null==n?{type:"Feature",id:r,properties:i,geometry:o}:{type:"Feature",id:r,bbox:n,properties:i,geometry:o}}ho.register("GeoJSON",function(e){return Wu.urlHasTilePattern(e.url)?Wu:Xu});var Ku=function(e){function t(){return e.apply(this,arguments)||this}pt(t,e);var r=t.prototype;return r.parseSourceData=function(t,r,n){var i="string"==typeof n?JSON.parse(n):n;i=this.toGeoJSON(i);var o=this.getLayers(i);e.prototype.preprocessLayers.call(this,o,t),r.layers=o;},r.toGeoJSON=function(e){if(e.objects&&1===Object.keys(e.objects).length){var t=Object.keys(e.objects)[0];e=$u(e,e.objects[t]);}else {var r={};for(var n in e.objects)r[n]=$u(e,e.objects[n]);e=r;}return e},t}(Xu);function $u(e,t){var r=function(e,t){return "GeometryCollection"===t.type?{type:"FeatureCollection",features:t.geometries.map(function(t){return Ju(e,t)})}:Ju(e,t)}(e,t);return "Feature"===r.type&&(r={type:"FeatureCollection",features:[r]}),r}var Qu=function(e){function t(t,r){return e.call(this,t,r)||this}return pt(t,e),t.prototype.parseSourceData=function(e,t,r){var n="string"==typeof r?JSON.parse(r):r;n=Ku.prototype.toGeoJSON(n),this.prepareGeoJSON(n,e,t);},t}(Wu);ho.register("TopoJSON",function(e){return Qu.urlHasTilePattern(e.url)?Qu:Ku}),e.Collision=aa,e.DataSource=ho,e.FeatureSelection=Ji,e.FilterOptions=kl,e.FontManager=ga,e.GLSL=Xn,e.Geo=ai,e.Label=na,e.LabelLineStraight=el,e.LabelPoint=la,e.Light=so,e.Material=eo,e.OBB=ra,e.ShaderProgram=Qn,e.Style=xo,e.StyleManager=ll,e.StyleParser=Ui,e.Task=En,e.TextCanvas=Fa,e.Texture=Hn,e.Thread=qe,e.Tile=Ul,e.TileID=vo,e.Utils=Qr,e.Vector=oo,e.VertexArrayObject=ei,e.VertexData=Mo,e.VertexElements=Eo,e.View=Wa,e.WorkerBroker=jr,e._createClass=dt,e._createForOfIteratorHelperLoose=xt,e._inheritsLoose=pt,e.addBaseURL=function(e,t){if(!e||!Tn(e))return e;var r,n="/"!==e[0];if(t?(r=document.createElement("a")).href=t:r=window.location,n)e=An(r.href)+e;else {var i=r.origin;i||(i=r.protocol+"//"+r.host),e=i+e;}return e},e.buildFilter=wl,e.cache=Li,e.clearFunctionStringCache=function(){Li.functions={},Li.num_functions=0,Li.num_cached=0;},e.commonjsRequire=function(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")},e.compileFunctionStrings=Oi,e.createCommonjsModule=t,e.createObjectURL=function(e){return void 0===xn&&"function"!=typeof(xn=window.URL&&window.URL.createObjectURL||window.webkitURL&&window.webkitURL.createObjectURL)&&(xn=null,Zr("warn","window.URL.createObjectURL (or vendor prefix) not found, unable to create local blob URLs")),xn?xn(e):e},e.debugSettings=en,e.debugSumLayerStats=function(e){var t={},r={};return e.filter(function(e){return e.debug.layers}).forEach(function(e){Object.keys(e.debug.layers.list).forEach(function(r){var n=e.debug.layers.list[r];bo(t,r,n.features,n.geoms,n.styles,n.base);}),function e(t,r){for(var n in t){var i=t[n];bo(r,n,i.features,i.geoms,i.styles,i.base),i.layers&&(r[n].layers=r[n].layers||{},e(i.layers,r[n].layers));}}(e.debug.layers.tree,r);}),{list:t,tree:r}},e.extensionForURL=function(e){var t=(e=e.split("/").pop()).lastIndexOf(".");if(t>-1)return e.substring(t+1)},e.flattenRelativeURL=function(e){for(var t=(e||"").split("/"),r=1;r<t.length;r++)"."===t[r]?(t.splice(r,1),r--):".."===t[r]&&(r+=0,t.splice(r-1,2),r--);return t.join("/")},e.isLocalURL=function(e){if("string"==typeof e)return e.search(/^(data|blob):/)>-1},e.isRelativeURL=Tn,e.isReserved=Ll,e.layerCache=function(){return Rl},e.log=Zr,e.mergeDebugSettings=function(e){Object.assign($r,e);},e.mergeObjects=si,e.parseLayers=function(e,t){Rl={};var r={};for(var n in e){var i=e[n];i&&(r[n]=Ol(n,i,null,t));}return r},e.pathForURL=An,e.require$$0=qn,e.sliceObject=Mn,e.subscribeMixin=Rn,e.version=Ir;});

define(["./shared"],function(e){"use strict";var t=Object.assign(self,{FeatureSelection:e.FeatureSelection,sources:{},styles:{},layers:{},tiles:{},init:function(t,r,i,o,s,n,a){return this.scene_id=t,this._worker_id=r,this.num_workers=i,e.log.setLevel(o),e.Utils.device_pixel_ratio=s,e.VertexElements.setElementIndexUint(n),e.FeatureSelection.setPrefix(this._worker_id),this.style_manager=new e.StyleManager,this.importExternalScripts(a),e.Label.id_prefix=r,e.Label.id_multiplier=i,r},importExternalScripts:function(t){var r=this;if(0!==t.length){e.log("debug","loading custom data source scripts in worker:",t);var i=Object.getOwnPropertyNames(window);importScripts.apply(void 0,t),Object.getOwnPropertyNames(window).forEach(function(e){-1===i.indexOf(e)&&(r[e]=window[e]);});}},updateConfig:function(t,r){var i=t.config,o=t.generation,s=t.introspection;return i=JSON.parse(i),e.mergeDebugSettings(r),this.generation=o,this.introspection=s,this.global=e.compileFunctionStrings(i.global),this.createDataSources(i),i.styles=e.compileFunctionStrings(i.styles,e.StyleParser.wrapFunction),this.styles=this.style_manager.build(i.styles),this.style_manager.initStyles({generation:this.generation,styles:this.styles,sources:this.sources,introspection:this.introspection}),this.layers=e.parseLayers(i.layers,this.style_manager.styles),this.syncing_textures=this.syncTextures(i.textures),this.configuring=this.syncing_textures.then(function(){e.log("debug","updated config");}),this.configuring},createDataSources:function(t){var r=this;this.last_config_sources=this.config_sources||{},this.config_sources=t.sources;var i=this.sources,o=[];for(var s in this.sources={},t.sources)if(JSON.stringify(this.last_config_sources[s])!==JSON.stringify(t.sources[s])){t.sources[s]=e.compileFunctionStrings(t.sources[s]);var n=void 0;try{n=e.DataSource.create(Object.assign({},t.sources[s],{name:s}),this.sources);}catch(e){continue}n&&(this.sources[s]=n,o.push(s));}else this.sources[s]=i[s];o.forEach(function(e){for(var t in r.tiles)r.tiles[t].source===e&&delete r.tiles[t];});},awaitConfiguration:function(){return this.configuring},buildTile:function(t){var r=this,i=t.tile;if(null==this.getTile(i.key)||!0!==this.getTile(i.key).loading)return i=this.tiles[i.key]=Object.assign(this.getTile(i.key)||{},i),this.awaitConfiguration().then(function(){if(!0!==i.loaded)i.loading=!0,i.loaded=!1,i.error=null,r.loadTileSourceData(i).then(function(){r.getTile(i.key)?(i.source_data.error&&e.log("warn","tile load error(s) for "+i.key+": "+i.source_data.error),i.loading=!1,i.loaded=!0,e.Tile.buildGeometry(i,r)):e.log("trace","stop tile build after data source load because tile was removed: "+i.key);}).catch(function(t){i.loading=!1,i.loaded=!1,i.error=t.stack,e.log("error","tile load error for "+i.key+": "+i.error),e.WorkerBroker.postMessage("TileManager_"+r.scene_id+".buildTileError",e.Tile.slice(i));});else {e.log("trace","used worker cache for tile "+i.key);try{e.Tile.buildGeometry(i,r);}catch(t){i.error=t.toString(),e.WorkerBroker.postMessage("TileManager_"+r.scene_id+".buildTileError",e.Tile.slice(i));}}})},loadTileSourceData:function(e){var t=this.sources[e.source];if(t){for(var r in this.tiles){var i=this.tiles[r];if(i.source===e.source&&i.coords.key===e.coords.key&&i.loaded)return Promise.resolve(t.copyTileData(i,e))}return t.load(e)}return e.source_data={},Promise.resolve(e)},getTile:function(e){return this.tiles[e]},removeTile:function(t){var r=this.tiles[t];null!=r&&(!0===r.loading&&(e.log("trace","cancel tile load for "+t),r.loading=!1,e.Tile.cancel(r)),e.FeatureSelection.clearTile(t),delete this.tiles[t],e.log("trace","remove tile from cache for "+t));},queryFeatures:function(t){var r=this,i=t.filter,o=t.visible,s=t.geometry,n=t.tile_keys,a=[],l=n.map(function(e){return r.tiles[e]}).filter(function(e){return e&&e.loaded});return null!=i&&(i=["{","["].indexOf(i[0])>-1?JSON.parse(i):i,i=e.compileFunctionStrings(i,e.StyleParser.wrapFunction)),i=e.buildFilter(i,e.FilterOptions),l.forEach(function(t){var n=function(n){var l=t.source_data.layers[n];if(null==l)return {v:void 0};l.features.forEach(function(l){var c=l.generation===r.generation;if(!(!0===o&&!c||!1===o&&c)){var u=e.StyleParser.getFeatureParseContext(l,t,r.global);if(u.source=t.source,u.layer=n,u.id=l.id,i(u)){var g={type:l.type,id:l.id,properties:Object.assign({},l.properties,{$source:u.source,$layer:u.layer,$geometry:u.geometry,$visible:c})};!0===s&&(g.geometry=e.Geo.copyGeometry(l.geometry),e.Geo.tileSpaceToLatlng(g.geometry,t.coords.z,t.min)),a.push(g);}}});};for(var l in t.source_data.layers){var c=n(l);if("object"==typeof c)return c.v}}),a},getFeatureSelection:function(t){var r=void 0===t?{}:t,i=r.id,o=r.key,s=e.FeatureSelection.map[o];return {id:i,feature:s&&s.feature}},resetFeatureSelection:function(t){void 0===t&&(t=null),e.FeatureSelection.reset(t);},getFeatureSelectionMapSize:function(){return e.FeatureSelection.getMapSize()},syncTextures:function(t){var r=[];return t&&r.push.apply(r,Object.keys(t)),e.log("trace","sync textures to worker:",r),r.length>0?e.Texture.syncTexturesToWorker(r):Promise.resolve()},updateDevicePixelRatio:function(t){e.Utils.device_pixel_ratio=t;},clearFunctionStringCache:function(){e.clearFunctionStringCache();},profile:function(e){console.profile("worker "+this._worker_id+": "+e);},profileEnd:function(e){console.profileEnd("worker "+this._worker_id+": "+e);},debug:{debugSettings:e.debugSettings,layerCache:e.layerCache,functionStringCache:e.cache}});e.WorkerBroker.addTarget("self",t);});

define(["./shared"],function(e){"use strict";var t,n=t={},r=0;function i(e,t){var n,r=t[t.length-1];return null==(n=s(e,t))?void 0:n[r]}function o(e,t,n){var r=t[t.length-1],i=s(e,t);i&&(i[r]=n);}function s(e,t){if(0!==t.length){for(var n=e,r=0;r<t.length-1;r++){if(null==(n=n[t[r]]))return}return n}}t.getContext=function(e,n){var i=!1;null==e&&((e=document.createElement("canvas")).style.position="absolute",e.style.top=0,e.style.left=0,e.style.zIndex=-1,document.body.appendChild(e),i=!0),e.addEventListener("webglcontextlost",function(){}),e.addEventListener("webglcontextrestored",function(){});var o=e.getContext("webgl",n)||e.getContext("experimental-webgl",n);if(!o)throw new Error("Couldn't create WebGL context.");return o._tangram_id=r++,i?(t.resize(o,window.innerWidth,window.innerHeight,n.device_pixel_ratio),window.addEventListener("resize",function(){t.resize(o,window.innerWidth,window.innerHeight,n.device_pixel_ratio);})):t.resize(o,parseFloat(e.style.width),parseFloat(e.style.height),n.device_pixel_ratio),o},t.resize=function(e,t,n,r){r=r||window.devicePixelRatio||1,e.canvas.style.width=t+"px",e.canvas.style.height=n+"px",e.canvas.width=Math.round(t*r),e.canvas.height=Math.round(n*r),e.bindFramebuffer(e.FRAMEBUFFER,null),e.viewport(0,0,e.canvas.width,e.canvas.height);};var a="global.",l=a.length,u="__global_prop";function h(e){return (null==e?void 0:e.slice(0,l))===a}function c(e,t){var n,r=Array.isArray(t)?t:[t],i=s(e,r),o=r[r.length-1];return void 0!==(null==i?void 0:null==(n=i[u])?void 0:n[o])}var f="undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{},d=[],p=[],g="undefined"!=typeof Uint8Array?Uint8Array:Array,m=!1;function v(){m=!0;for(var e="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",t=0,n=e.length;t<n;++t)d[t]=e[t],p[e.charCodeAt(t)]=t;p["-".charCodeAt(0)]=62,p["_".charCodeAt(0)]=63;}function _(e,t,n){for(var r,i,o=[],s=t;s<n;s+=3)r=(e[s]<<16)+(e[s+1]<<8)+e[s+2],o.push(d[(i=r)>>18&63]+d[i>>12&63]+d[i>>6&63]+d[63&i]);return o.join("")}function y(e){var t;m||v();for(var n=e.length,r=n%3,i="",o=[],s=0,a=n-r;s<a;s+=16383)o.push(_(e,s,s+16383>a?a:s+16383));return 1===r?(t=e[n-1],i+=d[t>>2],i+=d[t<<4&63],i+="=="):2===r&&(t=(e[n-2]<<8)+e[n-1],i+=d[t>>10],i+=d[t>>4&63],i+=d[t<<2&63],i+="="),o.push(i),o.join("")}function b(e,t,n,r,i){var o,s,a=8*i-r-1,l=(1<<a)-1,u=l>>1,h=-7,c=n?i-1:0,f=n?-1:1,d=e[t+c];for(c+=f,o=d&(1<<-h)-1,d>>=-h,h+=a;h>0;o=256*o+e[t+c],c+=f,h-=8);for(s=o&(1<<-h)-1,o>>=-h,h+=r;h>0;s=256*s+e[t+c],c+=f,h-=8);if(0===o)o=1-u;else {if(o===l)return s?NaN:1/0*(d?-1:1);s+=Math.pow(2,r),o-=u;}return (d?-1:1)*s*Math.pow(2,o-r)}function w(e,t,n,r,i,o){var s,a,l,u=8*o-i-1,h=(1<<u)-1,c=h>>1,f=23===i?Math.pow(2,-24)-Math.pow(2,-77):0,d=r?0:o-1,p=r?1:-1,g=t<0||0===t&&1/t<0?1:0;for(t=Math.abs(t),isNaN(t)||t===1/0?(a=isNaN(t)?1:0,s=h):(s=Math.floor(Math.log(t)/Math.LN2),t*(l=Math.pow(2,-s))<1&&(s--,l*=2),(t+=s+c>=1?f/l:f*Math.pow(2,1-c))*l>=2&&(s++,l/=2),s+c>=h?(a=0,s=h):s+c>=1?(a=(t*l-1)*Math.pow(2,i),s+=c):(a=t*Math.pow(2,c-1)*Math.pow(2,i),s=0));i>=8;e[n+d]=255&a,d+=p,a/=256,i-=8);for(s=s<<i|a,u+=i;u>0;e[n+d]=255&s,d+=p,s/=256,u-=8);e[n+d-p]|=128*g;}var k={}.toString,S=Array.isArray||function(e){return "[object Array]"==k.call(e)};A.TYPED_ARRAY_SUPPORT=void 0===f.TYPED_ARRAY_SUPPORT||f.TYPED_ARRAY_SUPPORT;var x=C();function C(){return A.TYPED_ARRAY_SUPPORT?2147483647:1073741823}function E(e,t){if(C()<t)throw new RangeError("Invalid typed array length");return A.TYPED_ARRAY_SUPPORT?(e=new Uint8Array(t)).__proto__=A.prototype:(null===e&&(e=new A(t)),e.length=t),e}function A(e,t,n){if(!(A.TYPED_ARRAY_SUPPORT||this instanceof A))return new A(e,t,n);if("number"==typeof e){if("string"==typeof t)throw new Error("If encoding is specified then the first argument must be a string");return O(this,e)}return T(this,e,t,n)}function T(e,t,n,r){if("number"==typeof t)throw new TypeError('"value" argument must not be a number');return "undefined"!=typeof ArrayBuffer&&t instanceof ArrayBuffer?function(e,t,n,r){if(t.byteLength,n<0||t.byteLength<n)throw new RangeError("'offset' is out of bounds");if(t.byteLength<n+(r||0))throw new RangeError("'length' is out of bounds");t=void 0===n&&void 0===r?new Uint8Array(t):void 0===r?new Uint8Array(t,n):new Uint8Array(t,n,r);A.TYPED_ARRAY_SUPPORT?(e=t).__proto__=A.prototype:e=R(e,t);return e}(e,t,n,r):"string"==typeof t?function(e,t,n){"string"==typeof n&&""!==n||(n="utf8");if(!A.isEncoding(n))throw new TypeError('"encoding" must be a valid string encoding');var r=0|I(t,n),i=(e=E(e,r)).write(t,n);i!==r&&(e=e.slice(0,i));return e}(e,t,n):function(e,t){if(B(t)){var n=0|L(t.length);return 0===(e=E(e,n)).length?e:(t.copy(e,0,0,n),e)}if(t){if("undefined"!=typeof ArrayBuffer&&t.buffer instanceof ArrayBuffer||"length"in t)return "number"!=typeof t.length||(r=t.length)!=r?E(e,0):R(e,t);if("Buffer"===t.type&&S(t.data))return R(e,t.data)}var r;throw new TypeError("First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.")}(e,t)}function z(e){if("number"!=typeof e)throw new TypeError('"size" argument must be a number');if(e<0)throw new RangeError('"size" argument must not be negative')}function O(e,t){if(z(t),e=E(e,t<0?0:0|L(t)),!A.TYPED_ARRAY_SUPPORT)for(var n=0;n<t;++n)e[n]=0;return e}function R(e,t){var n=t.length<0?0:0|L(t.length);e=E(e,n);for(var r=0;r<n;r+=1)e[r]=255&t[r];return e}function L(e){if(e>=C())throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+C().toString(16)+" bytes");return 0|e}function B(e){return !(null==e||!e._isBuffer)}function I(e,t){if(B(e))return e.length;if("undefined"!=typeof ArrayBuffer&&"function"==typeof ArrayBuffer.isView&&(ArrayBuffer.isView(e)||e instanceof ArrayBuffer))return e.byteLength;"string"!=typeof e&&(e=""+e);var n=e.length;if(0===n)return 0;for(var r=!1;;)switch(t){case"ascii":case"latin1":case"binary":return n;case"utf8":case"utf-8":case void 0:return se(e).length;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return 2*n;case"hex":return n>>>1;case"base64":return ae(e).length;default:if(r)return se(e).length;t=(""+t).toLowerCase(),r=!0;}}function F(e,t,n){var r=e[t];e[t]=e[n],e[n]=r;}function P(e,t,n,r,i){if(0===e.length)return -1;if("string"==typeof n?(r=n,n=0):n>2147483647?n=2147483647:n<-2147483648&&(n=-2147483648),n=+n,isNaN(n)&&(n=i?0:e.length-1),n<0&&(n=e.length+n),n>=e.length){if(i)return -1;n=e.length-1;}else if(n<0){if(!i)return -1;n=0;}if("string"==typeof t&&(t=A.from(t,r)),B(t))return 0===t.length?-1:M(e,t,n,r,i);if("number"==typeof t)return t&=255,A.TYPED_ARRAY_SUPPORT&&"function"==typeof Uint8Array.prototype.indexOf?i?Uint8Array.prototype.indexOf.call(e,t,n):Uint8Array.prototype.lastIndexOf.call(e,t,n):M(e,[t],n,r,i);throw new TypeError("val must be string, number or Buffer")}function M(e,t,n,r,i){var o,s=1,a=e.length,l=t.length;if(void 0!==r&&("ucs2"===(r=String(r).toLowerCase())||"ucs-2"===r||"utf16le"===r||"utf-16le"===r)){if(e.length<2||t.length<2)return -1;s=2,a/=2,l/=2,n/=2;}function u(e,t){return 1===s?e[t]:e.readUInt16BE(t*s)}if(i){var h=-1;for(o=n;o<a;o++)if(u(e,o)===u(t,-1===h?0:o-h)){if(-1===h&&(h=o),o-h+1===l)return h*s}else -1!==h&&(o-=o-h),h=-1;}else for(n+l>a&&(n=a-l),o=n;o>=0;o--){for(var c=!0,f=0;f<l;f++)if(u(e,o+f)!==u(t,f)){c=!1;break}if(c)return o}return -1}function U(e,t,n,r){n=Number(n)||0;var i=e.length-n;r?(r=Number(r))>i&&(r=i):r=i;var o=t.length;if(o%2!=0)throw new TypeError("Invalid hex string");r>o/2&&(r=o/2);for(var s=0;s<r;++s){var a=parseInt(t.substr(2*s,2),16);if(isNaN(a))return s;e[n+s]=a;}return s}function D(e,t,n,r){return le(se(t,e.length-n),e,n,r)}function j(e,t,n,r){return le(function(e){for(var t=[],n=0;n<e.length;++n)t.push(255&e.charCodeAt(n));return t}(t),e,n,r)}function N(e,t,n,r){return j(e,t,n,r)}function Z(e,t,n,r){return le(ae(t),e,n,r)}function W(e,t,n,r){return le(function(e,t){for(var n,r,i,o=[],s=0;s<e.length&&!((t-=2)<0);++s)n=e.charCodeAt(s),r=n>>8,i=n%256,o.push(i),o.push(r);return o}(t,e.length-n),e,n,r)}function q(e,t,n){return 0===t&&n===e.length?y(e):y(e.slice(t,n))}function Y(e,t,n){n=Math.min(e.length,n);for(var r=[],i=t;i<n;){var o,s,a,l,u=e[i],h=null,c=u>239?4:u>223?3:u>191?2:1;if(i+c<=n)switch(c){case 1:u<128&&(h=u);break;case 2:128==(192&(o=e[i+1]))&&(l=(31&u)<<6|63&o)>127&&(h=l);break;case 3:o=e[i+1],s=e[i+2],128==(192&o)&&128==(192&s)&&(l=(15&u)<<12|(63&o)<<6|63&s)>2047&&(l<55296||l>57343)&&(h=l);break;case 4:o=e[i+1],s=e[i+2],a=e[i+3],128==(192&o)&&128==(192&s)&&128==(192&a)&&(l=(15&u)<<18|(63&o)<<12|(63&s)<<6|63&a)>65535&&l<1114112&&(h=l);}null===h?(h=65533,c=1):h>65535&&(h-=65536,r.push(h>>>10&1023|55296),h=56320|1023&h),r.push(h),i+=c;}return function(e){var t=e.length;if(t<=V)return String.fromCharCode.apply(String,e);var n="",r=0;for(;r<t;)n+=String.fromCharCode.apply(String,e.slice(r,r+=V));return n}(r)}A.poolSize=8192,A._augment=function(e){return e.__proto__=A.prototype,e},A.from=function(e,t,n){return T(null,e,t,n)},A.TYPED_ARRAY_SUPPORT&&(A.prototype.__proto__=Uint8Array.prototype,A.__proto__=Uint8Array),A.alloc=function(e,t,n){return function(e,t,n,r){return z(t),t<=0?E(e,t):void 0!==n?"string"==typeof r?E(e,t).fill(n,r):E(e,t).fill(n):E(e,t)}(null,e,t,n)},A.allocUnsafe=function(e){return O(null,e)},A.allocUnsafeSlow=function(e){return O(null,e)},A.isBuffer=ue,A.compare=function(e,t){if(!B(e)||!B(t))throw new TypeError("Arguments must be Buffers");if(e===t)return 0;for(var n=e.length,r=t.length,i=0,o=Math.min(n,r);i<o;++i)if(e[i]!==t[i]){n=e[i],r=t[i];break}return n<r?-1:r<n?1:0},A.isEncoding=function(e){switch(String(e).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"latin1":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return !0;default:return !1}},A.concat=function(e,t){if(!S(e))throw new TypeError('"list" argument must be an Array of Buffers');if(0===e.length)return A.alloc(0);var n;if(void 0===t)for(t=0,n=0;n<e.length;++n)t+=e[n].length;var r=A.allocUnsafe(t),i=0;for(n=0;n<e.length;++n){var o=e[n];if(!B(o))throw new TypeError('"list" argument must be an Array of Buffers');o.copy(r,i),i+=o.length;}return r},A.byteLength=I,A.prototype._isBuffer=!0,A.prototype.swap16=function(){var e=this.length;if(e%2!=0)throw new RangeError("Buffer size must be a multiple of 16-bits");for(var t=0;t<e;t+=2)F(this,t,t+1);return this},A.prototype.swap32=function(){var e=this.length;if(e%4!=0)throw new RangeError("Buffer size must be a multiple of 32-bits");for(var t=0;t<e;t+=4)F(this,t,t+3),F(this,t+1,t+2);return this},A.prototype.swap64=function(){var e=this.length;if(e%8!=0)throw new RangeError("Buffer size must be a multiple of 64-bits");for(var t=0;t<e;t+=8)F(this,t,t+7),F(this,t+1,t+6),F(this,t+2,t+5),F(this,t+3,t+4);return this},A.prototype.toString=function(){var e=0|this.length;return 0===e?"":0===arguments.length?Y(this,0,e):function(e,t,n){var r=!1;if((void 0===t||t<0)&&(t=0),t>this.length)return "";if((void 0===n||n>this.length)&&(n=this.length),n<=0)return "";if((n>>>=0)<=(t>>>=0))return "";for(e||(e="utf8");;)switch(e){case"hex":return K(this,t,n);case"utf8":case"utf-8":return Y(this,t,n);case"ascii":return H(this,t,n);case"latin1":case"binary":return G(this,t,n);case"base64":return q(this,t,n);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return J(this,t,n);default:if(r)throw new TypeError("Unknown encoding: "+e);e=(e+"").toLowerCase(),r=!0;}}.apply(this,arguments)},A.prototype.equals=function(e){if(!B(e))throw new TypeError("Argument must be a Buffer");return this===e||0===A.compare(this,e)},A.prototype.inspect=function(){var e="";return this.length>0&&(e=this.toString("hex",0,50).match(/.{2}/g).join(" "),this.length>50&&(e+=" ... ")),"<Buffer "+e+">"},A.prototype.compare=function(e,t,n,r,i){if(!B(e))throw new TypeError("Argument must be a Buffer");if(void 0===t&&(t=0),void 0===n&&(n=e?e.length:0),void 0===r&&(r=0),void 0===i&&(i=this.length),t<0||n>e.length||r<0||i>this.length)throw new RangeError("out of range index");if(r>=i&&t>=n)return 0;if(r>=i)return -1;if(t>=n)return 1;if(this===e)return 0;for(var o=(i>>>=0)-(r>>>=0),s=(n>>>=0)-(t>>>=0),a=Math.min(o,s),l=this.slice(r,i),u=e.slice(t,n),h=0;h<a;++h)if(l[h]!==u[h]){o=l[h],s=u[h];break}return o<s?-1:s<o?1:0},A.prototype.includes=function(e,t,n){return -1!==this.indexOf(e,t,n)},A.prototype.indexOf=function(e,t,n){return P(this,e,t,n,!0)},A.prototype.lastIndexOf=function(e,t,n){return P(this,e,t,n,!1)},A.prototype.write=function(e,t,n,r){if(void 0===t)r="utf8",n=this.length,t=0;else if(void 0===n&&"string"==typeof t)r=t,n=this.length,t=0;else {if(!isFinite(t))throw new Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");t|=0,isFinite(n)?(n|=0,void 0===r&&(r="utf8")):(r=n,n=void 0);}var i=this.length-t;if((void 0===n||n>i)&&(n=i),e.length>0&&(n<0||t<0)||t>this.length)throw new RangeError("Attempt to write outside buffer bounds");r||(r="utf8");for(var o=!1;;)switch(r){case"hex":return U(this,e,t,n);case"utf8":case"utf-8":return D(this,e,t,n);case"ascii":return j(this,e,t,n);case"latin1":case"binary":return N(this,e,t,n);case"base64":return Z(this,e,t,n);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return W(this,e,t,n);default:if(o)throw new TypeError("Unknown encoding: "+r);r=(""+r).toLowerCase(),o=!0;}},A.prototype.toJSON=function(){return {type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}};var V=4096;function H(e,t,n){var r="";n=Math.min(e.length,n);for(var i=t;i<n;++i)r+=String.fromCharCode(127&e[i]);return r}function G(e,t,n){var r="";n=Math.min(e.length,n);for(var i=t;i<n;++i)r+=String.fromCharCode(e[i]);return r}function K(e,t,n){var r=e.length;(!t||t<0)&&(t=0),(!n||n<0||n>r)&&(n=r);for(var i="",o=t;o<n;++o)i+=oe(e[o]);return i}function J(e,t,n){for(var r=e.slice(t,n),i="",o=0;o<r.length;o+=2)i+=String.fromCharCode(r[o]+256*r[o+1]);return i}function X(e,t,n){if(e%1!=0||e<0)throw new RangeError("offset is not uint");if(e+t>n)throw new RangeError("Trying to access beyond buffer length")}function $(e,t,n,r,i,o){if(!B(e))throw new TypeError('"buffer" argument must be a Buffer instance');if(t>i||t<o)throw new RangeError('"value" argument is out of bounds');if(n+r>e.length)throw new RangeError("Index out of range")}function Q(e,t,n,r){t<0&&(t=65535+t+1);for(var i=0,o=Math.min(e.length-n,2);i<o;++i)e[n+i]=(t&255<<8*(r?i:1-i))>>>8*(r?i:1-i);}function ee(e,t,n,r){t<0&&(t=4294967295+t+1);for(var i=0,o=Math.min(e.length-n,4);i<o;++i)e[n+i]=t>>>8*(r?i:3-i)&255;}function te(e,t,n,r,i,o){if(n+r>e.length)throw new RangeError("Index out of range");if(n<0)throw new RangeError("Index out of range")}function ne(e,t,n,r,i){return i||te(e,0,n,4),w(e,t,n,r,23,4),n+4}function re(e,t,n,r,i){return i||te(e,0,n,8),w(e,t,n,r,52,8),n+8}A.prototype.slice=function(e,t){var n,r=this.length;if((e=~~e)<0?(e+=r)<0&&(e=0):e>r&&(e=r),(t=void 0===t?r:~~t)<0?(t+=r)<0&&(t=0):t>r&&(t=r),t<e&&(t=e),A.TYPED_ARRAY_SUPPORT)(n=this.subarray(e,t)).__proto__=A.prototype;else {var i=t-e;n=new A(i,void 0);for(var o=0;o<i;++o)n[o]=this[o+e];}return n},A.prototype.readUIntLE=function(e,t,n){e|=0,t|=0,n||X(e,t,this.length);for(var r=this[e],i=1,o=0;++o<t&&(i*=256);)r+=this[e+o]*i;return r},A.prototype.readUIntBE=function(e,t,n){e|=0,t|=0,n||X(e,t,this.length);for(var r=this[e+--t],i=1;t>0&&(i*=256);)r+=this[e+--t]*i;return r},A.prototype.readUInt8=function(e,t){return t||X(e,1,this.length),this[e]},A.prototype.readUInt16LE=function(e,t){return t||X(e,2,this.length),this[e]|this[e+1]<<8},A.prototype.readUInt16BE=function(e,t){return t||X(e,2,this.length),this[e]<<8|this[e+1]},A.prototype.readUInt32LE=function(e,t){return t||X(e,4,this.length),(this[e]|this[e+1]<<8|this[e+2]<<16)+16777216*this[e+3]},A.prototype.readUInt32BE=function(e,t){return t||X(e,4,this.length),16777216*this[e]+(this[e+1]<<16|this[e+2]<<8|this[e+3])},A.prototype.readIntLE=function(e,t,n){e|=0,t|=0,n||X(e,t,this.length);for(var r=this[e],i=1,o=0;++o<t&&(i*=256);)r+=this[e+o]*i;return r>=(i*=128)&&(r-=Math.pow(2,8*t)),r},A.prototype.readIntBE=function(e,t,n){e|=0,t|=0,n||X(e,t,this.length);for(var r=t,i=1,o=this[e+--r];r>0&&(i*=256);)o+=this[e+--r]*i;return o>=(i*=128)&&(o-=Math.pow(2,8*t)),o},A.prototype.readInt8=function(e,t){return t||X(e,1,this.length),128&this[e]?-1*(255-this[e]+1):this[e]},A.prototype.readInt16LE=function(e,t){t||X(e,2,this.length);var n=this[e]|this[e+1]<<8;return 32768&n?4294901760|n:n},A.prototype.readInt16BE=function(e,t){t||X(e,2,this.length);var n=this[e+1]|this[e]<<8;return 32768&n?4294901760|n:n},A.prototype.readInt32LE=function(e,t){return t||X(e,4,this.length),this[e]|this[e+1]<<8|this[e+2]<<16|this[e+3]<<24},A.prototype.readInt32BE=function(e,t){return t||X(e,4,this.length),this[e]<<24|this[e+1]<<16|this[e+2]<<8|this[e+3]},A.prototype.readFloatLE=function(e,t){return t||X(e,4,this.length),b(this,e,!0,23,4)},A.prototype.readFloatBE=function(e,t){return t||X(e,4,this.length),b(this,e,!1,23,4)},A.prototype.readDoubleLE=function(e,t){return t||X(e,8,this.length),b(this,e,!0,52,8)},A.prototype.readDoubleBE=function(e,t){return t||X(e,8,this.length),b(this,e,!1,52,8)},A.prototype.writeUIntLE=function(e,t,n,r){(e=+e,t|=0,n|=0,r)||$(this,e,t,n,Math.pow(2,8*n)-1,0);var i=1,o=0;for(this[t]=255&e;++o<n&&(i*=256);)this[t+o]=e/i&255;return t+n},A.prototype.writeUIntBE=function(e,t,n,r){(e=+e,t|=0,n|=0,r)||$(this,e,t,n,Math.pow(2,8*n)-1,0);var i=n-1,o=1;for(this[t+i]=255&e;--i>=0&&(o*=256);)this[t+i]=e/o&255;return t+n},A.prototype.writeUInt8=function(e,t,n){return e=+e,t|=0,n||$(this,e,t,1,255,0),A.TYPED_ARRAY_SUPPORT||(e=Math.floor(e)),this[t]=255&e,t+1},A.prototype.writeUInt16LE=function(e,t,n){return e=+e,t|=0,n||$(this,e,t,2,65535,0),A.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8):Q(this,e,t,!0),t+2},A.prototype.writeUInt16BE=function(e,t,n){return e=+e,t|=0,n||$(this,e,t,2,65535,0),A.TYPED_ARRAY_SUPPORT?(this[t]=e>>>8,this[t+1]=255&e):Q(this,e,t,!1),t+2},A.prototype.writeUInt32LE=function(e,t,n){return e=+e,t|=0,n||$(this,e,t,4,4294967295,0),A.TYPED_ARRAY_SUPPORT?(this[t+3]=e>>>24,this[t+2]=e>>>16,this[t+1]=e>>>8,this[t]=255&e):ee(this,e,t,!0),t+4},A.prototype.writeUInt32BE=function(e,t,n){return e=+e,t|=0,n||$(this,e,t,4,4294967295,0),A.TYPED_ARRAY_SUPPORT?(this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e):ee(this,e,t,!1),t+4},A.prototype.writeIntLE=function(e,t,n,r){if(e=+e,t|=0,!r){var i=Math.pow(2,8*n-1);$(this,e,t,n,i-1,-i);}var o=0,s=1,a=0;for(this[t]=255&e;++o<n&&(s*=256);)e<0&&0===a&&0!==this[t+o-1]&&(a=1),this[t+o]=(e/s>>0)-a&255;return t+n},A.prototype.writeIntBE=function(e,t,n,r){if(e=+e,t|=0,!r){var i=Math.pow(2,8*n-1);$(this,e,t,n,i-1,-i);}var o=n-1,s=1,a=0;for(this[t+o]=255&e;--o>=0&&(s*=256);)e<0&&0===a&&0!==this[t+o+1]&&(a=1),this[t+o]=(e/s>>0)-a&255;return t+n},A.prototype.writeInt8=function(e,t,n){return e=+e,t|=0,n||$(this,e,t,1,127,-128),A.TYPED_ARRAY_SUPPORT||(e=Math.floor(e)),e<0&&(e=255+e+1),this[t]=255&e,t+1},A.prototype.writeInt16LE=function(e,t,n){return e=+e,t|=0,n||$(this,e,t,2,32767,-32768),A.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8):Q(this,e,t,!0),t+2},A.prototype.writeInt16BE=function(e,t,n){return e=+e,t|=0,n||$(this,e,t,2,32767,-32768),A.TYPED_ARRAY_SUPPORT?(this[t]=e>>>8,this[t+1]=255&e):Q(this,e,t,!1),t+2},A.prototype.writeInt32LE=function(e,t,n){return e=+e,t|=0,n||$(this,e,t,4,2147483647,-2147483648),A.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8,this[t+2]=e>>>16,this[t+3]=e>>>24):ee(this,e,t,!0),t+4},A.prototype.writeInt32BE=function(e,t,n){return e=+e,t|=0,n||$(this,e,t,4,2147483647,-2147483648),e<0&&(e=4294967295+e+1),A.TYPED_ARRAY_SUPPORT?(this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e):ee(this,e,t,!1),t+4},A.prototype.writeFloatLE=function(e,t,n){return ne(this,e,t,!0,n)},A.prototype.writeFloatBE=function(e,t,n){return ne(this,e,t,!1,n)},A.prototype.writeDoubleLE=function(e,t,n){return re(this,e,t,!0,n)},A.prototype.writeDoubleBE=function(e,t,n){return re(this,e,t,!1,n)},A.prototype.copy=function(e,t,n,r){if(n||(n=0),r||0===r||(r=this.length),t>=e.length&&(t=e.length),t||(t=0),r>0&&r<n&&(r=n),r===n)return 0;if(0===e.length||0===this.length)return 0;if(t<0)throw new RangeError("targetStart out of bounds");if(n<0||n>=this.length)throw new RangeError("sourceStart out of bounds");if(r<0)throw new RangeError("sourceEnd out of bounds");r>this.length&&(r=this.length),e.length-t<r-n&&(r=e.length-t+n);var i,o=r-n;if(this===e&&n<t&&t<r)for(i=o-1;i>=0;--i)e[i+t]=this[i+n];else if(o<1e3||!A.TYPED_ARRAY_SUPPORT)for(i=0;i<o;++i)e[i+t]=this[i+n];else Uint8Array.prototype.set.call(e,this.subarray(n,n+o),t);return o},A.prototype.fill=function(e,t,n,r){if("string"==typeof e){if("string"==typeof t?(r=t,t=0,n=this.length):"string"==typeof n&&(r=n,n=this.length),1===e.length){var i=e.charCodeAt(0);i<256&&(e=i);}if(void 0!==r&&"string"!=typeof r)throw new TypeError("encoding must be a string");if("string"==typeof r&&!A.isEncoding(r))throw new TypeError("Unknown encoding: "+r)}else "number"==typeof e&&(e&=255);if(t<0||this.length<t||this.length<n)throw new RangeError("Out of range index");if(n<=t)return this;var o;if(t>>>=0,n=void 0===n?this.length:n>>>0,e||(e=0),"number"==typeof e)for(o=t;o<n;++o)this[o]=e;else {var s=B(e)?e:se(new A(e,r).toString()),a=s.length;for(o=0;o<n-t;++o)this[o+t]=s[o%a];}return this};var ie=/[^+\/0-9A-Za-z-_]/g;function oe(e){return e<16?"0"+e.toString(16):e.toString(16)}function se(e,t){var n;t=t||1/0;for(var r=e.length,i=null,o=[],s=0;s<r;++s){if((n=e.charCodeAt(s))>55295&&n<57344){if(!i){if(n>56319){(t-=3)>-1&&o.push(239,191,189);continue}if(s+1===r){(t-=3)>-1&&o.push(239,191,189);continue}i=n;continue}if(n<56320){(t-=3)>-1&&o.push(239,191,189),i=n;continue}n=65536+(i-55296<<10|n-56320);}else i&&(t-=3)>-1&&o.push(239,191,189);if(i=null,n<128){if((t-=1)<0)break;o.push(n);}else if(n<2048){if((t-=2)<0)break;o.push(n>>6|192,63&n|128);}else if(n<65536){if((t-=3)<0)break;o.push(n>>12|224,n>>6&63|128,63&n|128);}else {if(!(n<1114112))throw new Error("Invalid code point");if((t-=4)<0)break;o.push(n>>18|240,n>>12&63|128,n>>6&63|128,63&n|128);}}return o}function ae(e){return function(e){var t,n,r,i,o,s;m||v();var a=e.length;if(a%4>0)throw new Error("Invalid string. Length must be a multiple of 4");o="="===e[a-2]?2:"="===e[a-1]?1:0,s=new g(3*a/4-o),r=o>0?a-4:a;var l=0;for(t=0,n=0;t<r;t+=4,n+=3)i=p[e.charCodeAt(t)]<<18|p[e.charCodeAt(t+1)]<<12|p[e.charCodeAt(t+2)]<<6|p[e.charCodeAt(t+3)],s[l++]=i>>16&255,s[l++]=i>>8&255,s[l++]=255&i;return 2===o?(i=p[e.charCodeAt(t)]<<2|p[e.charCodeAt(t+1)]>>4,s[l++]=255&i):1===o&&(i=p[e.charCodeAt(t)]<<10|p[e.charCodeAt(t+1)]<<4|p[e.charCodeAt(t+2)]>>2,s[l++]=i>>8&255,s[l++]=255&i),s}(function(e){if((e=function(e){return e.trim?e.trim():e.replace(/^\s+|\s+$/g,"")}(e).replace(ie,"")).length<2)return "";for(;e.length%4!=0;)e+="=";return e}(e))}function le(e,t,n,r){for(var i=0;i<r&&!(i+n>=t.length||i>=e.length);++i)t[i+n]=e[i];return i}function ue(e){return null!=e&&(!!e._isBuffer||he(e)||function(e){return "function"==typeof e.readFloatLE&&"function"==typeof e.slice&&he(e.slice(0,0))}(e))}function he(e){return !!e.constructor&&"function"==typeof e.constructor.isBuffer&&e.constructor.isBuffer(e)}var ce=Object.freeze({__proto__:null,INSPECT_MAX_BYTES:50,kMaxLength:x,Buffer:A,SlowBuffer:function(e){return +e!=e&&(e=0),A.alloc(+e)},isBuffer:ue});function fe(){}function de(){de.init.call(this);}function pe(e){return void 0===e._maxListeners?de.defaultMaxListeners:e._maxListeners}function ge(e,t,n,r){var i,o,s,a;if("function"!=typeof n)throw new TypeError('"listener" argument must be a function');if((o=e._events)?(o.newListener&&(e.emit("newListener",t,n.listener?n.listener:n),o=e._events),s=o[t]):(o=e._events=new fe,e._eventsCount=0),s){if("function"==typeof s?s=o[t]=r?[n,s]:[s,n]:r?s.unshift(n):s.push(n),!s.warned&&(i=pe(e))&&i>0&&s.length>i){s.warned=!0;var l=new Error("Possible EventEmitter memory leak detected. "+s.length+" "+t+" listeners added. Use emitter.setMaxListeners() to increase limit");l.name="MaxListenersExceededWarning",l.emitter=e,l.type=t,l.count=s.length,a=l,"function"==typeof console.warn?console.warn(a):console.log(a);}}else s=o[t]=n,++e._eventsCount;return e}function me(e,t,n){var r=!1;function i(){e.removeListener(t,i),r||(r=!0,n.apply(e,arguments));}return i.listener=n,i}function ve(e){var t=this._events;if(t){var n=t[e];if("function"==typeof n)return 1;if(n)return n.length}return 0}function _e(e,t){for(var n=new Array(t);t--;)n[t]=e[t];return n}function ye(){throw new Error("setTimeout has not been defined")}function be(){throw new Error("clearTimeout has not been defined")}fe.prototype=Object.create(null),de.EventEmitter=de,de.usingDomains=!1,de.prototype.domain=void 0,de.prototype._events=void 0,de.prototype._maxListeners=void 0,de.defaultMaxListeners=10,de.init=function(){this.domain=null,de.usingDomains&&(void 0).active,this._events&&this._events!==Object.getPrototypeOf(this)._events||(this._events=new fe,this._eventsCount=0),this._maxListeners=this._maxListeners||void 0;},de.prototype.setMaxListeners=function(e){if("number"!=typeof e||e<0||isNaN(e))throw new TypeError('"n" argument must be a positive number');return this._maxListeners=e,this},de.prototype.getMaxListeners=function(){return pe(this)},de.prototype.emit=function(e){var t,n,r,i,o,s,a,l="error"===e;if(s=this._events)l=l&&null==s.error;else if(!l)return !1;if(a=this.domain,l){if(t=arguments[1],!a){if(t instanceof Error)throw t;var u=new Error('Uncaught, unspecified "error" event. ('+t+")");throw u.context=t,u}return t||(t=new Error('Uncaught, unspecified "error" event')),t.domainEmitter=this,t.domain=a,t.domainThrown=!1,a.emit("error",t),!1}if(!(n=s[e]))return !1;var h="function"==typeof n;switch(r=arguments.length){case 1:!function(e,t,n){if(t)e.call(n);else for(var r=e.length,i=_e(e,r),o=0;o<r;++o)i[o].call(n);}(n,h,this);break;case 2:!function(e,t,n,r){if(t)e.call(n,r);else for(var i=e.length,o=_e(e,i),s=0;s<i;++s)o[s].call(n,r);}(n,h,this,arguments[1]);break;case 3:!function(e,t,n,r,i){if(t)e.call(n,r,i);else for(var o=e.length,s=_e(e,o),a=0;a<o;++a)s[a].call(n,r,i);}(n,h,this,arguments[1],arguments[2]);break;case 4:!function(e,t,n,r,i,o){if(t)e.call(n,r,i,o);else for(var s=e.length,a=_e(e,s),l=0;l<s;++l)a[l].call(n,r,i,o);}(n,h,this,arguments[1],arguments[2],arguments[3]);break;default:for(i=new Array(r-1),o=1;o<r;o++)i[o-1]=arguments[o];!function(e,t,n,r){if(t)e.apply(n,r);else for(var i=e.length,o=_e(e,i),s=0;s<i;++s)o[s].apply(n,r);}(n,h,this,i);}return !0},de.prototype.addListener=function(e,t){return ge(this,e,t,!1)},de.prototype.on=de.prototype.addListener,de.prototype.prependListener=function(e,t){return ge(this,e,t,!0)},de.prototype.once=function(e,t){if("function"!=typeof t)throw new TypeError('"listener" argument must be a function');return this.on(e,me(this,e,t)),this},de.prototype.prependOnceListener=function(e,t){if("function"!=typeof t)throw new TypeError('"listener" argument must be a function');return this.prependListener(e,me(this,e,t)),this},de.prototype.removeListener=function(e,t){var n,r,i,o,s;if("function"!=typeof t)throw new TypeError('"listener" argument must be a function');if(!(r=this._events))return this;if(!(n=r[e]))return this;if(n===t||n.listener&&n.listener===t)0==--this._eventsCount?this._events=new fe:(delete r[e],r.removeListener&&this.emit("removeListener",e,n.listener||t));else if("function"!=typeof n){for(i=-1,o=n.length;o-- >0;)if(n[o]===t||n[o].listener&&n[o].listener===t){s=n[o].listener,i=o;break}if(i<0)return this;if(1===n.length){if(n[0]=void 0,0==--this._eventsCount)return this._events=new fe,this;delete r[e];}else !function(e,t){for(var n=t,r=n+1,i=e.length;r<i;n+=1,r+=1)e[n]=e[r];e.pop();}(n,i);r.removeListener&&this.emit("removeListener",e,s||t);}return this},de.prototype.removeAllListeners=function(e){var t,n;if(!(n=this._events))return this;if(!n.removeListener)return 0===arguments.length?(this._events=new fe,this._eventsCount=0):n[e]&&(0==--this._eventsCount?this._events=new fe:delete n[e]),this;if(0===arguments.length){for(var r,i=Object.keys(n),o=0;o<i.length;++o)"removeListener"!==(r=i[o])&&this.removeAllListeners(r);return this.removeAllListeners("removeListener"),this._events=new fe,this._eventsCount=0,this}if("function"==typeof(t=n[e]))this.removeListener(e,t);else if(t)do{this.removeListener(e,t[t.length-1]);}while(t[0]);return this},de.prototype.listeners=function(e){var t,n=this._events;return n&&(t=n[e])?"function"==typeof t?[t.listener||t]:function(e){for(var t=new Array(e.length),n=0;n<t.length;++n)t[n]=e[n].listener||e[n];return t}(t):[]},de.listenerCount=function(e,t){return "function"==typeof e.listenerCount?e.listenerCount(t):ve.call(e,t)},de.prototype.listenerCount=ve,de.prototype.eventNames=function(){return this._eventsCount>0?Reflect.ownKeys(this._events):[]};var we=ye,ke=be;function Se(e){if(we===setTimeout)return setTimeout(e,0);if((we===ye||!we)&&setTimeout)return we=setTimeout,setTimeout(e,0);try{return we(e,0)}catch(t){try{return we.call(null,e,0)}catch(t){return we.call(this,e,0)}}}"function"==typeof f.setTimeout&&(we=setTimeout),"function"==typeof f.clearTimeout&&(ke=clearTimeout);var xe,Ce=[],Ee=!1,Ae=-1;function Te(){Ee&&xe&&(Ee=!1,xe.length?Ce=xe.concat(Ce):Ae=-1,Ce.length&&ze());}function ze(){if(!Ee){var e=Se(Te);Ee=!0;for(var t=Ce.length;t;){for(xe=Ce,Ce=[];++Ae<t;)xe&&xe[Ae].run();Ae=-1,t=Ce.length;}xe=null,Ee=!1,function(e){if(ke===clearTimeout)return clearTimeout(e);if((ke===be||!ke)&&clearTimeout)return ke=clearTimeout,clearTimeout(e);try{ke(e);}catch(t){try{return ke.call(null,e)}catch(t){return ke.call(this,e)}}}(e);}}function Oe(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];Ce.push(new Re(e,t)),1!==Ce.length||Ee||Se(ze);}function Re(e,t){this.fun=e,this.array=t;}Re.prototype.run=function(){this.fun.apply(null,this.array);};function Le(){}var Be=Le,Ie=Le,Fe=Le,Pe=Le,Me=Le,Ue=Le,De=Le;var je=f.performance||{},Ne=je.now||je.mozNow||je.msNow||je.oNow||je.webkitNow||function(){return (new Date).getTime()};var Ze=new Date;var We={nextTick:Oe,title:"browser",browser:!0,env:{},argv:[],version:"",versions:{},on:Be,addListener:Ie,once:Fe,off:Pe,removeListener:Me,removeAllListeners:Ue,emit:De,binding:function(e){throw new Error("process.binding is not supported")},cwd:function(){return "/"},chdir:function(e){throw new Error("process.chdir is not supported")},umask:function(){return 0},hrtime:function(e){var t=.001*Ne.call(je),n=Math.floor(t),r=Math.floor(t%1*1e9);return e&&(n-=e[0],(r-=e[1])<0&&(n--,r+=1e9)),[n,r]},platform:"browser",release:{},config:{},uptime:function(){return (new Date-Ze)/1e3}},qe=function(e){return e&&"object"==typeof e&&"function"==typeof e.copy&&"function"==typeof e.fill&&"function"==typeof e.readUInt8},Ye=e.createCommonjsModule(function(e){"function"==typeof Object.create?e.exports=function(e,t){e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}});}:e.exports=function(e,t){e.super_=t;var n=function(){};n.prototype=t.prototype,e.prototype=new n,e.prototype.constructor=e;};}),Ve=e.createCommonjsModule(function(e,t){var n=/%[sdj%]/g;t.format=function(e){if(!m(e)){for(var t=[],r=0;r<arguments.length;r++)t.push(o(arguments[r]));return t.join(" ")}r=1;for(var i=arguments,s=i.length,a=String(e).replace(n,function(e){if("%%"===e)return "%";if(r>=s)return e;switch(e){case"%s":return String(i[r++]);case"%d":return Number(i[r++]);case"%j":try{return JSON.stringify(i[r++])}catch(e){return "[Circular]"}default:return e}}),l=i[r];r<s;l=i[++r])p(l)||!y(l)?a+=" "+l:a+=" "+o(l);return a},t.deprecate=function(e,n){if(v(f.process))return function(){return t.deprecate(e,n).apply(this,arguments)};var r=!1;return function(){return r||(console.error(n),r=!0),e.apply(this,arguments)}};var r,i={};function o(e,n){var r={seen:[],stylize:a};return arguments.length>=3&&(r.depth=arguments[2]),arguments.length>=4&&(r.colors=arguments[3]),d(n)?r.showHidden=n:n&&t._extend(r,n),v(r.showHidden)&&(r.showHidden=!1),v(r.depth)&&(r.depth=2),v(r.colors)&&(r.colors=!1),v(r.customInspect)&&(r.customInspect=!0),r.colors&&(r.stylize=s),l(r,e,r.depth)}function s(e,t){var n=o.styles[t];return n?"["+o.colors[n][0]+"m"+e+"["+o.colors[n][1]+"m":e}function a(e,t){return e}function l(e,n,r){if(e.customInspect&&n&&k(n.inspect)&&n.inspect!==t.inspect&&(!n.constructor||n.constructor.prototype!==n)){var i=n.inspect(r,e);return m(i)||(i=l(e,i,r)),i}var o=function(e,t){if(v(t))return e.stylize("undefined","undefined");if(m(t)){var n="'"+JSON.stringify(t).replace(/^"|"$/g,"").replace(/'/g,"\\'").replace(/\\"/g,'"')+"'";return e.stylize(n,"string")}if(g(t))return e.stylize(""+t,"number");if(d(t))return e.stylize(""+t,"boolean");if(p(t))return e.stylize("null","null")}(e,n);if(o)return o;var s=Object.keys(n),a=function(e){var t={};return e.forEach(function(e,n){t[e]=!0;}),t}(s);if(e.showHidden&&(s=Object.getOwnPropertyNames(n)),w(n)&&(s.indexOf("message")>=0||s.indexOf("description")>=0))return u(n);if(0===s.length){if(k(n)){var f=n.name?": "+n.name:"";return e.stylize("[Function"+f+"]","special")}if(_(n))return e.stylize(RegExp.prototype.toString.call(n),"regexp");if(b(n))return e.stylize(Date.prototype.toString.call(n),"date");if(w(n))return u(n)}var y,S="",x=!1,C=["{","}"];(c(n)&&(x=!0,C=["[","]"]),k(n))&&(S=" [Function"+(n.name?": "+n.name:"")+"]");return _(n)&&(S=" "+RegExp.prototype.toString.call(n)),b(n)&&(S=" "+Date.prototype.toUTCString.call(n)),w(n)&&(S=" "+u(n)),0!==s.length||x&&0!=n.length?r<0?_(n)?e.stylize(RegExp.prototype.toString.call(n),"regexp"):e.stylize("[Object]","special"):(e.seen.push(n),y=x?function(e,t,n,r,i){for(var o=[],s=0,a=t.length;s<a;++s)E(t,String(s))?o.push(h(e,t,n,r,String(s),!0)):o.push("");return i.forEach(function(i){i.match(/^\d+$/)||o.push(h(e,t,n,r,i,!0));}),o}(e,n,r,a,s):s.map(function(t){return h(e,n,r,a,t,x)}),e.seen.pop(),function(e,t,n){if(e.reduce(function(e,t){return t.indexOf("\n"),e+t.replace(/\u001b\[\d\d?m/g,"").length+1},0)>60)return n[0]+(""===t?"":t+"\n ")+" "+e.join(",\n  ")+" "+n[1];return n[0]+t+" "+e.join(", ")+" "+n[1]}(y,S,C)):C[0]+S+C[1]}function u(e){return "["+Error.prototype.toString.call(e)+"]"}function h(e,t,n,r,i,o){var s,a,u;if((u=Object.getOwnPropertyDescriptor(t,i)||{value:t[i]}).get?a=u.set?e.stylize("[Getter/Setter]","special"):e.stylize("[Getter]","special"):u.set&&(a=e.stylize("[Setter]","special")),E(r,i)||(s="["+i+"]"),a||(e.seen.indexOf(u.value)<0?(a=p(n)?l(e,u.value,null):l(e,u.value,n-1)).indexOf("\n")>-1&&(a=o?a.split("\n").map(function(e){return "  "+e}).join("\n").substr(2):"\n"+a.split("\n").map(function(e){return "   "+e}).join("\n")):a=e.stylize("[Circular]","special")),v(s)){if(o&&i.match(/^\d+$/))return a;(s=JSON.stringify(""+i)).match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)?(s=s.substr(1,s.length-2),s=e.stylize(s,"name")):(s=s.replace(/'/g,"\\'").replace(/\\"/g,'"').replace(/(^"|"$)/g,"'"),s=e.stylize(s,"string"));}return s+": "+a}function c(e){return Array.isArray(e)}function d(e){return "boolean"==typeof e}function p(e){return null===e}function g(e){return "number"==typeof e}function m(e){return "string"==typeof e}function v(e){return void 0===e}function _(e){return y(e)&&"[object RegExp]"===S(e)}function y(e){return "object"==typeof e&&null!==e}function b(e){return y(e)&&"[object Date]"===S(e)}function w(e){return y(e)&&("[object Error]"===S(e)||e instanceof Error)}function k(e){return "function"==typeof e}function S(e){return Object.prototype.toString.call(e)}function x(e){return e<10?"0"+e.toString(10):e.toString(10)}t.debuglog=function(e){if(v(r)&&(r=""),e=e.toUpperCase(),!i[e])if(new RegExp("\\b"+e+"\\b","i").test(r)){var n=We.pid;i[e]=function(){var r=t.format.apply(t,arguments);console.error("%s %d: %s",e,n,r);};}else i[e]=function(){};return i[e]},t.inspect=o,o.colors={bold:[1,22],italic:[3,23],underline:[4,24],inverse:[7,27],white:[37,39],grey:[90,39],black:[30,39],blue:[34,39],cyan:[36,39],green:[32,39],magenta:[35,39],red:[31,39],yellow:[33,39]},o.styles={special:"cyan",number:"yellow",boolean:"yellow",undefined:"grey",null:"bold",string:"green",date:"magenta",regexp:"red"},t.isArray=c,t.isBoolean=d,t.isNull=p,t.isNullOrUndefined=function(e){return null==e},t.isNumber=g,t.isString=m,t.isSymbol=function(e){return "symbol"==typeof e},t.isUndefined=v,t.isRegExp=_,t.isObject=y,t.isDate=b,t.isError=w,t.isFunction=k,t.isPrimitive=function(e){return null===e||"boolean"==typeof e||"number"==typeof e||"string"==typeof e||"symbol"==typeof e||void 0===e},t.isBuffer=qe;var C=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];function E(e,t){return Object.prototype.hasOwnProperty.call(e,t)}t.log=function(){var e,n;console.log("%s - %s",(e=new Date,n=[x(e.getHours()),x(e.getMinutes()),x(e.getSeconds())].join(":"),[e.getDate(),C[e.getMonth()],n].join(" ")),t.format.apply(t,arguments));},t.inherits=Ye,t._extend=function(e,t){if(!t||!y(t))return e;for(var n=Object.keys(t),r=n.length;r--;)e[n[r]]=t[n[r]];return e};}),He=(Ve.format,Ve.deprecate),Ge=Ve.debuglog,Ke=(Ve.inspect,Ve.isArray,Ve.isBoolean,Ve.isNull,Ve.isNullOrUndefined,Ve.isNumber,Ve.isString,Ve.isSymbol,Ve.isUndefined,Ve.isRegExp,Ve.isObject,Ve.isDate,Ve.isError,Ve.isFunction,Ve.isPrimitive,Ve.isBuffer,Ve.log,Ve.inherits);Ve._extend;function Je(){this.head=null,this.tail=null,this.length=0;}Je.prototype.push=function(e){var t={data:e,next:null};this.length>0?this.tail.next=t:this.head=t,this.tail=t,++this.length;},Je.prototype.unshift=function(e){var t={data:e,next:this.head};0===this.length&&(this.tail=t),this.head=t,++this.length;},Je.prototype.shift=function(){if(0!==this.length){var e=this.head.data;return 1===this.length?this.head=this.tail=null:this.head=this.head.next,--this.length,e}},Je.prototype.clear=function(){this.head=this.tail=null,this.length=0;},Je.prototype.join=function(e){if(0===this.length)return "";for(var t=this.head,n=""+t.data;t=t.next;)n+=e+t.data;return n},Je.prototype.concat=function(e){if(0===this.length)return A.alloc(0);if(1===this.length)return this.head.data;for(var t=A.allocUnsafe(e>>>0),n=this.head,r=0;n;)n.data.copy(t,r),r+=n.data.length,n=n.next;return t};var Xe=e.createCommonjsModule(function(e,t){var n=ce.Buffer;function r(e,t){for(var n in e)t[n]=e[n];}function i(e,t,r){return n(e,t,r)}n.from&&n.alloc&&n.allocUnsafe&&n.allocUnsafeSlow?e.exports=ce:(r(ce,t),t.Buffer=i),r(n,i),i.from=function(e,t,r){if("number"==typeof e)throw new TypeError("Argument must not be a number");return n(e,t,r)},i.alloc=function(e,t,r){if("number"!=typeof e)throw new TypeError("Argument must be a number");var i=n(e);return void 0!==t?"string"==typeof r?i.fill(t,r):i.fill(t):i.fill(0),i},i.allocUnsafe=function(e){if("number"!=typeof e)throw new TypeError("Argument must be a number");return n(e)},i.allocUnsafeSlow=function(e){if("number"!=typeof e)throw new TypeError("Argument must be a number");return ce.SlowBuffer(e)};}),$e=(Xe.Buffer,Xe.Buffer),Qe=$e.isEncoding||function(e){switch((e=""+e)&&e.toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":case"raw":return !0;default:return !1}};var et=tt;function tt(e){var t;switch(this.encoding=function(e){var t=function(e){if(!e)return "utf8";for(var t;;)switch(e){case"utf8":case"utf-8":return "utf8";case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return "utf16le";case"latin1":case"binary":return "latin1";case"base64":case"ascii":case"hex":return e;default:if(t)return;e=(""+e).toLowerCase(),t=!0;}}(e);if("string"!=typeof t&&($e.isEncoding===Qe||!Qe(e)))throw new Error("Unknown encoding: "+e);return t||e}(e),this.encoding){case"utf16le":this.text=it,this.end=ot,t=4;break;case"utf8":this.fillLast=rt,t=4;break;case"base64":this.text=st,this.end=at,t=3;break;default:return this.write=lt,void(this.end=ut)}this.lastNeed=0,this.lastTotal=0,this.lastChar=$e.allocUnsafe(t);}function nt(e){return e<=127?0:e>>5==6?2:e>>4==14?3:e>>3==30?4:-1}function rt(e){var t=this.lastTotal-this.lastNeed,n=function(e,t,n){if(128!=(192&t[0]))return e.lastNeed=0,"�".repeat(n);if(e.lastNeed>1&&t.length>1){if(128!=(192&t[1]))return e.lastNeed=1,"�".repeat(n+1);if(e.lastNeed>2&&t.length>2&&128!=(192&t[2]))return e.lastNeed=2,"�".repeat(n+2)}}(this,e,t);return void 0!==n?n:this.lastNeed<=e.length?(e.copy(this.lastChar,t,0,this.lastNeed),this.lastChar.toString(this.encoding,0,this.lastTotal)):(e.copy(this.lastChar,t,0,e.length),void(this.lastNeed-=e.length))}function it(e,t){if((e.length-t)%2==0){var n=e.toString("utf16le",t);if(n){var r=n.charCodeAt(n.length-1);if(r>=55296&&r<=56319)return this.lastNeed=2,this.lastTotal=4,this.lastChar[0]=e[e.length-2],this.lastChar[1]=e[e.length-1],n.slice(0,-1)}return n}return this.lastNeed=1,this.lastTotal=2,this.lastChar[0]=e[e.length-1],e.toString("utf16le",t,e.length-1)}function ot(e){var t=e&&e.length?this.write(e):"";if(this.lastNeed){var n=this.lastTotal-this.lastNeed;return t+this.lastChar.toString("utf16le",0,n)}return t}function st(e,t){var n=(e.length-t)%3;return 0===n?e.toString("base64",t):(this.lastNeed=3-n,this.lastTotal=3,1===n?this.lastChar[0]=e[e.length-1]:(this.lastChar[0]=e[e.length-2],this.lastChar[1]=e[e.length-1]),e.toString("base64",t,e.length-n))}function at(e){var t=e&&e.length?this.write(e):"";return this.lastNeed?t+this.lastChar.toString("base64",0,3-this.lastNeed):t}function lt(e){return e.toString(this.encoding)}function ut(e){return e&&e.length?this.write(e):""}tt.prototype.write=function(e){if(0===e.length)return "";var t,n;if(this.lastNeed){if(void 0===(t=this.fillLast(e)))return "";n=this.lastNeed,this.lastNeed=0;}else n=0;return n<e.length?t?t+this.text(e,n):this.text(e,n):t||""},tt.prototype.end=function(e){var t=e&&e.length?this.write(e):"";return this.lastNeed?t+"�".repeat(this.lastTotal-this.lastNeed):t},tt.prototype.text=function(e,t){var n=function(e,t,n){var r=t.length-1;if(r<n)return 0;var i=nt(t[r]);if(i>=0)return i>0&&(e.lastNeed=i-1),i;if(--r<n)return 0;if((i=nt(t[r]))>=0)return i>0&&(e.lastNeed=i-2),i;if(--r<n)return 0;if((i=nt(t[r]))>=0)return i>0&&(2===i?i=0:e.lastNeed=i-3),i;return 0}(this,e,t);if(!this.lastNeed)return e.toString("utf8",t);this.lastTotal=n;var r=e.length-(n-this.lastNeed);return e.copy(this.lastChar,0,r),e.toString("utf8",t,r)},tt.prototype.fillLast=function(e){if(this.lastNeed<=e.length)return e.copy(this.lastChar,this.lastTotal-this.lastNeed,0,this.lastNeed),this.lastChar.toString(this.encoding,0,this.lastTotal);e.copy(this.lastChar,this.lastTotal-this.lastNeed,0,e.length),this.lastNeed-=e.length;},ft.ReadableState=ct;var ht=Ge("stream");function ct(e,t){e=e||{},this.objectMode=!!e.objectMode,t instanceof jt&&(this.objectMode=this.objectMode||!!e.readableObjectMode);var n=e.highWaterMark,r=this.objectMode?16:16384;this.highWaterMark=n||0===n?n:r,this.highWaterMark=~~this.highWaterMark,this.buffer=new Je,this.length=0,this.pipes=null,this.pipesCount=0,this.flowing=null,this.ended=!1,this.endEmitted=!1,this.reading=!1,this.sync=!0,this.needReadable=!1,this.emittedReadable=!1,this.readableListening=!1,this.resumeScheduled=!1,this.defaultEncoding=e.defaultEncoding||"utf8",this.ranOut=!1,this.awaitDrain=0,this.readingMore=!1,this.decoder=null,this.encoding=null,e.encoding&&(this.decoder=new et(e.encoding),this.encoding=e.encoding);}function ft(e){if(!(this instanceof ft))return new ft(e);this._readableState=new ct(e,this),this.readable=!0,e&&"function"==typeof e.read&&(this._read=e.read),de.call(this);}function dt(e,t,n,r,i){var o=function(e,t){var n=null;ue(t)||"string"==typeof t||null==t||e.objectMode||(n=new TypeError("Invalid non-string/buffer chunk"));return n}(t,n);if(o)e.emit("error",o);else if(null===n)t.reading=!1,function(e,t){if(t.ended)return;if(t.decoder){var n=t.decoder.end();n&&n.length&&(t.buffer.push(n),t.length+=t.objectMode?1:n.length);}t.ended=!0,mt(e);}(e,t);else if(t.objectMode||n&&n.length>0)if(t.ended&&!i){var s=new Error("stream.push() after EOF");e.emit("error",s);}else if(t.endEmitted&&i){var a=new Error("stream.unshift() after end event");e.emit("error",a);}else {var l;!t.decoder||i||r||(n=t.decoder.write(n),l=!t.objectMode&&0===n.length),i||(t.reading=!1),l||(t.flowing&&0===t.length&&!t.sync?(e.emit("data",n),e.read(0)):(t.length+=t.objectMode?1:n.length,i?t.buffer.unshift(n):t.buffer.push(n),t.needReadable&&mt(e))),function(e,t){t.readingMore||(t.readingMore=!0,Oe(_t,e,t));}(e,t);}else i||(t.reading=!1);return function(e){return !e.ended&&(e.needReadable||e.length<e.highWaterMark||0===e.length)}(t)}Ke(ft,de),ft.prototype.push=function(e,t){var n=this._readableState;return n.objectMode||"string"!=typeof e||(t=t||n.defaultEncoding)!==n.encoding&&(e=A.from(e,t),t=""),dt(this,n,e,t,!1)},ft.prototype.unshift=function(e){return dt(this,this._readableState,e,"",!0)},ft.prototype.isPaused=function(){return !1===this._readableState.flowing},ft.prototype.setEncoding=function(e){return this._readableState.decoder=new et(e),this._readableState.encoding=e,this};var pt=8388608;function gt(e,t){return e<=0||0===t.length&&t.ended?0:t.objectMode?1:e!=e?t.flowing&&t.length?t.buffer.head.data.length:t.length:(e>t.highWaterMark&&(t.highWaterMark=function(e){return e>=pt?e=pt:(e--,e|=e>>>1,e|=e>>>2,e|=e>>>4,e|=e>>>8,e|=e>>>16,e++),e}(e)),e<=t.length?e:t.ended?t.length:(t.needReadable=!0,0))}function mt(e){var t=e._readableState;t.needReadable=!1,t.emittedReadable||(ht("emitReadable",t.flowing),t.emittedReadable=!0,t.sync?Oe(vt,e):vt(e));}function vt(e){ht("emit readable"),e.emit("readable"),wt(e);}function _t(e,t){for(var n=t.length;!t.reading&&!t.flowing&&!t.ended&&t.length<t.highWaterMark&&(ht("maybeReadMore read 0"),e.read(0),n!==t.length);)n=t.length;t.readingMore=!1;}function yt(e){ht("readable nexttick read 0"),e.read(0);}function bt(e,t){t.reading||(ht("resume read 0"),e.read(0)),t.resumeScheduled=!1,t.awaitDrain=0,e.emit("resume"),wt(e),t.flowing&&!t.reading&&e.read(0);}function wt(e){var t=e._readableState;for(ht("flow",t.flowing);t.flowing&&null!==e.read(););}function kt(e,t){return 0===t.length?null:(t.objectMode?n=t.buffer.shift():!e||e>=t.length?(n=t.decoder?t.buffer.join(""):1===t.buffer.length?t.buffer.head.data:t.buffer.concat(t.length),t.buffer.clear()):n=function(e,t,n){var r;e<t.head.data.length?(r=t.head.data.slice(0,e),t.head.data=t.head.data.slice(e)):r=e===t.head.data.length?t.shift():n?function(e,t){var n=t.head,r=1,i=n.data;e-=i.length;for(;n=n.next;){var o=n.data,s=e>o.length?o.length:e;if(s===o.length?i+=o:i+=o.slice(0,e),0===(e-=s)){s===o.length?(++r,n.next?t.head=n.next:t.head=t.tail=null):(t.head=n,n.data=o.slice(s));break}++r;}return t.length-=r,i}(e,t):function(e,t){var n=A.allocUnsafe(e),r=t.head,i=1;r.data.copy(n),e-=r.data.length;for(;r=r.next;){var o=r.data,s=e>o.length?o.length:e;if(o.copy(n,n.length-e,0,s),0===(e-=s)){s===o.length?(++i,r.next?t.head=r.next:t.head=t.tail=null):(t.head=r,r.data=o.slice(s));break}++i;}return t.length-=i,n}(e,t);return r}(e,t.buffer,t.decoder),n);var n;}function St(e){var t=e._readableState;if(t.length>0)throw new Error('"endReadable()" called on non-empty stream');t.endEmitted||(t.ended=!0,Oe(xt,t,e));}function xt(e,t){e.endEmitted||0!==e.length||(e.endEmitted=!0,t.readable=!1,t.emit("end"));}function Ct(e,t){for(var n=0,r=e.length;n<r;n++)if(e[n]===t)return n;return -1}function Et(){}function At(e,t,n){this.chunk=e,this.encoding=t,this.callback=n,this.next=null;}function Tt(e,t){Object.defineProperty(this,"buffer",{get:He(function(){return this.getBuffer()},"_writableState.buffer is deprecated. Use _writableState.getBuffer instead.")}),e=e||{},this.objectMode=!!e.objectMode,t instanceof jt&&(this.objectMode=this.objectMode||!!e.writableObjectMode);var n=e.highWaterMark,r=this.objectMode?16:16384;this.highWaterMark=n||0===n?n:r,this.highWaterMark=~~this.highWaterMark,this.needDrain=!1,this.ending=!1,this.ended=!1,this.finished=!1;var i=!1===e.decodeStrings;this.decodeStrings=!i,this.defaultEncoding=e.defaultEncoding||"utf8",this.length=0,this.writing=!1,this.corked=0,this.sync=!0,this.bufferProcessing=!1,this.onwrite=function(e){!function(e,t){var n=e._writableState,r=n.sync,i=n.writecb;if(function(e){e.writing=!1,e.writecb=null,e.length-=e.writelen,e.writelen=0;}(n),t)!function(e,t,n,r,i){--t.pendingcb,n?Oe(i,r):i(r);e._writableState.errorEmitted=!0,e.emit("error",r);}(e,n,r,t,i);else {var o=Bt(n);o||n.corked||n.bufferProcessing||!n.bufferedRequest||Lt(e,n),r?Oe(Rt,e,n,o,i):Rt(e,n,o,i);}}(t,e);},this.writecb=null,this.writelen=0,this.bufferedRequest=null,this.lastBufferedRequest=null,this.pendingcb=0,this.prefinished=!1,this.errorEmitted=!1,this.bufferedRequestCount=0,this.corkedRequestsFree=new Pt(this);}function zt(e){if(!(this instanceof zt||this instanceof jt))return new zt(e);this._writableState=new Tt(e,this),this.writable=!0,e&&("function"==typeof e.write&&(this._write=e.write),"function"==typeof e.writev&&(this._writev=e.writev)),de.call(this);}function Ot(e,t,n,r,i,o,s){t.writelen=r,t.writecb=s,t.writing=!0,t.sync=!0,n?e._writev(i,t.onwrite):e._write(i,o,t.onwrite),t.sync=!1;}function Rt(e,t,n,r){n||function(e,t){0===t.length&&t.needDrain&&(t.needDrain=!1,e.emit("drain"));}(e,t),t.pendingcb--,r(),Ft(e,t);}function Lt(e,t){t.bufferProcessing=!0;var n=t.bufferedRequest;if(e._writev&&n&&n.next){var r=t.bufferedRequestCount,i=new Array(r),o=t.corkedRequestsFree;o.entry=n;for(var s=0;n;)i[s]=n,n=n.next,s+=1;Ot(e,t,!0,t.length,i,"",o.finish),t.pendingcb++,t.lastBufferedRequest=null,o.next?(t.corkedRequestsFree=o.next,o.next=null):t.corkedRequestsFree=new Pt(t);}else {for(;n;){var a=n.chunk,l=n.encoding,u=n.callback;if(Ot(e,t,!1,t.objectMode?1:a.length,a,l,u),n=n.next,t.writing)break}null===n&&(t.lastBufferedRequest=null);}t.bufferedRequestCount=0,t.bufferedRequest=n,t.bufferProcessing=!1;}function Bt(e){return e.ending&&0===e.length&&null===e.bufferedRequest&&!e.finished&&!e.writing}function It(e,t){t.prefinished||(t.prefinished=!0,e.emit("prefinish"));}function Ft(e,t){var n=Bt(t);return n&&(0===t.pendingcb?(It(e,t),t.finished=!0,e.emit("finish")):It(e,t)),n}function Pt(e){var t=this;this.next=null,this.entry=null,this.finish=function(n){var r=t.entry;for(t.entry=null;r;){var i=r.callback;e.pendingcb--,i(n),r=r.next;}e.corkedRequestsFree?e.corkedRequestsFree.next=t:e.corkedRequestsFree=t;};}ft.prototype.read=function(e){ht("read",e),e=parseInt(e,10);var t=this._readableState,n=e;if(0!==e&&(t.emittedReadable=!1),0===e&&t.needReadable&&(t.length>=t.highWaterMark||t.ended))return ht("read: emitReadable",t.length,t.ended),0===t.length&&t.ended?St(this):mt(this),null;if(0===(e=gt(e,t))&&t.ended)return 0===t.length&&St(this),null;var r,i=t.needReadable;return ht("need readable",i),(0===t.length||t.length-e<t.highWaterMark)&&ht("length less than watermark",i=!0),t.ended||t.reading?ht("reading or ended",i=!1):i&&(ht("do read"),t.reading=!0,t.sync=!0,0===t.length&&(t.needReadable=!0),this._read(t.highWaterMark),t.sync=!1,t.reading||(e=gt(n,t))),null===(r=e>0?kt(e,t):null)?(t.needReadable=!0,e=0):t.length-=e,0===t.length&&(t.ended||(t.needReadable=!0),n!==e&&t.ended&&St(this)),null!==r&&this.emit("data",r),r},ft.prototype._read=function(e){this.emit("error",new Error("not implemented"));},ft.prototype.pipe=function(e,t){var n=this,r=this._readableState;switch(r.pipesCount){case 0:r.pipes=e;break;case 1:r.pipes=[r.pipes,e];break;default:r.pipes.push(e);}r.pipesCount+=1,ht("pipe count=%d opts=%j",r.pipesCount,t);var i=!t||!1!==t.end?s:u;function o(e){ht("onunpipe"),e===n&&u();}function s(){ht("onend"),e.end();}r.endEmitted?Oe(i):n.once("end",i),e.on("unpipe",o);var a=function(e){return function(){var t=e._readableState;ht("pipeOnDrain",t.awaitDrain),t.awaitDrain&&t.awaitDrain--,0===t.awaitDrain&&e.listeners("data").length&&(t.flowing=!0,wt(e));}}(n);e.on("drain",a);var l=!1;function u(){ht("cleanup"),e.removeListener("close",d),e.removeListener("finish",p),e.removeListener("drain",a),e.removeListener("error",f),e.removeListener("unpipe",o),n.removeListener("end",s),n.removeListener("end",u),n.removeListener("data",c),l=!0,!r.awaitDrain||e._writableState&&!e._writableState.needDrain||a();}var h=!1;function c(t){ht("ondata"),h=!1,!1!==e.write(t)||h||((1===r.pipesCount&&r.pipes===e||r.pipesCount>1&&-1!==Ct(r.pipes,e))&&!l&&(ht("false write response, pause",n._readableState.awaitDrain),n._readableState.awaitDrain++,h=!0),n.pause());}function f(t){var n;ht("onerror",t),g(),e.removeListener("error",f),0===(n="error",e.listeners(n).length)&&e.emit("error",t);}function d(){e.removeListener("finish",p),g();}function p(){ht("onfinish"),e.removeListener("close",d),g();}function g(){ht("unpipe"),n.unpipe(e);}return n.on("data",c),function(e,t,n){if("function"==typeof e.prependListener)return e.prependListener(t,n);e._events&&e._events[t]?Array.isArray(e._events[t])?e._events[t].unshift(n):e._events[t]=[n,e._events[t]]:e.on(t,n);}(e,"error",f),e.once("close",d),e.once("finish",p),e.emit("pipe",n),r.flowing||(ht("pipe resume"),n.resume()),e},ft.prototype.unpipe=function(e){var t=this._readableState;if(0===t.pipesCount)return this;if(1===t.pipesCount)return e&&e!==t.pipes?this:(e||(e=t.pipes),t.pipes=null,t.pipesCount=0,t.flowing=!1,e&&e.emit("unpipe",this),this);if(!e){var n=t.pipes,r=t.pipesCount;t.pipes=null,t.pipesCount=0,t.flowing=!1;for(var i=0;i<r;i++)n[i].emit("unpipe",this);return this}var o=Ct(t.pipes,e);return -1===o?this:(t.pipes.splice(o,1),t.pipesCount-=1,1===t.pipesCount&&(t.pipes=t.pipes[0]),e.emit("unpipe",this),this)},ft.prototype.on=function(e,t){var n=de.prototype.on.call(this,e,t);if("data"===e)!1!==this._readableState.flowing&&this.resume();else if("readable"===e){var r=this._readableState;r.endEmitted||r.readableListening||(r.readableListening=r.needReadable=!0,r.emittedReadable=!1,r.reading?r.length&&mt(this):Oe(yt,this));}return n},ft.prototype.addListener=ft.prototype.on,ft.prototype.resume=function(){var e=this._readableState;return e.flowing||(ht("resume"),e.flowing=!0,function(e,t){t.resumeScheduled||(t.resumeScheduled=!0,Oe(bt,e,t));}(this,e)),this},ft.prototype.pause=function(){return ht("call pause flowing=%j",this._readableState.flowing),!1!==this._readableState.flowing&&(ht("pause"),this._readableState.flowing=!1,this.emit("pause")),this},ft.prototype.wrap=function(e){var t=this._readableState,n=!1,r=this;for(var i in e.on("end",function(){if(ht("wrapped end"),t.decoder&&!t.ended){var e=t.decoder.end();e&&e.length&&r.push(e);}r.push(null);}),e.on("data",function(i){(ht("wrapped data"),t.decoder&&(i=t.decoder.write(i)),t.objectMode&&null==i)||(t.objectMode||i&&i.length)&&(r.push(i)||(n=!0,e.pause()));}),e)void 0===this[i]&&"function"==typeof e[i]&&(this[i]=function(t){return function(){return e[t].apply(e,arguments)}}(i));return function(e,t){for(var n=0,r=e.length;n<r;n++)t(e[n],n);}(["error","close","destroy","pause","resume"],function(t){e.on(t,r.emit.bind(r,t));}),r._read=function(t){ht("wrapped _read",t),n&&(n=!1,e.resume());},r},ft._fromList=kt,zt.WritableState=Tt,Ke(zt,de),Tt.prototype.getBuffer=function(){for(var e=this.bufferedRequest,t=[];e;)t.push(e),e=e.next;return t},zt.prototype.pipe=function(){this.emit("error",new Error("Cannot pipe, not readable"));},zt.prototype.write=function(e,t,n){var r=this._writableState,i=!1;return "function"==typeof t&&(n=t,t=null),A.isBuffer(e)?t="buffer":t||(t=r.defaultEncoding),"function"!=typeof n&&(n=Et),r.ended?function(e,t){var n=new Error("write after end");e.emit("error",n),Oe(t,n);}(this,n):function(e,t,n,r){var i=!0,o=!1;return null===n?o=new TypeError("May not write null values to stream"):A.isBuffer(n)||"string"==typeof n||void 0===n||t.objectMode||(o=new TypeError("Invalid non-string/buffer chunk")),o&&(e.emit("error",o),Oe(r,o),i=!1),i}(this,r,e,n)&&(r.pendingcb++,i=function(e,t,n,r,i){n=function(e,t,n){return e.objectMode||!1===e.decodeStrings||"string"!=typeof t||(t=A.from(t,n)),t}(t,n,r),A.isBuffer(n)&&(r="buffer");var o=t.objectMode?1:n.length;t.length+=o;var s=t.length<t.highWaterMark;s||(t.needDrain=!0);if(t.writing||t.corked){var a=t.lastBufferedRequest;t.lastBufferedRequest=new At(n,r,i),a?a.next=t.lastBufferedRequest:t.bufferedRequest=t.lastBufferedRequest,t.bufferedRequestCount+=1;}else Ot(e,t,!1,o,n,r,i);return s}(this,r,e,t,n)),i},zt.prototype.cork=function(){this._writableState.corked++;},zt.prototype.uncork=function(){var e=this._writableState;e.corked&&(e.corked--,e.writing||e.corked||e.finished||e.bufferProcessing||!e.bufferedRequest||Lt(this,e));},zt.prototype.setDefaultEncoding=function(e){if("string"==typeof e&&(e=e.toLowerCase()),!(["hex","utf8","utf-8","ascii","binary","base64","ucs2","ucs-2","utf16le","utf-16le","raw"].indexOf((e+"").toLowerCase())>-1))throw new TypeError("Unknown encoding: "+e);return this._writableState.defaultEncoding=e,this},zt.prototype._write=function(e,t,n){n(new Error("not implemented"));},zt.prototype._writev=null,zt.prototype.end=function(e,t,n){var r=this._writableState;"function"==typeof e?(n=e,e=null,t=null):"function"==typeof t&&(n=t,t=null),null!=e&&this.write(e,t),r.corked&&(r.corked=1,this.uncork()),r.ending||r.finished||function(e,t,n){t.ending=!0,Ft(e,t),n&&(t.finished?Oe(n):e.once("finish",n));t.ended=!0,e.writable=!1;}(this,r,n);},Ke(jt,ft);for(var Mt=Object.keys(zt.prototype),Ut=0;Ut<Mt.length;Ut++){var Dt=Mt[Ut];jt.prototype[Dt]||(jt.prototype[Dt]=zt.prototype[Dt]);}function jt(e){if(!(this instanceof jt))return new jt(e);ft.call(this,e),zt.call(this,e),e&&!1===e.readable&&(this.readable=!1),e&&!1===e.writable&&(this.writable=!1),this.allowHalfOpen=!0,e&&!1===e.allowHalfOpen&&(this.allowHalfOpen=!1),this.once("end",Nt);}function Nt(){this.allowHalfOpen||this._writableState.ended||Oe(Zt,this);}function Zt(e){e.end();}function Wt(e){this.afterTransform=function(t,n){return function(e,t,n){var r=e._transformState;r.transforming=!1;var i=r.writecb;if(!i)return e.emit("error",new Error("no writecb in Transform class"));r.writechunk=null,r.writecb=null,null!=n&&e.push(n);i(t);var o=e._readableState;o.reading=!1,(o.needReadable||o.length<o.highWaterMark)&&e._read(o.highWaterMark);}(e,t,n)},this.needTransform=!1,this.transforming=!1,this.writecb=null,this.writechunk=null,this.writeencoding=null;}function qt(e){if(!(this instanceof qt))return new qt(e);jt.call(this,e),this._transformState=new Wt(this);var t=this;this._readableState.needReadable=!0,this._readableState.sync=!1,e&&("function"==typeof e.transform&&(this._transform=e.transform),"function"==typeof e.flush&&(this._flush=e.flush)),this.once("prefinish",function(){"function"==typeof this._flush?this._flush(function(e){Yt(t,e);}):Yt(t);});}function Yt(e,t){if(t)return e.emit("error",t);var n=e._writableState,r=e._transformState;if(n.length)throw new Error("Calling transform done when ws.length != 0");if(r.transforming)throw new Error("Calling transform done when still transforming");return e.push(null)}function Vt(e){if(!(this instanceof Vt))return new Vt(e);qt.call(this,e);}function Ht(){de.call(this);}Ke(qt,jt),qt.prototype.push=function(e,t){return this._transformState.needTransform=!1,jt.prototype.push.call(this,e,t)},qt.prototype._transform=function(e,t,n){throw new Error("Not implemented")},qt.prototype._write=function(e,t,n){var r=this._transformState;if(r.writecb=n,r.writechunk=e,r.writeencoding=t,!r.transforming){var i=this._readableState;(r.needTransform||i.needReadable||i.length<i.highWaterMark)&&this._read(i.highWaterMark);}},qt.prototype._read=function(e){var t=this._transformState;null!==t.writechunk&&t.writecb&&!t.transforming?(t.transforming=!0,this._transform(t.writechunk,t.writeencoding,t.afterTransform)):t.needTransform=!0;},Ke(Vt,qt),Vt.prototype._transform=function(e,t,n){n(null,e);},Ke(Ht,de),Ht.Readable=ft,Ht.Writable=zt,Ht.Duplex=jt,Ht.Transform=qt,Ht.PassThrough=Vt,Ht.Stream=Ht,Ht.prototype.pipe=function(e,t){var n=this;function r(t){e.writable&&!1===e.write(t)&&n.pause&&n.pause();}function i(){n.readable&&n.resume&&n.resume();}n.on("data",r),e.on("drain",i),e._isStdio||t&&!1===t.end||(n.on("end",s),n.on("close",a));var o=!1;function s(){o||(o=!0,e.end());}function a(){o||(o=!0,"function"==typeof e.destroy&&e.destroy());}function l(e){if(u(),0===de.listenerCount(this,"error"))throw e}function u(){n.removeListener("data",r),e.removeListener("drain",i),n.removeListener("end",s),n.removeListener("close",a),n.removeListener("error",l),e.removeListener("error",l),n.removeListener("end",u),n.removeListener("close",u),e.removeListener("close",u);}return n.on("error",l),e.on("error",l),n.on("end",u),n.on("close",u),e.on("close",u),e.emit("pipe",n),e};var Gt=Ht,Kt=e.createCommonjsModule(function(e,t){if(t.base64=!0,t.array=!0,t.string=!0,t.arraybuffer="undefined"!=typeof ArrayBuffer&&"undefined"!=typeof Uint8Array,t.nodebuffer=!0,t.uint8array="undefined"!=typeof Uint8Array,"undefined"==typeof ArrayBuffer)t.blob=!1;else {var n=new ArrayBuffer(0);try{t.blob=0===new Blob([n],{type:"application/zip"}).size;}catch(e){try{var r=new(self.BlobBuilder||self.WebKitBlobBuilder||self.MozBlobBuilder||self.MSBlobBuilder);r.append(n),t.blob=0===r.getBlob("application/zip").size;}catch(e){t.blob=!1;}}}try{t.nodestream=!!Gt.Readable;}catch(e){t.nodestream=!1;}}),Jt=(Kt.base64,Kt.array,Kt.string,Kt.arraybuffer,Kt.nodebuffer,Kt.uint8array,Kt.blob,Kt.nodestream,"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="),Xt={encode:function(e){for(var t,n,r,i,o,s,a,l=[],u=0,h=e.length,c=h,f="string"!==or.getTypeOf(e);u<e.length;)c=h-u,f?(t=e[u++],n=u<h?e[u++]:0,r=u<h?e[u++]:0):(t=e.charCodeAt(u++),n=u<h?e.charCodeAt(u++):0,r=u<h?e.charCodeAt(u++):0),i=t>>2,o=(3&t)<<4|n>>4,s=c>1?(15&n)<<2|r>>6:64,a=c>2?63&r:64,l.push(Jt.charAt(i)+Jt.charAt(o)+Jt.charAt(s)+Jt.charAt(a));return l.join("")},decode:function(e){var t,n,r,i,o,s,a=0,l=0;if("data:"===e.substr(0,"data:".length))throw new Error("Invalid base64 input, it looks like a data url.");var u,h=3*(e=e.replace(/[^A-Za-z0-9\+\/\=]/g,"")).length/4;if(e.charAt(e.length-1)===Jt.charAt(64)&&h--,e.charAt(e.length-2)===Jt.charAt(64)&&h--,h%1!=0)throw new Error("Invalid base64 input, bad content length.");for(u=Kt.uint8array?new Uint8Array(0|h):new Array(0|h);a<e.length;)t=Jt.indexOf(e.charAt(a++))<<2|(i=Jt.indexOf(e.charAt(a++)))>>4,n=(15&i)<<4|(o=Jt.indexOf(e.charAt(a++)))>>2,r=(3&o)<<6|(s=Jt.indexOf(e.charAt(a++))),u[l++]=t,64!==o&&(u[l++]=n),64!==s&&(u[l++]=r);return u}},$t=!0,Qt=function(e,t){return new A(e,t)},en=function(e){return A.alloc?A.alloc(e):new A(e)},tn=function(e){return ue(e)},nn=function(e){return e&&"function"==typeof e.on&&"function"==typeof e.pause&&"function"==typeof e.resume},rn=e.createCommonjsModule(function(e){var t=e.exports="undefined"!=typeof window&&window.Math==Math?window:"undefined"!=typeof self&&self.Math==Math?self:Function("return this")();"number"==typeof __g&&(__g=t);}),on=e.createCommonjsModule(function(e){var t=e.exports={version:"2.3.0"};"number"==typeof __e&&(__e=t);}),sn=(on.version,function(e,t,n){if(function(e){if("function"!=typeof e)throw TypeError(e+" is not a function!")}(e),void 0===t)return e;switch(n){case 1:return function(n){return e.call(t,n)};case 2:return function(n,r){return e.call(t,n,r)};case 3:return function(n,r,i){return e.call(t,n,r,i)}}return function(){return e.apply(t,arguments)}}),an=function(e){return "object"==typeof e?null!==e:"function"==typeof e},ln=function(e){if(!an(e))throw TypeError(e+" is not an object!");return e},un=function(e){try{return !!e()}catch(e){return !0}},hn=!un(function(){return 7!=Object.defineProperty({},"a",{get:function(){return 7}}).a}),cn=rn.document,fn=an(cn)&&an(cn.createElement),dn=function(e){return fn?cn.createElement(e):{}},pn=!hn&&!un(function(){return 7!=Object.defineProperty(dn("div"),"a",{get:function(){return 7}}).a}),gn=Object.defineProperty,mn={f:hn?Object.defineProperty:function(e,t,n){if(ln(e),t=function(e,t){if(!an(e))return e;var n,r;if(t&&"function"==typeof(n=e.toString)&&!an(r=n.call(e)))return r;if("function"==typeof(n=e.valueOf)&&!an(r=n.call(e)))return r;if(!t&&"function"==typeof(n=e.toString)&&!an(r=n.call(e)))return r;throw TypeError("Can't convert object to primitive value")}(t,!0),ln(n),pn)try{return gn(e,t,n)}catch(e){}if("get"in n||"set"in n)throw TypeError("Accessors not supported!");return "value"in n&&(e[t]=n.value),e}},vn=hn?function(e,t,n){return mn.f(e,t,function(e,t){return {enumerable:!(1&e),configurable:!(2&e),writable:!(4&e),value:t}}(1,n))}:function(e,t,n){return e[t]=n,e},_n=function(e,t,n){var r,i,o,s=e&_n.F,a=e&_n.G,l=e&_n.S,u=e&_n.P,h=e&_n.B,c=e&_n.W,f=a?on:on[t]||(on[t]={}),d=f.prototype,p=a?rn:l?rn[t]:(rn[t]||{}).prototype;for(r in a&&(n=t),n)(i=!s&&p&&void 0!==p[r])&&r in f||(o=i?p[r]:n[r],f[r]=a&&"function"!=typeof p[r]?n[r]:h&&i?sn(o,rn):c&&p[r]==o?function(e){var t=function(t,n,r){if(this instanceof e){switch(arguments.length){case 0:return new e;case 1:return new e(t);case 2:return new e(t,n)}return new e(t,n,r)}return e.apply(this,arguments)};return t.prototype=e.prototype,t}(o):u&&"function"==typeof o?sn(Function.call,o):o,u&&((f.virtual||(f.virtual={}))[r]=o,e&_n.R&&d&&!d[r]&&vn(d,r,o)));};_n.F=1,_n.G=2,_n.S=4,_n.P=8,_n.B=16,_n.W=32,_n.U=64,_n.R=128;var yn,bn,wn,kn,Sn=_n,xn=rn.document&&document.documentElement,Cn={}.toString,En=rn.process,An=rn.setImmediate,Tn=rn.clearImmediate,zn=rn.MessageChannel,On=0,Rn={},Ln=function(){var e=+this;if(Rn.hasOwnProperty(e)){var t=Rn[e];delete Rn[e],t();}},Bn=function(e){Ln.call(e.data);};An&&Tn||(An=function(e){for(var t=[],n=1;arguments.length>n;)t.push(arguments[n++]);return Rn[++On]=function(){!function(e,t,n){var r=void 0===n;switch(t.length){case 0:return r?e():e.call(n);case 1:return r?e(t[0]):e.call(n,t[0]);case 2:return r?e(t[0],t[1]):e.call(n,t[0],t[1]);case 3:return r?e(t[0],t[1],t[2]):e.call(n,t[0],t[1],t[2]);case 4:return r?e(t[0],t[1],t[2],t[3]):e.call(n,t[0],t[1],t[2],t[3])}e.apply(n,t);}("function"==typeof e?e:Function(e),t);},yn(On),On},Tn=function(e){delete Rn[e];},"process"==(kn=En,Cn.call(kn).slice(8,-1))?yn=function(e){En.nextTick(sn(Ln,e,1));}:zn?(wn=(bn=new zn).port2,bn.port1.onmessage=Bn,yn=sn(wn.postMessage,wn,1)):rn.addEventListener&&"function"==typeof postMessage&&!rn.importScripts?(yn=function(e){rn.postMessage(e+"","*");},rn.addEventListener("message",Bn,!1)):yn="onreadystatechange"in dn("script")?function(e){xn.appendChild(dn("script")).onreadystatechange=function(){xn.removeChild(this),Ln.call(e);};}:function(e){setTimeout(sn(Ln,e,1),0);});var In={set:An,clear:Tn};Sn(Sn.G+Sn.B,{setImmediate:In.set,clearImmediate:In.clear});var Fn,Pn,Mn=on.setImmediate,Un=f.MutationObserver||f.WebKitMutationObserver;if(Un){var Dn=0,jn=new Un(qn),Nn=f.document.createTextNode("");jn.observe(Nn,{characterData:!0}),Fn=function(){Nn.data=Dn=++Dn%2;};}else if(f.setImmediate||void 0===f.MessageChannel)Fn="document"in f&&"onreadystatechange"in f.document.createElement("script")?function(){var e=f.document.createElement("script");e.onreadystatechange=function(){qn(),e.onreadystatechange=null,e.parentNode.removeChild(e),e=null;},f.document.documentElement.appendChild(e);}:function(){setTimeout(qn,0);};else {var Zn=new f.MessageChannel;Zn.port1.onmessage=qn,Fn=function(){Zn.port2.postMessage(0);};}var Wn=[];function qn(){var e,t;Pn=!0;for(var n=Wn.length;n;){for(t=Wn,Wn=[],e=-1;++e<n;)t[e]();n=Wn.length;}Pn=!1;}var Yn=function(e){1!==Wn.push(e)||Pn||Fn();};function Vn(){}var Hn={},Gn=["REJECTED"],Kn=["FULFILLED"],Jn=["PENDING"],Xn=$n;function $n(e){if("function"!=typeof e)throw new TypeError("resolver must be a function");this.state=Jn,this.queue=[],this.outcome=void 0,e!==Vn&&nr(this,e);}function Qn(e,t,n){this.promise=e,"function"==typeof t&&(this.onFulfilled=t,this.callFulfilled=this.otherCallFulfilled),"function"==typeof n&&(this.onRejected=n,this.callRejected=this.otherCallRejected);}function er(e,t,n){Yn(function(){var r;try{r=t(n);}catch(t){return Hn.reject(e,t)}r===e?Hn.reject(e,new TypeError("Cannot resolve promise with itself")):Hn.resolve(e,r);});}function tr(e){var t=e&&e.then;if(e&&("object"==typeof e||"function"==typeof e)&&"function"==typeof t)return function(){t.apply(e,arguments);}}function nr(e,t){var n=!1;function r(t){n||(n=!0,Hn.reject(e,t));}function i(t){n||(n=!0,Hn.resolve(e,t));}var o=rr(function(){t(i,r);});"error"===o.status&&r(o.value);}function rr(e,t){var n={};try{n.value=e(t),n.status="success";}catch(e){n.status="error",n.value=e;}return n}$n.prototype.catch=function(e){return this.then(null,e)},$n.prototype.then=function(e,t){if("function"!=typeof e&&this.state===Kn||"function"!=typeof t&&this.state===Gn)return this;var n=new this.constructor(Vn);this.state!==Jn?er(n,this.state===Kn?e:t,this.outcome):this.queue.push(new Qn(n,e,t));return n},Qn.prototype.callFulfilled=function(e){Hn.resolve(this.promise,e);},Qn.prototype.otherCallFulfilled=function(e){er(this.promise,this.onFulfilled,e);},Qn.prototype.callRejected=function(e){Hn.reject(this.promise,e);},Qn.prototype.otherCallRejected=function(e){er(this.promise,this.onRejected,e);},Hn.resolve=function(e,t){var n=rr(tr,t);if("error"===n.status)return Hn.reject(e,n.value);var r=n.value;if(r)nr(e,r);else {e.state=Kn,e.outcome=t;for(var i=-1,o=e.queue.length;++i<o;)e.queue[i].callFulfilled(t);}return e},Hn.reject=function(e,t){e.state=Gn,e.outcome=t;for(var n=-1,r=e.queue.length;++n<r;)e.queue[n].callRejected(t);return e},$n.resolve=function(e){if(e instanceof this)return e;return Hn.resolve(new this(Vn),e)},$n.reject=function(e){var t=new this(Vn);return Hn.reject(t,e)},$n.all=function(e){var t=this;if("[object Array]"!==Object.prototype.toString.call(e))return this.reject(new TypeError("must be an array"));var n=e.length,r=!1;if(!n)return this.resolve([]);var i=new Array(n),o=0,s=-1,a=new this(Vn);for(;++s<n;)l(e[s],s);return a;function l(e,s){t.resolve(e).then(function(e){i[s]=e,++o!==n||r||(r=!0,Hn.resolve(a,i));},function(e){r||(r=!0,Hn.reject(a,e));});}},$n.race=function(e){var t=this;if("[object Array]"!==Object.prototype.toString.call(e))return this.reject(new TypeError("must be an array"));var n=e.length,r=!1;if(!n)return this.resolve([]);var i=-1,o=new this(Vn);for(;++i<n;)s=e[i],t.resolve(s).then(function(e){r||(r=!0,Hn.resolve(o,e));},function(e){r||(r=!0,Hn.reject(o,e));});var s;return o};var ir={Promise:"undefined"!=typeof Promise?Promise:Xn},or=e.createCommonjsModule(function(e,t){function n(e){return e}function r(e,t){for(var n=0;n<e.length;++n)t[n]=255&e.charCodeAt(n);return t}t.newBlob=function(e,n){t.checkSupport("blob");try{return new Blob([e],{type:n})}catch(t){try{var r=new(self.BlobBuilder||self.WebKitBlobBuilder||self.MozBlobBuilder||self.MSBlobBuilder);return r.append(e),r.getBlob(n)}catch(e){throw new Error("Bug : can't construct the Blob.")}}};var i={stringifyByChunk:function(e,t,n){var r=[],i=0,o=e.length;if(o<=n)return String.fromCharCode.apply(null,e);for(;i<o;)"array"===t||"nodebuffer"===t?r.push(String.fromCharCode.apply(null,e.slice(i,Math.min(i+n,o)))):r.push(String.fromCharCode.apply(null,e.subarray(i,Math.min(i+n,o)))),i+=n;return r.join("")},stringifyByChar:function(e){for(var t="",n=0;n<e.length;n++)t+=String.fromCharCode(e[n]);return t},applyCanBeUsed:{uint8array:function(){try{return Kt.uint8array&&1===String.fromCharCode.apply(null,new Uint8Array(1)).length}catch(e){return !1}}(),nodebuffer:function(){try{return Kt.nodebuffer&&1===String.fromCharCode.apply(null,en(1)).length}catch(e){return !1}}()}};function o(e){var n=65536,r=t.getTypeOf(e),o=!0;if("uint8array"===r?o=i.applyCanBeUsed.uint8array:"nodebuffer"===r&&(o=i.applyCanBeUsed.nodebuffer),o)for(;n>1;)try{return i.stringifyByChunk(e,r,n)}catch(e){n=Math.floor(n/2);}return i.stringifyByChar(e)}function s(e,t){for(var n=0;n<e.length;n++)t[n]=e[n];return t}t.applyFromCharCode=o;var a={};a.string={string:n,array:function(e){return r(e,new Array(e.length))},arraybuffer:function(e){return a.string.uint8array(e).buffer},uint8array:function(e){return r(e,new Uint8Array(e.length))},nodebuffer:function(e){return r(e,en(e.length))}},a.array={string:o,array:n,arraybuffer:function(e){return new Uint8Array(e).buffer},uint8array:function(e){return new Uint8Array(e)},nodebuffer:function(e){return Qt(e)}},a.arraybuffer={string:function(e){return o(new Uint8Array(e))},array:function(e){return s(new Uint8Array(e),new Array(e.byteLength))},arraybuffer:n,uint8array:function(e){return new Uint8Array(e)},nodebuffer:function(e){return Qt(new Uint8Array(e))}},a.uint8array={string:o,array:function(e){return s(e,new Array(e.length))},arraybuffer:function(e){return e.buffer},uint8array:n,nodebuffer:function(e){return Qt(e)}},a.nodebuffer={string:o,array:function(e){return s(e,new Array(e.length))},arraybuffer:function(e){return a.nodebuffer.uint8array(e).buffer},uint8array:function(e){return s(e,new Uint8Array(e.length))},nodebuffer:n},t.transformTo=function(e,n){if(n||(n=""),!e)return n;t.checkSupport(e);var r=t.getTypeOf(n);return a[r][e](n)},t.getTypeOf=function(e){return "string"==typeof e?"string":"[object Array]"===Object.prototype.toString.call(e)?"array":Kt.nodebuffer&&tn(e)?"nodebuffer":Kt.uint8array&&e instanceof Uint8Array?"uint8array":Kt.arraybuffer&&e instanceof ArrayBuffer?"arraybuffer":void 0},t.checkSupport=function(e){if(!Kt[e.toLowerCase()])throw new Error(e+" is not supported by this platform")},t.MAX_VALUE_16BITS=65535,t.MAX_VALUE_32BITS=-1,t.pretty=function(e){var t,n,r="";for(n=0;n<(e||"").length;n++)r+="\\x"+((t=e.charCodeAt(n))<16?"0":"")+t.toString(16).toUpperCase();return r},t.delay=function(e,t,n){Mn(function(){e.apply(n||null,t||[]);});},t.inherits=function(e,t){var n=function(){};n.prototype=t.prototype,e.prototype=new n;},t.extend=function(){var e,t,n={};for(e=0;e<arguments.length;e++)for(t in arguments[e])arguments[e].hasOwnProperty(t)&&void 0===n[t]&&(n[t]=arguments[e][t]);return n},t.prepareContent=function(e,n,i,o,s){return ir.Promise.resolve(n).then(function(e){return Kt.blob&&(e instanceof Blob||-1!==["[object File]","[object Blob]"].indexOf(Object.prototype.toString.call(e)))&&"undefined"!=typeof FileReader?new ir.Promise(function(t,n){var r=new FileReader;r.onload=function(e){t(e.target.result);},r.onerror=function(e){n(e.target.error);},r.readAsArrayBuffer(e);}):e}).then(function(n){var a,l=t.getTypeOf(n);return l?("arraybuffer"===l?n=t.transformTo("uint8array",n):"string"===l&&(s?n=Xt.decode(n):i&&!0!==o&&(n=r(a=n,Kt.uint8array?new Uint8Array(a.length):new Array(a.length)))),n):ir.Promise.reject(new Error("Can't read the data of '"+e+"'. Is it in a supported JavaScript type (String, Blob, ArrayBuffer, etc) ?"))})};});or.newBlob,or.applyFromCharCode,or.transformTo,or.getTypeOf,or.checkSupport,or.MAX_VALUE_16BITS,or.MAX_VALUE_32BITS,or.pretty,or.delay,or.inherits,or.extend,or.prepareContent;function sr(e){this.name=e||"default",this.streamInfo={},this.generatedError=null,this.extraStreamInfo={},this.isPaused=!0,this.isFinished=!1,this.isLocked=!1,this._listeners={data:[],end:[],error:[]},this.previous=null;}sr.prototype={push:function(e){this.emit("data",e);},end:function(){if(this.isFinished)return !1;this.flush();try{this.emit("end"),this.cleanUp(),this.isFinished=!0;}catch(e){this.emit("error",e);}return !0},error:function(e){return !this.isFinished&&(this.isPaused?this.generatedError=e:(this.isFinished=!0,this.emit("error",e),this.previous&&this.previous.error(e),this.cleanUp()),!0)},on:function(e,t){return this._listeners[e].push(t),this},cleanUp:function(){this.streamInfo=this.generatedError=this.extraStreamInfo=null,this._listeners=[];},emit:function(e,t){if(this._listeners[e])for(var n=0;n<this._listeners[e].length;n++)this._listeners[e][n].call(this,t);},pipe:function(e){return e.registerPrevious(this)},registerPrevious:function(e){if(this.isLocked)throw new Error("The stream '"+this+"' has already been used.");this.streamInfo=e.streamInfo,this.mergeStreamInfo(),this.previous=e;var t=this;return e.on("data",function(e){t.processChunk(e);}),e.on("end",function(){t.end();}),e.on("error",function(e){t.error(e);}),this},pause:function(){return !this.isPaused&&!this.isFinished&&(this.isPaused=!0,this.previous&&this.previous.pause(),!0)},resume:function(){if(!this.isPaused||this.isFinished)return !1;this.isPaused=!1;var e=!1;return this.generatedError&&(this.error(this.generatedError),e=!0),this.previous&&this.previous.resume(),!e},flush:function(){},processChunk:function(e){this.push(e);},withStreamInfo:function(e,t){return this.extraStreamInfo[e]=t,this.mergeStreamInfo(),this},mergeStreamInfo:function(){for(var e in this.extraStreamInfo)this.extraStreamInfo.hasOwnProperty(e)&&(this.streamInfo[e]=this.extraStreamInfo[e]);},lock:function(){if(this.isLocked)throw new Error("The stream '"+this+"' has already been used.");this.isLocked=!0,this.previous&&this.previous.lock();},toString:function(){var e="Worker "+this.name;return this.previous?this.previous+" -> "+e:e}};var ar=sr,lr=e.createCommonjsModule(function(e,t){for(var n=new Array(256),r=0;r<256;r++)n[r]=r>=252?6:r>=248?5:r>=240?4:r>=224?3:r>=192?2:1;n[254]=n[254]=1;function i(){ar.call(this,"utf-8 decode"),this.leftOver=null;}function o(){ar.call(this,"utf-8 encode");}t.utf8encode=function(e){return Kt.nodebuffer?Qt(e,"utf-8"):function(e){var t,n,r,i,o,s=e.length,a=0;for(i=0;i<s;i++)55296==(64512&(n=e.charCodeAt(i)))&&i+1<s&&56320==(64512&(r=e.charCodeAt(i+1)))&&(n=65536+(n-55296<<10)+(r-56320),i++),a+=n<128?1:n<2048?2:n<65536?3:4;for(t=Kt.uint8array?new Uint8Array(a):new Array(a),o=0,i=0;o<a;i++)55296==(64512&(n=e.charCodeAt(i)))&&i+1<s&&56320==(64512&(r=e.charCodeAt(i+1)))&&(n=65536+(n-55296<<10)+(r-56320),i++),n<128?t[o++]=n:n<2048?(t[o++]=192|n>>>6,t[o++]=128|63&n):n<65536?(t[o++]=224|n>>>12,t[o++]=128|n>>>6&63,t[o++]=128|63&n):(t[o++]=240|n>>>18,t[o++]=128|n>>>12&63,t[o++]=128|n>>>6&63,t[o++]=128|63&n);return t}(e)},t.utf8decode=function(e){return Kt.nodebuffer?or.transformTo("nodebuffer",e).toString("utf-8"):function(e){var t,r,i,o,s=e.length,a=new Array(2*s);for(r=0,t=0;t<s;)if((i=e[t++])<128)a[r++]=i;else if((o=n[i])>4)a[r++]=65533,t+=o-1;else {for(i&=2===o?31:3===o?15:7;o>1&&t<s;)i=i<<6|63&e[t++],o--;o>1?a[r++]=65533:i<65536?a[r++]=i:(i-=65536,a[r++]=55296|i>>10&1023,a[r++]=56320|1023&i);}return a.length!==r&&(a.subarray?a=a.subarray(0,r):a.length=r),or.applyFromCharCode(a)}(e=or.transformTo(Kt.uint8array?"uint8array":"array",e))},or.inherits(i,ar),i.prototype.processChunk=function(e){var r=or.transformTo(Kt.uint8array?"uint8array":"array",e.data);if(this.leftOver&&this.leftOver.length){if(Kt.uint8array){var i=r;(r=new Uint8Array(i.length+this.leftOver.length)).set(this.leftOver,0),r.set(i,this.leftOver.length);}else r=this.leftOver.concat(r);this.leftOver=null;}var o=function(e,t){var r;for((t=t||e.length)>e.length&&(t=e.length),r=t-1;r>=0&&128==(192&e[r]);)r--;return r<0?t:0===r?t:r+n[e[r]]>t?r:t}(r),s=r;o!==r.length&&(Kt.uint8array?(s=r.subarray(0,o),this.leftOver=r.subarray(o,r.length)):(s=r.slice(0,o),this.leftOver=r.slice(o,r.length))),this.push({data:t.utf8decode(s),meta:e.meta});},i.prototype.flush=function(){this.leftOver&&this.leftOver.length&&(this.push({data:t.utf8decode(this.leftOver),meta:{}}),this.leftOver=null);},t.Utf8DecodeWorker=i,or.inherits(o,ar),o.prototype.processChunk=function(e){this.push({data:t.utf8encode(e.data),meta:e.meta});},t.Utf8EncodeWorker=o;});lr.utf8encode,lr.utf8decode,lr.Utf8DecodeWorker,lr.Utf8EncodeWorker;function ur(e){ar.call(this,"ConvertWorker to "+e),this.destType=e;}or.inherits(ur,ar),ur.prototype.processChunk=function(e){this.push({data:or.transformTo(this.destType,e.data),meta:e.meta});};var hr=ur,cr=Gt.Readable;function fr(e,t,n){cr.call(this,t),this._helper=e;var r=this;e.on("data",function(e,t){r.push(e)||r._helper.pause(),n&&n(t);}).on("error",function(e){r.emit("error",e);}).on("end",function(){r.push(null);});}or.inherits(fr,cr),fr.prototype._read=function(){this._helper.resume();};var dr=fr,pr=null;if(Kt.nodestream)try{pr=dr;}catch(e){}function gr(e,t){return new ir.Promise(function(n,r){var i=[],o=e._internalType,s=e._outputType,a=e._mimeType;e.on("data",function(e,n){i.push(e),t&&t(n);}).on("error",function(e){i=[],r(e);}).on("end",function(){try{var e=function(e,t,n){switch(e){case"blob":return or.newBlob(or.transformTo("arraybuffer",t),n);case"base64":return Xt.encode(t);default:return or.transformTo(e,t)}}(s,function(e,t){var n,r=0,i=null,o=0;for(n=0;n<t.length;n++)o+=t[n].length;switch(e){case"string":return t.join("");case"array":return Array.prototype.concat.apply([],t);case"uint8array":for(i=new Uint8Array(o),n=0;n<t.length;n++)i.set(t[n],r),r+=t[n].length;return i;case"nodebuffer":return A.concat(t);default:throw new Error("concat : unsupported type '"+e+"'")}}(o,i),a);n(e);}catch(e){r(e);}i=[];}).resume();})}function mr(e,t,n){var r=t;switch(t){case"blob":case"arraybuffer":r="uint8array";break;case"base64":r="string";}try{this._internalType=r,this._outputType=t,this._mimeType=n,or.checkSupport(r),this._worker=e.pipe(new hr(r)),e.lock();}catch(e){this._worker=new ar("error"),this._worker.error(e);}}mr.prototype={accumulate:function(e){return gr(this,e)},on:function(e,t){var n=this;return "data"===e?this._worker.on(e,function(e){t.call(n,e.data,e.meta);}):this._worker.on(e,function(){or.delay(t,arguments,n);}),this},resume:function(){return or.delay(this._worker.resume,[],this._worker),this},pause:function(){return this._worker.pause(),this},toNodejsStream:function(e){if(or.checkSupport("nodestream"),"nodebuffer"!==this._outputType)throw new Error(this._outputType+" is not supported by this method");return new pr(this,{objectMode:"nodebuffer"!==this._outputType},e)}};var vr=mr,_r={base64:!1,binary:!1,dir:!1,createFolders:!0,date:null,compression:null,compressionOptions:null,comment:null,unixPermissions:null,dosPermissions:null};function yr(e){ar.call(this,"DataWorker");var t=this;this.dataIsReady=!1,this.index=0,this.max=0,this.data=null,this.type="",this._tickScheduled=!1,e.then(function(e){t.dataIsReady=!0,t.data=e,t.max=e&&e.length||0,t.type=or.getTypeOf(e),t.isPaused||t._tickAndRepeat();},function(e){t.error(e);});}or.inherits(yr,ar),yr.prototype.cleanUp=function(){ar.prototype.cleanUp.call(this),this.data=null;},yr.prototype.resume=function(){return !!ar.prototype.resume.call(this)&&(!this._tickScheduled&&this.dataIsReady&&(this._tickScheduled=!0,or.delay(this._tickAndRepeat,[],this)),!0)},yr.prototype._tickAndRepeat=function(){this._tickScheduled=!1,this.isPaused||this.isFinished||(this._tick(),this.isFinished||(or.delay(this._tickAndRepeat,[],this),this._tickScheduled=!0));},yr.prototype._tick=function(){if(this.isPaused||this.isFinished)return !1;var e=null,t=Math.min(this.max,this.index+16384);if(this.index>=this.max)return this.end();switch(this.type){case"string":e=this.data.substring(this.index,t);break;case"uint8array":e=this.data.subarray(this.index,t);break;case"array":case"nodebuffer":e=this.data.slice(this.index,t);}return this.index=t,this.push({data:e,meta:{percent:this.max?this.index/this.max*100:0}})};var br=yr;function wr(e){ar.call(this,"DataLengthProbe for "+e),this.propName=e,this.withStreamInfo(e,0);}or.inherits(wr,ar),wr.prototype.processChunk=function(e){if(e){var t=this.streamInfo[this.propName]||0;this.streamInfo[this.propName]=t+e.data.length;}ar.prototype.processChunk.call(this,e);};var kr=wr;var Sr=function(){for(var e,t=[],n=0;n<256;n++){e=n;for(var r=0;r<8;r++)e=1&e?3988292384^e>>>1:e>>>1;t[n]=e;}return t}();var xr=function(e,t){return void 0!==e&&e.length?"string"!==or.getTypeOf(e)?function(e,t,n,r){var i=Sr,o=r+n;e^=-1;for(var s=r;s<o;s++)e=e>>>8^i[255&(e^t[s])];return -1^e}(0|t,e,e.length,0):function(e,t,n,r){var i=Sr,o=r+n;e^=-1;for(var s=r;s<o;s++)e=e>>>8^i[255&(e^t.charCodeAt(s))];return -1^e}(0|t,e,e.length,0):0};function Cr(){ar.call(this,"Crc32Probe"),this.withStreamInfo("crc32",0);}or.inherits(Cr,ar),Cr.prototype.processChunk=function(e){this.streamInfo.crc32=xr(e.data,this.streamInfo.crc32||0),this.push(e);};var Er=Cr;function Ar(e,t,n,r,i){this.compressedSize=e,this.uncompressedSize=t,this.crc32=n,this.compression=r,this.compressedContent=i;}Ar.prototype={getContentWorker:function(){var e=new br(ir.Promise.resolve(this.compressedContent)).pipe(this.compression.uncompressWorker()).pipe(new kr("data_length")),t=this;return e.on("end",function(){if(this.streamInfo.data_length!==t.uncompressedSize)throw new Error("Bug : uncompressed data size mismatch")}),e},getCompressedWorker:function(){return new br(ir.Promise.resolve(this.compressedContent)).withStreamInfo("compressedSize",this.compressedSize).withStreamInfo("uncompressedSize",this.uncompressedSize).withStreamInfo("crc32",this.crc32).withStreamInfo("compression",this.compression)}},Ar.createWorkerFrom=function(e,t,n){return e.pipe(new Er).pipe(new kr("uncompressedSize")).pipe(t.compressWorker(n)).pipe(new kr("compressedSize")).withStreamInfo("compression",t)};var Tr=Ar,zr=function(e,t,n){this.name=e,this.dir=n.dir,this.date=n.date,this.comment=n.comment,this.unixPermissions=n.unixPermissions,this.dosPermissions=n.dosPermissions,this._data=t,this._dataBinary=n.binary,this.options={compression:n.compression,compressionOptions:n.compressionOptions};};zr.prototype={internalStream:function(e){var t=null,n="string";try{if(!e)throw new Error("No output type specified.");var r="string"===(n=e.toLowerCase())||"text"===n;"binarystring"!==n&&"text"!==n||(n="string"),t=this._decompressWorker();var i=!this._dataBinary;i&&!r&&(t=t.pipe(new lr.Utf8EncodeWorker)),!i&&r&&(t=t.pipe(new lr.Utf8DecodeWorker));}catch(e){(t=new ar("error")).error(e);}return new vr(t,n,"")},async:function(e,t){return this.internalStream(e).accumulate(t)},nodeStream:function(e,t){return this.internalStream(e||"nodebuffer").toNodejsStream(t)},_compressWorker:function(e,t){if(this._data instanceof Tr&&this._data.compression.magic===e.magic)return this._data.getCompressedWorker();var n=this._decompressWorker();return this._dataBinary||(n=n.pipe(new lr.Utf8EncodeWorker)),Tr.createWorkerFrom(n,e,t)},_decompressWorker:function(){return this._data instanceof Tr?this._data.getContentWorker():this._data instanceof ar?this._data:new br(this._data)}};for(var Or=["asText","asBinary","asNodeBuffer","asUint8Array","asArrayBuffer"],Rr=function(){throw new Error("This method has been removed in JSZip 3.0, please check the upgrade guide.")},Lr=0;Lr<Or.length;Lr++)zr.prototype[Or[Lr]]=Rr;var Br=zr,Ir=e.createCommonjsModule(function(e,t){var n="undefined"!=typeof Uint8Array&&"undefined"!=typeof Uint16Array&&"undefined"!=typeof Int32Array;function r(e,t){return Object.prototype.hasOwnProperty.call(e,t)}t.assign=function(e){for(var t=Array.prototype.slice.call(arguments,1);t.length;){var n=t.shift();if(n){if("object"!=typeof n)throw new TypeError(n+"must be non-object");for(var i in n)r(n,i)&&(e[i]=n[i]);}}return e},t.shrinkBuf=function(e,t){return e.length===t?e:e.subarray?e.subarray(0,t):(e.length=t,e)};var i={arraySet:function(e,t,n,r,i){if(t.subarray&&e.subarray)e.set(t.subarray(n,n+r),i);else for(var o=0;o<r;o++)e[i+o]=t[n+o];},flattenChunks:function(e){var t,n,r,i,o,s;for(r=0,t=0,n=e.length;t<n;t++)r+=e[t].length;for(s=new Uint8Array(r),i=0,t=0,n=e.length;t<n;t++)o=e[t],s.set(o,i),i+=o.length;return s}},o={arraySet:function(e,t,n,r,i){for(var o=0;o<r;o++)e[i+o]=t[n+o];},flattenChunks:function(e){return [].concat.apply([],e)}};t.setTyped=function(e){e?(t.Buf8=Uint8Array,t.Buf16=Uint16Array,t.Buf32=Int32Array,t.assign(t,i)):(t.Buf8=Array,t.Buf16=Array,t.Buf32=Array,t.assign(t,o));},t.setTyped(n);}),Fr=(Ir.assign,Ir.shrinkBuf,Ir.setTyped,Ir.Buf8,Ir.Buf16,Ir.Buf32,4),Pr=0,Mr=1,Ur=2;function Dr(e){for(var t=e.length;--t>=0;)e[t]=0;}var jr=0,Nr=1,Zr=2,Wr=29,qr=256,Yr=qr+1+Wr,Vr=30,Hr=19,Gr=2*Yr+1,Kr=15,Jr=16,Xr=7,$r=256,Qr=16,ei=17,ti=18,ni=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0],ri=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13],ii=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7],oi=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],si=new Array(2*(Yr+2));Dr(si);var ai=new Array(2*Vr);Dr(ai);var li=new Array(512);Dr(li);var ui=new Array(256);Dr(ui);var hi=new Array(Wr);Dr(hi);var ci,fi,di,pi=new Array(Vr);function gi(e,t,n,r,i){this.static_tree=e,this.extra_bits=t,this.extra_base=n,this.elems=r,this.max_length=i,this.has_stree=e&&e.length;}function mi(e,t){this.dyn_tree=e,this.max_code=0,this.stat_desc=t;}function vi(e){return e<256?li[e]:li[256+(e>>>7)]}function _i(e,t){e.pending_buf[e.pending++]=255&t,e.pending_buf[e.pending++]=t>>>8&255;}function yi(e,t,n){e.bi_valid>Jr-n?(e.bi_buf|=t<<e.bi_valid&65535,_i(e,e.bi_buf),e.bi_buf=t>>Jr-e.bi_valid,e.bi_valid+=n-Jr):(e.bi_buf|=t<<e.bi_valid&65535,e.bi_valid+=n);}function bi(e,t,n){yi(e,n[2*t],n[2*t+1]);}function wi(e,t){var n=0;do{n|=1&e,e>>>=1,n<<=1;}while(--t>0);return n>>>1}function ki(e,t,n){var r,i,o=new Array(Kr+1),s=0;for(r=1;r<=Kr;r++)o[r]=s=s+n[r-1]<<1;for(i=0;i<=t;i++){var a=e[2*i+1];0!==a&&(e[2*i]=wi(o[a]++,a));}}function Si(e){var t;for(t=0;t<Yr;t++)e.dyn_ltree[2*t]=0;for(t=0;t<Vr;t++)e.dyn_dtree[2*t]=0;for(t=0;t<Hr;t++)e.bl_tree[2*t]=0;e.dyn_ltree[2*$r]=1,e.opt_len=e.static_len=0,e.last_lit=e.matches=0;}function xi(e){e.bi_valid>8?_i(e,e.bi_buf):e.bi_valid>0&&(e.pending_buf[e.pending++]=e.bi_buf),e.bi_buf=0,e.bi_valid=0;}function Ci(e,t,n,r){var i=2*t,o=2*n;return e[i]<e[o]||e[i]===e[o]&&r[t]<=r[n]}function Ei(e,t,n){for(var r=e.heap[n],i=n<<1;i<=e.heap_len&&(i<e.heap_len&&Ci(t,e.heap[i+1],e.heap[i],e.depth)&&i++,!Ci(t,r,e.heap[i],e.depth));)e.heap[n]=e.heap[i],n=i,i<<=1;e.heap[n]=r;}function Ai(e,t,n){var r,i,o,s,a=0;if(0!==e.last_lit)do{r=e.pending_buf[e.d_buf+2*a]<<8|e.pending_buf[e.d_buf+2*a+1],i=e.pending_buf[e.l_buf+a],a++,0===r?bi(e,i,t):(bi(e,(o=ui[i])+qr+1,t),0!==(s=ni[o])&&yi(e,i-=hi[o],s),bi(e,o=vi(--r),n),0!==(s=ri[o])&&yi(e,r-=pi[o],s));}while(a<e.last_lit);bi(e,$r,t);}function Ti(e,t){var n,r,i,o=t.dyn_tree,s=t.stat_desc.static_tree,a=t.stat_desc.has_stree,l=t.stat_desc.elems,u=-1;for(e.heap_len=0,e.heap_max=Gr,n=0;n<l;n++)0!==o[2*n]?(e.heap[++e.heap_len]=u=n,e.depth[n]=0):o[2*n+1]=0;for(;e.heap_len<2;)o[2*(i=e.heap[++e.heap_len]=u<2?++u:0)]=1,e.depth[i]=0,e.opt_len--,a&&(e.static_len-=s[2*i+1]);for(t.max_code=u,n=e.heap_len>>1;n>=1;n--)Ei(e,o,n);i=l;do{n=e.heap[1],e.heap[1]=e.heap[e.heap_len--],Ei(e,o,1),r=e.heap[1],e.heap[--e.heap_max]=n,e.heap[--e.heap_max]=r,o[2*i]=o[2*n]+o[2*r],e.depth[i]=(e.depth[n]>=e.depth[r]?e.depth[n]:e.depth[r])+1,o[2*n+1]=o[2*r+1]=i,e.heap[1]=i++,Ei(e,o,1);}while(e.heap_len>=2);e.heap[--e.heap_max]=e.heap[1],function(e,t){var n,r,i,o,s,a,l=t.dyn_tree,u=t.max_code,h=t.stat_desc.static_tree,c=t.stat_desc.has_stree,f=t.stat_desc.extra_bits,d=t.stat_desc.extra_base,p=t.stat_desc.max_length,g=0;for(o=0;o<=Kr;o++)e.bl_count[o]=0;for(l[2*e.heap[e.heap_max]+1]=0,n=e.heap_max+1;n<Gr;n++)(o=l[2*l[2*(r=e.heap[n])+1]+1]+1)>p&&(o=p,g++),l[2*r+1]=o,r>u||(e.bl_count[o]++,s=0,r>=d&&(s=f[r-d]),a=l[2*r],e.opt_len+=a*(o+s),c&&(e.static_len+=a*(h[2*r+1]+s)));if(0!==g){do{for(o=p-1;0===e.bl_count[o];)o--;e.bl_count[o]--,e.bl_count[o+1]+=2,e.bl_count[p]--,g-=2;}while(g>0);for(o=p;0!==o;o--)for(r=e.bl_count[o];0!==r;)(i=e.heap[--n])>u||(l[2*i+1]!==o&&(e.opt_len+=(o-l[2*i+1])*l[2*i],l[2*i+1]=o),r--);}}(e,t),ki(o,u,e.bl_count);}function zi(e,t,n){var r,i,o=-1,s=t[1],a=0,l=7,u=4;for(0===s&&(l=138,u=3),t[2*(n+1)+1]=65535,r=0;r<=n;r++)i=s,s=t[2*(r+1)+1],++a<l&&i===s||(a<u?e.bl_tree[2*i]+=a:0!==i?(i!==o&&e.bl_tree[2*i]++,e.bl_tree[2*Qr]++):a<=10?e.bl_tree[2*ei]++:e.bl_tree[2*ti]++,a=0,o=i,0===s?(l=138,u=3):i===s?(l=6,u=3):(l=7,u=4));}function Oi(e,t,n){var r,i,o=-1,s=t[1],a=0,l=7,u=4;for(0===s&&(l=138,u=3),r=0;r<=n;r++)if(i=s,s=t[2*(r+1)+1],!(++a<l&&i===s)){if(a<u)do{bi(e,i,e.bl_tree);}while(0!=--a);else 0!==i?(i!==o&&(bi(e,i,e.bl_tree),a--),bi(e,Qr,e.bl_tree),yi(e,a-3,2)):a<=10?(bi(e,ei,e.bl_tree),yi(e,a-3,3)):(bi(e,ti,e.bl_tree),yi(e,a-11,7));a=0,o=i,0===s?(l=138,u=3):i===s?(l=6,u=3):(l=7,u=4);}}Dr(pi);var Ri=!1;function Li(e,t,n,r){yi(e,(jr<<1)+(r?1:0),3),function(e,t,n,r){xi(e),r&&(_i(e,n),_i(e,~n)),Ir.arraySet(e.pending_buf,e.window,t,n,e.pending),e.pending+=n;}(e,t,n,!0);}var Bi={_tr_init:function(e){Ri||(function(){var e,t,n,r,i,o=new Array(Kr+1);for(n=0,r=0;r<Wr-1;r++)for(hi[r]=n,e=0;e<1<<ni[r];e++)ui[n++]=r;for(ui[n-1]=r,i=0,r=0;r<16;r++)for(pi[r]=i,e=0;e<1<<ri[r];e++)li[i++]=r;for(i>>=7;r<Vr;r++)for(pi[r]=i<<7,e=0;e<1<<ri[r]-7;e++)li[256+i++]=r;for(t=0;t<=Kr;t++)o[t]=0;for(e=0;e<=143;)si[2*e+1]=8,e++,o[8]++;for(;e<=255;)si[2*e+1]=9,e++,o[9]++;for(;e<=279;)si[2*e+1]=7,e++,o[7]++;for(;e<=287;)si[2*e+1]=8,e++,o[8]++;for(ki(si,Yr+1,o),e=0;e<Vr;e++)ai[2*e+1]=5,ai[2*e]=wi(e,5);ci=new gi(si,ni,qr+1,Yr,Kr),fi=new gi(ai,ri,0,Vr,Kr),di=new gi(new Array(0),ii,0,Hr,Xr);}(),Ri=!0),e.l_desc=new mi(e.dyn_ltree,ci),e.d_desc=new mi(e.dyn_dtree,fi),e.bl_desc=new mi(e.bl_tree,di),e.bi_buf=0,e.bi_valid=0,Si(e);},_tr_stored_block:Li,_tr_flush_block:function(e,t,n,r){var i,o,s=0;e.level>0?(e.strm.data_type===Ur&&(e.strm.data_type=function(e){var t,n=4093624447;for(t=0;t<=31;t++,n>>>=1)if(1&n&&0!==e.dyn_ltree[2*t])return Pr;if(0!==e.dyn_ltree[18]||0!==e.dyn_ltree[20]||0!==e.dyn_ltree[26])return Mr;for(t=32;t<qr;t++)if(0!==e.dyn_ltree[2*t])return Mr;return Pr}(e)),Ti(e,e.l_desc),Ti(e,e.d_desc),s=function(e){var t;for(zi(e,e.dyn_ltree,e.l_desc.max_code),zi(e,e.dyn_dtree,e.d_desc.max_code),Ti(e,e.bl_desc),t=Hr-1;t>=3&&0===e.bl_tree[2*oi[t]+1];t--);return e.opt_len+=3*(t+1)+5+5+4,t}(e),i=e.opt_len+3+7>>>3,(o=e.static_len+3+7>>>3)<=i&&(i=o)):i=o=n+5,n+4<=i&&-1!==t?Li(e,t,n,r):e.strategy===Fr||o===i?(yi(e,(Nr<<1)+(r?1:0),3),Ai(e,si,ai)):(yi(e,(Zr<<1)+(r?1:0),3),function(e,t,n,r){var i;for(yi(e,t-257,5),yi(e,n-1,5),yi(e,r-4,4),i=0;i<r;i++)yi(e,e.bl_tree[2*oi[i]+1],3);Oi(e,e.dyn_ltree,t-1),Oi(e,e.dyn_dtree,n-1);}(e,e.l_desc.max_code+1,e.d_desc.max_code+1,s+1),Ai(e,e.dyn_ltree,e.dyn_dtree)),Si(e),r&&xi(e);},_tr_tally:function(e,t,n){return e.pending_buf[e.d_buf+2*e.last_lit]=t>>>8&255,e.pending_buf[e.d_buf+2*e.last_lit+1]=255&t,e.pending_buf[e.l_buf+e.last_lit]=255&n,e.last_lit++,0===t?e.dyn_ltree[2*n]++:(e.matches++,t--,e.dyn_ltree[2*(ui[n]+qr+1)]++,e.dyn_dtree[2*vi(t)]++),e.last_lit===e.lit_bufsize-1},_tr_align:function(e){yi(e,Nr<<1,3),bi(e,$r,si),function(e){16===e.bi_valid?(_i(e,e.bi_buf),e.bi_buf=0,e.bi_valid=0):e.bi_valid>=8&&(e.pending_buf[e.pending++]=255&e.bi_buf,e.bi_buf>>=8,e.bi_valid-=8);}(e);}};var Ii=function(e,t,n,r){for(var i=65535&e|0,o=e>>>16&65535|0,s=0;0!==n;){n-=s=n>2e3?2e3:n;do{o=o+(i=i+t[r++]|0)|0;}while(--s);i%=65521,o%=65521;}return i|o<<16|0};var Fi=function(){for(var e,t=[],n=0;n<256;n++){e=n;for(var r=0;r<8;r++)e=1&e?3988292384^e>>>1:e>>>1;t[n]=e;}return t}();var Pi,Mi=function(e,t,n,r){var i=Fi,o=r+n;e^=-1;for(var s=r;s<o;s++)e=e>>>8^i[255&(e^t[s])];return -1^e},Ui={2:"need dictionary",1:"stream end",0:"","-1":"file error","-2":"stream error","-3":"data error","-4":"insufficient memory","-5":"buffer error","-6":"incompatible version"},Di=0,ji=1,Ni=3,Zi=4,Wi=5,qi=0,Yi=1,Vi=-2,Hi=-3,Gi=-5,Ki=-1,Ji=1,Xi=2,$i=3,Qi=4,eo=0,to=2,no=8,ro=9,io=15,oo=8,so=286,ao=30,lo=19,uo=2*so+1,ho=15,co=3,fo=258,po=fo+co+1,go=32,mo=42,vo=69,_o=73,yo=91,bo=103,wo=113,ko=666,So=1,xo=2,Co=3,Eo=4,Ao=3;function To(e,t){return e.msg=Ui[t],t}function zo(e){return (e<<1)-(e>4?9:0)}function Oo(e){for(var t=e.length;--t>=0;)e[t]=0;}function Ro(e){var t=e.state,n=t.pending;n>e.avail_out&&(n=e.avail_out),0!==n&&(Ir.arraySet(e.output,t.pending_buf,t.pending_out,n,e.next_out),e.next_out+=n,t.pending_out+=n,e.total_out+=n,e.avail_out-=n,t.pending-=n,0===t.pending&&(t.pending_out=0));}function Lo(e,t){Bi._tr_flush_block(e,e.block_start>=0?e.block_start:-1,e.strstart-e.block_start,t),e.block_start=e.strstart,Ro(e.strm);}function Bo(e,t){e.pending_buf[e.pending++]=t;}function Io(e,t){e.pending_buf[e.pending++]=t>>>8&255,e.pending_buf[e.pending++]=255&t;}function Fo(e,t){var n,r,i=e.max_chain_length,o=e.strstart,s=e.prev_length,a=e.nice_match,l=e.strstart>e.w_size-po?e.strstart-(e.w_size-po):0,u=e.window,h=e.w_mask,c=e.prev,f=e.strstart+fo,d=u[o+s-1],p=u[o+s];e.prev_length>=e.good_match&&(i>>=2),a>e.lookahead&&(a=e.lookahead);do{if(u[(n=t)+s]===p&&u[n+s-1]===d&&u[n]===u[o]&&u[++n]===u[o+1]){o+=2,n++;do{}while(u[++o]===u[++n]&&u[++o]===u[++n]&&u[++o]===u[++n]&&u[++o]===u[++n]&&u[++o]===u[++n]&&u[++o]===u[++n]&&u[++o]===u[++n]&&u[++o]===u[++n]&&o<f);if(r=fo-(f-o),o=f-fo,r>s){if(e.match_start=t,s=r,r>=a)break;d=u[o+s-1],p=u[o+s];}}}while((t=c[t&h])>l&&0!=--i);return s<=e.lookahead?s:e.lookahead}function Po(e){var t,n,r,i,o,s,a,l,u,h,c=e.w_size;do{if(i=e.window_size-e.lookahead-e.strstart,e.strstart>=c+(c-po)){Ir.arraySet(e.window,e.window,c,c,0),e.match_start-=c,e.strstart-=c,e.block_start-=c,t=n=e.hash_size;do{r=e.head[--t],e.head[t]=r>=c?r-c:0;}while(--n);t=n=c;do{r=e.prev[--t],e.prev[t]=r>=c?r-c:0;}while(--n);i+=c;}if(0===e.strm.avail_in)break;if(s=e.strm,a=e.window,l=e.strstart+e.lookahead,u=i,h=void 0,(h=s.avail_in)>u&&(h=u),n=0===h?0:(s.avail_in-=h,Ir.arraySet(a,s.input,s.next_in,h,l),1===s.state.wrap?s.adler=Ii(s.adler,a,h,l):2===s.state.wrap&&(s.adler=Mi(s.adler,a,h,l)),s.next_in+=h,s.total_in+=h,h),e.lookahead+=n,e.lookahead+e.insert>=co)for(o=e.strstart-e.insert,e.ins_h=e.window[o],e.ins_h=(e.ins_h<<e.hash_shift^e.window[o+1])&e.hash_mask;e.insert&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[o+co-1])&e.hash_mask,e.prev[o&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=o,o++,e.insert--,!(e.lookahead+e.insert<co)););}while(e.lookahead<po&&0!==e.strm.avail_in)}function Mo(e,t){for(var n,r;;){if(e.lookahead<po){if(Po(e),e.lookahead<po&&t===Di)return So;if(0===e.lookahead)break}if(n=0,e.lookahead>=co&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+co-1])&e.hash_mask,n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart),0!==n&&e.strstart-n<=e.w_size-po&&(e.match_length=Fo(e,n)),e.match_length>=co)if(r=Bi._tr_tally(e,e.strstart-e.match_start,e.match_length-co),e.lookahead-=e.match_length,e.match_length<=e.max_lazy_match&&e.lookahead>=co){e.match_length--;do{e.strstart++,e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+co-1])&e.hash_mask,n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart;}while(0!=--e.match_length);e.strstart++;}else e.strstart+=e.match_length,e.match_length=0,e.ins_h=e.window[e.strstart],e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+1])&e.hash_mask;else r=Bi._tr_tally(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++;if(r&&(Lo(e,!1),0===e.strm.avail_out))return So}return e.insert=e.strstart<co-1?e.strstart:co-1,t===Zi?(Lo(e,!0),0===e.strm.avail_out?Co:Eo):e.last_lit&&(Lo(e,!1),0===e.strm.avail_out)?So:xo}function Uo(e,t){for(var n,r,i;;){if(e.lookahead<po){if(Po(e),e.lookahead<po&&t===Di)return So;if(0===e.lookahead)break}if(n=0,e.lookahead>=co&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+co-1])&e.hash_mask,n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart),e.prev_length=e.match_length,e.prev_match=e.match_start,e.match_length=co-1,0!==n&&e.prev_length<e.max_lazy_match&&e.strstart-n<=e.w_size-po&&(e.match_length=Fo(e,n),e.match_length<=5&&(e.strategy===Ji||e.match_length===co&&e.strstart-e.match_start>4096)&&(e.match_length=co-1)),e.prev_length>=co&&e.match_length<=e.prev_length){i=e.strstart+e.lookahead-co,r=Bi._tr_tally(e,e.strstart-1-e.prev_match,e.prev_length-co),e.lookahead-=e.prev_length-1,e.prev_length-=2;do{++e.strstart<=i&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+co-1])&e.hash_mask,n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart);}while(0!=--e.prev_length);if(e.match_available=0,e.match_length=co-1,e.strstart++,r&&(Lo(e,!1),0===e.strm.avail_out))return So}else if(e.match_available){if((r=Bi._tr_tally(e,0,e.window[e.strstart-1]))&&Lo(e,!1),e.strstart++,e.lookahead--,0===e.strm.avail_out)return So}else e.match_available=1,e.strstart++,e.lookahead--;}return e.match_available&&(r=Bi._tr_tally(e,0,e.window[e.strstart-1]),e.match_available=0),e.insert=e.strstart<co-1?e.strstart:co-1,t===Zi?(Lo(e,!0),0===e.strm.avail_out?Co:Eo):e.last_lit&&(Lo(e,!1),0===e.strm.avail_out)?So:xo}function Do(e,t,n,r,i){this.good_length=e,this.max_lazy=t,this.nice_length=n,this.max_chain=r,this.func=i;}function jo(){this.strm=null,this.status=0,this.pending_buf=null,this.pending_buf_size=0,this.pending_out=0,this.pending=0,this.wrap=0,this.gzhead=null,this.gzindex=0,this.method=no,this.last_flush=-1,this.w_size=0,this.w_bits=0,this.w_mask=0,this.window=null,this.window_size=0,this.prev=null,this.head=null,this.ins_h=0,this.hash_size=0,this.hash_bits=0,this.hash_mask=0,this.hash_shift=0,this.block_start=0,this.match_length=0,this.prev_match=0,this.match_available=0,this.strstart=0,this.match_start=0,this.lookahead=0,this.prev_length=0,this.max_chain_length=0,this.max_lazy_match=0,this.level=0,this.strategy=0,this.good_match=0,this.nice_match=0,this.dyn_ltree=new Ir.Buf16(2*uo),this.dyn_dtree=new Ir.Buf16(2*(2*ao+1)),this.bl_tree=new Ir.Buf16(2*(2*lo+1)),Oo(this.dyn_ltree),Oo(this.dyn_dtree),Oo(this.bl_tree),this.l_desc=null,this.d_desc=null,this.bl_desc=null,this.bl_count=new Ir.Buf16(ho+1),this.heap=new Ir.Buf16(2*so+1),Oo(this.heap),this.heap_len=0,this.heap_max=0,this.depth=new Ir.Buf16(2*so+1),Oo(this.depth),this.l_buf=0,this.lit_bufsize=0,this.last_lit=0,this.d_buf=0,this.opt_len=0,this.static_len=0,this.matches=0,this.insert=0,this.bi_buf=0,this.bi_valid=0;}function No(e){var t;return e&&e.state?(e.total_in=e.total_out=0,e.data_type=to,(t=e.state).pending=0,t.pending_out=0,t.wrap<0&&(t.wrap=-t.wrap),t.status=t.wrap?mo:wo,e.adler=2===t.wrap?0:1,t.last_flush=Di,Bi._tr_init(t),qi):To(e,Vi)}function Zo(e){var t,n=No(e);return n===qi&&((t=e.state).window_size=2*t.w_size,Oo(t.head),t.max_lazy_match=Pi[t.level].max_lazy,t.good_match=Pi[t.level].good_length,t.nice_match=Pi[t.level].nice_length,t.max_chain_length=Pi[t.level].max_chain,t.strstart=0,t.block_start=0,t.lookahead=0,t.insert=0,t.match_length=t.prev_length=co-1,t.match_available=0,t.ins_h=0),n}function Wo(e,t,n,r,i,o){if(!e)return Vi;var s=1;if(t===Ki&&(t=6),r<0?(s=0,r=-r):r>15&&(s=2,r-=16),i<1||i>ro||n!==no||r<8||r>15||t<0||t>9||o<0||o>Qi)return To(e,Vi);8===r&&(r=9);var a=new jo;return e.state=a,a.strm=e,a.wrap=s,a.gzhead=null,a.w_bits=r,a.w_size=1<<a.w_bits,a.w_mask=a.w_size-1,a.hash_bits=i+7,a.hash_size=1<<a.hash_bits,a.hash_mask=a.hash_size-1,a.hash_shift=~~((a.hash_bits+co-1)/co),a.window=new Ir.Buf8(2*a.w_size),a.head=new Ir.Buf16(a.hash_size),a.prev=new Ir.Buf16(a.w_size),a.lit_bufsize=1<<i+6,a.pending_buf_size=4*a.lit_bufsize,a.pending_buf=new Ir.Buf8(a.pending_buf_size),a.d_buf=1*a.lit_bufsize,a.l_buf=3*a.lit_bufsize,a.level=t,a.strategy=o,a.method=n,Zo(e)}Pi=[new Do(0,0,0,0,function(e,t){var n=65535;for(n>e.pending_buf_size-5&&(n=e.pending_buf_size-5);;){if(e.lookahead<=1){if(Po(e),0===e.lookahead&&t===Di)return So;if(0===e.lookahead)break}e.strstart+=e.lookahead,e.lookahead=0;var r=e.block_start+n;if((0===e.strstart||e.strstart>=r)&&(e.lookahead=e.strstart-r,e.strstart=r,Lo(e,!1),0===e.strm.avail_out))return So;if(e.strstart-e.block_start>=e.w_size-po&&(Lo(e,!1),0===e.strm.avail_out))return So}return e.insert=0,t===Zi?(Lo(e,!0),0===e.strm.avail_out?Co:Eo):(e.strstart>e.block_start&&(Lo(e,!1),e.strm.avail_out),So)}),new Do(4,4,8,4,Mo),new Do(4,5,16,8,Mo),new Do(4,6,32,32,Mo),new Do(4,4,16,16,Uo),new Do(8,16,32,32,Uo),new Do(8,16,128,128,Uo),new Do(8,32,128,256,Uo),new Do(32,128,258,1024,Uo),new Do(32,258,258,4096,Uo)];var qo={deflateInit:function(e,t){return Wo(e,t,no,io,oo,eo)},deflateInit2:Wo,deflateReset:Zo,deflateResetKeep:No,deflateSetHeader:function(e,t){return e&&e.state?2!==e.state.wrap?Vi:(e.state.gzhead=t,qi):Vi},deflate:function(e,t){var n,r,i,o;if(!e||!e.state||t>Wi||t<0)return e?To(e,Vi):Vi;if(r=e.state,!e.output||!e.input&&0!==e.avail_in||r.status===ko&&t!==Zi)return To(e,0===e.avail_out?Gi:Vi);if(r.strm=e,n=r.last_flush,r.last_flush=t,r.status===mo)if(2===r.wrap)e.adler=0,Bo(r,31),Bo(r,139),Bo(r,8),r.gzhead?(Bo(r,(r.gzhead.text?1:0)+(r.gzhead.hcrc?2:0)+(r.gzhead.extra?4:0)+(r.gzhead.name?8:0)+(r.gzhead.comment?16:0)),Bo(r,255&r.gzhead.time),Bo(r,r.gzhead.time>>8&255),Bo(r,r.gzhead.time>>16&255),Bo(r,r.gzhead.time>>24&255),Bo(r,9===r.level?2:r.strategy>=Xi||r.level<2?4:0),Bo(r,255&r.gzhead.os),r.gzhead.extra&&r.gzhead.extra.length&&(Bo(r,255&r.gzhead.extra.length),Bo(r,r.gzhead.extra.length>>8&255)),r.gzhead.hcrc&&(e.adler=Mi(e.adler,r.pending_buf,r.pending,0)),r.gzindex=0,r.status=vo):(Bo(r,0),Bo(r,0),Bo(r,0),Bo(r,0),Bo(r,0),Bo(r,9===r.level?2:r.strategy>=Xi||r.level<2?4:0),Bo(r,Ao),r.status=wo);else {var s=no+(r.w_bits-8<<4)<<8;s|=(r.strategy>=Xi||r.level<2?0:r.level<6?1:6===r.level?2:3)<<6,0!==r.strstart&&(s|=go),s+=31-s%31,r.status=wo,Io(r,s),0!==r.strstart&&(Io(r,e.adler>>>16),Io(r,65535&e.adler)),e.adler=1;}if(r.status===vo)if(r.gzhead.extra){for(i=r.pending;r.gzindex<(65535&r.gzhead.extra.length)&&(r.pending!==r.pending_buf_size||(r.gzhead.hcrc&&r.pending>i&&(e.adler=Mi(e.adler,r.pending_buf,r.pending-i,i)),Ro(e),i=r.pending,r.pending!==r.pending_buf_size));)Bo(r,255&r.gzhead.extra[r.gzindex]),r.gzindex++;r.gzhead.hcrc&&r.pending>i&&(e.adler=Mi(e.adler,r.pending_buf,r.pending-i,i)),r.gzindex===r.gzhead.extra.length&&(r.gzindex=0,r.status=_o);}else r.status=_o;if(r.status===_o)if(r.gzhead.name){i=r.pending;do{if(r.pending===r.pending_buf_size&&(r.gzhead.hcrc&&r.pending>i&&(e.adler=Mi(e.adler,r.pending_buf,r.pending-i,i)),Ro(e),i=r.pending,r.pending===r.pending_buf_size)){o=1;break}o=r.gzindex<r.gzhead.name.length?255&r.gzhead.name.charCodeAt(r.gzindex++):0,Bo(r,o);}while(0!==o);r.gzhead.hcrc&&r.pending>i&&(e.adler=Mi(e.adler,r.pending_buf,r.pending-i,i)),0===o&&(r.gzindex=0,r.status=yo);}else r.status=yo;if(r.status===yo)if(r.gzhead.comment){i=r.pending;do{if(r.pending===r.pending_buf_size&&(r.gzhead.hcrc&&r.pending>i&&(e.adler=Mi(e.adler,r.pending_buf,r.pending-i,i)),Ro(e),i=r.pending,r.pending===r.pending_buf_size)){o=1;break}o=r.gzindex<r.gzhead.comment.length?255&r.gzhead.comment.charCodeAt(r.gzindex++):0,Bo(r,o);}while(0!==o);r.gzhead.hcrc&&r.pending>i&&(e.adler=Mi(e.adler,r.pending_buf,r.pending-i,i)),0===o&&(r.status=bo);}else r.status=bo;if(r.status===bo&&(r.gzhead.hcrc?(r.pending+2>r.pending_buf_size&&Ro(e),r.pending+2<=r.pending_buf_size&&(Bo(r,255&e.adler),Bo(r,e.adler>>8&255),e.adler=0,r.status=wo)):r.status=wo),0!==r.pending){if(Ro(e),0===e.avail_out)return r.last_flush=-1,qi}else if(0===e.avail_in&&zo(t)<=zo(n)&&t!==Zi)return To(e,Gi);if(r.status===ko&&0!==e.avail_in)return To(e,Gi);if(0!==e.avail_in||0!==r.lookahead||t!==Di&&r.status!==ko){var a=r.strategy===Xi?function(e,t){for(var n;;){if(0===e.lookahead&&(Po(e),0===e.lookahead)){if(t===Di)return So;break}if(e.match_length=0,n=Bi._tr_tally(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++,n&&(Lo(e,!1),0===e.strm.avail_out))return So}return e.insert=0,t===Zi?(Lo(e,!0),0===e.strm.avail_out?Co:Eo):e.last_lit&&(Lo(e,!1),0===e.strm.avail_out)?So:xo}(r,t):r.strategy===$i?function(e,t){for(var n,r,i,o,s=e.window;;){if(e.lookahead<=fo){if(Po(e),e.lookahead<=fo&&t===Di)return So;if(0===e.lookahead)break}if(e.match_length=0,e.lookahead>=co&&e.strstart>0&&(r=s[i=e.strstart-1])===s[++i]&&r===s[++i]&&r===s[++i]){o=e.strstart+fo;do{}while(r===s[++i]&&r===s[++i]&&r===s[++i]&&r===s[++i]&&r===s[++i]&&r===s[++i]&&r===s[++i]&&r===s[++i]&&i<o);e.match_length=fo-(o-i),e.match_length>e.lookahead&&(e.match_length=e.lookahead);}if(e.match_length>=co?(n=Bi._tr_tally(e,1,e.match_length-co),e.lookahead-=e.match_length,e.strstart+=e.match_length,e.match_length=0):(n=Bi._tr_tally(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++),n&&(Lo(e,!1),0===e.strm.avail_out))return So}return e.insert=0,t===Zi?(Lo(e,!0),0===e.strm.avail_out?Co:Eo):e.last_lit&&(Lo(e,!1),0===e.strm.avail_out)?So:xo}(r,t):Pi[r.level].func(r,t);if(a!==Co&&a!==Eo||(r.status=ko),a===So||a===Co)return 0===e.avail_out&&(r.last_flush=-1),qi;if(a===xo&&(t===ji?Bi._tr_align(r):t!==Wi&&(Bi._tr_stored_block(r,0,0,!1),t===Ni&&(Oo(r.head),0===r.lookahead&&(r.strstart=0,r.block_start=0,r.insert=0))),Ro(e),0===e.avail_out))return r.last_flush=-1,qi}return t!==Zi?qi:r.wrap<=0?Yi:(2===r.wrap?(Bo(r,255&e.adler),Bo(r,e.adler>>8&255),Bo(r,e.adler>>16&255),Bo(r,e.adler>>24&255),Bo(r,255&e.total_in),Bo(r,e.total_in>>8&255),Bo(r,e.total_in>>16&255),Bo(r,e.total_in>>24&255)):(Io(r,e.adler>>>16),Io(r,65535&e.adler)),Ro(e),r.wrap>0&&(r.wrap=-r.wrap),0!==r.pending?qi:Yi)},deflateEnd:function(e){var t;return e&&e.state?(t=e.state.status)!==mo&&t!==vo&&t!==_o&&t!==yo&&t!==bo&&t!==wo&&t!==ko?To(e,Vi):(e.state=null,t===wo?To(e,Hi):qi):Vi},deflateSetDictionary:function(e,t){var n,r,i,o,s,a,l,u,h=t.length;if(!e||!e.state)return Vi;if(2===(o=(n=e.state).wrap)||1===o&&n.status!==mo||n.lookahead)return Vi;for(1===o&&(e.adler=Ii(e.adler,t,h,0)),n.wrap=0,h>=n.w_size&&(0===o&&(Oo(n.head),n.strstart=0,n.block_start=0,n.insert=0),u=new Ir.Buf8(n.w_size),Ir.arraySet(u,t,h-n.w_size,n.w_size,0),t=u,h=n.w_size),s=e.avail_in,a=e.next_in,l=e.input,e.avail_in=h,e.next_in=0,e.input=t,Po(n);n.lookahead>=co;){r=n.strstart,i=n.lookahead-(co-1);do{n.ins_h=(n.ins_h<<n.hash_shift^n.window[r+co-1])&n.hash_mask,n.prev[r&n.w_mask]=n.head[n.ins_h],n.head[n.ins_h]=r,r++;}while(--i);n.strstart=r,n.lookahead=co-1,Po(n);}return n.strstart+=n.lookahead,n.block_start=n.strstart,n.insert=n.lookahead,n.lookahead=0,n.match_length=n.prev_length=co-1,n.match_available=0,e.next_in=a,e.input=l,e.avail_in=s,n.wrap=o,qi},deflateInfo:"pako deflate (from Nodeca project)"},Yo=!0,Vo=!0;try{String.fromCharCode.apply(null,[0]);}catch(e){Yo=!1;}try{String.fromCharCode.apply(null,new Uint8Array(1));}catch(e){Vo=!1;}for(var Ho=new Ir.Buf8(256),Go=0;Go<256;Go++)Ho[Go]=Go>=252?6:Go>=248?5:Go>=240?4:Go>=224?3:Go>=192?2:1;Ho[254]=Ho[254]=1;function Ko(e,t){if(t<65537&&(e.subarray&&Vo||!e.subarray&&Yo))return String.fromCharCode.apply(null,Ir.shrinkBuf(e,t));for(var n="",r=0;r<t;r++)n+=String.fromCharCode(e[r]);return n}var Jo={string2buf:function(e){var t,n,r,i,o,s=e.length,a=0;for(i=0;i<s;i++)55296==(64512&(n=e.charCodeAt(i)))&&i+1<s&&56320==(64512&(r=e.charCodeAt(i+1)))&&(n=65536+(n-55296<<10)+(r-56320),i++),a+=n<128?1:n<2048?2:n<65536?3:4;for(t=new Ir.Buf8(a),o=0,i=0;o<a;i++)55296==(64512&(n=e.charCodeAt(i)))&&i+1<s&&56320==(64512&(r=e.charCodeAt(i+1)))&&(n=65536+(n-55296<<10)+(r-56320),i++),n<128?t[o++]=n:n<2048?(t[o++]=192|n>>>6,t[o++]=128|63&n):n<65536?(t[o++]=224|n>>>12,t[o++]=128|n>>>6&63,t[o++]=128|63&n):(t[o++]=240|n>>>18,t[o++]=128|n>>>12&63,t[o++]=128|n>>>6&63,t[o++]=128|63&n);return t},buf2binstring:function(e){return Ko(e,e.length)},binstring2buf:function(e){for(var t=new Ir.Buf8(e.length),n=0,r=t.length;n<r;n++)t[n]=e.charCodeAt(n);return t},buf2string:function(e,t){var n,r,i,o,s=t||e.length,a=new Array(2*s);for(r=0,n=0;n<s;)if((i=e[n++])<128)a[r++]=i;else if((o=Ho[i])>4)a[r++]=65533,n+=o-1;else {for(i&=2===o?31:3===o?15:7;o>1&&n<s;)i=i<<6|63&e[n++],o--;o>1?a[r++]=65533:i<65536?a[r++]=i:(i-=65536,a[r++]=55296|i>>10&1023,a[r++]=56320|1023&i);}return Ko(a,r)},utf8border:function(e,t){var n;for((t=t||e.length)>e.length&&(t=e.length),n=t-1;n>=0&&128==(192&e[n]);)n--;return n<0?t:0===n?t:n+Ho[e[n]]>t?n:t}};var Xo=function(){this.input=null,this.next_in=0,this.avail_in=0,this.total_in=0,this.output=null,this.next_out=0,this.avail_out=0,this.total_out=0,this.msg="",this.state=null,this.data_type=2,this.adler=0;},$o=Object.prototype.toString,Qo=0,es=-1,ts=0,ns=8;function rs(e){if(!(this instanceof rs))return new rs(e);this.options=Ir.assign({level:es,method:ns,chunkSize:16384,windowBits:15,memLevel:8,strategy:ts,to:""},e||{});var t=this.options;t.raw&&t.windowBits>0?t.windowBits=-t.windowBits:t.gzip&&t.windowBits>0&&t.windowBits<16&&(t.windowBits+=16),this.err=0,this.msg="",this.ended=!1,this.chunks=[],this.strm=new Xo,this.strm.avail_out=0;var n=qo.deflateInit2(this.strm,t.level,t.method,t.windowBits,t.memLevel,t.strategy);if(n!==Qo)throw new Error(Ui[n]);if(t.header&&qo.deflateSetHeader(this.strm,t.header),t.dictionary){var r;if(r="string"==typeof t.dictionary?Jo.string2buf(t.dictionary):"[object ArrayBuffer]"===$o.call(t.dictionary)?new Uint8Array(t.dictionary):t.dictionary,(n=qo.deflateSetDictionary(this.strm,r))!==Qo)throw new Error(Ui[n]);this._dict_set=!0;}}function is(e,t){var n=new rs(t);if(n.push(e,!0),n.err)throw n.msg||Ui[n.err];return n.result}rs.prototype.push=function(e,t){var n,r,i=this.strm,o=this.options.chunkSize;if(this.ended)return !1;r=t===~~t?t:!0===t?4:0,"string"==typeof e?i.input=Jo.string2buf(e):"[object ArrayBuffer]"===$o.call(e)?i.input=new Uint8Array(e):i.input=e,i.next_in=0,i.avail_in=i.input.length;do{if(0===i.avail_out&&(i.output=new Ir.Buf8(o),i.next_out=0,i.avail_out=o),1!==(n=qo.deflate(i,r))&&n!==Qo)return this.onEnd(n),this.ended=!0,!1;0!==i.avail_out&&(0!==i.avail_in||4!==r&&2!==r)||("string"===this.options.to?this.onData(Jo.buf2binstring(Ir.shrinkBuf(i.output,i.next_out))):this.onData(Ir.shrinkBuf(i.output,i.next_out)));}while((i.avail_in>0||0===i.avail_out)&&1!==n);return 4===r?(n=qo.deflateEnd(this.strm),this.onEnd(n),this.ended=!0,n===Qo):2!==r||(this.onEnd(Qo),i.avail_out=0,!0)},rs.prototype.onData=function(e){this.chunks.push(e);},rs.prototype.onEnd=function(e){e===Qo&&("string"===this.options.to?this.result=this.chunks.join(""):this.result=Ir.flattenChunks(this.chunks)),this.chunks=[],this.err=e,this.msg=this.strm.msg;};var os={Deflate:rs,deflate:is,deflateRaw:function(e,t){return (t=t||{}).raw=!0,is(e,t)},gzip:function(e,t){return (t=t||{}).gzip=!0,is(e,t)}},ss=function(e,t){var n,r,i,o,s,a,l,u,h,c,f,d,p,g,m,v,_,y,b,w,k,S,x,C,E;n=e.state,r=e.next_in,C=e.input,i=r+(e.avail_in-5),o=e.next_out,E=e.output,s=o-(t-e.avail_out),a=o+(e.avail_out-257),l=n.dmax,u=n.wsize,h=n.whave,c=n.wnext,f=n.window,d=n.hold,p=n.bits,g=n.lencode,m=n.distcode,v=(1<<n.lenbits)-1,_=(1<<n.distbits)-1;e:do{p<15&&(d+=C[r++]<<p,p+=8,d+=C[r++]<<p,p+=8),y=g[d&v];t:for(;;){if(d>>>=b=y>>>24,p-=b,0===(b=y>>>16&255))E[o++]=65535&y;else {if(!(16&b)){if(0==(64&b)){y=g[(65535&y)+(d&(1<<b)-1)];continue t}if(32&b){n.mode=12;break e}e.msg="invalid literal/length code",n.mode=30;break e}w=65535&y,(b&=15)&&(p<b&&(d+=C[r++]<<p,p+=8),w+=d&(1<<b)-1,d>>>=b,p-=b),p<15&&(d+=C[r++]<<p,p+=8,d+=C[r++]<<p,p+=8),y=m[d&_];n:for(;;){if(d>>>=b=y>>>24,p-=b,!(16&(b=y>>>16&255))){if(0==(64&b)){y=m[(65535&y)+(d&(1<<b)-1)];continue n}e.msg="invalid distance code",n.mode=30;break e}if(k=65535&y,p<(b&=15)&&(d+=C[r++]<<p,(p+=8)<b&&(d+=C[r++]<<p,p+=8)),(k+=d&(1<<b)-1)>l){e.msg="invalid distance too far back",n.mode=30;break e}if(d>>>=b,p-=b,k>(b=o-s)){if((b=k-b)>h&&n.sane){e.msg="invalid distance too far back",n.mode=30;break e}if(S=0,x=f,0===c){if(S+=u-b,b<w){w-=b;do{E[o++]=f[S++];}while(--b);S=o-k,x=E;}}else if(c<b){if(S+=u+c-b,(b-=c)<w){w-=b;do{E[o++]=f[S++];}while(--b);if(S=0,c<w){w-=b=c;do{E[o++]=f[S++];}while(--b);S=o-k,x=E;}}}else if(S+=c-b,b<w){w-=b;do{E[o++]=f[S++];}while(--b);S=o-k,x=E;}for(;w>2;)E[o++]=x[S++],E[o++]=x[S++],E[o++]=x[S++],w-=3;w&&(E[o++]=x[S++],w>1&&(E[o++]=x[S++]));}else {S=o-k;do{E[o++]=E[S++],E[o++]=E[S++],E[o++]=E[S++],w-=3;}while(w>2);w&&(E[o++]=E[S++],w>1&&(E[o++]=E[S++]));}break}}break}}while(r<i&&o<a);r-=w=p>>3,d&=(1<<(p-=w<<3))-1,e.next_in=r,e.next_out=o,e.avail_in=r<i?i-r+5:5-(r-i),e.avail_out=o<a?a-o+257:257-(o-a),n.hold=d,n.bits=p;},as=[3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258,0,0],ls=[16,16,16,16,16,16,16,16,17,17,17,17,18,18,18,18,19,19,19,19,20,20,20,20,21,21,21,21,16,72,78],us=[1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577,0,0],hs=[16,16,16,16,17,17,18,18,19,19,20,20,21,21,22,22,23,23,24,24,25,25,26,26,27,27,28,28,29,29,64,64],cs=function(e,t,n,r,i,o,s,a){var l,u,h,c,f,d,p,g,m,v=a.bits,_=0,y=0,b=0,w=0,k=0,S=0,x=0,C=0,E=0,A=0,T=null,z=0,O=new Ir.Buf16(16),R=new Ir.Buf16(16),L=null,B=0;for(_=0;_<=15;_++)O[_]=0;for(y=0;y<r;y++)O[t[n+y]]++;for(k=v,w=15;w>=1&&0===O[w];w--);if(k>w&&(k=w),0===w)return i[o++]=20971520,i[o++]=20971520,a.bits=1,0;for(b=1;b<w&&0===O[b];b++);for(k<b&&(k=b),C=1,_=1;_<=15;_++)if(C<<=1,(C-=O[_])<0)return -1;if(C>0&&(0===e||1!==w))return -1;for(R[1]=0,_=1;_<15;_++)R[_+1]=R[_]+O[_];for(y=0;y<r;y++)0!==t[n+y]&&(s[R[t[n+y]]++]=y);if(0===e?(T=L=s,d=19):1===e?(T=as,z-=257,L=ls,B-=257,d=256):(T=us,L=hs,d=-1),A=0,y=0,_=b,f=o,S=k,x=0,h=-1,c=(E=1<<k)-1,1===e&&E>852||2===e&&E>592)return 1;for(;;){p=_-x,s[y]<d?(g=0,m=s[y]):s[y]>d?(g=L[B+s[y]],m=T[z+s[y]]):(g=96,m=0),l=1<<_-x,b=u=1<<S;do{i[f+(A>>x)+(u-=l)]=p<<24|g<<16|m|0;}while(0!==u);for(l=1<<_-1;A&l;)l>>=1;if(0!==l?(A&=l-1,A+=l):A=0,y++,0==--O[_]){if(_===w)break;_=t[n+s[y]];}if(_>k&&(A&c)!==h){for(0===x&&(x=k),f+=b,C=1<<(S=_-x);S+x<w&&!((C-=O[S+x])<=0);)S++,C<<=1;if(E+=1<<S,1===e&&E>852||2===e&&E>592)return 1;i[h=A&c]=k<<24|S<<16|f-o|0;}}return 0!==A&&(i[f+A]=_-x<<24|64<<16|0),a.bits=k,0},fs=0,ds=1,ps=2,gs=4,ms=5,vs=6,_s=0,ys=1,bs=2,ws=-2,ks=-3,Ss=-4,xs=-5,Cs=8,Es=1,As=2,Ts=3,zs=4,Os=5,Rs=6,Ls=7,Bs=8,Is=9,Fs=10,Ps=11,Ms=12,Us=13,Ds=14,js=15,Ns=16,Zs=17,Ws=18,qs=19,Ys=20,Vs=21,Hs=22,Gs=23,Ks=24,Js=25,Xs=26,$s=27,Qs=28,ea=29,ta=30,na=31,ra=32,ia=852,oa=592,sa=15;function aa(e){return (e>>>24&255)+(e>>>8&65280)+((65280&e)<<8)+((255&e)<<24)}function la(){this.mode=0,this.last=!1,this.wrap=0,this.havedict=!1,this.flags=0,this.dmax=0,this.check=0,this.total=0,this.head=null,this.wbits=0,this.wsize=0,this.whave=0,this.wnext=0,this.window=null,this.hold=0,this.bits=0,this.length=0,this.offset=0,this.extra=0,this.lencode=null,this.distcode=null,this.lenbits=0,this.distbits=0,this.ncode=0,this.nlen=0,this.ndist=0,this.have=0,this.next=null,this.lens=new Ir.Buf16(320),this.work=new Ir.Buf16(288),this.lendyn=null,this.distdyn=null,this.sane=0,this.back=0,this.was=0;}function ua(e){var t;return e&&e.state?(t=e.state,e.total_in=e.total_out=t.total=0,e.msg="",t.wrap&&(e.adler=1&t.wrap),t.mode=Es,t.last=0,t.havedict=0,t.dmax=32768,t.head=null,t.hold=0,t.bits=0,t.lencode=t.lendyn=new Ir.Buf32(ia),t.distcode=t.distdyn=new Ir.Buf32(oa),t.sane=1,t.back=-1,_s):ws}function ha(e){var t;return e&&e.state?((t=e.state).wsize=0,t.whave=0,t.wnext=0,ua(e)):ws}function ca(e,t){var n,r;return e&&e.state?(r=e.state,t<0?(n=0,t=-t):(n=1+(t>>4),t<48&&(t&=15)),t&&(t<8||t>15)?ws:(null!==r.window&&r.wbits!==t&&(r.window=null),r.wrap=n,r.wbits=t,ha(e))):ws}function fa(e,t){var n,r;return e?(r=new la,e.state=r,r.window=null,(n=ca(e,t))!==_s&&(e.state=null),n):ws}var da,pa,ga=!0;function ma(e){if(ga){var t;for(da=new Ir.Buf32(512),pa=new Ir.Buf32(32),t=0;t<144;)e.lens[t++]=8;for(;t<256;)e.lens[t++]=9;for(;t<280;)e.lens[t++]=7;for(;t<288;)e.lens[t++]=8;for(cs(ds,e.lens,0,288,da,0,e.work,{bits:9}),t=0;t<32;)e.lens[t++]=5;cs(ps,e.lens,0,32,pa,0,e.work,{bits:5}),ga=!1;}e.lencode=da,e.lenbits=9,e.distcode=pa,e.distbits=5;}function va(e,t,n,r){var i,o=e.state;return null===o.window&&(o.wsize=1<<o.wbits,o.wnext=0,o.whave=0,o.window=new Ir.Buf8(o.wsize)),r>=o.wsize?(Ir.arraySet(o.window,t,n-o.wsize,o.wsize,0),o.wnext=0,o.whave=o.wsize):((i=o.wsize-o.wnext)>r&&(i=r),Ir.arraySet(o.window,t,n-r,i,o.wnext),(r-=i)?(Ir.arraySet(o.window,t,n-r,r,0),o.wnext=r,o.whave=o.wsize):(o.wnext+=i,o.wnext===o.wsize&&(o.wnext=0),o.whave<o.wsize&&(o.whave+=i))),0}var _a={inflateReset:ha,inflateReset2:ca,inflateResetKeep:ua,inflateInit:function(e){return fa(e,sa)},inflateInit2:fa,inflate:function(e,t){var n,r,i,o,s,a,l,u,h,c,f,d,p,g,m,v,_,y,b,w,k,S,x,C,E=0,A=new Ir.Buf8(4),T=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15];if(!e||!e.state||!e.output||!e.input&&0!==e.avail_in)return ws;(n=e.state).mode===Ms&&(n.mode=Us),s=e.next_out,i=e.output,l=e.avail_out,o=e.next_in,r=e.input,a=e.avail_in,u=n.hold,h=n.bits,c=a,f=l,S=_s;e:for(;;)switch(n.mode){case Es:if(0===n.wrap){n.mode=Us;break}for(;h<16;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}if(2&n.wrap&&35615===u){n.check=0,A[0]=255&u,A[1]=u>>>8&255,n.check=Mi(n.check,A,2,0),u=0,h=0,n.mode=As;break}if(n.flags=0,n.head&&(n.head.done=!1),!(1&n.wrap)||(((255&u)<<8)+(u>>8))%31){e.msg="incorrect header check",n.mode=ta;break}if((15&u)!==Cs){e.msg="unknown compression method",n.mode=ta;break}if(h-=4,k=8+(15&(u>>>=4)),0===n.wbits)n.wbits=k;else if(k>n.wbits){e.msg="invalid window size",n.mode=ta;break}n.dmax=1<<k,e.adler=n.check=1,n.mode=512&u?Fs:Ms,u=0,h=0;break;case As:for(;h<16;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}if(n.flags=u,(255&n.flags)!==Cs){e.msg="unknown compression method",n.mode=ta;break}if(57344&n.flags){e.msg="unknown header flags set",n.mode=ta;break}n.head&&(n.head.text=u>>8&1),512&n.flags&&(A[0]=255&u,A[1]=u>>>8&255,n.check=Mi(n.check,A,2,0)),u=0,h=0,n.mode=Ts;case Ts:for(;h<32;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}n.head&&(n.head.time=u),512&n.flags&&(A[0]=255&u,A[1]=u>>>8&255,A[2]=u>>>16&255,A[3]=u>>>24&255,n.check=Mi(n.check,A,4,0)),u=0,h=0,n.mode=zs;case zs:for(;h<16;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}n.head&&(n.head.xflags=255&u,n.head.os=u>>8),512&n.flags&&(A[0]=255&u,A[1]=u>>>8&255,n.check=Mi(n.check,A,2,0)),u=0,h=0,n.mode=Os;case Os:if(1024&n.flags){for(;h<16;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}n.length=u,n.head&&(n.head.extra_len=u),512&n.flags&&(A[0]=255&u,A[1]=u>>>8&255,n.check=Mi(n.check,A,2,0)),u=0,h=0;}else n.head&&(n.head.extra=null);n.mode=Rs;case Rs:if(1024&n.flags&&((d=n.length)>a&&(d=a),d&&(n.head&&(k=n.head.extra_len-n.length,n.head.extra||(n.head.extra=new Array(n.head.extra_len)),Ir.arraySet(n.head.extra,r,o,d,k)),512&n.flags&&(n.check=Mi(n.check,r,d,o)),a-=d,o+=d,n.length-=d),n.length))break e;n.length=0,n.mode=Ls;case Ls:if(2048&n.flags){if(0===a)break e;d=0;do{k=r[o+d++],n.head&&k&&n.length<65536&&(n.head.name+=String.fromCharCode(k));}while(k&&d<a);if(512&n.flags&&(n.check=Mi(n.check,r,d,o)),a-=d,o+=d,k)break e}else n.head&&(n.head.name=null);n.length=0,n.mode=Bs;case Bs:if(4096&n.flags){if(0===a)break e;d=0;do{k=r[o+d++],n.head&&k&&n.length<65536&&(n.head.comment+=String.fromCharCode(k));}while(k&&d<a);if(512&n.flags&&(n.check=Mi(n.check,r,d,o)),a-=d,o+=d,k)break e}else n.head&&(n.head.comment=null);n.mode=Is;case Is:if(512&n.flags){for(;h<16;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}if(u!==(65535&n.check)){e.msg="header crc mismatch",n.mode=ta;break}u=0,h=0;}n.head&&(n.head.hcrc=n.flags>>9&1,n.head.done=!0),e.adler=n.check=0,n.mode=Ms;break;case Fs:for(;h<32;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}e.adler=n.check=aa(u),u=0,h=0,n.mode=Ps;case Ps:if(0===n.havedict)return e.next_out=s,e.avail_out=l,e.next_in=o,e.avail_in=a,n.hold=u,n.bits=h,bs;e.adler=n.check=1,n.mode=Ms;case Ms:if(t===ms||t===vs)break e;case Us:if(n.last){u>>>=7&h,h-=7&h,n.mode=$s;break}for(;h<3;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}switch(n.last=1&u,h-=1,3&(u>>>=1)){case 0:n.mode=Ds;break;case 1:if(ma(n),n.mode=Ys,t===vs){u>>>=2,h-=2;break e}break;case 2:n.mode=Zs;break;case 3:e.msg="invalid block type",n.mode=ta;}u>>>=2,h-=2;break;case Ds:for(u>>>=7&h,h-=7&h;h<32;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}if((65535&u)!=(u>>>16^65535)){e.msg="invalid stored block lengths",n.mode=ta;break}if(n.length=65535&u,u=0,h=0,n.mode=js,t===vs)break e;case js:n.mode=Ns;case Ns:if(d=n.length){if(d>a&&(d=a),d>l&&(d=l),0===d)break e;Ir.arraySet(i,r,o,d,s),a-=d,o+=d,l-=d,s+=d,n.length-=d;break}n.mode=Ms;break;case Zs:for(;h<14;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}if(n.nlen=257+(31&u),u>>>=5,h-=5,n.ndist=1+(31&u),u>>>=5,h-=5,n.ncode=4+(15&u),u>>>=4,h-=4,n.nlen>286||n.ndist>30){e.msg="too many length or distance symbols",n.mode=ta;break}n.have=0,n.mode=Ws;case Ws:for(;n.have<n.ncode;){for(;h<3;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}n.lens[T[n.have++]]=7&u,u>>>=3,h-=3;}for(;n.have<19;)n.lens[T[n.have++]]=0;if(n.lencode=n.lendyn,n.lenbits=7,x={bits:n.lenbits},S=cs(fs,n.lens,0,19,n.lencode,0,n.work,x),n.lenbits=x.bits,S){e.msg="invalid code lengths set",n.mode=ta;break}n.have=0,n.mode=qs;case qs:for(;n.have<n.nlen+n.ndist;){for(;v=(E=n.lencode[u&(1<<n.lenbits)-1])>>>16&255,_=65535&E,!((m=E>>>24)<=h);){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}if(_<16)u>>>=m,h-=m,n.lens[n.have++]=_;else {if(16===_){for(C=m+2;h<C;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}if(u>>>=m,h-=m,0===n.have){e.msg="invalid bit length repeat",n.mode=ta;break}k=n.lens[n.have-1],d=3+(3&u),u>>>=2,h-=2;}else if(17===_){for(C=m+3;h<C;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}h-=m,k=0,d=3+(7&(u>>>=m)),u>>>=3,h-=3;}else {for(C=m+7;h<C;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}h-=m,k=0,d=11+(127&(u>>>=m)),u>>>=7,h-=7;}if(n.have+d>n.nlen+n.ndist){e.msg="invalid bit length repeat",n.mode=ta;break}for(;d--;)n.lens[n.have++]=k;}}if(n.mode===ta)break;if(0===n.lens[256]){e.msg="invalid code -- missing end-of-block",n.mode=ta;break}if(n.lenbits=9,x={bits:n.lenbits},S=cs(ds,n.lens,0,n.nlen,n.lencode,0,n.work,x),n.lenbits=x.bits,S){e.msg="invalid literal/lengths set",n.mode=ta;break}if(n.distbits=6,n.distcode=n.distdyn,x={bits:n.distbits},S=cs(ps,n.lens,n.nlen,n.ndist,n.distcode,0,n.work,x),n.distbits=x.bits,S){e.msg="invalid distances set",n.mode=ta;break}if(n.mode=Ys,t===vs)break e;case Ys:n.mode=Vs;case Vs:if(a>=6&&l>=258){e.next_out=s,e.avail_out=l,e.next_in=o,e.avail_in=a,n.hold=u,n.bits=h,ss(e,f),s=e.next_out,i=e.output,l=e.avail_out,o=e.next_in,r=e.input,a=e.avail_in,u=n.hold,h=n.bits,n.mode===Ms&&(n.back=-1);break}for(n.back=0;v=(E=n.lencode[u&(1<<n.lenbits)-1])>>>16&255,_=65535&E,!((m=E>>>24)<=h);){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}if(v&&0==(240&v)){for(y=m,b=v,w=_;v=(E=n.lencode[w+((u&(1<<y+b)-1)>>y)])>>>16&255,_=65535&E,!(y+(m=E>>>24)<=h);){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}u>>>=y,h-=y,n.back+=y;}if(u>>>=m,h-=m,n.back+=m,n.length=_,0===v){n.mode=Xs;break}if(32&v){n.back=-1,n.mode=Ms;break}if(64&v){e.msg="invalid literal/length code",n.mode=ta;break}n.extra=15&v,n.mode=Hs;case Hs:if(n.extra){for(C=n.extra;h<C;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}n.length+=u&(1<<n.extra)-1,u>>>=n.extra,h-=n.extra,n.back+=n.extra;}n.was=n.length,n.mode=Gs;case Gs:for(;v=(E=n.distcode[u&(1<<n.distbits)-1])>>>16&255,_=65535&E,!((m=E>>>24)<=h);){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}if(0==(240&v)){for(y=m,b=v,w=_;v=(E=n.distcode[w+((u&(1<<y+b)-1)>>y)])>>>16&255,_=65535&E,!(y+(m=E>>>24)<=h);){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}u>>>=y,h-=y,n.back+=y;}if(u>>>=m,h-=m,n.back+=m,64&v){e.msg="invalid distance code",n.mode=ta;break}n.offset=_,n.extra=15&v,n.mode=Ks;case Ks:if(n.extra){for(C=n.extra;h<C;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}n.offset+=u&(1<<n.extra)-1,u>>>=n.extra,h-=n.extra,n.back+=n.extra;}if(n.offset>n.dmax){e.msg="invalid distance too far back",n.mode=ta;break}n.mode=Js;case Js:if(0===l)break e;if(d=f-l,n.offset>d){if((d=n.offset-d)>n.whave&&n.sane){e.msg="invalid distance too far back",n.mode=ta;break}d>n.wnext?(d-=n.wnext,p=n.wsize-d):p=n.wnext-d,d>n.length&&(d=n.length),g=n.window;}else g=i,p=s-n.offset,d=n.length;d>l&&(d=l),l-=d,n.length-=d;do{i[s++]=g[p++];}while(--d);0===n.length&&(n.mode=Vs);break;case Xs:if(0===l)break e;i[s++]=n.length,l--,n.mode=Vs;break;case $s:if(n.wrap){for(;h<32;){if(0===a)break e;a--,u|=r[o++]<<h,h+=8;}if(f-=l,e.total_out+=f,n.total+=f,f&&(e.adler=n.check=n.flags?Mi(n.check,i,f,s-f):Ii(n.check,i,f,s-f)),f=l,(n.flags?u:aa(u))!==n.check){e.msg="incorrect data check",n.mode=ta;break}u=0,h=0;}n.mode=Qs;case Qs:if(n.wrap&&n.flags){for(;h<32;){if(0===a)break e;a--,u+=r[o++]<<h,h+=8;}if(u!==(4294967295&n.total)){e.msg="incorrect length check",n.mode=ta;break}u=0,h=0;}n.mode=ea;case ea:S=ys;break e;case ta:S=ks;break e;case na:return Ss;case ra:default:return ws}return e.next_out=s,e.avail_out=l,e.next_in=o,e.avail_in=a,n.hold=u,n.bits=h,(n.wsize||f!==e.avail_out&&n.mode<ta&&(n.mode<$s||t!==gs))&&va(e,e.output,e.next_out,f-e.avail_out),c-=e.avail_in,f-=e.avail_out,e.total_in+=c,e.total_out+=f,n.total+=f,n.wrap&&f&&(e.adler=n.check=n.flags?Mi(n.check,i,f,e.next_out-f):Ii(n.check,i,f,e.next_out-f)),e.data_type=n.bits+(n.last?64:0)+(n.mode===Ms?128:0)+(n.mode===Ys||n.mode===js?256:0),(0===c&&0===f||t===gs)&&S===_s&&(S=xs),S},inflateEnd:function(e){if(!e||!e.state)return ws;var t=e.state;return t.window&&(t.window=null),e.state=null,_s},inflateGetHeader:function(e,t){var n;return e&&e.state?0==(2&(n=e.state).wrap)?ws:(n.head=t,t.done=!1,_s):ws},inflateSetDictionary:function(e,t){var n,r=t.length;return e&&e.state?0!==(n=e.state).wrap&&n.mode!==Ps?ws:n.mode===Ps&&Ii(1,t,r,0)!==n.check?ks:va(e,t,r,r)?(n.mode=na,Ss):(n.havedict=1,_s):ws},inflateInfo:"pako inflate (from Nodeca project)"},ya={Z_NO_FLUSH:0,Z_PARTIAL_FLUSH:1,Z_SYNC_FLUSH:2,Z_FULL_FLUSH:3,Z_FINISH:4,Z_BLOCK:5,Z_TREES:6,Z_OK:0,Z_STREAM_END:1,Z_NEED_DICT:2,Z_ERRNO:-1,Z_STREAM_ERROR:-2,Z_DATA_ERROR:-3,Z_BUF_ERROR:-5,Z_NO_COMPRESSION:0,Z_BEST_SPEED:1,Z_BEST_COMPRESSION:9,Z_DEFAULT_COMPRESSION:-1,Z_FILTERED:1,Z_HUFFMAN_ONLY:2,Z_RLE:3,Z_FIXED:4,Z_DEFAULT_STRATEGY:0,Z_BINARY:0,Z_TEXT:1,Z_UNKNOWN:2,Z_DEFLATED:8};var ba=function(){this.text=0,this.time=0,this.xflags=0,this.os=0,this.extra=null,this.extra_len=0,this.name="",this.comment="",this.hcrc=0,this.done=!1;},wa=Object.prototype.toString;function ka(e){if(!(this instanceof ka))return new ka(e);this.options=Ir.assign({chunkSize:16384,windowBits:0,to:""},e||{});var t=this.options;t.raw&&t.windowBits>=0&&t.windowBits<16&&(t.windowBits=-t.windowBits,0===t.windowBits&&(t.windowBits=-15)),!(t.windowBits>=0&&t.windowBits<16)||e&&e.windowBits||(t.windowBits+=32),t.windowBits>15&&t.windowBits<48&&0==(15&t.windowBits)&&(t.windowBits|=15),this.err=0,this.msg="",this.ended=!1,this.chunks=[],this.strm=new Xo,this.strm.avail_out=0;var n=_a.inflateInit2(this.strm,t.windowBits);if(n!==ya.Z_OK)throw new Error(Ui[n]);this.header=new ba,_a.inflateGetHeader(this.strm,this.header);}function Sa(e,t){var n=new ka(t);if(n.push(e,!0),n.err)throw n.msg||Ui[n.err];return n.result}ka.prototype.push=function(e,t){var n,r,i,o,s,a,l=this.strm,u=this.options.chunkSize,h=this.options.dictionary,c=!1;if(this.ended)return !1;r=t===~~t?t:!0===t?ya.Z_FINISH:ya.Z_NO_FLUSH,"string"==typeof e?l.input=Jo.binstring2buf(e):"[object ArrayBuffer]"===wa.call(e)?l.input=new Uint8Array(e):l.input=e,l.next_in=0,l.avail_in=l.input.length;do{if(0===l.avail_out&&(l.output=new Ir.Buf8(u),l.next_out=0,l.avail_out=u),(n=_a.inflate(l,ya.Z_NO_FLUSH))===ya.Z_NEED_DICT&&h&&(a="string"==typeof h?Jo.string2buf(h):"[object ArrayBuffer]"===wa.call(h)?new Uint8Array(h):h,n=_a.inflateSetDictionary(this.strm,a)),n===ya.Z_BUF_ERROR&&!0===c&&(n=ya.Z_OK,c=!1),n!==ya.Z_STREAM_END&&n!==ya.Z_OK)return this.onEnd(n),this.ended=!0,!1;l.next_out&&(0!==l.avail_out&&n!==ya.Z_STREAM_END&&(0!==l.avail_in||r!==ya.Z_FINISH&&r!==ya.Z_SYNC_FLUSH)||("string"===this.options.to?(i=Jo.utf8border(l.output,l.next_out),o=l.next_out-i,s=Jo.buf2string(l.output,i),l.next_out=o,l.avail_out=u-o,o&&Ir.arraySet(l.output,l.output,i,o,0),this.onData(s)):this.onData(Ir.shrinkBuf(l.output,l.next_out)))),0===l.avail_in&&0===l.avail_out&&(c=!0);}while((l.avail_in>0||0===l.avail_out)&&n!==ya.Z_STREAM_END);return n===ya.Z_STREAM_END&&(r=ya.Z_FINISH),r===ya.Z_FINISH?(n=_a.inflateEnd(this.strm),this.onEnd(n),this.ended=!0,n===ya.Z_OK):r!==ya.Z_SYNC_FLUSH||(this.onEnd(ya.Z_OK),l.avail_out=0,!0)},ka.prototype.onData=function(e){this.chunks.push(e);},ka.prototype.onEnd=function(e){e===ya.Z_OK&&("string"===this.options.to?this.result=this.chunks.join(""):this.result=Ir.flattenChunks(this.chunks)),this.chunks=[],this.err=e,this.msg=this.strm.msg;};var xa={Inflate:ka,inflate:Sa,inflateRaw:function(e,t){return (t=t||{}).raw=!0,Sa(e,t)},ungzip:Sa},Ca={};(0,Ir.assign)(Ca,os,xa,ya);var Ea=Ca,Aa="undefined"!=typeof Uint8Array&&"undefined"!=typeof Uint16Array&&"undefined"!=typeof Uint32Array?"uint8array":"array";function Ta(e,t){ar.call(this,"FlateWorker/"+e),this._pako=null,this._pakoAction=e,this._pakoOptions=t,this.meta={};}or.inherits(Ta,ar),Ta.prototype.processChunk=function(e){this.meta=e.meta,null===this._pako&&this._createPako(),this._pako.push(or.transformTo(Aa,e.data),!1);},Ta.prototype.flush=function(){ar.prototype.flush.call(this),null===this._pako&&this._createPako(),this._pako.push([],!0);},Ta.prototype.cleanUp=function(){ar.prototype.cleanUp.call(this),this._pako=null;},Ta.prototype._createPako=function(){this._pako=new Ea[this._pakoAction]({raw:!0,level:this._pakoOptions.level||-1});var e=this;this._pako.onData=function(t){e.push({data:t,meta:e.meta});};};var za={STORE:{magic:"\0\0",compressWorker:function(e){return new ar("STORE compression")},uncompressWorker:function(){return new ar("STORE decompression")}},DEFLATE:{magic:"\b\0",compressWorker:function(e){return new Ta("Deflate",e)},uncompressWorker:function(){return new Ta("Inflate",{})}}},Oa="PK",Ra="PK",La="PK",Ba="PK",Ia="PK",Fa="PK\b",Pa=function(e,t){var n,r="";for(n=0;n<t;n++)r+=String.fromCharCode(255&e),e>>>=8;return r},Ma=function(e,t,n,r,i,o){var s,a,l=e.file,u=e.compression,h=o!==lr.utf8encode,c=or.transformTo("string",o(l.name)),f=or.transformTo("string",lr.utf8encode(l.name)),d=l.comment,p=or.transformTo("string",o(d)),g=or.transformTo("string",lr.utf8encode(d)),m=f.length!==l.name.length,v=g.length!==d.length,_="",y="",b="",w=l.dir,k=l.date,S={crc32:0,compressedSize:0,uncompressedSize:0};t&&!n||(S.crc32=e.crc32,S.compressedSize=e.compressedSize,S.uncompressedSize=e.uncompressedSize);var x=0;t&&(x|=8),h||!m&&!v||(x|=2048);var C,E,A,T=0,z=0;w&&(T|=16),"UNIX"===i?(z=798,T|=(C=l.unixPermissions,E=w,A=C,C||(A=E?16893:33204),(65535&A)<<16)):(z=20,T|=63&(l.dosPermissions||0)),s=k.getUTCHours(),s<<=6,s|=k.getUTCMinutes(),s<<=5,s|=k.getUTCSeconds()/2,a=k.getUTCFullYear()-1980,a<<=4,a|=k.getUTCMonth()+1,a<<=5,a|=k.getUTCDate(),m&&(y=Pa(1,1)+Pa(xr(c),4)+f,_+="up"+Pa(y.length,2)+y),v&&(b=Pa(1,1)+Pa(xr(p),4)+g,_+="uc"+Pa(b.length,2)+b);var O="";return O+="\n\0",O+=Pa(x,2),O+=u.magic,O+=Pa(s,2),O+=Pa(a,2),O+=Pa(S.crc32,4),O+=Pa(S.compressedSize,4),O+=Pa(S.uncompressedSize,4),O+=Pa(c.length,2),O+=Pa(_.length,2),{fileRecord:Oa+O+c+_,dirRecord:Ra+Pa(z,2)+O+Pa(p.length,2)+"\0\0\0\0"+Pa(T,4)+Pa(r,4)+c+_+p}},Ua=function(e){return Fa+Pa(e.crc32,4)+Pa(e.compressedSize,4)+Pa(e.uncompressedSize,4)};function Da(e,t,n,r){ar.call(this,"ZipFileWorker"),this.bytesWritten=0,this.zipComment=t,this.zipPlatform=n,this.encodeFileName=r,this.streamFiles=e,this.accumulate=!1,this.contentBuffer=[],this.dirRecords=[],this.currentSourceOffset=0,this.entriesCount=0,this.currentFile=null,this._sources=[];}or.inherits(Da,ar),Da.prototype.push=function(e){var t=e.meta.percent||0,n=this.entriesCount,r=this._sources.length;this.accumulate?this.contentBuffer.push(e):(this.bytesWritten+=e.data.length,ar.prototype.push.call(this,{data:e.data,meta:{currentFile:this.currentFile,percent:n?(t+100*(n-r-1))/n:100}}));},Da.prototype.openedSource=function(e){this.currentSourceOffset=this.bytesWritten,this.currentFile=e.file.name;var t=this.streamFiles&&!e.file.dir;if(t){var n=Ma(e,t,!1,this.currentSourceOffset,this.zipPlatform,this.encodeFileName);this.push({data:n.fileRecord,meta:{percent:0}});}else this.accumulate=!0;},Da.prototype.closedSource=function(e){this.accumulate=!1;var t=this.streamFiles&&!e.file.dir,n=Ma(e,t,!0,this.currentSourceOffset,this.zipPlatform,this.encodeFileName);if(this.dirRecords.push(n.dirRecord),t)this.push({data:Ua(e),meta:{percent:100}});else for(this.push({data:n.fileRecord,meta:{percent:0}});this.contentBuffer.length;)this.push(this.contentBuffer.shift());this.currentFile=null;},Da.prototype.flush=function(){for(var e=this.bytesWritten,t=0;t<this.dirRecords.length;t++)this.push({data:this.dirRecords[t],meta:{percent:100}});var n=this.bytesWritten-e,r=function(e,t,n,r,i){var o=or.transformTo("string",i(r));return La+"\0\0\0\0"+Pa(e,2)+Pa(e,2)+Pa(t,4)+Pa(n,4)+Pa(o.length,2)+o}(this.dirRecords.length,n,e,this.zipComment,this.encodeFileName);this.push({data:r,meta:{percent:100}});},Da.prototype.prepareNextSource=function(){this.previous=this._sources.shift(),this.openedSource(this.previous.streamInfo),this.isPaused?this.previous.pause():this.previous.resume();},Da.prototype.registerPrevious=function(e){this._sources.push(e);var t=this;return e.on("data",function(e){t.processChunk(e);}),e.on("end",function(){t.closedSource(t.previous.streamInfo),t._sources.length?t.prepareNextSource():t.end();}),e.on("error",function(e){t.error(e);}),this},Da.prototype.resume=function(){return !!ar.prototype.resume.call(this)&&(!this.previous&&this._sources.length?(this.prepareNextSource(),!0):this.previous||this._sources.length||this.generatedError?void 0:(this.end(),!0))},Da.prototype.error=function(e){var t=this._sources;if(!ar.prototype.error.call(this,e))return !1;for(var n=0;n<t.length;n++)try{t[n].error(e);}catch(e){}return !0},Da.prototype.lock=function(){ar.prototype.lock.call(this);for(var e=this._sources,t=0;t<e.length;t++)e[t].lock();};var ja=Da,Na=function(e,t,n){var r=new ja(t.streamFiles,n,t.platform,t.encodeFileName),i=0;try{e.forEach(function(e,n){i++;var o=function(e,t){var n=e||t,r=za[n];if(!r)throw new Error(n+" is not a valid compression method !");return r}(n.options.compression,t.compression),s=n.options.compressionOptions||t.compressionOptions||{},a=n.dir,l=n.date;n._compressWorker(o,s).withStreamInfo("file",{name:e,dir:a,date:l,comment:n.comment||"",unixPermissions:n.unixPermissions,dosPermissions:n.dosPermissions}).pipe(r);}),r.entriesCount=i;}catch(e){r.error(e);}return r};function Za(e,t){ar.call(this,"Nodejs stream input adapter for "+e),this._upstreamEnded=!1,this._bindStream(t);}or.inherits(Za,ar),Za.prototype._bindStream=function(e){var t=this;this._stream=e,e.pause(),e.on("data",function(e){t.push({data:e,meta:{percent:0}});}).on("error",function(e){t.isPaused?this.generatedError=e:t.error(e);}).on("end",function(){t.isPaused?t._upstreamEnded=!0:t.end();});},Za.prototype.pause=function(){return !!ar.prototype.pause.call(this)&&(this._stream.pause(),!0)},Za.prototype.resume=function(){return !!ar.prototype.resume.call(this)&&(this._upstreamEnded?this.end():this._stream.resume(),!0)};var Wa=Za,qa=function(e,t,n){var r,i=or.getTypeOf(t),o=or.extend(n||{},_r);o.date=o.date||new Date,null!==o.compression&&(o.compression=o.compression.toUpperCase()),"string"==typeof o.unixPermissions&&(o.unixPermissions=parseInt(o.unixPermissions,8)),o.unixPermissions&&16384&o.unixPermissions&&(o.dir=!0),o.dosPermissions&&16&o.dosPermissions&&(o.dir=!0),o.dir&&(e=Va(e)),o.createFolders&&(r=Ya(e))&&Ha.call(this,r,!0);var s="string"===i&&!1===o.binary&&!1===o.base64;n&&void 0!==n.binary||(o.binary=!s),(t instanceof Tr&&0===t.uncompressedSize||o.dir||!t||0===t.length)&&(o.base64=!1,o.binary=!0,t="",o.compression="STORE",i="string");var a=null;a=t instanceof Tr||t instanceof ar?t:$t&&nn(t)?new Wa(e,t):or.prepareContent(e,t,o.binary,o.optimizedBinaryString,o.base64);var l=new Br(e,a,o);this.files[e]=l;},Ya=function(e){"/"===e.slice(-1)&&(e=e.substring(0,e.length-1));var t=e.lastIndexOf("/");return t>0?e.substring(0,t):""},Va=function(e){return "/"!==e.slice(-1)&&(e+="/"),e},Ha=function(e,t){return t=void 0!==t?t:_r.createFolders,e=Va(e),this.files[e]||qa.call(this,e,null,{dir:!0,createFolders:t}),this.files[e]};function Ga(e){return "[object RegExp]"===Object.prototype.toString.call(e)}var Ka={load:function(){throw new Error("This method has been removed in JSZip 3.0, please check the upgrade guide.")},forEach:function(e){var t,n,r;for(t in this.files)this.files.hasOwnProperty(t)&&(r=this.files[t],(n=t.slice(this.root.length,t.length))&&t.slice(0,this.root.length)===this.root&&e(n,r));},filter:function(e){var t=[];return this.forEach(function(n,r){e(n,r)&&t.push(r);}),t},file:function(e,t,n){if(1===arguments.length){if(Ga(e)){var r=e;return this.filter(function(e,t){return !t.dir&&r.test(e)})}var i=this.files[this.root+e];return i&&!i.dir?i:null}return e=this.root+e,qa.call(this,e,t,n),this},folder:function(e){if(!e)return this;if(Ga(e))return this.filter(function(t,n){return n.dir&&e.test(t)});var t=this.root+e,n=Ha.call(this,t),r=this.clone();return r.root=n.name,r},remove:function(e){e=this.root+e;var t=this.files[e];if(t||("/"!==e.slice(-1)&&(e+="/"),t=this.files[e]),t&&!t.dir)delete this.files[e];else for(var n=this.filter(function(t,n){return n.name.slice(0,e.length)===e}),r=0;r<n.length;r++)delete this.files[n[r].name];return this},generate:function(e){throw new Error("This method has been removed in JSZip 3.0, please check the upgrade guide.")},generateInternalStream:function(e){var t,n={};try{if((n=or.extend(e||{},{streamFiles:!1,compression:"STORE",compressionOptions:null,type:"",platform:"DOS",comment:null,mimeType:"application/zip",encodeFileName:lr.utf8encode})).type=n.type.toLowerCase(),n.compression=n.compression.toUpperCase(),"binarystring"===n.type&&(n.type="string"),!n.type)throw new Error("No output type specified.");or.checkSupport(n.type),"darwin"!==n.platform&&"freebsd"!==n.platform&&"linux"!==n.platform&&"sunos"!==n.platform||(n.platform="UNIX"),"win32"===n.platform&&(n.platform="DOS");var r=n.comment||this.comment||"";t=Na(this,n,r);}catch(e){(t=new ar("error")).error(e);}return new vr(t,n.type||"string",n.mimeType)},generateAsync:function(e,t){return this.generateInternalStream(e).accumulate(t)},generateNodeStream:function(e,t){return (e=e||{}).type||(e.type="nodebuffer"),this.generateInternalStream(e).toNodejsStream(t)}};function Ja(e){this.data=e,this.length=e.length,this.index=0,this.zero=0;}Ja.prototype={checkOffset:function(e){this.checkIndex(this.index+e);},checkIndex:function(e){if(this.length<this.zero+e||e<0)throw new Error("End of data reached (data length = "+this.length+", asked index = "+e+"). Corrupted zip ?")},setIndex:function(e){this.checkIndex(e),this.index=e;},skip:function(e){this.setIndex(this.index+e);},byteAt:function(e){},readInt:function(e){var t,n=0;for(this.checkOffset(e),t=this.index+e-1;t>=this.index;t--)n=(n<<8)+this.byteAt(t);return this.index+=e,n},readString:function(e){return or.transformTo("string",this.readData(e))},readData:function(e){},lastIndexOfSignature:function(e){},readAndCheckSignature:function(e){},readDate:function(){var e=this.readInt(4);return new Date(Date.UTC(1980+(e>>25&127),(e>>21&15)-1,e>>16&31,e>>11&31,e>>5&63,(31&e)<<1))}};var Xa=Ja;function $a(e){Xa.call(this,e);for(var t=0;t<this.data.length;t++)e[t]=255&e[t];}or.inherits($a,Xa),$a.prototype.byteAt=function(e){return this.data[this.zero+e]},$a.prototype.lastIndexOfSignature=function(e){for(var t=e.charCodeAt(0),n=e.charCodeAt(1),r=e.charCodeAt(2),i=e.charCodeAt(3),o=this.length-4;o>=0;--o)if(this.data[o]===t&&this.data[o+1]===n&&this.data[o+2]===r&&this.data[o+3]===i)return o-this.zero;return -1},$a.prototype.readAndCheckSignature=function(e){var t=e.charCodeAt(0),n=e.charCodeAt(1),r=e.charCodeAt(2),i=e.charCodeAt(3),o=this.readData(4);return t===o[0]&&n===o[1]&&r===o[2]&&i===o[3]},$a.prototype.readData=function(e){if(this.checkOffset(e),0===e)return [];var t=this.data.slice(this.zero+this.index,this.zero+this.index+e);return this.index+=e,t};var Qa=$a;function el(e){Xa.call(this,e);}or.inherits(el,Xa),el.prototype.byteAt=function(e){return this.data.charCodeAt(this.zero+e)},el.prototype.lastIndexOfSignature=function(e){return this.data.lastIndexOf(e)-this.zero},el.prototype.readAndCheckSignature=function(e){return e===this.readData(4)},el.prototype.readData=function(e){this.checkOffset(e);var t=this.data.slice(this.zero+this.index,this.zero+this.index+e);return this.index+=e,t};var tl=el;function nl(e){Qa.call(this,e);}or.inherits(nl,Qa),nl.prototype.readData=function(e){if(this.checkOffset(e),0===e)return new Uint8Array(0);var t=this.data.subarray(this.zero+this.index,this.zero+this.index+e);return this.index+=e,t};var rl=nl;function il(e){rl.call(this,e);}or.inherits(il,rl),il.prototype.readData=function(e){this.checkOffset(e);var t=this.data.slice(this.zero+this.index,this.zero+this.index+e);return this.index+=e,t};var ol=il,sl=function(e){var t=or.getTypeOf(e);return or.checkSupport(t),"string"!==t||Kt.uint8array?"nodebuffer"===t?new ol(e):Kt.uint8array?new rl(or.transformTo("uint8array",e)):new Qa(or.transformTo("array",e)):new tl(e)};function al(e,t){this.options=e,this.loadOptions=t;}al.prototype={isEncrypted:function(){return 1==(1&this.bitFlag)},useUTF8:function(){return 2048==(2048&this.bitFlag)},readLocalPart:function(e){var t,n;if(e.skip(22),this.fileNameLength=e.readInt(2),n=e.readInt(2),this.fileName=e.readData(this.fileNameLength),e.skip(n),-1===this.compressedSize||-1===this.uncompressedSize)throw new Error("Bug or corrupted zip : didn't get enough informations from the central directory (compressedSize === -1 || uncompressedSize === -1)");if(null===(t=function(e){for(var t in za)if(za.hasOwnProperty(t)&&za[t].magic===e)return za[t];return null}(this.compressionMethod)))throw new Error("Corrupted zip : compression "+or.pretty(this.compressionMethod)+" unknown (inner file : "+or.transformTo("string",this.fileName)+")");this.decompressed=new Tr(this.compressedSize,this.uncompressedSize,this.crc32,t,e.readData(this.compressedSize));},readCentralPart:function(e){this.versionMadeBy=e.readInt(2),e.skip(2),this.bitFlag=e.readInt(2),this.compressionMethod=e.readString(2),this.date=e.readDate(),this.crc32=e.readInt(4),this.compressedSize=e.readInt(4),this.uncompressedSize=e.readInt(4);var t=e.readInt(2);if(this.extraFieldsLength=e.readInt(2),this.fileCommentLength=e.readInt(2),this.diskNumberStart=e.readInt(2),this.internalFileAttributes=e.readInt(2),this.externalFileAttributes=e.readInt(4),this.localHeaderOffset=e.readInt(4),this.isEncrypted())throw new Error("Encrypted zip are not supported");e.skip(t),this.readExtraFields(e),this.parseZIP64ExtraField(e),this.fileComment=e.readData(this.fileCommentLength);},processAttributes:function(){this.unixPermissions=null,this.dosPermissions=null;var e=this.versionMadeBy>>8;this.dir=!!(16&this.externalFileAttributes),0===e&&(this.dosPermissions=63&this.externalFileAttributes),3===e&&(this.unixPermissions=this.externalFileAttributes>>16&65535),this.dir||"/"!==this.fileNameStr.slice(-1)||(this.dir=!0);},parseZIP64ExtraField:function(e){if(this.extraFields[1]){var t=sl(this.extraFields[1].value);this.uncompressedSize===or.MAX_VALUE_32BITS&&(this.uncompressedSize=t.readInt(8)),this.compressedSize===or.MAX_VALUE_32BITS&&(this.compressedSize=t.readInt(8)),this.localHeaderOffset===or.MAX_VALUE_32BITS&&(this.localHeaderOffset=t.readInt(8)),this.diskNumberStart===or.MAX_VALUE_32BITS&&(this.diskNumberStart=t.readInt(4));}},readExtraFields:function(e){var t,n,r,i=e.index+this.extraFieldsLength;for(this.extraFields||(this.extraFields={});e.index<i;)t=e.readInt(2),n=e.readInt(2),r=e.readData(n),this.extraFields[t]={id:t,length:n,value:r};},handleUTF8:function(){var e=Kt.uint8array?"uint8array":"array";if(this.useUTF8())this.fileNameStr=lr.utf8decode(this.fileName),this.fileCommentStr=lr.utf8decode(this.fileComment);else {var t=this.findExtraFieldUnicodePath();if(null!==t)this.fileNameStr=t;else {var n=or.transformTo(e,this.fileName);this.fileNameStr=this.loadOptions.decodeFileName(n);}var r=this.findExtraFieldUnicodeComment();if(null!==r)this.fileCommentStr=r;else {var i=or.transformTo(e,this.fileComment);this.fileCommentStr=this.loadOptions.decodeFileName(i);}}},findExtraFieldUnicodePath:function(){var e=this.extraFields[28789];if(e){var t=sl(e.value);return 1!==t.readInt(1)?null:xr(this.fileName)!==t.readInt(4)?null:lr.utf8decode(t.readData(e.length-5))}return null},findExtraFieldUnicodeComment:function(){var e=this.extraFields[25461];if(e){var t=sl(e.value);return 1!==t.readInt(1)?null:xr(this.fileComment)!==t.readInt(4)?null:lr.utf8decode(t.readData(e.length-5))}return null}};var ll=al;function ul(e){this.files=[],this.loadOptions=e;}ul.prototype={checkSignature:function(e){if(!this.reader.readAndCheckSignature(e)){this.reader.index-=4;var t=this.reader.readString(4);throw new Error("Corrupted zip or bug: unexpected signature ("+or.pretty(t)+", expected "+or.pretty(e)+")")}},isSignature:function(e,t){var n=this.reader.index;this.reader.setIndex(e);var r=this.reader.readString(4)===t;return this.reader.setIndex(n),r},readBlockEndOfCentral:function(){this.diskNumber=this.reader.readInt(2),this.diskWithCentralDirStart=this.reader.readInt(2),this.centralDirRecordsOnThisDisk=this.reader.readInt(2),this.centralDirRecords=this.reader.readInt(2),this.centralDirSize=this.reader.readInt(4),this.centralDirOffset=this.reader.readInt(4),this.zipCommentLength=this.reader.readInt(2);var e=this.reader.readData(this.zipCommentLength),t=Kt.uint8array?"uint8array":"array",n=or.transformTo(t,e);this.zipComment=this.loadOptions.decodeFileName(n);},readBlockZip64EndOfCentral:function(){this.zip64EndOfCentralSize=this.reader.readInt(8),this.reader.skip(4),this.diskNumber=this.reader.readInt(4),this.diskWithCentralDirStart=this.reader.readInt(4),this.centralDirRecordsOnThisDisk=this.reader.readInt(8),this.centralDirRecords=this.reader.readInt(8),this.centralDirSize=this.reader.readInt(8),this.centralDirOffset=this.reader.readInt(8),this.zip64ExtensibleData={};for(var e,t,n,r=this.zip64EndOfCentralSize-44;0<r;)e=this.reader.readInt(2),t=this.reader.readInt(4),n=this.reader.readData(t),this.zip64ExtensibleData[e]={id:e,length:t,value:n};},readBlockZip64EndOfCentralLocator:function(){if(this.diskWithZip64CentralDirStart=this.reader.readInt(4),this.relativeOffsetEndOfZip64CentralDir=this.reader.readInt(8),this.disksCount=this.reader.readInt(4),this.disksCount>1)throw new Error("Multi-volumes zip are not supported")},readLocalFiles:function(){var e,t;for(e=0;e<this.files.length;e++)t=this.files[e],this.reader.setIndex(t.localHeaderOffset),this.checkSignature(Oa),t.readLocalPart(this.reader),t.handleUTF8(),t.processAttributes();},readCentralDir:function(){var e;for(this.reader.setIndex(this.centralDirOffset);this.reader.readAndCheckSignature(Ra);)(e=new ll({zip64:this.zip64},this.loadOptions)).readCentralPart(this.reader),this.files.push(e);if(this.centralDirRecords!==this.files.length&&0!==this.centralDirRecords&&0===this.files.length)throw new Error("Corrupted zip or bug: expected "+this.centralDirRecords+" records in central dir, got "+this.files.length)},readEndOfCentral:function(){var e=this.reader.lastIndexOfSignature(La);if(e<0)throw !this.isSignature(0,Oa)?new Error("Can't find end of central directory : is this a zip file ? If it is, see https://stuk.github.io/jszip/documentation/howto/read_zip.html"):new Error("Corrupted zip: can't find end of central directory");this.reader.setIndex(e);var t=e;if(this.checkSignature(La),this.readBlockEndOfCentral(),this.diskNumber===or.MAX_VALUE_16BITS||this.diskWithCentralDirStart===or.MAX_VALUE_16BITS||this.centralDirRecordsOnThisDisk===or.MAX_VALUE_16BITS||this.centralDirRecords===or.MAX_VALUE_16BITS||this.centralDirSize===or.MAX_VALUE_32BITS||this.centralDirOffset===or.MAX_VALUE_32BITS){if(this.zip64=!0,(e=this.reader.lastIndexOfSignature(Ba))<0)throw new Error("Corrupted zip: can't find the ZIP64 end of central directory locator");if(this.reader.setIndex(e),this.checkSignature(Ba),this.readBlockZip64EndOfCentralLocator(),!this.isSignature(this.relativeOffsetEndOfZip64CentralDir,Ia)&&(this.relativeOffsetEndOfZip64CentralDir=this.reader.lastIndexOfSignature(Ia),this.relativeOffsetEndOfZip64CentralDir<0))throw new Error("Corrupted zip: can't find the ZIP64 end of central directory");this.reader.setIndex(this.relativeOffsetEndOfZip64CentralDir),this.checkSignature(Ia),this.readBlockZip64EndOfCentral();}var n=this.centralDirOffset+this.centralDirSize;this.zip64&&(n+=20,n+=12+this.zip64EndOfCentralSize);var r=t-n;if(r>0)this.isSignature(t,Ra)||(this.reader.zero=r);else if(r<0)throw new Error("Corrupted zip: missing "+Math.abs(r)+" bytes.")},prepareReader:function(e){this.reader=sl(e);},load:function(e){this.prepareReader(e),this.readEndOfCentral(),this.readCentralDir(),this.readLocalFiles();}};var hl=ul;function cl(e){return new ir.Promise(function(t,n){var r=e.decompressed.getContentWorker().pipe(new Er);r.on("error",function(e){n(e);}).on("end",function(){r.streamInfo.crc32!==e.decompressed.crc32?n(new Error("Corrupted zip : CRC32 mismatch")):t();}).resume();})}function fl(){if(!(this instanceof fl))return new fl;if(arguments.length)throw new Error("The constructor with parameters has been removed in JSZip 3.0, please check the upgrade guide.");this.files={},this.comment=null,this.root="",this.clone=function(){var e=new fl;for(var t in this)"function"!=typeof this[t]&&(e[t]=this[t]);return e};}fl.prototype=Ka,fl.prototype.loadAsync=function(e,t){var n=this;return t=or.extend(t||{},{base64:!1,checkCRC32:!1,optimizedBinaryString:!1,createFolders:!1,decodeFileName:lr.utf8decode}),$t&&nn(e)?ir.Promise.reject(new Error("JSZip can't accept a stream when loading a zip file.")):or.prepareContent("the loaded zip file",e,!0,t.optimizedBinaryString,t.base64).then(function(e){var n=new hl(t);return n.load(e),n}).then(function(e){var n=[ir.Promise.resolve(e)],r=e.files;if(t.checkCRC32)for(var i=0;i<r.length;i++)n.push(cl(r[i]));return ir.Promise.all(n)}).then(function(e){for(var r=e.shift(),i=r.files,o=0;o<i.length;o++){var s=i[o];n.file(s.fileNameStr,s.decompressed,{binary:!0,optimizedBinaryString:!0,date:s.date,dir:s.dir,comment:s.fileCommentStr.length?s.fileCommentStr:null,unixPermissions:s.unixPermissions,dosPermissions:s.dosPermissions,createFolders:t.createFolders});}return r.zipComment.length&&(n.comment=r.zipComment),n})},fl.support=Kt,fl.defaults=_r,fl.version="3.1.5",fl.loadAsync=function(e,t){return (new fl).loadAsync(e,t)},fl.external=ir;var dl=fl;function pl(e){return null==e}var gl={isNothing:pl,isObject:function(e){return "object"==typeof e&&null!==e},toArray:function(e){return Array.isArray(e)?e:pl(e)?[]:[e]},repeat:function(e,t){var n,r="";for(n=0;n<t;n+=1)r+=e;return r},isNegativeZero:function(e){return 0===e&&Number.NEGATIVE_INFINITY===1/e},extend:function(e,t){var n,r,i,o;if(t)for(n=0,r=(o=Object.keys(t)).length;n<r;n+=1)e[i=o[n]]=t[i];return e}};function ml(e,t){Error.call(this),Error.captureStackTrace?Error.captureStackTrace(this,this.constructor):this.stack=(new Error).stack||"",this.name="YAMLException",this.reason=e,this.mark=t,this.message=(this.reason||"(unknown reason)")+(this.mark?" "+this.mark.toString():"");}ml.prototype=Object.create(Error.prototype),ml.prototype.constructor=ml,ml.prototype.toString=function(e){var t=this.name+": ";return t+=this.reason||"(unknown reason)",!e&&this.mark&&(t+=" "+this.mark.toString()),t};var vl=ml;function _l(e,t,n,r,i){this.name=e,this.buffer=t,this.position=n,this.line=r,this.column=i;}_l.prototype.getSnippet=function(e,t){var n,r,i,o,s;if(!this.buffer)return null;for(e=e||4,t=t||75,n="",r=this.position;r>0&&-1==="\0\r\n\u2028\u2029".indexOf(this.buffer.charAt(r-1));)if(r-=1,this.position-r>t/2-1){n=" ... ",r+=5;break}for(i="",o=this.position;o<this.buffer.length&&-1==="\0\r\n\u2028\u2029".indexOf(this.buffer.charAt(o));)if((o+=1)-this.position>t/2-1){i=" ... ",o-=5;break}return s=this.buffer.slice(r,o),gl.repeat(" ",e)+n+s+i+"\n"+gl.repeat(" ",e+this.position-r+n.length)+"^"},_l.prototype.toString=function(e){var t,n="";return this.name&&(n+='in "'+this.name+'" '),n+="at line "+(this.line+1)+", column "+(this.column+1),e||(t=this.getSnippet())&&(n+=":\n"+t),n};var yl=_l,bl=["kind","resolve","construct","instanceOf","predicate","represent","defaultStyle","styleAliases"],wl=["scalar","sequence","mapping"];var kl=function(e,t){var n,r;if(t=t||{},Object.keys(t).forEach(function(t){if(-1===bl.indexOf(t))throw new vl('Unknown option "'+t+'" is met in definition of "'+e+'" YAML type.')}),this.tag=e,this.kind=t.kind||null,this.resolve=t.resolve||function(){return !0},this.construct=t.construct||function(e){return e},this.instanceOf=t.instanceOf||null,this.predicate=t.predicate||null,this.represent=t.represent||null,this.defaultStyle=t.defaultStyle||null,this.styleAliases=(n=t.styleAliases||null,r={},null!==n&&Object.keys(n).forEach(function(e){n[e].forEach(function(t){r[String(t)]=e;});}),r),-1===wl.indexOf(this.kind))throw new vl('Unknown kind "'+this.kind+'" is specified for "'+e+'" YAML type.')};function Sl(e,t,n){var r=[];return e.include.forEach(function(e){n=Sl(e,t,n);}),e[t].forEach(function(e){n.forEach(function(t,n){t.tag===e.tag&&r.push(n);}),n.push(e);}),n.filter(function(e,t){return -1===r.indexOf(t)})}function xl(e){this.include=e.include||[],this.implicit=e.implicit||[],this.explicit=e.explicit||[],this.implicit.forEach(function(e){if(e.loadKind&&"scalar"!==e.loadKind)throw new vl("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.")}),this.compiledImplicit=Sl(this,"implicit",[]),this.compiledExplicit=Sl(this,"explicit",[]),this.compiledTypeMap=function(){var e,t,n={};function r(e){n[e.tag]=e;}for(e=0,t=arguments.length;e<t;e+=1)arguments[e].forEach(r);return n}(this.compiledImplicit,this.compiledExplicit);}xl.DEFAULT=null,xl.create=function(){var e,t;switch(arguments.length){case 1:e=xl.DEFAULT,t=arguments[0];break;case 2:e=arguments[0],t=arguments[1];break;default:throw new vl("Wrong number of arguments for Schema.create function")}if(e=gl.toArray(e),t=gl.toArray(t),!e.every(function(e){return e instanceof xl}))throw new vl("Specified list of super schemas (or a single Schema object) contains a non-Schema object.");if(!t.every(function(e){return e instanceof kl}))throw new vl("Specified list of YAML types (or a single Type object) contains a non-Type object.");return new xl({include:e,explicit:t})};var Cl=xl,El=new Cl({explicit:[new kl("tag:yaml.org,2002:str",{kind:"scalar",construct:function(e){return null!==e?e:""}}),new kl("tag:yaml.org,2002:seq",{kind:"sequence",construct:function(e){return null!==e?e:[]}}),new kl("tag:yaml.org,2002:map",{kind:"mapping",construct:function(e){return null!==e?e:{}}})]});var Al=new kl("tag:yaml.org,2002:null",{kind:"scalar",resolve:function(e){if(null===e)return !0;var t=e.length;return 1===t&&"~"===e||4===t&&("null"===e||"Null"===e||"NULL"===e)},construct:function(){return null},predicate:function(e){return null===e},represent:{canonical:function(){return "~"},lowercase:function(){return "null"},uppercase:function(){return "NULL"},camelcase:function(){return "Null"}},defaultStyle:"lowercase"});var Tl=new kl("tag:yaml.org,2002:bool",{kind:"scalar",resolve:function(e){if(null===e)return !1;var t=e.length;return 4===t&&("true"===e||"True"===e||"TRUE"===e)||5===t&&("false"===e||"False"===e||"FALSE"===e)},construct:function(e){return "true"===e||"True"===e||"TRUE"===e},predicate:function(e){return "[object Boolean]"===Object.prototype.toString.call(e)},represent:{lowercase:function(e){return e?"true":"false"},uppercase:function(e){return e?"TRUE":"FALSE"},camelcase:function(e){return e?"True":"False"}},defaultStyle:"lowercase"});function zl(e){return 48<=e&&e<=55}function Ol(e){return 48<=e&&e<=57}var Rl=new kl("tag:yaml.org,2002:int",{kind:"scalar",resolve:function(e){if(null===e)return !1;var t,n,r=e.length,i=0,o=!1;if(!r)return !1;if("-"!==(t=e[i])&&"+"!==t||(t=e[++i]),"0"===t){if(i+1===r)return !0;if("b"===(t=e[++i])){for(i++;i<r;i++)if("_"!==(t=e[i])){if("0"!==t&&"1"!==t)return !1;o=!0;}return o}if("x"===t){for(i++;i<r;i++)if("_"!==(t=e[i])){if(!(48<=(n=e.charCodeAt(i))&&n<=57||65<=n&&n<=70||97<=n&&n<=102))return !1;o=!0;}return o}for(;i<r;i++)if("_"!==(t=e[i])){if(!zl(e.charCodeAt(i)))return !1;o=!0;}return o}for(;i<r;i++)if("_"!==(t=e[i])){if(":"===t)break;if(!Ol(e.charCodeAt(i)))return !1;o=!0;}return !!o&&(":"!==t||/^(:[0-5]?[0-9])+$/.test(e.slice(i)))},construct:function(e){var t,n,r=e,i=1,o=[];return -1!==r.indexOf("_")&&(r=r.replace(/_/g,"")),"-"!==(t=r[0])&&"+"!==t||("-"===t&&(i=-1),t=(r=r.slice(1))[0]),"0"===r?0:"0"===t?"b"===r[1]?i*parseInt(r.slice(2),2):"x"===r[1]?i*parseInt(r,16):i*parseInt(r,8):-1!==r.indexOf(":")?(r.split(":").forEach(function(e){o.unshift(parseInt(e,10));}),r=0,n=1,o.forEach(function(e){r+=e*n,n*=60;}),i*r):i*parseInt(r,10)},predicate:function(e){return "[object Number]"===Object.prototype.toString.call(e)&&e%1==0&&!gl.isNegativeZero(e)},represent:{binary:function(e){return "0b"+e.toString(2)},octal:function(e){return "0"+e.toString(8)},decimal:function(e){return e.toString(10)},hexadecimal:function(e){return "0x"+e.toString(16).toUpperCase()}},defaultStyle:"decimal",styleAliases:{binary:[2,"bin"],octal:[8,"oct"],decimal:[10,"dec"],hexadecimal:[16,"hex"]}}),Ll=new RegExp("^(?:[-+]?(?:[0-9][0-9_]*)\\.[0-9_]*(?:[eE][-+][0-9]+)?|\\.[0-9_]+(?:[eE][-+][0-9]+)?|[-+]?[0-9][0-9_]*(?::[0-5]?[0-9])+\\.[0-9_]*|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$");var Bl=/^[-+]?[0-9]+e/;var Il=new Cl({include:[El],implicit:[Al,Tl,Rl,new kl("tag:yaml.org,2002:float",{kind:"scalar",resolve:function(e){return null!==e&&!!Ll.test(e)},construct:function(e){var t,n,r,i;return n="-"===(t=e.replace(/_/g,"").toLowerCase())[0]?-1:1,i=[],"+-".indexOf(t[0])>=0&&(t=t.slice(1)),".inf"===t?1===n?Number.POSITIVE_INFINITY:Number.NEGATIVE_INFINITY:".nan"===t?NaN:t.indexOf(":")>=0?(t.split(":").forEach(function(e){i.unshift(parseFloat(e,10));}),t=0,r=1,i.forEach(function(e){t+=e*r,r*=60;}),n*t):n*parseFloat(t,10)},predicate:function(e){return "[object Number]"===Object.prototype.toString.call(e)&&(e%1!=0||gl.isNegativeZero(e))},represent:function(e,t){var n;if(isNaN(e))switch(t){case"lowercase":return ".nan";case"uppercase":return ".NAN";case"camelcase":return ".NaN"}else if(Number.POSITIVE_INFINITY===e)switch(t){case"lowercase":return ".inf";case"uppercase":return ".INF";case"camelcase":return ".Inf"}else if(Number.NEGATIVE_INFINITY===e)switch(t){case"lowercase":return "-.inf";case"uppercase":return "-.INF";case"camelcase":return "-.Inf"}else if(gl.isNegativeZero(e))return "-0.0";return n=e.toString(10),Bl.test(n)?n.replace("e",".e"):n},defaultStyle:"lowercase"})]}),Fl=new Cl({include:[Il]}),Pl=new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?)?$");var Ml=new kl("tag:yaml.org,2002:timestamp",{kind:"scalar",resolve:function(e){return null!==e&&null!==Pl.exec(e)},construct:function(e){var t,n,r,i,o,s,a,l,u=0,h=null;if(null===(t=Pl.exec(e)))throw new Error("Date resolve error");if(n=+t[1],r=+t[2]-1,i=+t[3],!t[4])return new Date(Date.UTC(n,r,i));if(o=+t[4],s=+t[5],a=+t[6],t[7]){for(u=t[7].slice(0,3);u.length<3;)u+="0";u=+u;}return t[9]&&(h=6e4*(60*+t[10]+ +(t[11]||0)),"-"===t[9]&&(h=-h)),l=new Date(Date.UTC(n,r,i,o,s,a,u)),h&&l.setTime(l.getTime()-h),l},instanceOf:Date,represent:function(e){return e.toISOString()}});var Ul=new kl("tag:yaml.org,2002:merge",{kind:"scalar",resolve:function(e){return "<<"===e||null===e}}),Dl={}.Buffer,jl="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";var Nl=new kl("tag:yaml.org,2002:binary",{kind:"scalar",resolve:function(e){if(null===e)return !1;var t,n,r=0,i=e.length,o=jl;for(n=0;n<i;n++)if(!((t=o.indexOf(e.charAt(n)))>64)){if(t<0)return !1;r+=6;}return r%8==0},construct:function(e){var t,n,r=e.replace(/[\r\n=]/g,""),i=r.length,o=jl,s=0,a=[];for(t=0;t<i;t++)t%4==0&&t&&(a.push(s>>16&255),a.push(s>>8&255),a.push(255&s)),s=s<<6|o.indexOf(r.charAt(t));return 0==(n=i%4*6)?(a.push(s>>16&255),a.push(s>>8&255),a.push(255&s)):18===n?(a.push(s>>10&255),a.push(s>>2&255)):12===n&&a.push(s>>4&255),a},predicate:function(e){return Dl},represent:function(e){var t,n,r="",i=0,o=e.length,s=jl;for(t=0;t<o;t++)t%3==0&&t&&(r+=s[i>>18&63],r+=s[i>>12&63],r+=s[i>>6&63],r+=s[63&i]),i=(i<<8)+e[t];return 0==(n=o%3)?(r+=s[i>>18&63],r+=s[i>>12&63],r+=s[i>>6&63],r+=s[63&i]):2===n?(r+=s[i>>10&63],r+=s[i>>4&63],r+=s[i<<2&63],r+=s[64]):1===n&&(r+=s[i>>2&63],r+=s[i<<4&63],r+=s[64],r+=s[64]),r}}),Zl=Object.prototype.hasOwnProperty,Wl=Object.prototype.toString;var ql=new kl("tag:yaml.org,2002:omap",{kind:"sequence",resolve:function(e){if(null===e)return !0;var t,n,r,i,o,s=[],a=e;for(t=0,n=a.length;t<n;t+=1){if(r=a[t],o=!1,"[object Object]"!==Wl.call(r))return !1;for(i in r)if(Zl.call(r,i)){if(o)return !1;o=!0;}if(!o)return !1;if(-1!==s.indexOf(i))return !1;s.push(i);}return !0},construct:function(e){return null!==e?e:[]}}),Yl=Object.prototype.toString;var Vl=new kl("tag:yaml.org,2002:pairs",{kind:"sequence",resolve:function(e){if(null===e)return !0;var t,n,r,i,o,s=e;for(o=new Array(s.length),t=0,n=s.length;t<n;t+=1){if(r=s[t],"[object Object]"!==Yl.call(r))return !1;if(1!==(i=Object.keys(r)).length)return !1;o[t]=[i[0],r[i[0]]];}return !0},construct:function(e){if(null===e)return [];var t,n,r,i,o,s=e;for(o=new Array(s.length),t=0,n=s.length;t<n;t+=1)r=s[t],i=Object.keys(r),o[t]=[i[0],r[i[0]]];return o}}),Hl=Object.prototype.hasOwnProperty;var Gl=new Cl({include:[Fl],implicit:[Ml,Ul],explicit:[Nl,ql,Vl,new kl("tag:yaml.org,2002:set",{kind:"mapping",resolve:function(e){if(null===e)return !0;var t,n=e;for(t in n)if(Hl.call(n,t)&&null!==n[t])return !1;return !0},construct:function(e){return null!==e?e:{}}})]});var Kl=new kl("tag:yaml.org,2002:js/undefined",{kind:"scalar",resolve:function(){return !0},construct:function(){},predicate:function(e){return void 0===e},represent:function(){return ""}});var Jl,Xl=new kl("tag:yaml.org,2002:js/regexp",{kind:"scalar",resolve:function(e){if(null===e)return !1;if(0===e.length)return !1;var t=e,n=/\/([gim]*)$/.exec(e),r="";if("/"===t[0]){if(n&&(r=n[1]),r.length>3)return !1;if("/"!==t[t.length-r.length-1])return !1}return !0},construct:function(e){var t=e,n=/\/([gim]*)$/.exec(e),r="";return "/"===t[0]&&(n&&(r=n[1]),t=t.slice(1,t.length-r.length-1)),new RegExp(t,r)},predicate:function(e){return "[object RegExp]"===Object.prototype.toString.call(e)},represent:function(e){var t="/"+e.source+"/";return e.global&&(t+="g"),e.multiline&&(t+="m"),e.ignoreCase&&(t+="i"),t}});try{var $l=e.commonjsRequire;Jl=$l("esprima");}catch(e){"undefined"!=typeof window&&(Jl=window.esprima);}var Ql=new kl("tag:yaml.org,2002:js/function",{kind:"scalar",resolve:function(e){if(null===e)return !1;try{var t="("+e+")",n=Jl.parse(t,{range:!0});return "Program"===n.type&&1===n.body.length&&"ExpressionStatement"===n.body[0].type&&"FunctionExpression"===n.body[0].expression.type}catch(e){return !1}},construct:function(e){var t,n="("+e+")",r=Jl.parse(n,{range:!0}),i=[];if("Program"!==r.type||1!==r.body.length||"ExpressionStatement"!==r.body[0].type||"FunctionExpression"!==r.body[0].expression.type)throw new Error("Failed to resolve function");return r.body[0].expression.params.forEach(function(e){i.push(e.name);}),t=r.body[0].expression.body.range,new Function(i,n.slice(t[0]+1,t[1]-1))},predicate:function(e){return "[object Function]"===Object.prototype.toString.call(e)},represent:function(e){return e.toString()}}),eu=Cl.DEFAULT=new Cl({include:[Gl],explicit:[Kl,Xl,Ql]}),tu=Object.prototype.hasOwnProperty,nu=1,ru=2,iu=3,ou=4,su=1,au=2,lu=3,uu=/[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/,hu=/[\x85\u2028\u2029]/,cu=/[,\[\]\{\}]/,fu=/^(?:!|!!|![a-z\-]+!)$/i,du=/^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;function pu(e){return 10===e||13===e}function gu(e){return 9===e||32===e}function mu(e){return 9===e||32===e||10===e||13===e}function vu(e){return 44===e||91===e||93===e||123===e||125===e}function _u(e){var t;return 48<=e&&e<=57?e-48:97<=(t=32|e)&&t<=102?t-97+10:-1}function yu(e){return 48===e?"\0":97===e?"":98===e?"\b":116===e?"\t":9===e?"\t":110===e?"\n":118===e?"\v":102===e?"\f":114===e?"\r":101===e?"":32===e?" ":34===e?'"':47===e?"/":92===e?"\\":78===e?"":95===e?" ":76===e?"\u2028":80===e?"\u2029":""}function bu(e){return e<=65535?String.fromCharCode(e):String.fromCharCode(55296+(e-65536>>10),56320+(e-65536&1023))}for(var wu=new Array(256),ku=new Array(256),Su=0;Su<256;Su++)wu[Su]=yu(Su)?1:0,ku[Su]=yu(Su);function xu(e,t){this.input=e,this.filename=t.filename||null,this.schema=t.schema||eu,this.onWarning=t.onWarning||null,this.legacy=t.legacy||!1,this.json=t.json||!1,this.listener=t.listener||null,this.implicitTypes=this.schema.compiledImplicit,this.typeMap=this.schema.compiledTypeMap,this.length=e.length,this.position=0,this.line=0,this.lineStart=0,this.lineIndent=0,this.documents=[];}function Cu(e,t){return new vl(t,new yl(e.filename,e.input,e.position,e.line,e.position-e.lineStart))}function Eu(e,t){throw Cu(e,t)}function Au(e,t){e.onWarning&&e.onWarning.call(null,Cu(e,t));}var Tu={YAML:function(e,t,n){var r,i,o;null!==e.version&&Eu(e,"duplication of %YAML directive"),1!==n.length&&Eu(e,"YAML directive accepts exactly one argument"),null===(r=/^([0-9]+)\.([0-9]+)$/.exec(n[0]))&&Eu(e,"ill-formed argument of the YAML directive"),i=parseInt(r[1],10),o=parseInt(r[2],10),1!==i&&Eu(e,"unacceptable YAML version of the document"),e.version=n[0],e.checkLineBreaks=o<2,1!==o&&2!==o&&Au(e,"unsupported YAML version of the document");},TAG:function(e,t,n){var r,i;2!==n.length&&Eu(e,"TAG directive accepts exactly two arguments"),r=n[0],i=n[1],fu.test(r)||Eu(e,"ill-formed tag handle (first argument) of the TAG directive"),tu.call(e.tagMap,r)&&Eu(e,'there is a previously declared suffix for "'+r+'" tag handle'),du.test(i)||Eu(e,"ill-formed tag prefix (second argument) of the TAG directive"),e.tagMap[r]=i;}};function zu(e,t,n,r){var i,o,s,a;if(t<n){if(a=e.input.slice(t,n),r)for(i=0,o=a.length;i<o;i+=1)9===(s=a.charCodeAt(i))||32<=s&&s<=1114111||Eu(e,"expected valid JSON character");else uu.test(a)&&Eu(e,"the stream contains non-printable characters");e.result+=a;}}function Ou(e,t,n,r){var i,o,s,a;for(gl.isObject(n)||Eu(e,"cannot merge mappings; the provided source object is unacceptable"),s=0,a=(i=Object.keys(n)).length;s<a;s+=1)o=i[s],tu.call(t,o)||(t[o]=n[o],r[o]=!0);}function Ru(e,t,n,r,i,o){var s,a;if(i=String(i),null===t&&(t={}),"tag:yaml.org,2002:merge"===r)if(Array.isArray(o))for(s=0,a=o.length;s<a;s+=1)Ou(e,t,o[s],n);else Ou(e,t,o,n);else e.json||tu.call(n,i)||!tu.call(t,i)||Eu(e,"duplicated mapping key"),t[i]=o,delete n[i];return t}function Lu(e){var t;10===(t=e.input.charCodeAt(e.position))?e.position++:13===t?(e.position++,10===e.input.charCodeAt(e.position)&&e.position++):Eu(e,"a line break is expected"),e.line+=1,e.lineStart=e.position;}function Bu(e,t,n){for(var r=0,i=e.input.charCodeAt(e.position);0!==i;){for(;gu(i);)i=e.input.charCodeAt(++e.position);if(t&&35===i)do{i=e.input.charCodeAt(++e.position);}while(10!==i&&13!==i&&0!==i);if(!pu(i))break;for(Lu(e),i=e.input.charCodeAt(e.position),r++,e.lineIndent=0;32===i;)e.lineIndent++,i=e.input.charCodeAt(++e.position);}return -1!==n&&0!==r&&e.lineIndent<n&&Au(e,"deficient indentation"),r}function Iu(e){var t,n=e.position;return !(45!==(t=e.input.charCodeAt(n))&&46!==t||t!==e.input.charCodeAt(n+1)||t!==e.input.charCodeAt(n+2)||(n+=3,0!==(t=e.input.charCodeAt(n))&&!mu(t)))}function Fu(e,t){1===t?e.result+=" ":t>1&&(e.result+=gl.repeat("\n",t-1));}function Pu(e,t){var n,r,i=e.tag,o=e.anchor,s=[],a=!1;for(null!==e.anchor&&(e.anchorMap[e.anchor]=s),r=e.input.charCodeAt(e.position);0!==r&&45===r&&mu(e.input.charCodeAt(e.position+1));)if(a=!0,e.position++,Bu(e,!0,-1)&&e.lineIndent<=t)s.push(null),r=e.input.charCodeAt(e.position);else if(n=e.line,Du(e,t,iu,!1,!0),s.push(e.result),Bu(e,!0,-1),r=e.input.charCodeAt(e.position),(e.line===n||e.lineIndent>t)&&0!==r)Eu(e,"bad indentation of a sequence entry");else if(e.lineIndent<t)break;return !!a&&(e.tag=i,e.anchor=o,e.kind="sequence",e.result=s,!0)}function Mu(e){var t,n,r,i,o=!1,s=!1;if(33!==(i=e.input.charCodeAt(e.position)))return !1;if(null!==e.tag&&Eu(e,"duplication of a tag property"),60===(i=e.input.charCodeAt(++e.position))?(o=!0,i=e.input.charCodeAt(++e.position)):33===i?(s=!0,n="!!",i=e.input.charCodeAt(++e.position)):n="!",t=e.position,o){do{i=e.input.charCodeAt(++e.position);}while(0!==i&&62!==i);e.position<e.length?(r=e.input.slice(t,e.position),i=e.input.charCodeAt(++e.position)):Eu(e,"unexpected end of the stream within a verbatim tag");}else {for(;0!==i&&!mu(i);)33===i&&(s?Eu(e,"tag suffix cannot contain exclamation marks"):(n=e.input.slice(t-1,e.position+1),fu.test(n)||Eu(e,"named tag handle cannot contain such characters"),s=!0,t=e.position+1)),i=e.input.charCodeAt(++e.position);r=e.input.slice(t,e.position),cu.test(r)&&Eu(e,"tag suffix cannot contain flow indicator characters");}return r&&!du.test(r)&&Eu(e,"tag name cannot contain such characters: "+r),o?e.tag=r:tu.call(e.tagMap,n)?e.tag=e.tagMap[n]+r:"!"===n?e.tag="!"+r:"!!"===n?e.tag="tag:yaml.org,2002:"+r:Eu(e,'undeclared tag handle "'+n+'"'),!0}function Uu(e){var t,n;if(38!==(n=e.input.charCodeAt(e.position)))return !1;for(null!==e.anchor&&Eu(e,"duplication of an anchor property"),n=e.input.charCodeAt(++e.position),t=e.position;0!==n&&!mu(n)&&!vu(n);)n=e.input.charCodeAt(++e.position);return e.position===t&&Eu(e,"name of an anchor node must contain at least one character"),e.anchor=e.input.slice(t,e.position),!0}function Du(e,t,n,r,i){var o,s,a,l,u,h,c,f,d=1,p=!1,g=!1;if(null!==e.listener&&e.listener("open",e),e.tag=null,e.anchor=null,e.kind=null,e.result=null,o=s=a=ou===n||iu===n,r&&Bu(e,!0,-1)&&(p=!0,e.lineIndent>t?d=1:e.lineIndent===t?d=0:e.lineIndent<t&&(d=-1)),1===d)for(;Mu(e)||Uu(e);)Bu(e,!0,-1)?(p=!0,a=o,e.lineIndent>t?d=1:e.lineIndent===t?d=0:e.lineIndent<t&&(d=-1)):a=!1;if(a&&(a=p||i),1!==d&&ou!==n||(c=nu===n||ru===n?t:t+1,f=e.position-e.lineStart,1===d?a&&(Pu(e,f)||function(e,t,n){var r,i,o,s,a=e.tag,l=e.anchor,u={},h={},c=null,f=null,d=null,p=!1,g=!1;for(null!==e.anchor&&(e.anchorMap[e.anchor]=u),s=e.input.charCodeAt(e.position);0!==s;){if(r=e.input.charCodeAt(e.position+1),o=e.line,63!==s&&58!==s||!mu(r)){if(!Du(e,n,ru,!1,!0))break;if(e.line===o){for(s=e.input.charCodeAt(e.position);gu(s);)s=e.input.charCodeAt(++e.position);if(58===s)mu(s=e.input.charCodeAt(++e.position))||Eu(e,"a whitespace character is expected after the key-value separator within a block mapping"),p&&(Ru(e,u,h,c,f,null),c=f=d=null),g=!0,p=!1,i=!1,c=e.tag,f=e.result;else {if(!g)return e.tag=a,e.anchor=l,!0;Eu(e,"can not read an implicit mapping pair; a colon is missed");}}else {if(!g)return e.tag=a,e.anchor=l,!0;Eu(e,"can not read a block mapping entry; a multiline key may not be an implicit key");}}else 63===s?(p&&(Ru(e,u,h,c,f,null),c=f=d=null),g=!0,p=!0,i=!0):p?(p=!1,i=!0):Eu(e,"incomplete explicit mapping pair; a key node is missed"),e.position+=1,s=r;if((e.line===o||e.lineIndent>t)&&(Du(e,t,ou,!0,i)&&(p?f=e.result:d=e.result),p||(Ru(e,u,h,c,f,d),c=f=d=null),Bu(e,!0,-1),s=e.input.charCodeAt(e.position)),e.lineIndent>t&&0!==s)Eu(e,"bad indentation of a mapping entry");else if(e.lineIndent<t)break}return p&&Ru(e,u,h,c,f,null),g&&(e.tag=a,e.anchor=l,e.kind="mapping",e.result=u),g}(e,f,c))||function(e,t){var n,r,i,o,s,a,l,u,h,c,f=!0,d=e.tag,p=e.anchor,g={};if(91===(c=e.input.charCodeAt(e.position)))i=93,a=!1,r=[];else {if(123!==c)return !1;i=125,a=!0,r={};}for(null!==e.anchor&&(e.anchorMap[e.anchor]=r),c=e.input.charCodeAt(++e.position);0!==c;){if(Bu(e,!0,t),(c=e.input.charCodeAt(e.position))===i)return e.position++,e.tag=d,e.anchor=p,e.kind=a?"mapping":"sequence",e.result=r,!0;f||Eu(e,"missed comma between flow collection entries"),h=null,o=s=!1,63===c&&mu(e.input.charCodeAt(e.position+1))&&(o=s=!0,e.position++,Bu(e,!0,t)),n=e.line,Du(e,t,nu,!1,!0),u=e.tag,l=e.result,Bu(e,!0,t),c=e.input.charCodeAt(e.position),!s&&e.line!==n||58!==c||(o=!0,c=e.input.charCodeAt(++e.position),Bu(e,!0,t),Du(e,t,nu,!1,!0),h=e.result),a?Ru(e,r,g,u,l,h):o?r.push(Ru(e,null,g,u,l,h)):r.push(l),Bu(e,!0,t),44===(c=e.input.charCodeAt(e.position))?(f=!0,c=e.input.charCodeAt(++e.position)):f=!1;}Eu(e,"unexpected end of the stream within a flow collection");}(e,c)?g=!0:(s&&function(e,t){var n,r,i,o,s,a=su,l=!1,u=t,h=0,c=!1;if(124===(o=e.input.charCodeAt(e.position)))r=!1;else {if(62!==o)return !1;r=!0;}for(e.kind="scalar",e.result="";0!==o;)if(43===(o=e.input.charCodeAt(++e.position))||45===o)su===a?a=43===o?lu:au:Eu(e,"repeat of a chomping mode identifier");else {if(!((i=48<=(s=o)&&s<=57?s-48:-1)>=0))break;0===i?Eu(e,"bad explicit indentation width of a block scalar; it cannot be less than one"):l?Eu(e,"repeat of an indentation width identifier"):(u=t+i-1,l=!0);}if(gu(o)){do{o=e.input.charCodeAt(++e.position);}while(gu(o));if(35===o)do{o=e.input.charCodeAt(++e.position);}while(!pu(o)&&0!==o)}for(;0!==o;){for(Lu(e),e.lineIndent=0,o=e.input.charCodeAt(e.position);(!l||e.lineIndent<u)&&32===o;)e.lineIndent++,o=e.input.charCodeAt(++e.position);if(!l&&e.lineIndent>u&&(u=e.lineIndent),pu(o))h++;else {if(e.lineIndent<u){a===lu?e.result+=gl.repeat("\n",h):a===su&&l&&(e.result+="\n");break}for(r?gu(o)?(c=!0,e.result+=gl.repeat("\n",h+1)):c?(c=!1,e.result+=gl.repeat("\n",h+1)):0===h?l&&(e.result+=" "):e.result+=gl.repeat("\n",h):e.result+=l?gl.repeat("\n",h+1):gl.repeat("\n",h),l=!0,h=0,n=e.position;!pu(o)&&0!==o;)o=e.input.charCodeAt(++e.position);zu(e,n,e.position,!1);}}return !0}(e,c)||function(e,t){var n,r,i;if(39!==(n=e.input.charCodeAt(e.position)))return !1;for(e.kind="scalar",e.result="",e.position++,r=i=e.position;0!==(n=e.input.charCodeAt(e.position));)if(39===n){if(zu(e,r,e.position,!0),39!==(n=e.input.charCodeAt(++e.position)))return !0;r=i=e.position,e.position++;}else pu(n)?(zu(e,r,i,!0),Fu(e,Bu(e,!1,t)),r=i=e.position):e.position===e.lineStart&&Iu(e)?Eu(e,"unexpected end of the document within a single quoted scalar"):(e.position++,i=e.position);Eu(e,"unexpected end of the stream within a single quoted scalar");}(e,c)||function(e,t){var n,r,i,o,s,a,l;if(34!==(a=e.input.charCodeAt(e.position)))return !1;for(e.kind="scalar",e.result="",e.position++,n=r=e.position;0!==(a=e.input.charCodeAt(e.position));){if(34===a)return zu(e,n,e.position,!0),e.position++,!0;if(92===a){if(zu(e,n,e.position,!0),pu(a=e.input.charCodeAt(++e.position)))Bu(e,!1,t);else if(a<256&&wu[a])e.result+=ku[a],e.position++;else if((s=120===(l=a)?2:117===l?4:85===l?8:0)>0){for(i=s,o=0;i>0;i--)(s=_u(a=e.input.charCodeAt(++e.position)))>=0?o=(o<<4)+s:Eu(e,"expected hexadecimal character");e.result+=bu(o),e.position++;}else Eu(e,"unknown escape sequence");n=r=e.position;}else pu(a)?(zu(e,n,r,!0),Fu(e,Bu(e,!1,t)),n=r=e.position):e.position===e.lineStart&&Iu(e)?Eu(e,"unexpected end of the document within a double quoted scalar"):(e.position++,r=e.position);}Eu(e,"unexpected end of the stream within a double quoted scalar");}(e,c)?g=!0:!function(e){var t,n,r;if(42!==(r=e.input.charCodeAt(e.position)))return !1;for(r=e.input.charCodeAt(++e.position),t=e.position;0!==r&&!mu(r)&&!vu(r);)r=e.input.charCodeAt(++e.position);return e.position===t&&Eu(e,"name of an alias node must contain at least one character"),n=e.input.slice(t,e.position),e.anchorMap.hasOwnProperty(n)||Eu(e,'unidentified alias "'+n+'"'),e.result=e.anchorMap[n],Bu(e,!0,-1),!0}(e)?function(e,t,n){var r,i,o,s,a,l,u,h,c=e.kind,f=e.result;if(mu(h=e.input.charCodeAt(e.position))||vu(h)||35===h||38===h||42===h||33===h||124===h||62===h||39===h||34===h||37===h||64===h||96===h)return !1;if((63===h||45===h)&&(mu(r=e.input.charCodeAt(e.position+1))||n&&vu(r)))return !1;for(e.kind="scalar",e.result="",i=o=e.position,s=!1;0!==h;){if(58===h){if(mu(r=e.input.charCodeAt(e.position+1))||n&&vu(r))break}else if(35===h){if(mu(e.input.charCodeAt(e.position-1)))break}else {if(e.position===e.lineStart&&Iu(e)||n&&vu(h))break;if(pu(h)){if(a=e.line,l=e.lineStart,u=e.lineIndent,Bu(e,!1,-1),e.lineIndent>=t){s=!0,h=e.input.charCodeAt(e.position);continue}e.position=o,e.line=a,e.lineStart=l,e.lineIndent=u;break}}s&&(zu(e,i,o,!1),Fu(e,e.line-a),i=o=e.position,s=!1),gu(h)||(o=e.position+1),h=e.input.charCodeAt(++e.position);}return zu(e,i,o,!1),!!e.result||(e.kind=c,e.result=f,!1)}(e,c,nu===n)&&(g=!0,null===e.tag&&(e.tag="?")):(g=!0,null===e.tag&&null===e.anchor||Eu(e,"alias node should not have any properties")),null!==e.anchor&&(e.anchorMap[e.anchor]=e.result)):0===d&&(g=a&&Pu(e,f))),null!==e.tag&&"!"!==e.tag)if("?"===e.tag){for(l=0,u=e.implicitTypes.length;l<u;l+=1)if((h=e.implicitTypes[l]).resolve(e.result)){e.result=h.construct(e.result),e.tag=h.tag,null!==e.anchor&&(e.anchorMap[e.anchor]=e.result);break}}else tu.call(e.typeMap,e.tag)?(h=e.typeMap[e.tag],null!==e.result&&h.kind!==e.kind&&Eu(e,"unacceptable node kind for !<"+e.tag+'> tag; it should be "'+h.kind+'", not "'+e.kind+'"'),h.resolve(e.result)?(e.result=h.construct(e.result),null!==e.anchor&&(e.anchorMap[e.anchor]=e.result)):Eu(e,"cannot resolve a node with !<"+e.tag+"> explicit tag")):Eu(e,"unknown tag !<"+e.tag+">");return null!==e.listener&&e.listener("close",e),null!==e.tag||null!==e.anchor||g}function ju(e){var t,n,r,i,o=e.position,s=!1;for(e.version=null,e.checkLineBreaks=e.legacy,e.tagMap={},e.anchorMap={};0!==(i=e.input.charCodeAt(e.position))&&(Bu(e,!0,-1),i=e.input.charCodeAt(e.position),!(e.lineIndent>0||37!==i));){for(s=!0,i=e.input.charCodeAt(++e.position),t=e.position;0!==i&&!mu(i);)i=e.input.charCodeAt(++e.position);for(r=[],(n=e.input.slice(t,e.position)).length<1&&Eu(e,"directive name must not be less than one character in length");0!==i;){for(;gu(i);)i=e.input.charCodeAt(++e.position);if(35===i){do{i=e.input.charCodeAt(++e.position);}while(0!==i&&!pu(i));break}if(pu(i))break;for(t=e.position;0!==i&&!mu(i);)i=e.input.charCodeAt(++e.position);r.push(e.input.slice(t,e.position));}0!==i&&Lu(e),tu.call(Tu,n)?Tu[n](e,n,r):Au(e,'unknown document directive "'+n+'"');}Bu(e,!0,-1),0===e.lineIndent&&45===e.input.charCodeAt(e.position)&&45===e.input.charCodeAt(e.position+1)&&45===e.input.charCodeAt(e.position+2)?(e.position+=3,Bu(e,!0,-1)):s&&Eu(e,"directives end mark is expected"),Du(e,e.lineIndent-1,ou,!1,!0),Bu(e,!0,-1),e.checkLineBreaks&&hu.test(e.input.slice(o,e.position))&&Au(e,"non-ASCII line breaks are interpreted as content"),e.documents.push(e.result),e.position===e.lineStart&&Iu(e)?46===e.input.charCodeAt(e.position)&&(e.position+=3,Bu(e,!0,-1)):e.position<e.length-1&&Eu(e,"end of the stream or a document separator is expected");}function Nu(e,t){t=t||{},0!==(e=String(e)).length&&(10!==e.charCodeAt(e.length-1)&&13!==e.charCodeAt(e.length-1)&&(e+="\n"),65279===e.charCodeAt(0)&&(e=e.slice(1)));var n=new xu(e,t);for(n.input+="\0";32===n.input.charCodeAt(n.position);)n.lineIndent+=1,n.position+=1;for(;n.position<n.length-1;)ju(n);return n.documents}function Zu(e,t,n){var r,i,o=Nu(e,n);for(r=0,i=o.length;r<i;r+=1)t(o[r]);}function Wu(e,t){var n=Nu(e,t);if(0!==n.length){if(1===n.length)return n[0];throw new vl("expected a single document in the stream, but found more")}}var qu={loadAll:Zu,load:Wu,safeLoadAll:function(e,t,n){Zu(e,t,gl.extend({schema:Gl},n));},safeLoad:function(e,t){return Wu(e,gl.extend({schema:Gl},t))}};function Yu(e){return function(){throw new Error("Function "+e+" is deprecated and cannot be used.")}}var Vu={Type:kl,Schema:Cl,FAILSAFE_SCHEMA:El,JSON_SCHEMA:Il,CORE_SCHEMA:Fl,DEFAULT_SAFE_SCHEMA:Gl,DEFAULT_FULL_SCHEMA:eu,load:qu.load,loadAll:qu.loadAll,safeLoad:qu.safeLoad,safeLoadAll:qu.safeLoadAll,YAMLException:vl,MINIMAL_SCHEMA:El,SAFE_SCHEMA:Gl,DEFAULT_SCHEMA:eu,scan:Yu("scan"),parse:Yu("parse"),compose:Yu("compose"),addConstructor:Yu("addConstructor")},Hu=function(){function t(t,n,r){void 0===r&&(r=null),this.url=t,!n||e.isRelativeURL(n)&&!e.isRelativeURL(this.url)?this.path=e.pathForURL(this.url):this.path=n,this.path_for_parent=n||this.path,this.parent=r,this.container=null,this.parent&&(this.parent.container?this.container=this.parent.container:this.parent.isContainer()&&(this.container=this.parent));}var n=t.prototype;return n.load=function(){return Ku(this.url)},n.resourceFor=function(e){return {url:this.urlFor(e),path:this.pathFor(e),type:this.typeFor(e)}},n.urlFor=function(t){return h(t)?t:e.isRelativeURL(t)&&this.container?this.parent.urlFor(this.path_for_parent+t):e.addBaseURL(t,this.path)},n.pathFor=function(t){return e.pathForURL(t)},n.typeFor=function(t){return e.extensionForURL(t)},n.isContainer=function(){return !1},t}(),Gu=function(t){function n(e,n,r){var i;return (i=t.call(this,e,n,r)||this).zip=null,i.files={},i.root=null,i.path="",i}e._inheritsLoose(n,t);var r=n.prototype;return r.isContainer=function(){return !0},r.load=function(){return new Promise(function(t,n){var r;return this.zip=new dl,"string"==typeof this.url?Promise.resolve(e.Utils.io(this.url,6e4,"arraybuffer")).then(function(e){try{return r=e.body,Promise.resolve(this.zip.loadAsync(r)).then(function(e){try{return Promise.resolve(this.parseZipFiles()).then(function(e){try{return t(this.loadRoot())}catch(e){return n(e)}}.bind(this),n)}catch(e){return n(e)}}.bind(this),n)}catch(e){return n(e)}}.bind(this),n):t(this)}.bind(this))},r.urlFor=function(n){return h(n)?n:e.isRelativeURL(n)?this.urlForZipFile(e.flattenRelativeURL(n)):t.prototype.urlFor.call(this,n)},r.typeFor=function(n){return e.isRelativeURL(n)?this.typeForZipFile(n):t.prototype.typeFor.call(this,n)},r.loadRoot=function(){return this.findRoot(),Ku(this.urlForZipFile(this.root))},r.findRoot=function(){var t=this,n=Object.keys(this.files).filter(function(e){return 0===t.files[e].depth}).filter(function(t){return "yaml"===e.extensionForURL(t)});if(1===n.length&&(this.root=n[0]),!this.root){var r="Could not find root scene for bundle '"+this.url+"': ";throw r+="The zip archive's root level must contain a single scene file with the '.yaml' extension. ",n.length>0?r+="Found multiple YAML files at the root level: "+n.map(function(e){return "'"+e+"'"}).join(", ")+".":r+="Found NO YAML files at the root level.",Error(r)}},r.parseZipFiles=function(){return new Promise(function(t,n){var r,i,o,s,a,l;return r=[],i=[],this.zip.forEach(function(e,t){t.dir||(r.push(e),i.push(t.async("arraybuffer")));}),Promise.resolve(Promise.all(i)).then(function(i){try{for(o=i,s=0;s<o.length;s++)a=r[s],l=a.split("/").length-1,this.files[a]={data:o[s],type:e.extensionForURL(a),depth:l};return t()}catch(e){return n(e)}}.bind(this),n)}.bind(this))},r.urlForZipFile=function(t){if(this.files[t])return this.files[t].url||(this.files[t].url=e.createObjectURL(new Blob([this.files[t].data]))),this.files[t].url},r.typeForZipFile=function(e){return this.files[e]&&this.files[e].type},n}(Hu);function Ku(t){return new Promise(function(n,r){"string"==typeof t?e.Utils.io(t).then(function(e){var t=e.body;try{n(function(e){return Vu.safeLoad(e,{json:!0})}(t));}catch(e){r(e);}},r):(t=Object.assign({},t),n(t));})}var Ju={loadScene:function(t,n){return new Promise(function(r,i){var o,s,a,l,u,h,c,f,d,p;return o=this,a=(s=void 0===n?{}:n).path,l=s.type,u=[],h={},Promise.resolve(this.loadSceneRecursive({url:t,path:a,type:l},null,h,u)).then(function(t){try{return c=t,f=this.finalize(c),d=f.config,p=f.bundle,d?(u.length>0&&u.forEach(function(t){var n="Failed to import scene: "+t.url;e.log("error",n,t),o.trigger("error",{type:"scene_import",message:n,error:t,url:t.url});}),r({config:d,bundle:p,texture_nodes:h})):i(u[0])}catch(e){return i(e)}}.bind(this),i)}.bind(this))},loadSceneRecursive:function(t,n,r,i){return new Promise(function(o,s){var a,l,u,h,c,f,d,p,g;if(a=this,l=t.url,u=t.path,h=t.type,void 0===r&&(r={}),void 0===i&&(i=[]),!l)return o({});c=function(t,n,r,i){return void 0===i&&(i=null),null!=i&&"zip"===i||"string"==typeof t&&!e.isLocalURL(t)&&"zip"===e.extensionForURL(t)?new Gu(t,n,r):new Hu(t,n,r)}(l,u,n,h);var m=function(e){try{return e.url=l,i.push(e),o({})}catch(e){return s(e)}};try{return Promise.resolve(c.load()).then(function(t){try{return null==(f=t).import?(this.normalize(f,c,r),o({config:f,bundle:c})):(Array.isArray(f.import)||(f.import=[f.import]),d=[],f.import.forEach(function(t){"object"==typeof t&&(t=e.createObjectURL(new Blob([JSON.stringify(t)]))),d.push(c.resourceFor(t));}),delete f.import,p=d.map(function(e){return a.loadSceneRecursive(e,c,r,i)}),Promise.resolve(Promise.all(p)).then(function(t){try{return g=t.map(function(e){return a.normalize(e.config,e.bundle,r)}).map(function(e){return e.config}),this.normalize(f,c,r),f=e.mergeObjects.apply(void 0,g.concat([f])),o({config:f,bundle:c,texture_nodes:r})}catch(e){return m(e)}}.bind(this),m))}catch(e){return m(e)}}.bind(this),m)}catch(e){m(e);}}.bind(this))},normalize:function(e,t,n){return void 0===n&&(n={}),this.normalizeDataSources(e,t),this.normalizeFonts(e,t),this.normalizeTextures(e,t),this.collectTextures(e,t,n),{config:e,bundle:t,texture_nodes:n}},normalizeDataSources:function(e,t){for(var n in e.sources=e.sources||{},e.sources)this.normalizeDataSource(e.sources[n],t);return e},normalizeDataSource:function(e,t){if(e.url=t.urlFor(e.url),Array.isArray(e.composite)&&e.composite.forEach(function(e){return e.url=t.urlFor(e.url)}),e.scripts)for(var n in Array.isArray(e.scripts)&&(e.scripts=e.scripts.reduce(function(e,t){return e[t]=t,e},{})),e.scripts)e.scripts[n]=t.urlFor(e.scripts[n]);return e},normalizeFonts:function(e,t){for(var n in e.fonts=e.fonts||{},e.fonts)if(Array.isArray(e.fonts[n]))e.fonts[n].forEach(function(e){e.url=e.url&&t.urlFor(e.url);});else {var r=e.fonts[n];r.url=r.url&&t.urlFor(r.url);}return e},normalizeTextures:function(e,t){if(e.textures=e.textures||{},e.textures)for(var n in e.textures){var r=e.textures[n];r.url&&(r.url=t.urlFor(r.url));}},collectTextures:function(t,n,r){var i=this;if(t.styles){var o=function(e){var o=t.styles[e],s=o.texture;if("string"==typeof s&&!t.textures[s]){var a=["styles",e,"texture"];i.addTextureNode(a,n,r);}o.material&&["emission","ambient","diffuse","specular","normal"].forEach(function(s){var a=null!=o.material[s]&&o.material[s].texture;if("string"==typeof a&&!t.textures[a]){var l=["styles",e,"material",s,"texture"];i.addTextureNode(l,n,r);}});};for(var s in t.styles)o(s);}if(t.styles){var a=function(o){var s=t.styles[o];s.shaders&&s.shaders.uniforms&&e.GLSL.parseUniforms(s.shaders.uniforms).forEach(function(e){var s=e.type,a=e.value,l=e.key;if("sampler2D"===s&&"string"==typeof a&&!t.textures[a]){var u=["styles",o,"shaders","uniforms",l];i.addTextureNode(u,n,r);}});};for(var l in t.styles)a(l);}if(t.layers)for(var u=[t.layers],h=[["layers"]];u.length>0;){var c=u.pop(),f=h.pop();if("object"==typeof c&&!Array.isArray(c))for(var d in c)if("draw"===d){var p=c[d];for(var g in p){if(p[g].texture){var m=p[g].texture;if("string"==typeof m&&!t.textures[m]){var v=[].concat(f,[d,"draw",g,"texture"]);this.addTextureNode(v,n,r);}}if(p[g].outline&&p[g].outline.texture){var _=p[g].outline.texture;if("string"==typeof _&&!t.textures[_]){var y=[].concat(f,[d,"draw",g,"outline","texture"]);this.addTextureNode(y,n,r);}}}}else {if(e.isReserved(d))continue;u.push(c[d]),h.push([].concat(f,[d]));}}},addTextureNode:function(e,t,n){n[JSON.stringify(e)]={path:e,bundle:t};},hoistTextureNodes:function(e,t,n){void 0===n&&(n={});for(var r=0,s=Object.values(n);r<s.length;r++){var a=s[r],l=a.path,u=a.bundle,h=i(e,l);if("string"==typeof h&&null==e.textures[h])if(c(e,l)){var f=t.urlFor(h);e.textures[h]={url:f};}else {var d=u.urlFor(h);e.textures[d]={url:d},o(e,l,d);}}},applyGlobalProperties:function(t){return t.global&&0!==Object.keys(t.global).length?function t(n,r,i,o){var s,h;if((null==i?void 0:null==(s=i[u])?void 0:s[o])?h=i[u][o]:"string"==typeof r&&r.slice(0,l)===a&&(h=r),h){null==i[u]&&Object.defineProperty(i,u,{value:{}}),i[u][o]=h;for(var c,f=n[h];"string"==typeof f&&f.slice(0,l)===a;){if((c=c||[h]).indexOf(f)>-1){e.log({level:"warn",once:!0},"Global properties: cyclical reference detected",c),f=null;break}c.push(f),f=n[f];}Object.defineProperty(i,o,{enumerable:!0,get:function(){return f},set:function(e){delete i[u][o],delete i[o],i[o]=e;}});}else if(Array.isArray(r))for(var d=0;d<r.length;d++)t(n,r[d],r,d);else if("object"==typeof r)for(var p in r)t(n,r[p],r,p);return r}(function e(t,n,r){for(var i in void 0===n&&(n=null),void 0===r&&(r={}),n=n?n+".":a,t){var o=n+i,s=t[i];r[o]=s,"object"!=typeof s||Array.isArray(s)||e(s,o,r);}return r}(t.global),t):t},finalize:function(e){var t=e.config,n=e.bundle;return t?(t.global=t.global||{},t.scene=t.scene||{},t.cameras=t.cameras||{},t.lights=t.lights||{},t.styles=t.styles||{},t.layers=t.layers||{},t.camera&&(t.cameras.default=t.camera),0===Object.keys(t.cameras).length&&(t.cameras.default={}),(0===Object.keys(t.lights).length||Object.keys(t.lights).every(function(e){return !1===t.lights[e].visible}))&&(t.lights.default_light={type:"directional"}),{config:t,bundle:n}):{}}};e.subscribeMixin(Ju);var Xu=function(){function t(){this.tiles={},this.max_proxy_descendant_depth=6,this.max_proxy_ancestor_depth=7,this.children_cache={};}var n=t.prototype;return n.addTile=function(t){for(this.tiles[t.key]=this.tiles[t.key]||{descendants:0},this.tiles[t.key].tile=t;t.style_z>=0;){if(!(t=e.TileID.parent(t)))return;this.tiles[t.key]||(this.tiles[t.key]={descendants:0}),this.tiles[t.key].descendants++;}},n.removeTile=function(t){for(this.tiles[t.key]&&(delete this.tiles[t.key].tile,0===this.tiles[t.key].descendants&&delete this.tiles[t.key]);t.style_z>=0;){if(!(t=e.TileID.parent(t)))return;this.tiles[t.key]&&this.tiles[t.key].descendants>0&&(this.tiles[t.key].descendants--,0!==this.tiles[t.key].descendants||this.tiles[t.key].tile||delete this.tiles[t.key]);}},n.getAncestor=function(t){for(var n=0;n<this.max_proxy_ancestor_depth;){if(!(t=e.TileID.parent(t)))return;if(this.tiles[t.key]&&this.tiles[t.key].tile&&this.tiles[t.key].tile.loaded)return this.tiles[t.key].tile;n++;}},n.getDescendants=function(t,n){var r=this;void 0===n&&(n=0);var i=[];if(n<this.max_proxy_descendant_depth){var o=e.TileID.children(t,this.children_cache);if(!o)return;o.forEach(function(e){r.tiles[e.key]&&(r.tiles[e.key].tile&&r.tiles[e.key].tile.loaded?i.push(r.tiles[e.key].tile):r.tiles[e.key].descendants>0&&i.push.apply(i,r.getDescendants(e,n+1)));});}return i},t}(),$u={},Qu={};function eh(t,n,r){return new Promise(function(i,o){var s,a,l,u,h;return void 0===r&&(r=!1),Qu=$u,$u={},s=function(t,n){var r={},i={};for(var o in t.forEach(function(t){var o=e.Geo.unitsPerMeter(t.coords.z),s=Math.pow(2,n-t.style_z),a=o*s,l=e.Geo.metersPerPixel(n),u=Object.assign({},t.meshes,t.pending_label_meshes);for(var h in u)u[h].forEach(function(n){if(n.labels)for(var s in n.labels)if(!t.isProxy()||Qu[s]){var u=n.labels[s].container.label,h=n.labels[s].container.linked,c=n.labels[s].ranges,f=r[s]={};if(f.discard=th.bind(f),f.build_id=t.build_id,Object.assign(f,u),f.layout=Object.assign({},u.layout),f.layout.repeat_scale=.75,f.layout.repeat_distance=f.layout.repeat_distance||0,f.layout.repeat_distance/=a,f.position=[f.position[0]/o+t.min.x,f.position[1]/o+t.min.y],f.unit_scale=l,"point"===f.type)e.LabelPoint.prototype.updateBBoxes.call(f);else if("straight"===f.type)e.LabelLineStraight.prototype.updateBBoxes.call(f,f.position,f.size,f.angle,f.angle,f.offset);else if(u.obbs){var d=u.obbs.map(function(n){var r=n.x,i=n.y,s=n.a,l=n.w,u=n.h;return r=r/o+t.min.x,i=i/o+t.min.y,l/=a,u/=a,new e.OBB(r,i,s,l,u)});f.obbs=d,f.aabbs=d.map(function(e){return e.getExtent()});}i[s]={label:f,linked:h,ranges:c,mesh:n};}});}),i){var s=i[o];s.linked&&(s.linked=i[s.linked]);}return i=Object.keys(i).map(function(e){return i[e]})}(t,n),e.Collision.startTile("main",{apply_repeat_groups:!0,return_hidden:!0}),e.Collision.addStyle("main","main"),a=Math.max.apply(Math,[0].concat(Object.values(t).map(function(e){return Object.values(e.meshes)}).flat().map(function(e){return Math.max.apply(Math,[0].concat(e.map(function(e){return e.labels?Object.keys(e.labels).length:0})))}))),(l=Math.floor(a/e.Geo.tile_size))>0?e.Collision.initGrid({anchor:{x:Math.min.apply(Math,t.map(function(e){return e.min.x})),y:Math.min.apply(Math,t.map(function(e){return e.min.y}))},span:t[0].span.x/l}):e.Collision.initGrid(),Promise.resolve(e.Collision.collide(s,"main","main")).then(function(e){try{return h=[],(u=e).forEach(function(e){var t=0;!0!==e.show||r&&e.label.breach&&!Qu[e.label.id]||(t=1),t&&($u[e.label.id]=!0);var n=!0;e.ranges.forEach(function(r){if(n){var i=e.mesh;if(i.valid){for(var o=i.vertex_layout.offset.a_shape,s=i.vertex_layout.stride,a=0;a<r[1];a++){if(i.vertex_data[r[0]+a*s+o+6]===t)return void(n=!1);i.vertex_data[r[0]+a*s+o+6]=t;}-1===h.indexOf(i)&&h.push(i);}}});}),h.forEach(function(e){return e.upload()}),t.forEach(function(e){return e.swapPendingLabels()}),i({labels:u,containers:s})}catch(e){return o(e)}},o)})}function th(t,n){if(void 0===n&&(n=null),this.obb)return e.Label.prototype.occluded.call(this,t,n);if(this.obbs)for(var r=0;r<this.obbs.length;r++){var i={aabb:this.aabbs[r],obb:this.obbs[r]};if(e.Label.prototype.occluded.call(i,t,n))return !0}return !1}var nh=function(){function t(t){var n=t.scene;this.scene=n,this.tiles={},this.pyramid=new Xu,this.visible_coords={},this.queued_coords=[],this.building_tiles=null,this.renderable_tiles=[],this.collision={tile_keys:null,mesh_set:null,zoom:null,zoom_steps:3},this.main_thread_target=["TileManager",this.scene.id].join("_"),e.WorkerBroker.addTarget(this.main_thread_target,this);}var n=t.prototype;return n.destroy=function(){this.forEachTile(function(e){return e.destroy()}),this.tiles={},this.pyramid=null,this.visible_coords={},this.queued_coords=[],this.scene=null,e.WorkerBroker.removeTarget(this.main_thread_target);},n.keepTile=function(e){this.tiles[e.key]=e,this.pyramid.addTile(e);},n.hasTile=function(e){return void 0!==this.tiles[e]},n.forgetTile=function(e){if(this.hasTile(e)){var t=this.tiles[e];this.pyramid.removeTile(t);}delete this.tiles[e],this.tileBuildStop(e);},n.removeTile=function(t){e.log("trace","tile unload for "+t);var n=this.tiles[t];null!=n&&n.destroy(),this.forgetTile(n.key),this.scene.requestRedraw();},n.forEachTile=function(e){for(var t in this.tiles)e(this.tiles[t]);},n.removeTiles=function(e){var t=[];for(var n in this.tiles){e(this.tiles[n])&&t.push(n);}for(var r=0;r<t.length;r++){var i=t[r];this.removeTile(i);}},n.updateTilesForView=function(){this.visible_coords={};for(var e=this.view.findVisibleTileCoordinates(),t=0;t<e.length;t++){var n=e[t];this.queueCoordinate(n),this.visible_coords[n.key]=n;}this.updateTileStates();},n.updateTileStates=function(){var e=this;return this.forEachTile(function(t){e.updateVisibility(t);}),this.loadQueuedCoordinates(),this.updateProxyTiles(),this.view.pruneTilesForView(),this.updateRenderableTiles(),this.style_manager.updateActiveStyles(this.renderable_tiles),this.style_manager.updateActiveBlendOrders(this.renderable_tiles),this.updateLabels()},n.updateLabels=function(){var t=this;if(this.scene.building&&!this.scene.building.initial)return Promise.resolve({});var n=this.renderable_tiles.filter(function(e){return e.valid}).filter(function(e){return e.built});return 0===n.length?Promise.resolve({}):(n.sort(function(e,t){return e.build_id<t.build_id?-1:e.build_id>t.build_id?1:0}),this.collision.zoom===rh(this.view.zoom,this.collision.zoom_steps)&&this.collision.tile_keys===JSON.stringify(n.map(function(e){return e.key}))&&this.collision.mesh_set===ih(n)?Promise.resolve({}):(this.collision.task||(this.collision.zoom=rh(this.view.zoom,this.collision.zoom_steps),this.collision.tile_keys=JSON.stringify(n.map(function(e){return e.key})),this.collision.mesh_set=ih(n),this.collision.task={type:"tileManagerUpdateLabels",run:function(r){return new Promise(function(i,o){var s;return Promise.resolve(eh(n,t.collision.zoom,t.isLoadingVisibleTiles())).then(function(n){try{return s=n,t.scene.requestRedraw(),t.collision.task=null,e.Task.finish(r,s),t.updateTileStates(),i()}catch(e){return o(e)}},o)})},immediate:!0},e.Task.add(this.collision.task)),this.collision.task.promise))},n.updateProxyTiles=function(){var e=this;if(0!==this.view.zoom_direction){this.forEachTile(function(e){return e.setProxyFor(null)});var t=!1;this.forEachTile(function(n){if(n.visible&&!n.labeled){var r=e.pyramid.getAncestor(n);if(r)r.setProxyFor(n),t=!0;else for(var i=e.pyramid.getDescendants(n),o=0;o<i.length;o++)i[o].setProxyFor(n),t=!0;}}),t||(this.view.zoom_direction=0);}},n.updateVisibility=function(t){if(t.visible=!1,t.style_z===this.view.tile_zoom)if(this.visible_coords[t.coords.key])t.visible=!0;else for(var n in this.visible_coords)if(e.TileID.isDescendant(t.coords,this.visible_coords[n])){t.visible=!0;break}},n.pruneToVisibleTiles=function(){this.removeTiles(function(e){return !e.visible});},n.getRenderableTiles=function(){return this.renderable_tiles},n.updateRenderableTiles=function(){for(var e in this.renderable_tiles=[],this.tiles){var t=this.tiles[e];t.visible&&t.loaded&&this.renderable_tiles.push(t);}return this.renderable_tiles},n.isLoadingVisibleTiles=function(){var e=this;return Object.keys(this.tiles).some(function(t){return e.tiles[t].visible&&!e.tiles[t].built})},n.allVisibleTilesLabeled=function(){return this.renderable_tiles.every(function(e){return e.labeled})},n.queueCoordinate=function(e){this.queued_coords[this.queued_coords.length]=e;},n.loadQueuedCoordinates=function(){var t=this;0!==this.queued_coords.length&&(this.queued_coords.sort(function(n,r){var i=t.view.center.meters,o=e.Geo.metersPerTile(n.z)/2,s=e.Geo.metersForTile(n);s.x+=o,s.y-=o;var a=e.Geo.metersForTile(r);a.x+=o,a.y-=o;var l=Math.abs(i.x-s.x)+Math.abs(i.y-s.y),u=Math.abs(i.x-a.x)+Math.abs(i.y-a.y);return n.center_dist=l,r.center_dist=u,u>l?-1:u===l?0:1}),this.queued_coords.forEach(function(e){return t.loadCoordinate(e)}),this.queued_coords=[]);},n.loadCoordinate=function(t){if(t.z===this.view.center.tile.z)for(var n in this.scene.sources){var r=this.scene.sources[n];if(r.builds_geometry_tiles&&r.includesTile(t,this.view.tile_zoom)){var i=e.TileID.normalizedKey(t,r,this.view.tile_zoom);if(i&&!this.hasTile(i)){e.log("trace","load tile "+i+", distance from view center: "+t.center_dist);var o=new e.Tile({source:r,coords:t,workers:this.scene.workers,style_z:this.view.baseZoom(t.z),view:this.view});this.keepTile(o),this.buildTile(o);}}}},n.buildTile=function(e,t){this.tileBuildStart(e.key),this.updateVisibility(e),e.build(this.scene.generation,t);},n.buildTileStylesCompleted=function(t){var n=t.tile,r=t.progress;if(null==this.tiles[n.key])e.log("trace","discarded tile "+n.key+" in TileManager.buildTileStylesCompleted because previously removed"),e.Tile.abortBuild(n),this.updateTileStates();else if(n.generation!==this.scene.generation)e.log("trace","discarded tile "+n.key+" in TileManager.buildTileStylesCompleted because built with scene config gen "+n.generation+", current "+this.scene.generation),e.Tile.abortBuild(n),this.updateTileStates();else {if(this.tiles[n.key]){if(n.id<this.tiles[n.key].id)return e.log("trace","discarded tile "+n.key+" for id "+n.id+" in TileManager.buildTileStylesCompleted because built for discarded tile id"),void e.Tile.abortBuild(n);n=this.tiles[n.key].merge(n);}r.done&&(n.built=!0),n.buildMeshes(this.scene.styles,r),this.updateTileStates(),this.scene.requestRedraw();}r.done&&this.tileBuildStop(n.key);},n.buildTileError=function(t){e.log("error","Error building tile "+t.key+":",t.error),this.forgetTile(t.key),e.Tile.abortBuild(t);},n.tileBuildStart=function(t){this.building_tiles=this.building_tiles||{},this.building_tiles[t]=!0,e.log("trace","tileBuildStart for "+t+": "+Object.keys(this.building_tiles).length);},n.tileBuildStop=function(t){this.building_tiles&&(e.log("trace","tileBuildStop for "+t+": "+Object.keys(this.building_tiles).length),delete this.building_tiles[t],this.checkBuildQueue());},n.checkBuildQueue=function(){this.building_tiles&&0!==Object.keys(this.building_tiles).length||(this.building_tiles=null,this.scene.tileManagerBuildDone());},n.getDebugProp=function(e,t){var n=[];for(var r in this.tiles)null==this.tiles[r].debug[e]||"function"==typeof t&&!0!==t(this.tiles[r])||n.push(this.tiles[r].debug[e]);return n},n.getDebugSum=function(e,t){var n=0;for(var r in this.tiles)null==this.tiles[r].debug[e]||"function"==typeof t&&!0!==t(this.tiles[r])||(n+=this.tiles[r].debug[e]);return n},n.getDebugAverage=function(e,t){return this.getDebugSum(e,t)/Object.keys(this.tiles).length},e._createClass(t,[{key:"view",get:function(){return this.scene.view}},{key:"style_manager",get:function(){return this.scene.style_manager}}]),t}();function rh(e,t,n){return void 0===n&&(n=2),(Math.floor(e*t)/t).toFixed(n)}function ih(e){return JSON.stringify(Object.entries(e).map(function(e){var t=e[1];return Object.entries(t.meshes).map(function(e){return e[1].map(function(e){return e.created_at})})}))}var oh=function(){function e(e,t){t(e),this.value=e,this.setup=t;}return e.prototype.set=function(e){JSON.stringify(this.value)!==JSON.stringify(e)&&(this.setup(e),this.value=e);},e}(),sh=function(e){this.defaults={},this.defaults.culling=!0,this.defaults.culling_face=e.BACK,this.defaults.blending=!1,this.defaults.blending_src=e.ONE_MINUS_SRC_ALPHA,this.defaults.blending_dst=e.ONE_MINUS_SRC_ALPHA,this.defaults.blending_src_alpha=e.ONE,this.defaults.blending_dst_alpha=e.ONE_MINUS_SRC_ALPHA,this.defaults.depth_write=!0,this.defaults.depth_test=!0,e.depthFunc(e.LESS),this.culling=new oh({cull:this.defaults.culling,face:this.defaults.culling_face},function(t){t.cull?(e.enable(e.CULL_FACE),e.cullFace(t.face)):e.disable(e.CULL_FACE);}),this.blending=new oh({blend:this.defaults.blending,src:this.defaults.blending_src,dst:this.defaults.blending_dst,src_alpha:this.defaults.blending_src_alpha,dst_alpha:this.defaults.blending_dst_alpha},function(t){t.blend?(e.enable(e.BLEND),t.src_alpha&&t.dst_alpha?e.blendFuncSeparate(t.src,t.dst,t.src_alpha,t.dst_alpha):e.blendFunc(t.src,t.dst)):e.disable(e.BLEND);}),this.depth_write=new oh({depth_write:this.defaults.depth_write},function(t){e.depthMask(t.depth_write);}),this.depth_test=new oh({depth_test:this.defaults.depth_test},function(t){t.depth_test?e.enable(e.DEPTH_TEST):e.disable(e.DEPTH_TEST);});};e.require$$0("Uint8",1,function(e){return function(t,n,r){return e(this,t,n,r)}},!0);var ah=function(){function t(){this.canvas=null,this.gl=null,this.screenshot_canvas=null,this.screenshot_context=null,this.queue_screenshot=null,this.video_capture=null;}var n=t.prototype;return n.setCanvas=function(e,t){this.canvas=e,this.gl=t;},n.screenshot=function(e){var t=this,n=(void 0===e?{}:e).background;return null!=this.queue_screenshot?this.queue_screenshot.promise:(this.queue_screenshot={background:n},this.queue_screenshot.promise=new Promise(function(e,n){t.queue_screenshot.resolve=e,t.queue_screenshot.reject=n;}),this.queue_screenshot.promise)},n.completeScreenshot=function(){if(null!=this.queue_screenshot){var t=this.canvas.width,n=this.canvas.height,r=new Uint8Array(t*n*4);this.gl.readPixels(0,0,t,n,this.gl.RGBA,this.gl.UNSIGNED_BYTE,r);var i=this.queue_screenshot.background;i=i&&"transparent"!==i?e.StyleParser.parseColor(i).slice(0,3).map(function(e){return 255*e}):null;for(var o=new Uint8ClampedArray(t*n*4),s=0;s<n;s++)for(var a=0;a<t;a++){var l=4*((n-s-1)*t+a),u=4*(s*t+a),h=r[l+3];o[u+0]=255*r[l+0]/h,o[u+1]=255*r[l+1]/h,o[u+2]=255*r[l+2]/h,o[u+3]=h,i&&(h/=255,o[u+0]=o[u+0]*h+i[0]*(1-h),o[u+1]=o[u+1]*h+i[1]*(1-h),o[u+2]=o[u+2]*h+i[2]*(1-h),o[u+3]=255);}this.screenshot_canvas=this.screenshot_canvas||document.createElement("canvas");var c=this.screenshot_canvas;c.width=t,c.height=n,this.screenshot_context=this.screenshot_context||c.getContext("2d");var f=this.screenshot_context,d=new ImageData(o,t,n);f.putImageData(d,0,0);for(var p=c.toDataURL("image/png"),g=atob(p.slice(22)),m=new Uint8Array(g.length),v=0;v<g.length;++v)m[v]=g.charCodeAt(v);var _=new Blob([m],{type:"image/png"});this.queue_screenshot.resolve({url:p,blob:_,type:"png"}),this.queue_screenshot=null;}},n.startVideoCapture=function(){var t=this;if("function"!=typeof window.MediaRecorder||!this.canvas||"function"!=typeof this.canvas.captureStream)return e.log("warn","Video capture (Canvas.captureStream and/or MediaRecorder APIs) not supported by browser"),!1;if(this.video_capture)return e.log("warn","Video capture already in progress, call Scene.stopVideoCapture() first"),!1;try{var n=this.video_capture={};n.chunks=[],n.stream=this.canvas.captureStream(),n.options={mimeType:"video/webm"},n.media_recorder=new MediaRecorder(n.stream,n.options),n.media_recorder.ondataavailable=function(r){if(r.data.size>0&&n.chunks.push(r.data),n.resolve){var i=new Blob(n.chunks,{type:n.options.mimeType}),o=e.createObjectURL(i);if(n.stream)(n.stream.getTracks()||[]).forEach(function(e){e.stop(),n.stream.removeTrack(e);});n.stream=null,n.media_recorder=null,t.video_capture=null,n.resolve({url:o,blob:i,type:"webm"});}},n.media_recorder.start();}catch(t){return this.video_capture=null,e.log("error","Scene video capture failed",t),!1}return !0},n.stopVideoCapture=function(){var t=this;return this.video_capture?(this.video_capture.promise=new Promise(function(e,n){t.video_capture.resolve=e,t.video_capture.reject=n;}),this.video_capture.media_recorder.stop(),this.video_capture.promise):(e.log("warn","No scene video capture in progress, call Scene.startVideoCapture() first"),Promise.resolve({}))},t}();var lh,uh=function(){function t(n,r){var i;r=r||{},e.subscribeMixin(this),this.id=t.id++,this.initialized=!1,this.initializing=null,this.sources={},this.view=new e.View(this,r),this.tile_manager=new nh({scene:this}),this.num_workers=r.numWorkers||2,!0===r.disableVertexArrayObjects&&(e.VertexArrayObject.disabled=!0),e.Utils.use_high_density_display=void 0===r.highDensityDisplay||r.highDensityDisplay,e.Utils.updateDevicePixelRatio(),this.config=null,this.config_source=n,this.config_bundle=null,this.last_valid_config_source=null,this.styles=null,this.style_manager=new e.StyleManager,this.building=null,this.dirty=!0,r.preUpdate&&this.subscribe({pre_update:r.preUpdate}),r.postUpdate&&this.subscribe({post_update:r.postUpdate}),this.render_loop=!r.disableRenderLoop,this.render_loop_active=!1,this.render_loop_stop=!1,this.render_count=0,this.last_render_count=0,this.render_count_changed=!1,this.frame=0,this.last_main_render=-1,this.last_selection_render=-1,this.media_capture=new ah,this.selection=null,this.selection_feature_count=0,this.fetching_selection_map=null,this.prev_textures=null,this.introspection=!0===r.introspection,this.times={},this.resetTime(),this.container=r.container,this.canvas=null,this.contextOptions=r.webGLContextOptions,this.lights=null,this.background=null,this.createListeners(),this.updating=0,this.generation=t.generation,this.last_complete_generation=t.generation,(i=this).debug={profile:function(t){console.profile("main thread: "+t),e.WorkerBroker.postMessage(i.workers,"self.profile",t);},profileEnd:function(t){console.profileEnd("main thread: "+t),e.WorkerBroker.postMessage(i.workers,"self.profileEnd",t);},timeRebuild:function(t,n){void 0===t&&(t=1),void 0===n&&(n={});var r=[];!function o(){var s=+new Date;i.rebuild(n).then(function(){if(r.push(+new Date-s),r.length<t)o();else {var n=~~(r.reduce(function(e,t){return e+t})/r.length);e.log("info","Profiled rebuild "+t+" times: "+n+" avg ("+Math.min.apply(Math,r)+" min, "+Math.max.apply(Math,r)+" max)");}});}();},geometryCountByStyle:function(){var e={};return i.tile_manager.getRenderableTiles().forEach(function(t){var n=function(n){e[n]=e[n]||0,t.meshes[n].forEach(function(t){e[n]+=t.geometry_count;});};for(var r in t.meshes)n(r);}),e},geometryCountByBaseStyle:function(){var e=i.debug.geometryCountByStyle(),t={};for(var n in e){var r=i.styles[n].baseStyle();t[r]=t[r]||0,t[r]+=e[n];}return t},geometryCountTotal:function(){var e=i.debug.geometryCountByStyle();return Object.keys(e).reduce(function(t,n){return e[n]+t},0)},geometrySizeByStyle:function(){var e={};return i.tile_manager.getRenderableTiles().forEach(function(t){var n=function(n){e[n]=e[n]||0,t.meshes[n].forEach(function(t){e[n]+=t.buffer_size;});};for(var r in t.meshes)n(r);}),e},geometrySizeByBaseStyle:function(){var e=i.debug.geometrySizeByStyle(),t={};for(var n in e){var r=i.styles[n].baseStyle();t[r]=t[r]||0,t[r]+=e[n];}return t},geometrySizeTotal:function(){var e=i.debug.geometrySizeByStyle();return Object.keys(e).reduce(function(t,n){return e[n]+t},0)},textureSizeTotal:function(){return Object.values(e.Texture.textures).map(function(e){return e.byteSize()}).reduce(function(e,t){return e+t})},layerStats:function(){return e.debugSettings.layer_stats?e.debugSumLayerStats(i.tile_manager.getRenderableTiles()):(e.log("warn","Enable the 'layer_stats' debug setting to collect layer stats"),{})},renderableTilesCount:function(){return i.tile_manager.getRenderableTiles().length}},this.log_level=r.logLevel||"warn",e.log.setLevel(this.log_level),e.log.reset();}t.create=function(e,n){return void 0===n&&(n={}),new t(e,n)};var r=t.prototype;return r.load=function(t,n){var r=this;return void 0===t&&(t=null),void 0===n&&(n={}),this.initializing?this.initializing:(e.log.reset(),this.updating++,this.initialized=!1,this.view_complete=!1,this.times.frame=null,this.times.build=null,(n="string"==typeof n?{base_path:n}:n).blocking=void 0===n.blocking||n.blocking,!1!==this.render_loop&&this.setupRenderLoop(),this.createCanvas(),this.prev_textures=this.config&&Object.keys(this.config.textures),this.initializing=this.loadScene(t,n).then(function(t){return new Promise(function(i,o){var s,a,l;return s=t.texture_nodes,Promise.resolve(r.createWorkers()).then(function(t){try{if(r.destroyFeatureSelection(),e.WorkerBroker.postMessage(r.workers,"self.clearFunctionStringCache"),a="object"==typeof r.config_source||r.hasSubscribersFor("load"),l=r.updateConfig({texture_nodes:s,serialize_funcs:a,normalize:!1,loading:!0,fade_in:!0}),!0===n.blocking)return Promise.resolve(l).then(function(e){try{return u.call(this)}catch(e){return o(e)}}.bind(this),o);function u(){return r.freePreviousTextures(),r.updating--,r.initializing=null,r.initialized=!0,r.last_valid_config_source=r.config_source,r.last_valid_options={base_path:n.base_path,file_type:n.file_type},r.requestRedraw(),i()}return u.call(this)}catch(e){return o(e)}}.bind(this),o)})}).catch(function(t){var n,i;if(r.initializing=null,r.updating=0,"YAMLException"===t.name?(n="yaml",i="Error parsing scene YAML"):i="Error initializing scene",r.trigger("error",{type:n,message:i,error:t,url:r.config_source}),i="Scene.load() failed to load "+JSON.stringify(r.config_source)+": "+t.message,r.last_valid_config_source)return e.log("warn",i,t),e.log("info","Scene.load() reverting to last valid configuration"),r.load(r.last_valid_config_source,r.last_valid_base_path);throw e.log("error",i,t),t}),this.initializing)},r.destroy=function(){if(this.initialized=!1,this.render_loop_stop=!0,this.destroyListeners(),this.destroyFeatureSelection(),this.canvas&&this.canvas.parentNode&&(this.canvas.parentNode.removeChild(this.canvas),this.canvas=null),this.container=null,this.gl){e.Texture.destroy(this.gl),this.style_manager.destroy(this.gl),this.styles={},e.ShaderProgram.reset();var t=this.gl.getExtension("WEBGL_lose_context");t&&t.loseContext(),this.gl=null;}this.sources={},this.destroyWorkers(),this.tile_manager.destroy(),this.tile_manager=null,e.log.reset();},r.createCanvas=function(){if(!this.canvas){this.container=this.container||document.body,this.canvas=document.createElement("canvas"),this.canvas.style.position="absolute",this.canvas.style.top=0,this.canvas.style.left=0,this.container.style.backgroundColor="transparent",this.container.appendChild(this.canvas);try{this.gl=n.getContext(this.canvas,Object.assign({alpha:!0,premultipliedAlpha:!0,stencil:!0,device_pixel_ratio:e.Utils.device_pixel_ratio,powerPreference:"high-performance"},this.contextOptions));}catch(e){throw new Error("Couldn't create WebGL context. Your browser may not support WebGL, or it's turned off? Visit http://webglreport.com/ for more info.")}this.resizeMap(this.container.clientWidth,this.container.clientHeight),e.VertexArrayObject.init(this.gl),this.render_states=new sh(this.gl),this.media_capture.setCanvas(this.canvas,this.gl);}},r.updateExternalScripts=function(){var e=[].concat(this.external_scripts||[]),t=[];if(this.config.scene.scripts)for(var n in this.config.scene.scripts)-1===t.indexOf(this.config.scene.scripts[n])&&t.push(this.config.scene.scripts[n]);for(var r in this.config.sources){var i=this.config.sources[r];if(i.scripts)for(var o in i.scripts)-1===t.indexOf(i.scripts[o])&&t.push(i.scripts[o]);}return this.external_scripts=t,!(this.external_scripts.length===e.length&&this.external_scripts.every(function(t,n){return t===e[n]}))},r.createWorkers=function(){return this.updateExternalScripts()&&this.destroyWorkers(),this.workers?Promise.resolve():this.makeWorkers()},r.makeWorkers=function(){var t=this,n=!!this.gl.getExtension("OES_element_index_uint"),r=[];this.workers=[];for(var i=function(i){var o=new Worker(Tangram.workerURL);t.workers[i]=o,e.WorkerBroker.addWorker(o),e.log("debug","Scene.makeWorkers: initializing worker "+i);var s=i;r.push(e.WorkerBroker.postMessage(o,"self.init",t.id,i,t.num_workers,t.log_level,e.Utils.device_pixel_ratio,n,t.external_scripts).then(function(t){return e.log("debug","Scene.makeWorkers: initialized worker "+t),t},function(t){return e.log("error","Scene.makeWorkers: failed to initialize worker "+s+":",t),Promise.reject(t)}));},o=0;o<this.num_workers;o++)i(o);return this.next_worker=0,Promise.all(r).then(function(){e.log.setWorkers(t.workers);})},r.destroyWorkers=function(){this.selection=null,Array.isArray(this.workers)&&(e.log.setWorkers(null),this.workers.forEach(function(e){e.terminate();}),this.workers=null);},r.ready=function(){return !(!this.view.ready()||0===Object.keys(this.sources).length)},r.updateDevicePixelRatio=function(){var t=this;e.Utils.updateDevicePixelRatio()&&e.WorkerBroker.postMessage(this.workers,"self.updateDevicePixelRatio",e.Utils.device_pixel_ratio).then(function(){return t.rebuild()}).then(function(){return t.resizeMap(t.view.size.css.width,t.view.size.css.height)});},r.resizeMap=function(t,r){0===t&&0===r||(this.dirty=!0,this.view.setViewportSize(t,r),this.gl&&n.resize(this.gl,t,r,e.Utils.device_pixel_ratio));},r.requestRedraw=function(){this.dirty=!0;},r.immediateRedraw=function(){this.dirty=!0,this.update();},r.renderLoop=function(){this.render_loop_active=!0,this.update(),e.Task.setState({user_moving_view:this.view.user_input_active}),e.Task.processAll(),this.render_loop_stop?(this.render_loop_stop=!1,this.render_loop_active=!1):window.requestAnimationFrame(this.renderLoop.bind(this));},r.setupRenderLoop=function(){var e=this;this.render_loop_active||setTimeout(function(){e.renderLoop();},0);},r.update=function(){var t=this.dirty,n=!!this.selection&&this.selection.hasPendingRequests(),r=!(!1===t&&!1===n||!1===this.initialized||this.updating>0||!1===this.ready());return this.trigger("pre_update",r),this.view.update(),!!r&&(this.dirty=!1,this.updateDevicePixelRatio(),this.render({main:t,selection:n}),this.updateViewComplete(),this.media_capture.completeScreenshot(),this.trigger("post_update",r),(!0===this.animated||this.view.isAnimating())&&(this.dirty=!0),this.frame++,e.log("trace","Scene.render()"),!0)},r.render=function(t){var n=this,r=t.main,i=t.selection,o=this.gl;if(this.updateBackground(),Object.keys(this.lights).forEach(function(e){return n.lights[e].update()}),this.render_count_changed=!1,r&&(this.render_count=this.renderPass(),this.last_main_render=this.frame,this.render_count!==this.last_render_count&&(this.render_count_changed=!0,this.logFirstFrame(),this.getFeatureSelectionMapSize().then(function(t){n.selection_feature_count=t,e.log("info","Scene: rendered "+n.render_count+" primitives ("+t+" features in selection map)");})),this.last_render_count=this.render_count),i){if(this.view.panning||this.view.user_input_active)return void this.selection.clearPendingRequests();!this.selection.locked&&this.last_selection_render<this.last_main_render&&(this.selection.bind(),this.renderPass("selection_program",{allow_blend:!1}),o.bindFramebuffer(o.FRAMEBUFFER,null),o.viewport(0,0,this.canvas.width,this.canvas.height),o.clearColor.apply(o,this.background.computed_color),this.last_selection_render=this.frame),this.selection.read();}return !0},r.renderPass=function(t,n){var r=this;void 0===t&&(t="program");var i=(void 0===n?{}:n).allow_blend;i=null==i||i,this.clearFrame();for(var o,s,a=0,l=this.style_manager.getActiveBlendOrders(),u=e._createForOfIteratorHelperLoose(l);!(s=u()).done;)for(var h=s.value,c=h.blend_order,f=h.styles,d=function(n){var s=r.styles[f[n]];if(null==s)return "continue";if(s.blend!==o){var l=Object.assign({},e.Style.render_states[s.blend],{blend:i&&s.blend});r.setRenderState(l);}var u=i&&s.blend;if("translucent"===u)r.gl.colorMask(!1,!1,!1,!1),r.renderStyle(s.name,t,c),r.gl.colorMask(!0,!0,!0,!0),r.gl.depthFunc(r.gl.EQUAL),r.gl.enable(r.gl.STENCIL_TEST),r.gl.clearStencil(0),r.gl.clear(r.gl.STENCIL_BUFFER_BIT),r.gl.stencilFunc(r.gl.EQUAL,r.gl.ZERO,255),r.gl.stencilOp(r.gl.KEEP,r.gl.KEEP,r.gl.INCR),a+=r.renderStyle(s.name,t,c),r.gl.disable(r.gl.STENCIL_TEST),r.gl.depthFunc(r.gl.LESS);else if("opaque"!==u&&!0===s.stencil_proxy_tiles){var h=r.tile_manager.getRenderableTiles().filter(function(e){return e.meshes[s.name]}).map(function(e){return e.proxy_level}).reduce(function(e,t){return e.indexOf(t)>-1||e.push(t),e},[]).sort();if(h.length>1){r.gl.enable(r.gl.STENCIL_TEST),r.gl.clearStencil(0),r.gl.clear(r.gl.STENCIL_BUFFER_BIT),r.gl.stencilOp(r.gl.KEEP,r.gl.KEEP,r.gl.REPLACE);for(var d=0;d<h.length;d++)r.gl.stencilFunc(r.gl.GEQUAL,h.length-d,255),a+=r.renderStyle(s.name,t,c,h[d]);r.gl.disable(r.gl.STENCIL_TEST);}else a+=r.renderStyle(s.name,t,c);}else a+=r.renderStyle(s.name,t,c);o=s.blend;},p=0;p<f.length;p++)d(p);return a},r.renderStyle=function(t,n,r,i){var o=this;void 0===i&&(i=null);for(var s,a=this.styles[t],l=!0,u=0,h=this.tile_manager.getRenderableTiles().filter(function(e){return "number"!=typeof i||e.proxy_level===i}).map(function(e){if(e.meshes[t])return [e,e.meshes[t].filter(function(e){return e.variant.blend_order===r})]}).filter(function(e){return e}),c=Math.max.apply(Math,h.map(function(e){var t=e[1];return Math.max.apply(Math,t.map(function(e){return e.variant.mesh_order}))})),f=function(r){for(var i,c=function(){var e=i.value,h=e[0],c=e[1],f=!0;if(!h.shouldProxyForStyle(t))return "continue";var d=c.filter(function(e){return e.variant.mesh_order===r});return 0===d.length?"continue":!0!==l||(l=!1,s=o.setupStyle(a,n))?void d.forEach(function(e){!0===f&&(f=!1,o.view.setupTile(h,s)),a.render(e)&&o.requestRedraw(),u+=e.geometry_count;}):{v:{v:0}}},f=e._createForOfIteratorHelperLoose(h);!(i=f()).done;){var d=c();if("continue"!==d&&"object"==typeof d)return d.v}},d=0;d<c+1;d++){var p=f(d);if("object"==typeof p)return p.v}return u},r.setupStyle=function(e,t){var n;try{if(!(n=e.getProgram(t)))return}catch(t){return void this.trigger("warning",{type:"styles",message:"Error compiling style "+e.name,style:e,shader_errors:e.program&&e.program.shader_errors})}for(var r in n.use(),e.setup(),n.uniform("1f","u_time",this.animated?(+new Date-this.start_time)/1e3:0),this.view.setupProgram(n),this.lights)this.lights[r].setupProgram(n);return n},r.clearFrame=function(){this.initialized&&(this.render_states.depth_write.set({depth_write:!0}),this.gl.clear(this.gl.COLOR_BUFFER_BIT|this.gl.DEPTH_BUFFER_BIT|this.gl.STENCIL_BUFFER_BIT));},r.setRenderState=function(e){var t=void 0===e?{}:e,n=t.depth_test,r=t.depth_write,i=t.cull_face,o=t.blend;if(this.initialized){var s=this.render_states;n=!1!==n&&s.defaults.depth_test,r=!1!==r&&s.defaults.depth_write,i=!1!==i&&s.defaults.culling,o=null!=o?o:s.defaults.blending;var a=this.gl;s.depth_test.set({depth_test:n}),s.depth_write.set({depth_write:r}),s.culling.set({cull:i,face:s.defaults.culling_face}),o?"opaque"===o?s.blending.set({blend:!1}):"overlay"===o||"inlay"===o||"translucent"===o?s.blending.set({blend:!0,src:a.SRC_ALPHA,dst:a.ONE_MINUS_SRC_ALPHA,src_alpha:a.ONE,dst_alpha:a.ONE_MINUS_SRC_ALPHA}):"add"===o?s.blending.set({blend:!0,src:a.ONE,dst:a.ONE}):"multiply"===o&&s.blending.set({blend:!0,src:a.ZERO,dst:a.SRC_COLOR}):s.blending.set({blend:!1});}},r.getFeatureAt=function(t,n){var r=(void 0===n?{}:n).radius;if(!this.initialized)return e.log("debug","Scene.getFeatureAt() called before scene was initialized"),Promise.resolve();if(0===this.selection_feature_count)return Promise.resolve();this.selection||this.resetFeatureSelection();var i={x:t.x/this.view.size.css.width,y:t.y/this.view.size.css.height};return r=r>0?{x:r/this.view.size.css.width,y:r/this.view.size.css.height}:null,this.selection.getFeatureAt(i,{radius:r}).then(function(e){return Object.assign(e,{pixel:t})}).catch(function(e){return Promise.resolve({error:e})})},r.queryFeatures=function(t){return new Promise(function(n,r){var i,o,s,a,l,u,h,c,f,d,p,g,m,v,_,y,b;return o=(i=void 0===t?{}:t).filter,s=i.unique,a=void 0===s||s,l=i.group_by,u=void 0===l?null:l,c=void 0===(h=i.visible)?null:h,f=i.geometry,d=void 0!==f&&f,this.initialized?(o=e.Utils.serializeWithFunctions(o),p=!0===(a="string"==typeof a?[a]:a)||Array.isArray(a)&&a.indexOf("$id")>-1,g=a&&function(t){var n=Array.isArray(a)?e.sliceObject(t.properties,a):t.properties,r=p?t.id:null;return d?JSON.stringify({geometry:t.geometry,properties:n,id:r}):JSON.stringify({properties:n,id:r})},u=("string"==typeof u||Array.isArray(u))&&u,m=u&&function(t){return Array.isArray(u)?JSON.stringify(e.sliceObject(t,u)):t[u]},v=this.tile_manager.getRenderableTiles().map(function(e){return e.key}),Promise.resolve(e.WorkerBroker.postMessage(this.workers,"self.queryFeatures",{filter:o,visible:c,geometry:d,tile_keys:v})).then(function(e){try{return _=[],y={},b={},e.forEach(function(e){return e.forEach(function(e){if(g){var t=g(e);if(y[t])return;y[t]=!0;}if(m){var n=m(e.properties);b[n]=b[n]||[],b[n].push(e);}else _.push(e);})}),n(m?b:_)}catch(e){return r(e)}},r)):n([])}.bind(this))},r.rebuild=function(n){var r=this,i=void 0===n?{}:n,o=i.initial,s=void 0!==o&&o,a=i.new_generation,l=void 0===a||a,u=i.sources,h=void 0===u?null:u,c=i.serialize_funcs,f=i.profile,d=void 0!==f&&f,p=i.fade_in,g=void 0!==p&&p;return new Promise(function(n,i){if(r.building){r.building.queued&&r.building.queued.reject&&(e.log("debug","Scene.rebuild: request superceded by a newer call"),r.building.queued.resolve(!1));var o={initial:s,new_generation:l,sources:h,serialize_funcs:c,profile:d,fade_in:g};return r.building.queued={resolve:n,reject:i,options:o},void e.log("trace","Scene.rebuild(): queuing request")}if(r.building={resolve:n,reject:i,initial:s},d&&r.debug.profile("Scene.rebuild"),l)for(var a in r.generation=++t.generation,r.styles)r.styles[a].setGeneration(r.generation);r.syncConfigToWorker({serialize_funcs:c}),r.resetWorkerFeatureSelection(h),r.resetTime(),r.tile_manager.pruneToVisibleTiles(),r.tile_manager.forEachTile(function(e){(!h||h.indexOf(e.source.name)>-1)&&r.tile_manager.buildTile(e,{fade_in:g});}),r.tile_manager.updateTilesForView(),r.tile_manager.checkBuildQueue();}).then(function(){d&&r.debug.profileEnd("Scene.rebuild");})},r.tileManagerBuildDone=function(){if(e.TextCanvas.pruneTextCache(),this.building){e.log("info","Scene: build geometry finished"),this.building.resolve&&(this.logFirstBuild(),this.building.resolve(!0));var t=this.building.queued;this.building=null,t?(e.log("debug","Scene: starting queued rebuild() request"),this.rebuild(t.options).then(t.resolve,t.reject)):this.tile_manager.updateLabels();}},r.loadScene=function(t,n){return new Promise(function(r,i){var o,s,a,l,u,h,c;return void 0===t&&(t=null),s=(o=void 0===n?{}:n).base_path,a=o.file_type,this.config_source=t||this.config_source,"string"==typeof this.config_source?this.base_path=e.pathForURL(s||this.config_source):this.base_path=e.pathForURL(s),this.config_path=this.base_path,Promise.resolve(Ju.loadScene(this.config_source,{path:this.base_path,type:a})).then(function(e){try{return u=(l=e).config,h=l.bundle,c=l.texture_nodes,this.config=u,this.config_bundle=h,r({texture_nodes:c})}catch(e){return i(e)}}.bind(this),i)}.bind(this))},r.setDataSource=function(t,n){if(t&&n&&n.type&&(n.url||n.data)){var r=null==this.config.sources[t],i=this.config.sources[t]=Object.assign({},n);return i.data&&"object"==typeof i.data&&(i.url=e.createObjectURL(new Blob([JSON.stringify(i.data)])),delete i.data),r?this.updateConfig({rebuild:{sources:[t]}}):this.rebuild({sources:[t]})}e.log("error","No name provided or not a valid config:",t,n);},r.createDataSources=function(t){var n=this;void 0===t&&(t=!1);var r=[],i=Object.keys(this.sources),o=0;for(var s in this.config.sources){var a=this.config.sources[s],l=this.sources[s];try{var u=Object.assign({},a,{name:s,id:o++});if(this.sources[s]=e.DataSource.create(u,this.sources),!this.sources[s])throw {}}catch(t){delete this.sources[s];var h="Could not create data source: "+t.message;e.log("warn","Scene: "+h,a),this.trigger("warning",{type:"sources",source:a,message:h});}(t||e.DataSource.tileLayoutChanged(this.sources[s],l))&&r.push(s);}for(var c in i.forEach(function(e){n.config.sources[e]||(delete n.sources[e],r.push(e));}),r.length>0&&this.tile_manager.removeTiles(function(e){return r.indexOf(e.source.name)>-1}),this.config.layers){var f=this.config.layers[c];!1!==f.enabled&&f.data&&this.sources[f.data.source]&&(this.sources[f.data.source].builds_geometry_tiles=!0);}},r.loadTextures=function(){var t=this;return e.Texture.createFromObject(this.gl,this.config.textures).then(function(){return e.Texture.createDefault(t.gl)})},r.freePreviousTextures=function(){var t=this;this.prev_textures&&(this.prev_textures.forEach(function(n){!t.config.textures[n]&&e.Texture.textures[n]&&e.Texture.textures[n].destroy();}),this.prev_textures=null);},r.updateStyles=function(){if(!this.initialized&&!this.initializing)throw new Error("Scene.updateStyles() called before scene was initialized");for(var e in this.styles=this.style_manager.build(this.config.styles),this.style_manager.initStyles(this),this.styles)this.styles[e].setGL(this.gl);this.dirty=!0;},r.getActiveCamera=function(){return this.view.getActiveCamera()},r.setActiveCamera=function(e){return this.view.setActiveCamera(e)},r.createLights=function(){for(var t in this.lights={},e.debugSettings.wireframe&&(e.Light.enabled=!1),this.config.lights)if(this.config.lights[t]&&"object"==typeof this.config.lights[t]){var n=this.config.lights[t];n.name=t.replace("-","_"),n.visible=!1!==n.visible,n.visible&&(this.lights[n.name]=e.Light.create(this.view,n));}e.Light.inject(this.lights);},r.setBackground=function(){var t=this.config.scene.background;this.background={},t&&t.color&&(this.background.color=e.StyleParser.createColorPropertyCache(t.color)),this.background.color||(this.background.color=e.StyleParser.createColorPropertyCache([0,0,0,0]));},r.updateBackground=function(){var t,n=this.background.computed_color,r=this.background.computed_color=e.StyleParser.evalCachedColorProperty(this.background.color,{zoom:this.view.tile_zoom});n&&!r.some(function(e,t){return n[t]!==e})||(1===r[3]?this.canvas.style.backgroundColor="rgba("+r.map(function(e){return Math.floor(255*e)}).join(", ")+")":this.canvas.style.backgroundColor="transparent",(t=this.gl).clearColor.apply(t,r));},r.setIntrospection=function(e){var t=this;return e!==this.introspection?(this.introspection=null!=e&&e,this.updating++,this.updateConfig({normalize:!1}).then(function(){return t.updating--})):Promise.resolve()},r.updateConfig=function(n){var r=this,i=void 0===n?{}:n,o=i.loading,s=void 0!==o&&o,a=i.rebuild,l=void 0===a||a,u=i.serialize_funcs,h=i.texture_nodes,c=void 0===h?{}:h,f=i.normalize,d=void 0===f||f,p=i.fade_in,g=void 0!==p&&p;this.generation=++t.generation,this.updating++,this.config=Ju.applyGlobalProperties(this.config),d&&Ju.normalize(this.config,this.config_bundle,c),Ju.hoistTextureNodes(this.config,this.config_bundle,c),this.trigger(s?"load":"update",{config:this.config}),this.style_manager.init(),this.view.reset(),this.createLights(),this.createDataSources(s),this.loadTextures(),this.setBackground(),e.FontManager.loadFonts(this.config.fonts),this.updateStyles();var m=l?this.rebuild(Object.assign({initial:s,new_generation:!1,serialize_funcs:u,fade_in:g},"object"==typeof l&&l)):this.syncConfigToWorker({serialize_funcs:u});return this.updating--,this.view.updateBounds(),this.requestRedraw(),m.then(function(){r.last_render_count=0,r.requestRedraw();})},r.syncConfigToWorker=function(t){var n=(void 0===t?{}:t).serialize_funcs,r=void 0===n||n?e.Utils.serializeWithFunctions(this.config):JSON.stringify(this.config);return e.WorkerBroker.postMessage(this.workers,"self.updateConfig",{config:r,generation:this.generation,introspection:this.introspection},e.debugSettings)},r.createListeners=function(){var t=this;this.listeners={},this.listeners.view={move:function(){return t.trigger("move")}},this.view.subscribe(this.listeners.view),this.listeners.texture={update:function(){return t.dirty=!0},warning:function(e){return t.trigger("warning",Object.assign({type:"textures"},e))}},e.Texture.subscribe(this.listeners.texture),this.listeners.scene_loader={error:function(e){return t.trigger("error",Object.assign({type:"scene"},e))}},Ju.subscribe(this.listeners.scene_loader);},r.destroyListeners=function(){this.unsubscribeAll(),this.view.unsubscribe(this.listeners.view),e.Texture.unsubscribe(this.listeners.texture),Ju.unsubscribe(this.listeners.scene_loader),this.listeners=null;},r.destroyFeatureSelection=function(){this.selection&&(this.selection.destroy(),this.selection=null);},r.resetFeatureSelection=function(){var t=this;this.selection=new e.FeatureSelection(this.gl,this.workers,function(){return t.building}),this.last_render_count=0;},r.resetWorkerFeatureSelection=function(t){void 0===t&&(t=null),this.workers&&e.WorkerBroker.postMessage(this.workers,"self.resetFeatureSelection",t);},r.getFeatureSelectionMapSize=function(){var t=this;return null==this.fetching_selection_map&&(this.fetching_selection_map=e.WorkerBroker.postMessage(this.workers,"self.getFeatureSelectionMapSize").then(function(e){return t.fetching_selection_map=null,e.reduce(function(e,t){return e+t})})),this.fetching_selection_map},r.resetTime=function(){this.start_time=+new Date;},r.updateViewComplete=function(){!this.render_count_changed&&this.generation===this.last_complete_generation||this.building||this.tile_manager.isLoadingVisibleTiles()||!this.tile_manager.allVisibleTilesLabeled()||(this.tile_manager.updateLabels(),this.last_complete_generation=this.generation,this.trigger("view_complete",{first:!0!==this.view_complete}),this.view_complete=!0);},r.resetViewComplete=function(){this.last_complete_generation=null;},r.screenshot=function(e){var t=(void 0===e?{}:e).background,n=void 0===t?"white":t;return this.requestRedraw(),this.media_capture.screenshot({background:n})},r.startVideoCapture=function(){return this.requestRedraw(),this.media_capture.startVideoCapture()},r.stopVideoCapture=function(){return this.media_capture.stopVideoCapture()},r.logFirstFrame=function(){0!==this.last_render_count||this.times.first_frame||(this.times.first_frame=+new Date-this.start_time,e.log("debug","Scene: initial frame time: "+this.times.first_frame));},r.logFirstBuild=function(){null==this.times.first_build&&(this.times.first_build=+new Date-this.start_time,e.log("debug","Scene: initial build time: "+this.times.first_build));},e._createClass(t,[{key:"animated",get:function(){var e=this;return !1!==this.config.scene.animated&&this.style_manager.getActiveStyles().some(function(t){return e.styles[t].animated})}}]),t}();uh.id=0,uh.generation=0;var hh={map:{},scrollWheelZoom:{},doubleClickZoom:{}};return {leafletLayer:function(t){return function(t){if(void 0!==lh)return new lh(t);if(e.Thread.is_main){var n,r=t.leaflet||window.L,i=r.GridLayer?r.GridLayer:r.TileLayer,o=i===r.GridLayer?"1.x":"0.7.x",s={};return i===r.TileLayer&&(s._addTile=function(){},s._removeTile=function(){},s._reset=function(){i.prototype._reset.apply(this,arguments),this.scene&&this.scene.container&&this.scene.canvas&&this.scene.container.appendChild(this.scene.canvas);}),Object.assign(s,{initialize:function(e){e.showDebug=!!e.showDebug,r.setOptions(this,e),this.updateTangramDebugSettings(),this.createScene(),this.hooks={},this._updating_tangram=!1;},createScene:function(){this.scene=uh.create(this.options.scene,{numWorkers:this.options.numWorkers,preUpdate:this.options.preUpdate,postUpdate:this.options.postUpdate,continuousZoom:"1.x"===lh.leafletVersion,wrapView:!0!==this.options.noWrap,highDensityDisplay:this.options.highDensityDisplay,logLevel:this.options.logLevel,introspection:this.options.introspection,webGLContextOptions:this.options.webGLContextOptions,disableRenderLoop:this.options.disableRenderLoop});},onAdd:function(t){var n=this;this.scene||this.createScene(),i.prototype.onAdd.apply(this,arguments),this.hooks.resize=function(){n._updating_tangram=!0,n.updateSize(),n._updating_tangram=!1;},t.on("resize",this.hooks.resize),this.hooks.move=function(){if(!n._updating_tangram){n._updating_tangram=!0,n.scene.view.setPanning(!0);var r=t.getCenter();r.zoom=Math.max(Math.min(t.getZoom(),t.getMaxZoom()||e.Geo.default_view_max_zoom),t.getMinZoom()),n.scene.view.setView(r),n._mapLayerCount>1&&n.scene.immediateRedraw(),n._updating_tangram=!1;}},t.on("move",this.hooks.move),this.hooks.moveend=function(){n.scene.view.setPanning(!1),n.scene.requestRedraw();},t.on("moveend",this.hooks.moveend),this.hooks.drag=function(){n.scene.view.markUserInput();},t.on("drag",this.hooks.drag),this._map_pane_observer=new MutationObserver(function(e){e.forEach(function(){return n.reverseTransform()});}),this._map_pane_observer.observe(t.getPanes().mapPane,{attributes:!0}),this.modifyScrollWheelBehavior(t),this.modifyZoomBehavior(t),this.trackMapLayerCounts(t),this.setupSelectionEventHandlers(t),this.setSelectionEvents(this.options.events,{radius:this.options.selectionRadius}),this.scene.container=this.getContainer(),this.updateSize(),this.updateView(),this.resizeOnFirstVisible(),this.scene.subscribe({move:this.onTangramViewUpdate.bind(this)}),this.scene.load(this.options.scene,{base_path:this.options.sceneBasePath,file_type:this.options.sceneFileType,blocking:!1}).then(function(){if(!n.options.attribution)for(var e=0,r=Object.entries(n.scene.config.sources);e<r.length;e++){var i=r[e],o=i[1];o.attribution&&t.attributionControl.addAttribution(o.attribution);}n._updating_tangram=!0,n.updateSize(),n.updateView(),n.reverseTransform(),n._updating_tangram=!1,n.fire("init");}).catch(function(e){n.fire("error",e);});},onRemove:function(e){i.prototype.onRemove.apply(this,arguments),e.off("layeradd layerremove overlayadd overlayremove",this._updateMapLayerCount),e.off("resize",this.hooks.resize),e.off("move",this.hooks.move),e.off("moveend",this.hooks.moveend),e.off("drag",this.hooks.drag),e.off("click",this.hooks.click),e.off("mousemove",this.hooks.mousemove),e.off("mouseout",this.hooks.mouseout),document.removeEventListener("visibilitychange",this.hooks.visibilitychange),this.hooks={},this._map_pane_observer.disconnect(),this.scene&&(this.scene.destroy(),this.scene=null);},createTile:function(e){var t=e.x+"/"+e.y+"/"+e.z,n=document.createElement("div");if(n.setAttribute("data-tile-key",t),n.style.width="256px",n.style.height="256px",this.options.showDebug){var r=document.createElement("div");r.textContent=t,r.style.position="absolute",r.style.left=0,r.style.top=0,r.style.color="white",r.style.fontSize="16px",r.style.textOutline="1px #000000",r.style.padding="8px",n.appendChild(r),n.style.borderStyle="solid",n.style.borderColor="white",n.style.borderWidth="1px";}return n},modifyScrollWheelBehavior:function(e){if(this.scene.view.continuous_zoom&&e.scrollWheelZoom&&!1!==this.options.modifyScrollWheel){e.options.zoomSnap=0;var t=e.scrollWheelZoom.enabled();e.scrollWheelZoom.disable(),r.Browser.chrome||r.Browser.safari?e.scrollWheelZoom._onWheelScroll=function(e){var t=r.DomEvent.getWheelDelta(e);this._delta+=t,this._lastMousePos=this._map.mouseEventToContainerPoint(e),this._performZoom(),r.DomEvent.stop(e);}:e.options.wheelDebounceTime=20;var i=(s=function(e){e._moveEnd(!0),e.fire("viewreset");},a=2*e.options.wheelDebounceTime,function(){var e=this,t=arguments;clearTimeout(l),l=setTimeout(function(){l=null,s.apply(e,t);},a);});hh.scrollWheelZoom._performZoom||(hh.scrollWheelZoom._performZoom=e.scrollWheelZoom._performZoom);var o=this;e.scrollWheelZoom._performZoom=function(){if(this._map===o._map){var e=this._map,t=e.getZoom();e._stop();var r=this._delta/(4*this._map.options.wheelPxPerZoomLevel);this._delta=0,t+r>=this._map.getMaxZoom()?r=this._map.getMaxZoom()-t:t+r<=this._map.getMinZoom()&&(r=this._map.getMinZoom()-t),r&&("center"===e.options.scrollWheelZoom?n(o,e.getCenter(),t+r):n(o,this._lastMousePos,t+r),i(e));}else hh.scrollWheelZoom._performZoom.call(this);},t&&e.scrollWheelZoom.enable();}var s,a,l;},modifyZoomBehavior:function(e){if(this.scene.view.continuous_zoom&&!1!==this.options.modifyZoomBehavior){var t=this,i=function(t,i,o){e._stop();var s=e._zoom;i=r.latLng(i),o=void 0===o?s:o,o=Math.min(o,e.getMaxZoom());var a=Date.now(),l=75;return e._moveStart(!0),function u(){var h=(Date.now()-a)/l;h<=1?(e._flyToFrame=r.Util.requestAnimFrame(u,e),n(t,i,s+(o-s)*h)):n(t,i,o)._moveEnd(!0);}.call(e),e};if(e.doubleClickZoom){var o=e.doubleClickZoom.enabled();e.doubleClickZoom.disable(),hh.doubleClickZoom._onDoubleClick||(hh.doubleClickZoom._onDoubleClick=e.doubleClickZoom._onDoubleClick),e.doubleClickZoom._onDoubleClick=function(e){if(this._map===t._map){var n=this._map,r=n.getZoom(),o=n.options.zoomDelta,s=e.originalEvent.shiftKey?r-o:r+o;"center"===n.options.doubleClickZoom?i(t,n.getCenter(),s):i(t,n.containerPointToLatLng(e.containerPoint),s);}else hh.doubleClickZoom._onDoubleClick.call(this,e);},o&&e.doubleClickZoom.enable();}e._zoomAnimated&&(hh.map._animateZoom||(hh.map._animateZoom=e._animateZoom),e._animateZoom=function(e,n,o,s){this===t._map?(o&&(this._animatingZoom=!0,this._animateToCenter=e,this._animateToZoom=n,i(t,e,n)),setTimeout(r.Util.bind(this._onZoomTransitionEnd,this),250)):hh.map._animateZoom.call(this,e,n,o,s);});}},updateView:function(){var t=this._map.getCenter();t.zoom=Math.max(Math.min(this._map.getZoom(),this._map.getMaxZoom()||e.Geo.default_view_max_zoom),this._map.getMinZoom()),this.scene.view.setView(t);},updateSize:function(){var e=this._map.getSize();this.scene.resizeMap(e.x,e.y);},resizeOnFirstVisible:function(){var e=this,t=!0;this.hooks.visibilitychange=function(){t&&(t=!1,e.updateSize());},document.addEventListener("visibilitychange",this.hooks.visibilitychange);},onTangramViewUpdate:function(){if(this._map&&!this._updating_tangram){var e=this._map.getCenter(),t=this.scene.view.center;e.lng===t.lng&&e.lat===t.lat&&this._map.getZoom()===this.scene.view.zoom||(this._updating_tangram=!0,this._map.setView([this.scene.view.center.lat,this.scene.view.center.lng],this.scene.view.zoom,{animate:!1}),this._updating_tangram=!1);}},render:function(){this.scene&&this.scene.update();},reverseTransform:function(){if(this._map&&this.scene&&this.scene.container){var e=this._map.containerPointToLayerPoint([0,0]);r.DomUtil.setPosition(this.scene.container,e);}},setupSelectionEventHandlers:function(e){var t=this;this._selection_events={},this._selection_radius=null,this.hooks.click=function(e){"function"==typeof t._selection_events.click&&t.scene.getFeatureAt(e.containerPoint,{radius:t._selection_radius}).then(function(n){var r=Object.assign({},n,{leaflet_event:e});t._selection_events.click(r);});},e.on("click",this.hooks.click),this.hooks.mousemove=function(e){"function"==typeof t._selection_events.hover&&t.scene.getFeatureAt(e.containerPoint,{radius:t._selection_radius}).then(function(n){var r=Object.assign({},n,{leaflet_event:e});t._selection_events.hover(r);});},e.on("mousemove",this.hooks.mousemove),this.hooks.mouseout=function(e){"function"==typeof t._selection_events.hover&&t._selection_events.hover({changed:!0,leaflet_event:e});},e.on("mouseout",this.hooks.mouseout);},setSelectionEvents:function(e,t){var n=void 0===t?{}:t,r=n.radius;this._selection_events=Object.assign(this._selection_events,e),this._selection_radius=void 0!==r?r:this._selection_radius;},trackMapLayerCounts:function(e){var t=this;this._updateMapLayerCount=function(){var n=e.getPanes().mapPane.childNodes;t._mapLayerCount=0;for(var r=0;r<n.length;r++)t._mapLayerCount+=n[r].childNodes.length;},e.on("layeradd layerremove overlayadd overlayremove",this._updateMapLayerCount),this._updateMapLayerCount();},updateTangramDebugSettings:function(){e.mergeDebugSettings(this.options.debug||{});}}),n=function(e,t,n){var i=e._map,o=e.scene,s=i.getZoomScale(n),a=i.getSize().divideBy(2),l=t instanceof r.Point?t:i.latLngToContainerPoint(t),u=l.subtract(a).multiplyBy(1-1/s),h=i.containerPointToLatLng(a.add(u));return o&&o.view.markUserInput(),i._move(h,n,{flyTo:!0})},"function"!=typeof(lh=i.extend(s)).remove&&(lh.prototype.remove=function(){this._map&&this._map.removeLayer(this),this.fire("remove");}),lh.layerBaseClass=i,lh.leafletVersion=o,new lh(t)}}(t)},debug:{log:e.log,yaml:Vu,Utils:e.Utils,Geo:e.Geo,Vector:e.Vector,DataSource:e.DataSource,GLSL:e.GLSL,ShaderProgram:e.ShaderProgram,VertexData:e.VertexData,Texture:e.Texture,Material:e.Material,Light:e.Light,Scene:uh,WorkerBroker:e.WorkerBroker,Task:e.Task,StyleManager:e.StyleManager,StyleParser:e.StyleParser,TileID:e.TileID,Collision:e.Collision,FeatureSelection:e.FeatureSelection,TextCanvas:e.TextCanvas,debugSettings:e.debugSettings},version:e.version}});

// Loads each of the chunks produced by the first Rollup pass.

// This allows the rollup ESM build to work within a <script type="module"> tag
// Script modules can't expose exports
try {
	Tangram.debug.ESM = false; // mark build as ES module
	Tangram.debug.SHA = '81ee5a1ddf14547d5653c42972e0a66fa999d545';
	if (false === true && typeof window === 'object') {
	    window.Tangram = Tangram;
	}
} catch(e) {}

return Tangram;

})));
